;; Copyright (c) 2011-2014, Palo Alto Research Center, Inc.

;; Developed with the sponsorship of the Defense Advanced Research
;; Projects Agency (DARPA) and delivered to the U.S. Government with
;; Unlimited Rights as defined in DFARS 252.227-7013.

;; Permission is hereby granted, free of charge, to any person obtaining
;; a copy of this data, including any software or models in source or
;; binary form, specifications, algorithms, and
;; documentation (collectively “the Data”), to deal in the Data without
;; restriction, including without limitation the rights to use, copy,
;; modify, merge, publish, distribute, sublicense, and/or sell copies of
;; the Data, and to permit persons to whom the Data is furnished to do
;; so, subject to the following conditions:

;; The above copyright notice and this permission notice shall be
;; included in all copies or substantial portions of the Data.

;; THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
;; MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;; NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS, SPONSORS, DEVELOPERS,
;; CONTRIBUTORS, OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
;; OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
;; ARISING FROM, OUT OF OR IN CONNECTION WITH THE DATA OR THE USE OR
;; OTHER DEALINGS IN THE DATA.


;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: package.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 07, 2011 13:07:35
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, March 01, 2012 at 16:33:12 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :cl-user)

(defpackage :env2
     (:use :com.gigamonkeys.test :cl)
     (:export
      #:*system-being-analyzed*
      #:*envisioner-major-version*
      #:*envisioner-minor-version*
      #:*envisioner-version-tag*
      #:*envisioner-vcs-revision*
    #:>>
    #:across-variable
    #:active-constraints
    #:active-one-var-constraints
    #:add-cycles
    #:add-mode-to-model
    #:add-sensor-mode-to-model
    #:add-variable-constraint
    #:adjacent-constraints
    #:adjacent-constraints?
    #:all-derivs
    #:all-derivs-known
    #:all-failure-or-success?
    #:all-finite-q-quantities
    #:all-knownp
    #:all-qvalues-for-var-known?
    #:all-transition-sets
    #:all-values-for-qspace
    #:analyze
    #:analyze-triangle-wave-source-test
    #:blist-for-constraint
    #:blist-for-constraint-derivs
    #:canonicalize-result
    #:cell-p
    #:cell-situation
    #:cell-solved
    #:cell-statevar
    #:cell-values
    #:cell-var
    #:check-cycle
    #:clear-constraints
    #:clobber
    #:clobber-mode-initials
    #:clobber-var
    #:collect-prototype
    #:collect-prototype-1
    #:collect-state
    #:compare-ok-numeric-qualitative-p
    #:condition-satisfied-atom?
    #:condition-satisfied?
    #:confirm-uses-gone
    #:constraint-active-p
    #:constraint-condition
    #:constraint-consistency-sets
    #:constraint-consistent-transitions
    #:constraint-degree
    #:constraint-eliminated
    #:constraint-equation
    #:constraint-function
    #:constraint-id
    #:constraint-p
    #:constraint-source
    #:constraint-variable-count
    #:constraint-variables
    #:constraint-waiting
    #:constraints-by-degree
    #:constraints-consistency-sets
    #:construct-cycles
    #:construct-deriv-constraint
    #:construct-kvl-loop
    #:construct-kvls
    #:construct-kvls-from-cycles
    #:construct-loop
    #:construct-multiply
    #:construct-pair
    #:construct-qarithmatic-constraint
    #:construct-qequal
    #:construct-qset
    #:construct-qsum-constraint
    #:construct-set-mode-constraint
    #:construct-spanning-tree
    #:construct-summer
    #:contradiction
    #:copy-cell
    #:copy-constraint
    #:copy-datum
    #:copy-deriv-constraint
    #:copy-general-summer-constraint
    #:copy-metamodel
    #:copy-mode
    #:copy-model
    #:copy-multiply-constraint
    #:copy-node
    #:copy-possible-transition
    #:copy-q-quantity
    #:copy-qequal-constraint
    #:copy-qset-constraint
    #:copy-set-mode-constraint
    #:copy-situation
    #:copy-system
    #:copy-terminal
    #:copy-var
    #:create
    #:create-across-variable
    #:create-boolean-variable
    #:create-component
    #:create-components
    #:create-datum
    #:create-deriv-for-var
    #:create-equations
    #:create-fixed-parameters
    #:create-landmark-sensor-vars
    #:create-landmarks
    #:create-legend
    #:create-let*
    #:create-model
    #:create-modes
    #:create-next-sit-interpretations
    #:create-node
    #:create-q-quantity
    #:create-qspace
    #:create-sensor-component
    #:create-sensor-modes
    #:create-simple-variable
    #:create-situation
    #:create-situation-and-system
    #:create-situation-copy
    #:create-system
    #:create-terminal
    #:create-through-variable
    #:create-var
    #:ctl-binary-operator?
    #:ctl-unary-operator?
    #:datum-cell
    #:datum-consequences
    #:datum-justifications
    #:datum-p
    #:datum-quantity
    #:datum-type
    #:datum-unknowns
    #:debug-print
    #:defmetamodel-1
    #:defprototype
    #:delete-value-from-cell
    #:deriv->simpleq
    #:deriv-constraint-condition
    #:deriv-constraint-consistent-transitions
    #:deriv-constraint-deriv
    #:deriv-constraint-eliminated
    #:deriv-constraint-equation
    #:deriv-constraint-function
    #:deriv-constraint-handler
    #:deriv-constraint-handler-trans-set
    #:deriv-constraint-id
    #:deriv-constraint-p
    #:deriv-constraint-source
    #:deriv-constraint-var
    #:deriv-constraint-variables
    #:deriv-constraint-waiting
    #:describe-constraint
    #:describe-constraints
    #:describe-multiply
    #:describe-qequal-constraint
    #:describe-summer
    #:display-envisionment
    #:display-value
    #:display-var-value
    #:divergent?
    #:duplicate-sits
    #:eliminate
    #:ensure-consistency-with-new-value
    #:ensure-justification
    #:envision
    #:envision-Adby346
    #:envision-lc-oscillator
    #:envision-rlc-parallel
    #:envision-rlc-series
    #:envisioner
    #:evaluate-condition
    #:evaluate-q=-arg
    #:evaluate-situation-wrt
    #:expt-diode
    #:expt-rc
    #:expt-rc-2
    #:fail-situations
    #:figure-landmark-constraints
    #:filter-constraint-by-adj-constraint
    #:filter-global-situations
    #:filter-pos-trans-by-one-var-constraints
    #:find-ground
    #:find-locally-named-component
    #:find-locally-named-variable
    #:find-named-component
    #:find-named-node
    #:find-named-terminal
    #:find-or-create-across-variable
    #:find-or-create-boolean-variable
    #:find-or-create-simple-variable
    #:find-or-create-through-variable
    #:find-or-create-variable
    #:find-or-create-variables
    #:find-possible-transitions
    #:find-situation
    #:finite-transition?
    #:full-name
    #:full-name-1
    #:general-summer
    #:general-summer-constraint-condition
    #:general-summer-constraint-consistent-transitions
    #:general-summer-constraint-eliminated
    #:general-summer-constraint-equation
    #:general-summer-constraint-function
    #:general-summer-constraint-id
    #:general-summer-constraint-neg-vars
    #:general-summer-constraint-p
    #:general-summer-constraint-pos-vars
    #:general-summer-constraint-source
    #:general-summer-constraint-variables
    #:general-summer-constraint-waiting
    #:general-summer-datum
    #:general-summer-one-datum
    #:general-summer-trans-set
    #:get-mode
    #:get-root-model
    #:get-viz-var
    #:generate-gml
    #:generate-json
    #:handle-=
    #:handle-and
    #:handle-exists-until
    #:handle-multiplication-constraint
    #:handle-qmulti-constraint
    #:inconsistent-by-constraint?
    #:inconsistent-transition-sets?
    #:insert-external-parameters
    #:interval->simpleq
    #:interval?
    #:invert-polarity
    #:KCL
    #:kcl-general
    #:kcl-model
    #:kcl-node
    #:known-value?
    #:known-vars
    #:landmark-above
    #:landmark-below
    #:landmark-for-var?
    #:local-constraint-filtering
    #:logical-operator?
    #:lookup
    #:lookup-1
    #:lookup-model
    #:lookupc
    #:lookupv
    #:make-cell
    #:make-constraint
    #:make-datum
    #:make-deriv-constraint
    #:make-general-summer-constraint
    #:make-identity-transition
    #:make-metamodel
    #:make-mode
    #:make-model
    #:make-multiply-constraint
    #:make-node
    #:make-pos-trans
    #:make-possible-transition
    #:make-q-quantity
    #:make-qequal-constraint
    #:make-qset-constraint
    #:make-set-mode-constraint
    #:make-situation
    #:make-situation-from-interpretation
    #:make-system
    #:make-terminal
    #:make-var
    #:map-external-terminals
    #:metamodel-all-equations
    #:metamodel-all-terminals
    #:metamodel-all-variables
    #:metamodel-body
    #:metamodel-equations
    #:metamodel-external-parameters
    #:metamodel-external-variables
    #:metamodel-failure-conditions
    #:metamodel-failures
    #:metamodel-fixed-parameters
    #:metamodel-id
    #:metamodel-initial-conditions
    #:metamodel-internal-nodes
    #:metamodel-modelica
    #:metamodel-modes
    #:metamodel-name
    #:metamodel-p
    #:metamodel-source
    #:metamodel-success-conditions
    #:metamodel-superclasses
    #:metamodel-variables
    #:mode-datum
    #:mode-entry
    #:mode-equations
    #:mode-initial
    #:mode-name
    #:mode-p
    #:mode-parent
    #:mode-transition?
    #:mode-value
    #:mode-var?
    #:mode-vars
    #:model-bindings
    #:model-components
    #:model-constraints
    #:model-display
    #:model-equations
    #:model-failures
    #:model-fixed-parameters
    #:model-id
    #:model-local-name
    #:model-mode
    #:model-modes
    #:model-nodes
    #:model-p
    #:model-parent
    #:model-prototype
    #:model-sensors
    #:model-terminals
    #:model-variables
    #:multiply-constraint-args
    #:multiply-constraint-condition
    #:multiply-constraint-consistent-transitions
    #:multiply-constraint-eliminated
    #:multiply-constraint-equation
    #:multiply-constraint-function
    #:multiply-constraint-id
    #:multiply-constraint-multiplicands
    #:multiply-constraint-p
    #:multiply-constraint-polarity
    #:multiply-constraint-result
    #:multiply-constraint-source
    #:multiply-constraint-variables
    #:multiply-constraint-waiting
    #:multiply-handler-datum
    #:multiply-handler-trans-set
    #:new-id
    #:next-component-mode
    #:next-situations
    #:next-situations-continuous
    #:next-situations-discrete
    #:no-change?
    #:node-across-variables
    #:node-conservation-p
    #:node-display
    #:node-id
    #:node-in-parent
    #:node-mark
    #:node-name
    #:node-p
    #:node-parent
    #:node-terminals
    #:node-type
    #:node-variable
    #:node-x
    #:node-y
    #:node-z
    #:num-edges
    #:num-sits-by-depth
    #:numeric-multiply-one-datum
    #:numeric-summer-one-datum
    #:numerical-value
    #:out-graphviz-dot
    #:pairwise-constraint-filtering
    #:parameter-p
    #:parse-ctl
    #:parse-equation
    #:parse-equation-1
    #:parse-equation-1-atom
    #:parse-mode
    #:parse-q-equation
    #:plunk-derivs
    #:plunk-unknown-qspace
    #:plunk-var
    #:possible-transitions-interval
    #:possible-transition-id
    #:possible-transition-new-value
    #:possible-transition-old-value
    #:possible-transition-p
    #:possible-transition-reason
    #:possible-transition-variable
    #:possible-transitions-instant
    #:print-cell
    #:print-constraint
    #:print-datum
    #:print-differences
    #:print-model
    #:print-node
    #:print-q-quantity
    #:print-single-var
    #:print-situation
    #:print-terminal
    #:print-transition
    #:print-transition-set
    #:print-var
    #:print-vars
    #:print-varss
    #:process-=
    #:process-initial-conditions
    #:process-mode-conditions
    #:process-mode-conditions-1
    #:process-mode-initials
    #:process-prototype-initial-conditions
    #:propagate
    #:q-add
    #:q-divide
    #:q-invert
    #:q-multiply
    #:q-quantity-deriv
    #:q-quantity-equal
    #:q-quantity-p
    #:q-quantity-qspace
    #:q-quantity-value
    #:q-subtract
    #:qderiv
    #:qequal-constraint-condition
    #:qequal-constraint-consistent-transitions
    #:qequal-constraint-eliminated
    #:qequal-constraint-equation
    #:qequal-constraint-function
    #:qequal-constraint-handler
    #:qequal-constraint-handler-datum
    #:qequal-constraint-handler-trans-set
    #:qequal-constraint-id
    #:qequal-constraint-p
    #:qequal-constraint-polarity
    #:qequal-constraint-source
    #:qequal-constraint-var1
    #:qequal-constraint-var2
    #:qequal-constraint-variables
    #:qequal-constraint-waiting
    #:qmulti-for-one-unknown
    #:qmulti-no-unknown
    #:qset-constraint-condition
    #:qset-constraint-consistent-transitions
    #:qset-constraint-constant
    #:qset-constraint-eliminated
    #:qset-constraint-equation
    #:qset-constraint-function
    #:qset-constraint-handler
    #:qset-constraint-handler-datum
    #:qset-constraint-handler-trans-set
    #:qset-constraint-id
    #:qset-constraint-p
    #:qset-constraint-source
    #:qset-constraint-var
    #:qset-constraint-variables
    #:qset-constraint-waiting
    #:qspace-for-value
    #:qualitative-datums
    #:qualitative-values
    #:quantity-var?
    #:quantity-vars
    #:quiescence?
    #:remove-last
    #:remove-trailing-system-names
    #:retrieve-across-variable
    #:retrieve-cell
    #:run-completer
    #:run-constraints
    #:run-constraints1
    #:set-consistent-with-constraint?
    #:set-deriv
    #:set-derivs
    #:set-mode
    #:set-mode-constraint-condition
    #:set-mode-constraint-consistent-transitions
    #:set-mode-constraint-eliminated
    #:set-mode-constraint-equation
    #:set-mode-constraint-function
    #:set-mode-constraint-id
    #:set-mode-constraint-mode-name
    #:set-mode-constraint-mode-var
    #:set-mode-constraint-p
    #:set-mode-constraint-source
    #:set-mode-constraint-variables
    #:set-mode-constraint-waiting
    #:set-mode-equation?
    #:sets-consistent-with-interpretation
    #:shortest-path-to-sit
    #:shortest-path-to-sit-1
    #:simple-qvalue
    #:simpleq->interval
    #:simpleq-p
    #:simpleqspace?
    #:situation
    #:situation-a
    #:situation-abstraction
    #:situation-b
    #:situation-cell
    #:situation-children
    #:situation-complete
    #:situation-data
    #:situation-depth
    #:situation-eliminated
    #:situation-id
    #:situation-in-transitions
    #:situation-p
    #:situation-parents
    #:situation-particles
    #:situation-possible-transitions
    #:situation-probability
    #:situation-qinitialized
    #:situation-situation-atms-node
    #:situation-solved
    #:situation-state
    #:situation-status
    #:situation-string
    #:situation-time
    #:situation-trace
    #:situation-type
    #:situation-values
    #:situation-zgraph-vertex
    #:situations
    #:situations-satisfying
    #:sroot
    #:start-server
    #:stop-server
    #:store-cell
    #:string-graphviz-dot
    #:sub-cycles
    #:success-situations
    #:summary-env
    #:symbolic-datum
    #:symbolic-multiply-one-datum
    #:symbolic-summer-one-datum
    #:symbolic-value
    #:system-analyses
    #:system-atms
    #:system-constraints
    #:system-debug
    #:system-deriv-equivalent-classes
    #:system-global-situation
    #:system-id
    #:system-initial-situations
    #:system-landmark-relations
    #:system-max-cell
    #:system-mode-components
    #:system-models
    #:system-name
    #:system-nodes
    #:system-p
    #:system-parameters
    #:system-queue
    #:system-situations
    #:system-statevars
    #:system-success-function
    #:system-symbolic-variables
    #:system-top-models
    #:system-var-equivalent-classes
    #:system-variables
    #:terminal-across-variables
    #:terminal-id
    #:terminal-name
    #:terminal-node
    #:terminal-p
    #:terminal-parent
    #:terminal-situations
    #:terminal-through-variable
    #:terminal-type
    #:terminal-variable
    #:through-type
    #:top-models
    #:total-situations
    #:trace-envisioner
    #:trace-model-construction
    #:trajectories-satisfying
    #:trajectories-satisfying-1
    #:transitions
    #:type-from-value
    #:unknown-derivs
    #:unknown-vars
    #:untrace-envisioner
    #:untrace-model-construction
    #:update-success-function
    #:val-from-blist
    #:valid-infinite-aysmptotic-apprach?
    #:value->qspace
    #:values-in-situation
    #:var-deriv
    #:var-eliminated
    #:var-equivalent-class
    #:var-fundamental-type
    #:var-id
    #:var-integral
    #:var-landmarks
    #:var-local-name
    #:var-max-width
    #:var-mean
    #:var-node+
    #:var-node-
    #:var-p
    #:var-parent
    #:var-qpf-index
    #:var-qspaces
    #:var-sd
    #:var-symbolic-name
    #:var-terminal
    #:var-to-plunk
    #:var-type
    #:var-uses
    #:variable-node?
))



(defpackage :env2-names)  ; a place to put, e.g., derivs and systems

(in-package :env2)

(defconstant +env2-names+ (find-package :env2-names))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: defs.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: November 30, 2011 16:14:55
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Tuesday, December 17, 2013 at 17:29:42 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

(defconstant *envisioner-major-version* 2
  "The major version number.  This should change whenever major
changes to the API are made, so that other parts of the system
can key off of it.")

;;; Version 1: Started 05/18/2014 Johan.  Has new *set-global* partially implemented.
(defconstant *envisioner-minor-version* 1
  "The minor version number.  This should change whenever changes
are made to the system.")

;;; Avoid looking this up repeatedly.  When a limit is violated, this
;;; will be its qualitative value.
(defconstant *violated* (intern "violated" :keyword))

(defconstant *success* (intern "success" :keyword))

(defparameter *envisioner-version-tag* "experimental"
  "This is a free form tag to mark this copy of the envisioner
in some fashion.")

(defparameter *envisioner-vcs-revision* nil
  "A string giving the version control system revision for this
version of the envisioner code.  In practice this is difficult to
determine from inside the system.  It is typically set by an external
tool that can look into the VCS.")

(defvar *error-on-error* nil)		; Set to t to provoke errors instead.  Used in note-exception.

(defvar *use-global* nil)			; If t, global-cell will be used.
(defvar *system-being-analyzed* nil)

;;; all variables, flags should be stored in this data structure so it is possible have multiple envisionings
;;; at the same time or be called recursively.
(defstruct (system (:print-object print-system))
  id					; for generating unique id's
                                        ; integer, automatically generated by something

  name					; external name.  symbol assigned by programmer.

  constraints				; list of constraint structs

  variables				; list of all variable structs known to the system

  active-variables			; [04/17/2014 Johan] variables (above) with all eliminated variables removed.
					; This list is scanned so often, its worth maintaining this subset.

  top-models				; models without parents.  Root of the model hierarchy,
                                        ; contains a list of component structures (usually only
                                        ; one element).  Hard to see where there would be more.

  models				; list of all component instances, model structs

  mode-components			; list of model struct, components with modes.

  queue					; list of pending constraint structs to propagate.

  situations				; list of all situations, situation struct
					; [This should be flushed soon. 04/07/2014 Johan]

  situation-queue                       ; this is the queue of situations to explored

  max-cell				; size of the array for storing values of variables in
                                        ; each situation.  Integer.  So, number of variables you
                                        ; need to store in each situation.  If number of vars
                                        ; exceeds this, the code blows up.
					; [04/17/2014 Johan] Some of these uses will be replaced by
					; max-position


  max-position

  success-function			; evaluation predicate; returns :failure|:success|:maybe
                                        ; called on a situation

  var-equivalent-classes                ; structures created to contain eliminated variables,
                                        ; of type equivalence class.  TBD.  Part of the eliminator.

  debug					; print out debugging information.  Boolean flag.

  initial-situations                    ; starting situations for the envisioner graph.

  ;;  slots below this are unused by env2

  nodes					; (unused?)  list of all nodes. is this necessary?  

  analyses				; (Unused.)  set of types of analyses that have been done
                                        ; :simple-qualitative, :numeric,

  atms					; (Unused.)  atms instance used to analyze this system. 

  symbolic-variables			; hash table maps atoms to system variables.

  deriv-equivalent-classes

  global-situation			; this situation holds all the constants.

  statevars

  parameters				; quick lookup for qpf.

  when-equations	 ;  this holds the when equations of the model

  match-qstates         ; the sequence of qstates inferred from a csv file

  terminate-on-success-failure?         ; Should the envisionmenber stop at success and failure situations

  symbolic-state-vars			; Statevars for symbolic analysis.

  parse					; Equations.

  ics					; Initial variable values.

  xml-parse				; Raw parse of OM output.

  time					; This is a variable created to represent time.

  qplus					; Holds the qplus constant variable.  

  quantity-vars				; All the quantity-vars.

  (env-count 0)				; A counter purely for integers.
  
  collect-vars				; Vars which are used for collect-state.

  tstart				; (Symbolic) variable representing the beginning time.

  last-contradiction			; Used to be *r*.  Last contradiction encountered.

  compacted-p

  key-hash-table			; [04/27/2014 Johan] used for hash key entries.

  key-counter				; [04/27/2014 Johan] For key-counter.
  
  unconditional-constraints		; Non-eliminated unconditional constraints.
  
  conditional-constraints		; Eliminated conditional constraints.
  
  state-size				; Size of collect-state.

  new-instants

  new-intervals

  (datum-counter 0)
  
  (cell-counter 0)

  possible-transition-table

  xml-variables				; Hash table xml variable -> var (used only for debugging).

  initial-conditions			; These may be stored somewhere else but cannot find them.

  depth-bound				; Depth bound of envisionment if one was supplied.
  )

(defun print-system (system stream)
  (format stream "#<system: ~d>" (system-id system) ))

(defun new-id ()
  (incf (system-id *system-being-analyzed*)))

(defparameter *debug?* nil "global debug flag to allow for let binding")

(defmacro debug-print (flag &rest args)
  `(when (or *debug?*
	     (and *system-being-analyzed* (system-debug *system-being-analyzed*))
	     ,flag)
     (format t . ,args)))

(defun debug-break (&optional flag)
  (when (or flag 
	    (system-debug *system-being-analyzed*)
	    *debug?*)
    (break)))

(defstruct (model (:print-object print-model))
  ;; instance of a metamodel
  id               ; automatically assigned integer
  parent           ; model which contains this
  terminals        ; list of terminal structs (unused?)
  variables        ; alist of (name . variable struct) values
  equations        ; (unused) -- for Johan's future use
  components       ; list of model structs, the subcomponent instances
  prototype        ; prototype meta-model which this model instantiates
  local-name       ; symbol (name local to the parent model)
  nodes            ; (unused) -- deprecated QML usage
  mode             ; mode variable (if it has a mode).
  modes            ; definition of modes, list of mode structs
  fixed-parameters ; list of variable structs for parameters (resistance, capacitance, ...)
  sensors          ; (unused) (do we still need them?)
  constraints      ; list of constraint structs generated for this model
  bindings         ; (unused, deprecated QML) a-list of terminal bindings
  failures         ; (unused) -- for future, to store failure modes
  display          ; (reserved for future use -- Johan)
                   ; reference to graphic visualization of schematic.
  )

(defmacro defprototype (&rest args) `(defmetamodel-1 ',(car args) ',(cdr args)))
(defmacro defconnector (&rest args) `(defmetamodel-1 ',(car args) ',(cdr args)))

(defun print-model (model stream)
  (format stream "#<component: ~d ~a>" (model-id model) (model-parent model)))


;;; this is confused:  working on fixing right now***
;;; terminal connects a component to a node.
(defstruct (terminal (:print-object print-terminal))
  ;; we don't want to talk about these
  id
  parent
  type
  name
  through-variable			; the through variable associated with it.
  across-variables	    		; through variable as a-list.
  node
  variable				; like :boolean.  don't re-use through-variable for cleanliness.
  )

(defun print-terminal (terminal stream)
  (format stream "#<terminal: ~d ~a>" (terminal-id terminal) (terminal-type terminal)))

(defstruct (node (:print-object print-node))
  ;; also a pointless and deprecated construct
  id
  parent
  name
  type
  terminals
  x
  y
  z
  across-variables                      ; ((othernode . var) ...) kept in id order.  high id points to lo id.
  mark					; used in spanning tree calculations.
  in-parent				; can be compressed into 1 slot, but this is easier.
  display				; points to graphical displayed object corresponding to this.
  variable
  (conservation-p t))			; t if conservation law applies.

(defun print-node (node stream)
  (format stream "#<node: ~d ~a>" (node-id node) (node-name node)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Situation

(defstruct (situation (:print-object print-situation))
  id                    ; unique integer (auto-generated)
  type                  ; :instant or :interval
  state                 ; Used internally to identify duplicate situations.
  parents               ; preceeding situations in the env graph
  children              ; succeding situations in the env graph
  situation-atms-node   ; (unused) - atms node associated with this situation.
  probability           ; (unused, reserved for future use, PCC calc) p(<this node> given <root>)
  values                ; vector containing cells for each variable in the situation
  complete              ; non-nil if analysis of out edges complete
  depth                 ; depth in the envisionment.
                        ; used as a way to limit the size of the envisionment.
  possible-transitions  ; (unused) for debugging, contains results of find-possible-transitions.
  status                ; :success or :failure or nil
  eliminated            ; this situation has been eliminated.
  trace                 ; for debugging only.



  abstraction           ; (unused)
  solved                ; solved steps.
  particles             ;
  symbolic-situation	; Symbolic details are stored here.
  data                  ; complete set of state variable changes in the form of (t . <vector>).
					; this is overkill but we have it.
  time                  ; for instants its a number, for intervals its an open interval (start . end)
  qinitialized                    ; parameters have been set.
  conditions			  ; transition conditions analysis.
  active-constraints
  key
  )

;;; Removed slots from v1:
;;;  zgraph-vertex         ; zgraph vertex this corresponds to.


(defstruct symbolic-situation
  amatrix				; For linear situations (i.e., the equations in the situation are of the form x'=ax+b).
  bmatrix
  situation
  )

(defun print-situation (situation stream)
  (format stream "#<situation: ~d>" (situation-id situation)))

(defmacro situation-cell (var situation)
  `(aref (situation-values ,situation) (var-position ,var)))

;;; [04/11/2014 Johan] I changed this to a function so debugging can trap out.


(defun create-situation (type parent)
  (make-situation; :values (make-array (1+ (system-max-position *system-being-analyzed*))
		;		      :initial-element nil)
		   :type type
		   :id (incf (system-env-count *system-being-analyzed*))
		   :depth (if parent (1+ (situation-depth parent)) 0)
		   :parents (when parent (list parent))))

;; [06/07/2012 klenk] This is the abstraction of objects
(defstruct (sit-set (:print-object print-sit-set))
  sits                        ;These are the situations covered by the abstraction
  vars                        ;the variables covered by this abstraction
  next-sit-sets               ;analogous to next-situation
  display-plist               ;plist for display specific parameters
  )

(defun print-sit-set (sit-set stream)
  (format stream "#<sit-set: ~d>" (when (sit-set-sits sit-set)
				    (situation-id (car (sit-set-sits sit-set))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Variables

;; [06/08/2012 klenk] I removed qspaces from this list as it was preventing us from making discrete vars
(defmacro create-var (parent local-name &rest args)
  `(make-var :id (incf (system-max-cell *system-being-analyzed*))
	     :local-name ,local-name
	     :parent ,parent
	     :qspaces (list '(Inf- Q0 Inf+)) 
	     ,@args))

;;; [04/06/2014 Johan] replacing the macro create-var because we need to trace it for debugging.
(defun ncreate-var (parent local-name &optional fixed? fundamental-type type state-var? source dummy?)
  (make-var :id (incf (system-max-cell *system-being-analyzed*))
	    :local-name local-name
	    :parent parent
	    :qspaces (copy-tree (list '(Inf- Q0 Inf+)))
	    :fixed? fixed?
	    :fundamental-type fundamental-type
	    :type type
	    :state-var? state-var?
	    :source source
	    :dummy? dummy?
	    ))

;; [11/30/2011 klenk] Added for version 2: deriv and integral
(defstruct (var (:print-object print-var))
  id                        ; unique id.  Integer, auto-generated.
  type                      ; domain-specific type, keyword
  parent                    ; model it is part of.
  fixed?                    ; When true the value will not change...[05/07/2014 Johan] no longer true.
  discrete-var?             ; this is where you 
  dummy?
;; [11/14/2013 klenk] :flow, :through, :mode left over from v1
  fundamental-type          ; :variable, :fixed-parameter, :discrete, :time 
  local-name                ; name in parent.
  uses                      ; constraint list, all constraints which reference this var
  terminal                  ; (deprecated) if through, terminal it is about.
  node+                     ; (deprecated) if across, +
  node-                     ; (deprecated) if across, -
  equivalent-class          ; its equivalent class if any, a equivalence class struct
  eliminated                ; whether this has been eliminated -- can be computed, but this is faster.

  qspaces   ; list of qspaces (qspaces are represented by a list of symbols) ; If discrete, then the list of symbols are the values
  deriv     ; pointer to var representing the derivative for this variable
  integral  ; pointer to var representing the integral for this variable

  state-var? ; true if this is a state variable
  output-var? ; true means that the value for this variable is determined by other variables
              ; not qualitative integration



  symbolic-name	                        ; used in any symbolic compuations.***** soon to be obsolete.
  qpf-index				; pointer into the array of a qpf particle which contains parameters.
  mean					; for qpf
  sd					; for qpf.
  symbolic-state-var?			; Whether it is symbolic state-var.
  ;; These are for debugging.
  omdetails				; Details fed from om.
  why-fixed				; Reason this var is fixed.
  symbolic-only				; Only needed for symbolic analysis.
  source				; What created it.
  position				; [04/17/2014 Johan] Will be used for compacted representations as index.
  value					; [04/29/2014 Johan] Slot for storing current/temporary value.
  possible-transitions			; [04/29/2014 Johan] Slot for storing current possible transitions of this var.
  deriv-value				; [05/01/2014 Johan] Slot for storing current deriv value.***** obsolete.
  transition-table			; [05/01/2014 Johan] Slot for all transitions ever used on this variable.
  global-cell	                        ; [05/07/2014 Johan] global cell.
 )

(defun print-var (var stream)
  (format stream "#<var: ~d ~a>" (var-id var) (full-name var)))


(defstruct (equivalent-class (:print-object print-equivalent-class))
					; these vars are all equal (or -equal).
  positives
  negatives
  representative
  constraints
  merged				; in another equivalence class.
  id					;
  history)				; A debugging trace.

(defun print-equivalent-class (eclass stream)
  (format stream "#<eclass: ~d>" (equivalent-class-id eclass)))



(defstruct mode
  ;; a set of conditional equations, may be in either metamodels or models
  ;; when in a metamodel, contains a prototype set of equations for the models
  ;; when in a model, contains parsed equations for the entry condition into the mode,
  ;; the initial values of the model variables for the mode, and the equations for
  ;; that mode
  name                           ; mode name, symbol or keyword
  entry                          ; entry condition, logical expression
  initial                        ; initial variable values upon entry
  equations                      ; the parsed equations which form the constraints for the mode
  parent                         ; the model which contains this mode
  )

;;; this contains all the information relevant to var in a situation.
(defstruct (cell (:print-object print-cell))
  ;; [04/17/2014 Johan] removed id to improve space efficiency.
;  id					; unique id.
  values				; a list of datums
  var					; var it belongs to.
  situation				; situation it belongs to.
  solved				; indicates this cell has been solved.
;; [04/17/2014 Johan] This does ont appear to be used anymore.
;  statevar				; t if statevar.  *** should these be local or global.
  )

(defun print-cell (cell stream)
  (format stream "#<cell of ~a>" (cell-var cell)))

(defstruct (datum (:print-object print-datum))
  cell					; cell it belongs to.
  quantity				; values this cell might have at a time.
                                        ; For qualitative these are q-quantities
                                        ; For numeric, these are numbers
                                        ; For symoblic, these are symbols
                                        ; For modes, these are symbols
					; the actual quantity.
  type					; :qualitative, :numeric, :mode, :symbolic
;; [04/17/2014 Johan] Removed because this should be associated with the var.
;  units					; volt, ampere, meter, ...
  justifications			; like tms justifications. ; not used yet
  consequences				; like tms consequences. ; not used yet
  unknowns				; used only with maxima now.  maybe merge with quantity.
  )

(defun print-datum (datum stream)
  (if (datum-cell datum)
      (format stream "#<datum: ~a = ~a>"
	      (cell-var (datum-cell datum))
	      (datum-quantity datum))
    (format stream "#<datum: ~a>" (datum-quantity datum))))

(defstruct (q-quantity (:print-object print-q-quantity))
  value ;; a landmark or an interval
  qspace ;; a total order list of landmarks bounded by Inf- and Inf+ and includes Q0
  deriv  ;; Dec,Std,Inc 
;; [12/15/2011 klenk] nil is required when setting conditions, we will be overrighting it later, or using the 
;; [12/15/2011 klenk] completer
  )

;;;[05/16/2014 Johan] needed to make [nil:Std] print out with errors.
(defun print-q-quantity (struct stream)
;;  (print (list 'trying  (q-quantity-qspace struct) (simpleqspace? (q-quantity-qspace struct))))
  (cond ((and (q-quantity-value struct) (simpleqspace? (q-quantity-qspace struct)))
	 (format stream "[~a : ~a]" 
		 (val->simpleq struct)
		 (q-quantity-deriv struct)))
	(t
	 (format stream "[~a : ~a]" (q-quantity-value struct) (q-quantity-deriv struct)))))

(defstruct possible-transition
  ;; set of these are created for each variable in each possible situation
  ;; to hold the possible next values for that variable
  id
  variable ;var
  old-value ; q-quantity
  new-value ; q-quantity
;; [05/01/2014 Johan] This was no longer used.
;;  reason ; :continuous or :mode
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Component model library

(defvar *model-library* (make-hash-table :test #'eq))

(defstruct metamodel
  ;; the prototype for a particular model or component, like a "resistor"
  ;; These slots are storage for a parsed defprototype, see defmetamodel-1
  ;; in create-model.lisp
  id
  name               ; symbol, kept on *model-library* list
  external-variables ; used by Johan's drawing program for defining the models
  variables          ; list of variables as parsed defprototype values
  equations
  body
  internal-nodes
  modes
  source				; where it came from.
  fixed-parameters			; such as resistance.
  failures
  modelica				; corresponding modelica model.
;;; Useful for specifying the usecase
  initial-conditions
  success-conditions  ;;; not implemented yet
  failure-conditions  ;;; not implemented yet
  external-parameters
  superclasses				; a list of its superclasses (other metamodels).  Modelica :extends
  all-terminals				; after scanning superclasses
  all-variables				; after scanning superclasses
  all-equations				; after scanning superclasses
  all-components
  )



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Constraints

;;; all constraints include this.
(defstruct (constraint (:print-object print-constraint))
  id
  variables  ; variables in the equation				
  equation   ; lisp form of the equation represented by this constraint
  waiting    ; queue of waiting vars to propagate
  condition  ; logical condition that needs to hold for the constraint to be active
  eliminated ; boolean flag this constraint has been eliminated
  source     ; contains a model, kind of like a "parent" slot
  function ; called with self, and either a datum or a list of possible transitions
           ; When called with a datum, if a variable in the contraint is unknown, and
           ; can be computed from the situation pointed at by the datum, will evaluate
           ; the value of the unknown variable, if possible.  Otherwise, it simply
           ; computes a boolean as to whether the constraint is satisfied.
  consistent-transitions ; internal slot -- this is determined in step 3 of the envisionment algorithm
  ;; It contains the table of allowable values for this constraint, given
  ;; possible-transitions.
;;; [04/17/2014 Johan] to optimize:
  situation-val		 ; This constraint has set a value in this situation.
  situation-dir          ; This constraint has set a value in this situation.
  adjacents		 ; Used in envisionment algorithm.
  )

(defun print-constraint (constraint stream)
  (format stream "#<~A : ~A>" (type-of constraint)  (constraint-id constraint)))

(defun constraint-variable-count (constraint)
  (length (constraint-variables constraint)))

(defstruct (general-summer-constraint (:include constraint))
  ;; sum of variables must equal zero, or results if specified.
  pos-vars                              ; variables to be added
  neg-vars                              ; variables to be subtracted
  qr-only				; If t, means it only appears for qr.
  ;; For debugging.
  history
  opos-vars
  oneg-vars
  results
  )

(defstruct (multiply-constraint (:include constraint))
  ;; V = iR
  result                                ; left-hand side (must be a single variable)
  multiplicands                         ; right hand side (list of vars to be multiplied)
  polarity                              ; when true, qualitatively invert result before comparison
  ;; For debugging:
  updates
  oresult
  omultiplicands
  opolarity
  )     

(defstruct (qset-constraint (:include constraint))
  ;; r = q+
  var                                   ; single var
  constant                              ; number, or symbol denoting a landmark, or interval
                                        ; represented by list of two landmarks
  ) 

;;; [04/17/2014 Johan] Note this

(defstruct (qequal-constraint (:include constraint))
  ;; two vars are equal or opposite
  var1
  var2
  polarity ; When '+ var1 Q= var2 and '- var1 Q= (- var2)
  )

(defstruct (set-mode-constraint (:include constraint))
  ;; this mode variable is in this mode
  mode-var                              ; var
  mode-name)                            ; name of mode (symbol)

;; [12/13/2011 klenk] deriv constraints are not used by the completer. They are only used when computing
;; [12/13/2011 klenk] transition sets
;; [04/17/2014 Johan] Note this only relates x and dx/dt.  Not higher order.
(defstruct (deriv-constraint (:include constraint))
  ;; v = der(position)
  var                                   ; variable, e.g. position
  deriv                                 ; variable which is the derivative of "var", e.g. velocity
  polarity   ; + or -
  )

(defstruct (power-constraint (:include constraint))
  ;; (= result (power base exp)) assumes that exp is a positive integer
  base                                   ; variable, e.g. position
  result					; variable which is the derivative of "var", e.g. velocity
  exp        ; an integer
  base-polarity   ; + or -
  result-polarity ; + or -
  )

;; [11/ 7/2013 klenk] Greater than constraint  evaluates (> lhs rhs)
(defstruct (gt-constraint (:include constraint))
  lhs
  rhs 
  invert?
  )


;; [12/ 6/2012 klenk] Modelica when equation
(defstruct (mod-when (:include constraint))
  trigger                                   ; condition when pre(false) and true, then the equation is evaluated in the 
  equ				    ; currently just a list, and car needs to be reinit
  )

(defstruct (interpolation (:include constraint))
  u  ; input var
  y  ; output var
  table	; a list of triples (<input-range><output-range><deriv-relationship>)
  symbolic-table ; the symbolic array used by Modelica
  )

;; [06/ 4/2013 klenk]sin(x) would have the qspace for x be (-inf 0 1 2 3 4 (:goto 0) inf)
;; Then when there was a transition to 4, we would know that it was actually a transition to 0 
(defstruct (piecewise-monotonic-fn-1-arg (:include constraint))
  u ; input var
  y ; output var
  fn ; a list of triples (<input-val><output-cal><deriv-relationship>)
     ; <deriv-relationship> is + same, - opposite, and 0 means the output var deriv is 0
     ; This should cover the entire input space
  )

;;; v1 = pre(v2)
;;; v1 is an output variable and is only computed after transitions for v2
(defstruct (modelica-pre (:include constraint))
  result ;; v1
  var  ;v2
  )
				   

				   
				   
  
			  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: chatter.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: February 02, 2012 18:31:20
;;;;   Purpose: This will identify terminal intervals that are actually chatterboxes
;;;;            At this point, we will simply add the remaining edges.
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, February 02, 2012 at 18:41:21 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(defun add-chatter-boxes ()
  (dolist (terminal (terminal-situations))
    (when (eql (situation-complete terminal) :possible-terminal-interval)
      (setf (situation-complete terminal) t)
      (let ((chatter-instant (find-parent-situation terminal)))
	(when chatter-instant
	  (push chatter-instant (situation-children terminal))
	  (push terminal (situation-parents chatter-instant)))))))
	    


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: completer.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 07, 2011 17:02:16
;;;;   Purpose: The completer propogates qualitative values through constraints
;;;;            and returns a list of situations in which every variables has a value in every qspace
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Friday, November 15, 2013 at 09:50:01 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

; A discrete transition is necessary to pass in because we need to know what the 
; active constraints were in the previous interval
; When equations ;;;; NOT IMPLEMENTED YET!!! DISCRETE 
; newly-active is the set of constraints that must be true in the right instant
; copy-known-constant-variables-for-transition
;     - identify which variables cannot change mag for the transition 
;     - identify which variables cannot change dir for the transition 
; run-completer 
;     - effectively plunk each unknown mag and deriv
; return all possible right instants
;; [08/27/2012 klenk] Newly-active is now the complete set of constraints that are active in the new situation
;; [09/06/2012 klenk] left-instant is really a pseudo-instant
;; [04/18/2014 klenk] we know that a modelica even occured between left-instant and its parent.
(defun next-situations-discrete (left-instant newly-active)
  (let ((next-partial-sit (create-situation :instant left-instant))
	(right-instants)
	(*debug?* nil)
	)
    (copy-fixed-parameters left-instant next-partial-sit)
    (perform-when-equations left-instant next-partial-sit)
    (if (eql (run-constraints next-partial-sit) :fail) (error "~% incompatible when ~A" next-partial-sit))
    (copy-known-constant-vars-for-transition left-instant next-partial-sit newly-active)
;; [08/27/2012 klenk] nothing happens at this step currently, because all
;; [09/07/2012 klenk] discrete variables should be set by constraints
    (determine-discrete-values left-instant next-partial-sit newly-active)
    (if (eql (run-constraints next-partial-sit newly-active) :fail) 
	(debug-print nil "~% incompatible known-constant-values ~A" next-partial-sit)
	(progn 
	  (debug-print nil "~%--- Partial Right Instant after Discrete Changes ~A" next-partial-sit)
	  (debug-print nil "~% ~A" (with-output-to-string (stream) (print-vars next-partial-sit :stream stream)))
;	  (debug-break)
	  (let ((full-situations (run-completer next-partial-sit left-instant newly-active)))
	    ;;*** just for dx;
;	    (dolist (sit full-situations) (all-knownp sit))

	    (debug-print nil "~% completer results in ~A Situations" (length full-situations) )
;;	    (unless (= (length full-situations) 1) (error "Ambiguous discrete transition ~A" (length full-situations)))
	    (dolist (right-instant full-situations)
;	      (format t "~% right-instant ~a is interned ~a"
;		      right-instant (situation-is-interned right-instant))

	      ;; Debugging****
	      ;;
;	      (unless (situation-is-interned right-instant) (error "Cannot happen"))

	      (push :discrete-transition  (situation-trace next-partial-sit))
	      (let ((old (find-situation right-instant)))
		
;;; [4/11/2014 Johan] Does this do the right thing?
;;; Commented out just to test more.
		(cond (nil old (pushnew left-instant (situation-parents old))
			   (pushnew old (situation-children left-instant))
			   (when (discrete-transition? left-instant old)
			     (dolist (new-right-instant
					 (next-situations-discrete old 
								   (active-constraints old)
					;(newly-active-constraints sit parent)
								   ))
;			       (assert (not (event-loop? new-right-instant)))
			       (push new-right-instant right-instants))))

			     


;; [06/04/2012 klenk] Per danny's suggestion, we not worry about condensing the graph by identifying duplicate right instants
		;; (old (pushnew left-instant (situation-parents old))
		;;      (pushnew old (situation-children left-instant))
		;;      (debug-print t "~%--- Found old right Instant ~A" right-instant)
		;;      (debug-print nil "~% ~A" (with-output-to-string (stream) (print-vars next-partial-sit :stream stream))))
		((discrete-transition? left-instant right-instant)
		 (debug-print nil "~%Discrete transition chain ~A creating right instants" right-instant)
		 (add-system-situation right-instant)
		 (push right-instant (situation-children left-instant))
		 
		 (dolist (new-right-instant
			   (next-situations-discrete right-instant 
						     (active-constraints right-instant)
					;(newly-active-constraints sit parent)
						     ))
		   (assert (not (event-loop? new-right-instant)))
		   (push new-right-instant right-instants)))
		(t
		 (debug-print nil "~%--- Right Instant ~A" right-instant)
		 (debug-print nil "~% ~A" (with-output-to-string (stream) (print-vars next-partial-sit :stream stream)))
		 (pushnew left-instant (situation-parents right-instant))
		 (pushnew right-instant (situation-children left-instant))
		 (add-system-situation right-instant)
		 (pushnew right-instant right-instants)))))
	 ;   (unless (< (length right-instants) 2) (error "discrete-ambiguity!"))
	  right-instants
	  )))))


;; [09/07/2012 klenk] This function looks to identical situations within the event
(defun event-loop? (sit)
  (declare (ignore sit)))

	  

;; [06/01/2012 klenk] We copy over the vars that are provably constant between the 
;; [06/01/2012 klenk] left and right instant.
;; [06/01/2012 klenk] The following groups have the same magnitude
;; [06/01/2012 klenk] 1) All state vars (and their associated landmark vars)
;; [06/01/2012 klenk] 2) Variables whose equations in terms of the state variables is constant
;; [06/01/2012 klenk] 3) Variables defining the discrete transition
;; [06/01/2012 klenk] Is there a class of variables who we know their derivatives are constant?
;; [06/01/2012 klenk]    - The state variables who's constitutent equations are the same?
;; [09/ 8/2012 klenk] New Idea: Identify which vars may change in magnitude by the change in constraints
;; [09/ 8/2012 klenk] And then propagate through the constraints
(defun copy-known-constant-vars-for-transition (left-instant right-instant newly-actives)
  (dolist (var 
	    ;(remove-if-not #'var-state-var? (quantity-vars))) 
	    (known-constant-vars-for-transition left-instant newly-actives))
    (unless (qualitative-values var right-instant)
      (clobber var 
	       (create-q-quantity 
		var
		(q-quantity-value (car (qualitative-values var left-instant))) nil nil)
	       right-instant '((:state-var-discrete)))))
  
;; [06/29/2012 klenk] Discrete vars are set by the quantity-vars
;; [06/29/2012 klenk] This will not work if there is a conjunction in the condition
;; [06/29/2012 klenk] involving a discrete var and a continuous var
  )

(defun copy-fixed-parameters (left right)
  (dolist (fixed-var (fixed-parameters))
    (assert (= (length (var-qspaces fixed-var)) 1))
    (clobber fixed-var 
	     (create-q-quantity 
	      fixed-var
	      (q-quantity-value (car (qualitative-values fixed-var left)))
	      (car (var-qspaces fixed-var)) 
	      'Std)
	     right '((:state-var-discrete)))))


;; [06/01/2012 klenk] place holder for call out to MACSYMA or OpenModelica
;; [08/27/2012 klenk] Johan suggests plunking everything
;; [08/27/2012 klenk] Therefore I'm going to implement the transition of (1) state vars
;; [09/ 8/2012 klenk] Plunking everything leads to too many situations. Now we are implementing the
;; [09/ 8/2012 klenk] variable propagation method
(defun known-constant-vars-for-transition (parent active-constraints)
;; [09/ 8/2012 klenk]  possibly the newly active constraints should be considered processed already
;; [09/ 8/2012 klenk] This would provide some directionality in the discrete change
;; [09/ 8/2012 klenk] This does not make a difference for the first one
  (multiple-value-bind (possibly-changed-vars processed-constraints) 
      (changing-vars parent)
    (let ((queue (remove-if-not #'(lambda (constraint)
				    (and (some #'(lambda (var) (member var (constraint-variables constraint)))
					       possibly-changed-vars)
					 (not (member constraint processed-constraints))))
				active-constraints)))
      (do nil
;; [09/10/2012 klenk] We may also want to consider that a possibly-changed-var should be considered constant if
;; [09/10/2012 klenk] we can prove it from things that are constant in this discrete transition.
	  ((null queue) (remove-if #'(lambda (var)
				       (member var possibly-changed-vars))
				   (quantity-vars)))
	(let ((constraint (pop queue)))
	  (debug-print nil "~% constraint : ~A" constraint)
	  (push constraint processed-constraints)
	  (dolist (var (constraint-variables constraint))
	    (unless (or (var-state-var? var)
			(var-fixed? var)
			(member var possibly-changed-vars))
	      (debug-print nil "~%     Adding ~A to possibly-changed-vars : ~A" var possibly-changed-vars)
	      (push var possibly-changed-vars)
	      (dolist (constraint active-constraints)
		(when (and (member var (constraint-variables constraint))
			   (not (member constraint processed-constraints)))
		  (pushnew constraint queue))))))))))
  
	    


;; [09/ 8/2012 klenk] Identify the vars that occur in constraints that are no longer valid and in newly valid constraints 
(defun changing-vars (sit)
;;; [04/11/2014 Johan] I do not understand what this is checking for.
;; [04/18/2014 klenk] To allow for multiple parents, then we need to ensure that they all have the same constraints.
;  (assert (every #'(lambda (parent)
;		     (equal (active-constraints parent)
;			    (active-constraints (car (situation-parents sit)))))
;		 (cdr (situation-parents sit))))
  (multiple-value-bind (old new)
;; [04/18/2014 klenk] This assumes there is only one parent
      (constraint-difference sit (car (situation-parents sit)))
;    (debug-print t "~%constraint differences: ~% old: ~A ~% new: ~A" old new)
;    (debug-print t "~% Adding ~A to possibly changed vars" (remove-if #'var-state-var?
;								      (intersection (mapcan #'constraint-variables old)
;										    (mapcan #'constraint-variables new))))
    (values (remove-if #'(lambda (var)
			   (or (var-state-var? var)
			       (var-fixed? var)
			       (discrete-var? var)))
		       (intersection (mapcan #'(lambda (con)
						 (copy-list (constraint-variables con)))
					     old)
				     (mapcan #'(lambda (con)
						 (copy-list (constraint-variables con)))
					     new)))
	    new)))
  ;(remove-if-not #'var-state-var? (quantity-vars *system-being-analyzed*)))




;; [05/29/2012 klenk] This will perform discrete value updates resulting from when equations
;; [05/29/2012 klenk] Is there any when equation condition that is newly satisfied
(defun perform-when-equations (left-instant next-partial-sit)
  (dolist (when-event (when-events left-instant (car (situation-parents left-instant))))
    (ecase (car (mod-when-equ when-event))
      (reinit
       (clobber (second (mod-when-equ when-event))
		(evaluate-q=-arg (third (mod-when-equ when-event)) left-instant)
		next-partial-sit
		'((reinit)))))))
       


(defun when-events (child parent)
  (remove-if-not #'(lambda (mod-when)
		     (and (not (evaluate-condition-tv (mod-when-trigger mod-when)  parent))
			  (evaluate-condition-tv (mod-when-trigger mod-when)  child)))
		 (system-when-equations *system-being-analyzed*)))


;; [06/25/2012 klenk] The newly-active constraints are the ones which must be so
;; [06/26/2012 klenk] Therefore we run the constraints and assign values
;; [06/26/2012 klenk] Then we copy over the rest
;; [08/27/2012 klenk] No longer do we assume next-partial-sit is comnplete
;; [08/27/2012 klenk] Instead we will just do plunking galore. One potential problem is 
;; [08/27/2012 klenk] how to deal with chains of discrete transitions? Do we just wait until
;; [08/27/2012 klenk] the following interval to recognize it? That seems pretty terrible
(defun determine-discrete-values (left-instant next-partial-sit newly-actives)
  (declare (ignore left-instant next-partial-sit newly-actives))
;;   (when (eql (run-constraints next-partial-sit newly-actives) :fail)
;;     (error "new discrete-values are incompatible with known values"))
;; ;; [06/25/2012 klenk] assume unknown discrete values have not changed
;;   (dolist (var (discrete-vars))
;;     (unless (discrete-value var next-partial-sit)
;;       (clobber var (discrete-value var left-instant)
;; 	       next-partial-sit '((:discrete-var-discrete)) :discrete)))
;; ;; [06/25/2012 klenk] If this occurs, we need to copy next-partial-sit except for some 
;; ;; [06/25/2012 klenk] of the discrete values mentioned in consequences of the new constraints
;;   (assert (not (newly-active-constraints left-instant next-partial-sit)))
  )



;; [01/ 3/2012 klenk] 1) Clobber each of the mode vars in the system
;; [01/ 3/2012 klenk] 2) Run the constraints
;; [01/ 3/2012 klenk] 3) Run the completer to create the following intervals
(defun next-situations-discrete-modes (left-instant)
  (confirm-uses-gone)
  (debug-print nil "~%--- Discrete Transition from ~A" left-instant)
  (let ((right-instant (create-right-instant-modes left-instant)))
    (when right-instant
      (let ((possible-transitions (instants->interval-transitions left-instant right-instant))
	    (active-constraints (active-constraints right-instant)))
        (filter-global-situations ;; Step 6
	 (create-next-sit-interpretations ;; Step 5
	  (pairwise-constraint-filtering ;; Step 4
	   (local-constraint-filtering possible-transitions active-constraints)))  ;; Step 3
	 right-instant))))) 

;; [01/16/2012 klenk] There should be a check here for steady-state left-instant and right-instant
;; [05/18/2014 Johan] Do not clobber globals.
(defun create-right-instant-modes (left-instant)
  (let ((next-partial-sit (create-situation :instant left-instant)))
    (dolist (comp (system-mode-components *system-being-analyzed*))
      (unless (var-global-cell (model-mode comp))
	(let ((new-mode (next-component-mode comp left-instant)))
	  (cond 
	   (new-mode 
	    (debug-print nil "~% New mode ~A for component ~A" (mode-name new-mode) comp)
	    (set-mode (model-mode comp) (mode-name new-mode) next-partial-sit))
	   (t
	    (clobber (model-mode comp) (mode-value (model-mode comp) left-instant)
		     next-partial-sit '((:unchanged-mode)) :mode))))))
    (debug-print nil "~%--- Partial Right Instant ~A" next-partial-sit)
    (debug-print nil "~% ~A" (with-output-to-string (stream) (print-vars next-partial-sit :stream stream)))
    
    (if (eql (run-constraints next-partial-sit) :fail)
	(debug-print nil "~% Impossible right instant ~A" next-partial-sit)
	(progn 
	       (debug-print nil "~%--- Partial Right Instant (after constraints) ~A" next-partial-sit)
	       (debug-print nil "~% ~A" (with-output-to-string (stream) (print-vars next-partial-sit :stream stream)))
	       (set-derivs next-partial-sit)
	       (attach-to-envisionment-modes left-instant next-partial-sit)))))

;; [05/29/2012 klenk] This does not use any of QRMs built in mode machinery
;; [05/29/2012 klenk] Process when equations (not implemented)
;; [05/29/2012 klenk] Run constraints
;; [05/29/2012 klenk] inherit qualitative magnitudes of state vars
;; [05/29/2012 klenk] run constraints
;; [05/29/2012 klenk] 


;; [01/16/2012 klenk] Check for steady state
(defun attach-to-envisionment-modes (left-instant right-instant)
  (add-system-situation right-instant)
  (push right-instant (situation-children left-instant))
  (setf (situation-complete right-instant) t)
  (unless (instant-instant-steady-state? left-instant right-instant)
    right-instant
    ))



;; [12/05/2011 klenk] every var's deriv is zero
(defun instant-instant-steady-state? (left right)
  (every #'(lambda (var)
	     (let ((qvals (if (qualitative-values var right)
			      (qualitative-values var right)
			      (qualitative-values var left))))
;; [01/17/2012 klenk] Could the right side have no deriv? If so this could result in errors
	       (eql (q-quantity-deriv (car qvals)) 'Std)))
	(quantity-vars *system-being-analyzed*)))


    
(defun instants->interval-transitions (left-instant right-instant)
  (let (changes)
    (dolist (var (quantity-vars *system-being-analyzed*))
      (unless (var-eliminated var)
	(dolist (left-value (qualitative-values var left-instant))
	  (dolist (change (instants->interval-trans-for-var var left-value right-instant))
	    (debug-print nil " ~A " (print-transition change nil))  
	    (when (finite-transition? change)
	      (push change changes)))
	  )))
    changes))

(defun instants->interval-trans-for-var (var left-value right-instant)
  (cond ((qualitative-value-in-qspace var right-instant (q-quantity-qspace left-value))
	 (transitions var :instant 
		      (qualitative-value-in-qspace var right-instant (q-quantity-qspace left-value))))
	(t (transitions var :instant left-value)))) 




;;;Likely move the above code to the envisioner. Likely remove the previous sit argument from run-completer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;   Purpose: The completer propogates qualitative values through constraints
;;;;            and returns a list of situations in which every variables has a value in every qspace
;;;;            Every q-qauntity has a deriv of Std unless it has an explicit deriv
(defun run-completer (partial-sit left-instant &optional active-constraints)


;  (format t "~% Running completer on ~a" partial-sit)
;  (print-vars partial-sit)


;  (error "stop")

;  (if (= (situation-id partial-sit) 3)
;      (print-vars partial-sit))


;  (if (= (situation-id partial-sit) 3)
;      (error "stop"))

  (let ((failed? (eql (run-constraints partial-sit active-constraints) :fail)))
    (debug-print nil "~%Running completer on sit ~A : ~A ~%~A" partial-sit 
		 failed?
		 (with-output-to-string (stream)
		   (print-vars partial-sit :stream stream
			       :fixed-parameters? t)))
    (multiple-value-bind (unknownv unknownd) 
	(any-unknowns partial-sit)
;      (print (list unknownv unknownd failed?))
      (cond (failed? nil);;*** why not test earlier????******
	    ((and (null unknownv)
		  (null unknownd))
;	     (check2-clobbered)
	     (push :completer-generated (situation-trace partial-sit))
	     (list partial-sit))
	    ((and (null unknownv)
		  unknownd)
	     (set-derivs partial-sit)
;	     (check2-clobbered)
	     (push :completer-generated (situation-trace partial-sit))
	     (list partial-sit))
	    ((unknown-discrete-vars-with-pre-values partial-sit left-instant)
;	     (print 'A)
;	     (check2-clobbered)
	     (push :completer-generated (situation-trace partial-sit))
	     (inherit-discrete-vars partial-sit left-instant active-constraints))
	    (t
;	     (print 'D)
	     (mapcan #'(lambda (new-sit)
			 (run-completer new-sit left-instant active-constraints))
		     (plunk-var (var-to-plunk partial-sit) partial-sit left-instant
				active-constraints)))))))

;; [09/ 2/2012 klenk] If there is a known pre-value, then we should use it
;; [09/ 2/2012 klenk] A more faithful to Modelica definition would look for a
;; [09/ 2/2012 klenk] constraint with an initial() in it, and ensure that it was
;; [09/ 2/2012 klenk] false first
(defun unknown-discrete-vars-with-pre-values (partial-sit left-instant)
   (remove-if-not #'(lambda (var)
		      (and (discrete-var? var)
			   (discrete-value-symbol var left-instant)
			   ))
		  (unknown-vars partial-sit)))

;; [09/ 2/2012 klenk] THIS DOES NOT WORK BECAUSE THE STUCK v. UNKNOWN PROBLEM 
(defun inherit-discrete-vars (partial-sit left-instant active-constraints)
  (error "outdated code")
  (dolist (var (unknown-discrete-vars-with-pre-values partial-sit left-instant))
    (clobber var (discrete-value-symbol var left-instant) partial-sit '((:init))))
  (run-completer partial-sit left-instant active-constraints))

;;;[05/12/2014 Johan] modified to handle global.
(defun create-situation-copy (sit)
  (let ((new-sit (if (situation-parents sit)
		     (create-situation (situation-type sit)
				       (car (situation-parents sit)))
		     (create-situation (situation-type sit) nil))))
     (dolist (var (system-active-variables *system-being-analyzed*))
      (unless (var-global-cell var)
	(dolist (value (values-in-situation var sit))
	  (clobber var (datum-quantity value) new-sit
		   (car (datum-justifications value))
		   (datum-type value)))))
    new-sit
    ))


;;; [04/17/2014 Johan] same as old version, but more efficient.
;;; Returns first unknown var.
(defun var-to-plunk (sit)
  (dolist (var (system-active-variables *system-being-analyzed*))
    (cond ((var-global-cell var))
	  ((and (mode-var? var) (mode-value var sit)))
	  ((all-qvalues-for-var-known-new? var sit))
	  (t (return-from var-to-plunk var)))))

(defun unknown-vars (sit)
  (remove-if #'(lambda (var)
		 (or
;; [06/12/2012 klenk] fixed parameters should be known. They are important.
;; [03/16/2012 klenk] Use parameter-p if needed in the future
;		     (eq (var-fundamental-type var) :fixed-parameter)
;                     (parameter-p var)
;                     (var-fixed? var)
		  (var-global-cell var)
		     (and (mode-var? var) (mode-value var sit))
		     (all-qvalues-for-var-known? var sit)))
    (system-active-variables *system-being-analyzed*)))

;; [05/30/2012 klenk] If the left-instant has a magnitude does not violate the constraints, use it
;; [08/27/2012 klenk] This is very arbitrary, Ignoring the left-instant is more complete
(defun plunk-var (var sit left-instant active-constraints)
  (declare (ignore left-instant))
  (plunk-unknown-qspace var sit active-constraints))
;;   (let ((values (when left-instant (qualitative-values var left-instant)))
;; 	(new-sit (create-situation-copy sit)))
;;     (assert (or (null values)(= (length values) 1)))
;;     (cond (left-instant
;; ;; [08/06/2012 klenk] This assumption is built into earlier code so this should not be 
;; ;; [08/06/2012 klenk] necessary. When we relax it, it will be easier to fix if it is 
;; ;; [08/06/2012 klenk] in one place
;; 	   (error "This code assumes that all values are continuous")
;; 	   (clobber var (create-q-quantity 
;; 			 var
;; 			 (q-quantity-value (car values)) nil nil)
;; 		    new-sit '((:state-var-discrete)))
;; 	   (if (eq (run-constraints new-sit) :fail)
;; 	       (plunk-unknown-qspace var sit)
;; 	       (list new-sit)))
;; 	  (t  (plunk-unknown-qspace var sit)))))



;;; [04/17/2014 Johan] optimized a bit.
;;; Note that if a derivative is set to nil in clobber, this will set it to 'Std.  Do we want that behavior?
(defun set-derivs (sit)
  (debug-print nil "~% Completer setting derivs of ~A" sit)
  (dolist (var (system-active-variables *system-being-analyzed*))
    (cond ((var-global-cell var))
	  ((all-derivs-known var sit))
	  ((var-deriv var) 
	   (ecase (simple-qvalue (var-deriv var) sit)
	     (Q+ (set-deriv var 'Inc sit))
	     (Q0 (set-deriv var 'Std sit))
	     (Q- (set-deriv var 'Dec sit))))
	  (t
	   (set-deriv var 'Std sit)))))

(defun set-deriv (var deriv sit)
  (dolist (q-quantity (qualitative-values var sit))
    (assert (null (q-quantity-deriv q-quantity)))
    (setf (q-quantity-deriv q-quantity) deriv)))

;; [12/18/2011 klenk] This is not used currently. For now, assume unknown derivs are Std
(defun plunk-derivs (var sit active-constraints)
  (debug-print nil "~%Plunking deriv for var ~A in ~A" var sit)
  (let (ret)
    (dolist (deriv '(Dec Std Inc) ret)
      (let ((new-sit (create-situation-copy sit)))
	(dolist (qvalue (qualitative-values var new-sit))
	  (let ((new-qvalue (create-q-quantity var (q-quantity-value qvalue) 
					       (q-quantity-qspace qvalue) deriv)))
	    (clobber var new-qvalue sit '((plunk)) :qualitative)))
	(unless (eq (run-constraints new-sit active-constraints) :fail) 
	  (push new-sit ret))))))

(defun try-clobber (var value sit justification)
  (catch :contradiction
    (clobber var value sit justification) :succeed))

;; [12/15/2011 klenk] Only do simpleq and can't handle multiple qspaces yet
;; [08/27/2012 klenk] If discrete, then the space of values is pretty clear
(defun plunk-unknown-qspace (var sit active-constraints)
;  (format t "~% Plunking ~a in ~a" var sit)
;  (check2-clobbered)
  (cond ((discrete-var? var)
	 (plunk-discrete-var var sit active-constraints))
	(t 
	 (plunk-continuous-var var sit active-constraints))))


(defun complete-discrete-values (left-limit)
  (let ((unknown-discrete-vars 
	 (remove-if #'dummy-var? (unknown-discrete-vars left-limit))))
  (if (null unknown-discrete-vars)
      (list left-limit)
      (remove 
       nil
       (mapcan #'(lambda (val)
		   (clear-constraints)
		   (let ((new-sit (create-situation-copy left-limit)))
		     (clobber (car unknown-discrete-vars)
			      val new-sit '((plunk)) :discrete)
;; [06/21/2013 klenk] We can't run the constraints on the pre-values
		     ;(unless (eq (run-constraints new-sit) :fail)
		     ;  (debug-print nil "~%created new sit: ~A" new-sit)
		       (complete-discrete-values new-sit)
		       ))
	       (vals-for-discrete-var (car unknown-discrete-vars)))))))

(defun vals-for-discrete-var (var)
  (car (var-qspaces var)))

;; [08/27/2012 klenk] All discrete vars should be set by constraints
;; [08/31/2012 klenk] In Modelica, if the value is not changed then it is the parents value
(defun plunk-discrete-var (var sit active-constraints)
  (error "should not happen anymore, use complete-discrete-values")
  (debug-print nil "~%Plunking discrete var ~A in ~A" var sit)
  (assert (= (length (var-qspaces var)) 1))
  (let ((pre-value (determine-pre-value var sit))
	(ret))
    (cond (pre-value
	   (clobber var pre-value sit '((:unchanged-discrete)))
	   (unless (eq (run-constraints sit active-constraints) :fail)
	     sit))
	  (t
	   (dolist (value (car (var-qspaces var)) ret)
	     ;; [08/06/2012 klenk] Need to clear out the system-queue before doing this
	     (clear-constraints)
	     (let ((new-sit (create-situation-copy sit)))
	       (clobber var value new-sit '((plunk)))
	       (unless (eq (run-constraints new-sit active-constraints) :fail)
		 (debug-print nil "~%created new sit: ~A" new-sit)
		 (push new-sit ret)))))
	  )))

;;;[05/16/2014 Johan] Again.  I don't understand how this could possibly have worked.
(defun plunk-continuous-var (var sit active-constraints)
  (if (var-global-cell var) (error "should not get here"))
;  (check2-clobbered)
  (let* ((qvalues (qualitative-values var sit))
	 (unknown-qspaces (remove-if #'(lambda (qspace)
					 (member qspace qvalues 
						 :key #'q-quantity-qspace))
				     (var-qspaces var))))
    (cond ((= (length unknown-qspaces) 1)
	   (debug-print nil "~%Plunking var ~A in ~A" var sit)
	   (plunk-continuous-values var sit active-constraints unknown-qspaces)
	   (let (ret)
	     (dolist (value 
		       (q-quantities-for-var var unknown-qspaces)
					;:derivs '(Std)) ret
		      ret)
;; [08/06/2012 klenk] Need to clear out the system-queue before doing this
	       (clear-constraints)
	       (let ((new-sit (create-situation-copy sit)))
;		 (format t "~% Plunking ~a = ~a" var value)
		 (when (eq (try-clobber var value new-sit '((plunk))) :succeed)
                   (unless (eq (run-constraints new-sit active-constraints) :fail)
                     (debug-print nil "~%created new sit: ~A" new-sit)
                     (push new-sit ret)))))))
	  ((and qvalues (null (cdr qvalues)))
	   (plunk-continuous-values var sit active-constraints (list (q-quantity-qspace (car qvalues)))))
	  (t (error "Stub plunk-unknown-qspace")))))

(defun plunk-continuous-values (var sit active-constraints unknown-qspaces)
  (let (ret)
    (dolist (value 
		(q-quantities-for-var var unknown-qspaces)
					;:derivs '(Std)) ret
	      ret)
      ;; [08/06/2012 klenk] Need to clear out the system-queue before doing this
      (clear-constraints)
      (let ((new-sit (create-situation-copy sit)))
					;		 (format t "~% Plunking ~a = ~a" var value)
	(when (eq (try-clobber var value new-sit '((plunk))) :succeed)
	  (unless (eq (run-constraints new-sit active-constraints) :fail)
	    (debug-print nil "~%created new sit: ~A" new-sit)
	    (push new-sit ret)))))))


;;; [04/07/2014 Johan] 
(defun unknown-vars (sit)
  (remove-if #'(lambda (var)
		 (or 
;; [06/12/2012 klenk] fixed parameters should be known. They are important.
;; [03/16/2012 klenk] Use parameter-p if needed in the future
;		     (eq (var-fundamental-type var) :fixed-parameter)
;                     (parameter-p var)
;                     (var-fixed? var)
		  (var-global-cell var)
		  (and (mode-var? var) (mode-value var sit))
		  (all-qvalues-for-var-known-new? var sit)))
    (system-active-variables *system-being-analyzed*)))

;;; [04/07/2014 Johan] 
;;; Often unknown-vars is called just to check unknowness.  This wastes conses and cpu-time.
;;; any-knowns does one sweep through the sit's variables.  Returns two values [unknownv, unknownd]
(defun any-unknowns (sit)
  (let ((unknownv)
	(unknownd))
    (dolist (var (system-active-variables *system-being-analyzed*))
      (unless (var-global-cell var)
	(cond (unknownv)
	      ((and (mode-var? var) (mode-value var sit)))
	      ((all-qvalues-for-var-known-new? var sit))
	      (t (setq unknownv t) (if unknownd (return-from any-unknowns (values t t)))))
	(cond (unknownd)
	      ((all-derivs-known var sit))
	      (t (if unknownv (return-from any-unknowns (values t t)))
		 (setq unknownd t)))))
    (values unknownv unknownd)))

;; [06/21/2013 klenk] This is all qspaces unless the var is a fixed parameter, phyisical
;; [06/21/2013 klenk] quantity which must be positive (e.g., Moment of Inertia)
(defun q-quantities-for-var (var unknown-qspaces)
  (if (and (physical-fixed-quantity? var)
	   (simpleqspace? (car unknown-qspaces)))
      (list (make-q-quantity :value '(Q0 Inf+)
			     :qspace (car unknown-qspaces)
			     :deriv 'Std))
      (all-finite-q-quantities (car unknown-qspaces))))

(defun physical-fixed-quantity? (var)
  (and (var-fixed? var)
       (member (var-type var) '(env2-names::|Modelica.SIunits.Inertia|))))

(defun unknown-discrete-vars (sit)
  (remove-if #'(lambda (var)
		 (or (var-fixed? var)
		     (discrete-value var sit)))
	     (discrete-vars *system-being-analyzed*)))

(defun known-vars (sit)
  (error "called?")
  (remove-if #'(lambda (var)
		 (or (and (mode-var? var) (not (mode-value var sit)))
		     (not (all-qvalues-for-var-known? var sit))))
	     (system-active-variables *system-being-analyzed*)))

(defun all-derivs-known (var sit)
  (every #'q-quantity-deriv
	 (qualitative-values var sit)))

(defun all-knownp (situation)
  (let ((unknowns (unknown-vars situation)))    
    (when unknowns
      (dolist (var unknowns)
        (format t "~%~A is unknown in situation ~A~%" var situation))
      (error (format nil "Unknowns ~A in situation ~A" unknowns situation)))
    t))

;;; [05/16/2014 Johan] .
;;; This just checks that quantity spaces are there, not that the values are????????
(defun all-qvalues-for-var-known? (var situation)
  (let ((qvalues (qualitative-values var situation)))
    (every #'(lambda (qspace)
	       (let ((ret (find qspace qvalues :key #'q-quantity-qspace :test 'equal)))
		 ret
		 ))
	   (var-qspaces var))))

;;; This makes sure they all have a value too.
(defun all-qvalues-for-var-known-new? (var situation)
  (let ((qvalues (qualitative-values var situation)))
    (every #'(lambda (qspace)
	       (let ((ret (find qspace qvalues :key #'q-quantity-qspace :test 'equal)))
		 (and ret (q-quantity-value ret))
		 ))
	   (var-qspaces var))))

;(defun all-qvalues-for-var-known-new? (var situation)
;  (dolist (datum (values-in-situation var situation) t)
;    (and (eq :qualitative (datum-type datum))
;	 (datum-quantity datum)
;	 (null (q-quantity-value (datum-quantity datum)))
;	 (return nil))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: construct-constraints.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December  1, 2011 09:12:19
;;;;   Purpose: creates constraints (and constraint handlers) for both transition sets
;;;;            and datums
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, January 08, 2014 at 14:01:05 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

;; [02/01/2012 klenk] Create a summer constraint where the exp must evaluate to 0
(defun construct-summer-from-exp (exp condition source)
  (ecase (car exp)
    (+ (construct-summer (cdr exp) nil condition source))))

;;; Store a constraint of the system
;;; Have a separate function for this because we may change this.
(defun record-constraint (constraint condition)
  (push constraint (system-constraints *system-being-analyzed*))
  (if condition (push constraint (system-conditional-constraints *system-being-analyzed*))
    (push constraint (system-unconditional-constraints *system-being-analyzed*))))

(defun unrecord-constraint (constraint)
  (setf (system-constraints *system-being-analyzed*) (delete constraint (system-constraints *system-being-analyzed*) :count 1 :test #'eq))
;;; Remove pointers from var to constraints.
  (dolist (var (constraint-variables constraint))
    (setf (var-uses var) (delete constraint (var-uses var) :count 1 :test #'eq)))
;;; Delete constraint from over all system.  
  (if (constraint-condition constraint)
      (setf (system-conditional-constraints *system-being-analyzed*) (delete constraint (system-conditional-constraints *system-being-analyzed*) :count 1 :test #'eq))
    (setf (system-unconditional-constraints *system-being-analyzed*) (delete constraint (system-unconditional-constraints *system-being-analyzed*) :count 1 :test #'eq))))

(defun construct-summer (positives negatives condition &optional source)
  (let ((constraint (make-general-summer-constraint :id (new-id)
						    :pos-vars positives
						    :neg-vars negatives
						    :function 'general-summer
						    :source source
						    :condition condition
						    :variables (append positives negatives)
						    :opos-vars positives
						    :oneg-vars negatives
						    )))
    ;; Mark it as for qr use only.
    (dolist (var (constraint-variables constraint))
      (when (eq var (qplus-var))
	(setf (general-summer-constraint-qr-only constraint) t)
	(return nil)))

    (debug-print nil "~%construct summer ~A id: ~A p: ~A n: ~A~%" 
		 source (constraint-id constraint) positives negatives)
    (assert (not (some #'discrete-var? (append positives negatives))))
    (when (and source (model-p source))
      (push constraint (model-constraints source)))
    (record-constraint constraint condition)
    (mapc #'(lambda (var) (add-variable-constraint constraint var)) positives)
    (mapc #'(lambda (var) (add-variable-constraint constraint var)) negatives)
    constraint ))

(defun add-variable-constraint (constraint var)
  (push constraint (var-uses var)))

(defun remove-constraint (constraint)
  (debug-print nil "~% Removing ~a" constraint)
  (unrecord-constraint constraint)
  (dolist (var (constraint-variables constraint))
    (setf (var-uses var) (delete constraint (var-uses var) :count 1 :test #'eq)))
  (when (model-p (constraint-source constraint))
    (setf (model-constraints (constraint-source constraint))
	  (delete constraint (model-constraints (constraint-source constraint)) :count 1 :test #'eq))))

(defun summer-constraints (system)
  (remove-if-not #'general-summer-constraint-p (system-constraints system)))
       
;;; This is designed only to be used by symbolic for now.
;;; It assumes the form is (= v (:tempinterpol1 ...))
(defun construct-tempinterpol1 (model eqn condition)
  (let* ((interpol (third eqn))
	 (input (second interpol))
	 (array (third interpol))
	 (column (fourth interpol))
	 (dimensions (array-dimensions array))
	 (rows (car dimensions))
	 (columns (second dimensions)))
    ;; Not fully implemented.  Just cases I've seen so far.
    ;; A one raw table can ignore input.
    (cond ((= rows 1)
	   (construct-summer (list (second eqn)) (aref array 0 (1- column)) condition 'construct-tempinterpol1)
	   )
	  (t (error "stub construct-tempinterpol1")))))



    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun construct-set-mode-constraint (parent mode-var mode-name condition)
  (let ((constraint (make-set-mode-constraint :source parent :mode-var mode-var
					  :mode-name mode-name :id (new-id)
					  :condition condition
					  :function 'set-mode-constraint-handler
					  :variables (list mode-var))))
    (when condition
      (push constraint (var-uses (second condition))))
    (push constraint (var-uses mode-var))
    (push constraint (model-constraints parent))
    (record-constraint constraint condition)))


(defun construct-pair (parent x1 x2 condition negate)
  (cond ((and (var-p x1)(var-p x2))
	 (construct-qequal parent x1 x2 condition negate 'construct-pair1))
	((and (var-p x1)(simpleq-p x2))
	 (construct-qset parent x1 
			 (simpleq->interval x2)
			 condition negate))
	((and (var-p x1)(interval? x2))
	 (construct-qset parent x1 x2 condition negate))
	(t (error "Invalid syntax of equation pair"))))

;;; [05/12/2014 Johan] Don't construct qset-constraints if we are using global.
(defun construct-qset (parent var constant condition negate)
  (cond ((and (null condition) *use-global*)
	 (let ((constant (if negate (q-invert constant) constant)))
	   (clobber-global var constant)))
	(t (let ((constraint (make-qset-constraint :source parent :var var
						   :id (new-id)
						   :constant (if negate (q-invert constant) constant)
						   :condition condition
						   :function 'qset-constraint-handler
						   :variables (list var))))
	     ;; [06/08/2012 klenk] Do we need to push the constraint onto the vars that make up the conditions?
					;    (when condition
					;      (push constraint (var-uses (second condition))))
	     (push constraint (var-uses var))
	     (push constraint (model-constraints parent))
	     (record-constraint constraint condition)
	     constraint))))

;;; [04/17/2014 Johan] This too needs be built in.
(defun construct-deriv-constraint (var deriv parent)
;;  (assert (and (var-p var) (var-p deriv)))
  ;; Check for duplicate.
;;  (dolist (old (var-uses var))
;;    (and (deriv-constraint-p old)
;;	 (null (constraint-condition old))
;;	 (eq (deriv-constraint-deriv old) deriv)
;;	 (error "Duplicate construct of deriv constraint")))


;  (if (and (var-deriv var) (eql (var-deriv var) deriv))
;      (find-if #'deriv-constraint-p (var-uses var))


      (let ((constraint (make-deriv-constraint :source parent :var var :deriv deriv
					       :polarity '+
					       :id (new-id)
					       :function 'deriv-constraint-handler
					       :variables (list var deriv))))
;	(if (= (constraint-id constraint) 397) (error "no"))
	(push constraint (var-uses var))
	(push constraint (var-uses deriv))
	(push constraint (model-constraints parent))
	(cond ((and (var-deriv var)
		    ;(not (eq (var-deriv var) deriv))
		    )
	       (debug-print nil "~% Warning var already has a derivative: ~a ~a" var deriv))
	      (t (setf (var-deriv deriv) deriv)))
	(cond ((and (var-integral deriv)
		    ;(not (eq (var-integral deriv) var))
		    )
	       (debug-print nil "~% Warning var already has an integral: ~a ~a" var deriv))
	      (t (setf (var-integral deriv) var)))

	(record-constraint constraint nil)
	constraint))
;)

    
;;; Assumes condition is always of form (= x mode).
;;; (q= var1 var2) negate means one is flipped.
;;; The above two comments are both false [Johan 11/10/2013]
(defun construct-qequal (parent var1 var2 condition negate who)
  (assert (and (var-p var1)(var-p var2)))
  (when (eq var1 var2)
    (error "Constructing useless x Q= x"))
  ;;*** I guess if the condition is true right now we could avoid the constructoin.
  (cond (condition)
	((var-global-cell var1) (clobber-global var2 (datum-quantity (qualitative-datum var1 'global))) (return-from construct-qequal nil))
	((var-global-cell var2) (clobber-global var1 (datum-quantity (qualitative-datum var2 'global))) (return-from construct-qequal nil)))

  (let ((constraint (make-qequal-constraint :var1 var1 :var2 var2 :condition condition
					    :function 'qequal-constraint-handler
					    ;*** tis may not be needed for qequal constraints.
					    :variables (list var1 var2)
					    :id (new-id)
					    :polarity (if negate '- '+)
					    :source `(construct-qequal ,who)
					    )))
;    (if (= (constraint-id constraint) 456) (error "no"))

    (push constraint (var-uses var1))
    (push constraint (var-uses var2))
    (push constraint (model-constraints parent))
    (record-constraint constraint condition)
    constraint))

(defun propagate-discrete-information (var1 var2)
;  (when (or (discrete-var? var1)(discrete-var? var2)) (break))
  (assert (= (length (var-qspaces var1))(length (var-qspaces var2)) 1))
  (let ((v1-qspace (car (var-qspaces var1)))
	(v2-qspace (car (var-qspaces var2))))
    (cond ((and (discrete-var? var1)(discrete-var? var2))
	   (cond ((and (simpleqspace? v1-qspace)
		       (not (simpleqspace? v2-qspace)))
		  (setf (var-qspaces var1)(var-qspaces var2)))
		 ((and (simpleqspace? v2-qspace)
		       (not (simpleqspace? v1-qspace)))
		  (setf (var-qspaces var2)(var-qspaces var1)))
		 (t (assert (equal (var-qspaces var2)(var-qspaces var1))))))
	  ((discrete-var? var1)
	   (setf (var-fundamental-type var2) :discrete)
	   (setf (var-qspaces var2)(var-qspaces var1)))
	  ((discrete-var? var2)
	   (setf (var-fundamental-type var1) :discrete)
	   (setf (var-qspaces var1)(var-qspaces var2))))))
  

(defun construct-qarithmatic-constraint (parent lhs rhs condition)
  (cond ((summer-equation? (list '= lhs rhs))
	 (construct-qsum-constraint parent lhs rhs condition))
	(t
	 (ecase (car rhs)
	   (* (construct-multiply parent lhs (cdr rhs) condition))
	   (/ (assert (= (length (cdr rhs)) 2))
	      (construct-multiply parent (cadr rhs)
				  (cons lhs (cddr rhs)) condition ))))))


(defun construct-qsum-constraint (parent lhs rhs condition )
  (cond ((every #'var-p (cons lhs rhs))			      
	 (construct-summer (list lhs) rhs condition parent)) 
	(t 
	 (multiple-value-bind (pos negs)
	     (determine-pos-negs (list '- lhs rhs))
	   (construct-summer pos negs condition parent)))))

(defun determine-pos-negs (form &optional neg?)
  (cond ((var-p form)
	 (if neg? 
	     (values nil (list form))
	     (list form)))
	((and (listp form)
	      (eql (car form) 'pre)
	      (= (length form) 2))
	 (if neg? 
	     (values nil (list form))
	     (list form)))
	((and (listp form)
	      (eql (car form) '-)
	      (= (length form) 2))
	 (determine-pos-negs (cadr form) (not neg?)))
	
	((and (listp form)
	      (eql (car form) '-)
	      (= (length form) 3))
	 (multiple-value-bind (pos1 neg1)
	     (determine-pos-negs (cadr form) neg?)
	   (multiple-value-bind (pos2 neg2)
	       (determine-pos-negs (caddr form) (not neg?))
	     (values (append pos1 pos2)(append neg1 neg2)))))
	((and (listp form)
	      (eql (car form) '+))
	 (let (pos neg)
	   (dolist (arg (cdr form)(values pos neg))
	     (multiple-value-bind (pos1 neg1)
		 (determine-pos-negs arg neg?)
	       (setq pos (append pos pos1)
		     neg (append neg neg1))))))
	(t (error "shouldn't happen: determine-pos-negs; form is ~A, neg? is ~A" form neg?))))


;; [05/14/2012 klenk] Polarity only needs to be flipped for 
(defun construct-multiply (parent lhs rhs condition &key (polarity '+))
  (let ((constraint (make-multiply-constraint :id (new-id)
					      :result lhs
					      :multiplicands rhs
					      :function 'handle-multiplication-constraint
					      :source parent
					      :condition condition
					      :polarity polarity
					      :variables (cons lhs rhs))))
    ;; Record debugging information:
    (setf (multiply-constraint-oresult constraint) lhs
	  (multiply-constraint-omultiplicands constraint) (copy-list rhs)
	  (multiply-constraint-opolarity constraint) polarity)

;    (if (= (constraint-id constraint) 58) (error "no"))

      (debug-print nil "~%construct multiply ~A id: ~A result: ~A args: ~A~%" 
		   parent (constraint-id constraint) lhs rhs)
      (record-constraint constraint condition)
      (when parent (push constraint (model-constraints parent)))
      (push constraint (var-uses lhs))
      (mapc #'(lambda (var) (push constraint (var-uses var))) rhs)
      constraint))

(defun construct-connect-constraints (model lhs rhs condition)
  (assert (and (model-p lhs)(model-p rhs)(null condition)))
  (dolist (var-pair (model-variables lhs))
    (let ((var1 (cdr var-pair))
	  (var2 (cdr (assoc (car var-pair) (model-variables rhs)))))
      (cond ((flow? var1)
	     (assert (flow? var2))
	     (push (list 'KCL var1 var2)(model-constraints model)))
	    (t 
;	     (format t "~% var1: ~A var2: ~A" var1 var2)
	     ;; For symbolic algebra to work it needs to know about the connect constraints.
	     ;; Does it foul up the qequal constraint?
	     (construct-summer (list var1) (list var2) condition)
	     (construct-qequal model var1 var2 condition nil 'construct-connect-constraints))))))

(defun construct-mod-when-constraint (parent lhs rhs condition)
  (assert (null condition))
  (let ((when-mod (make-mod-when :trigger lhs :equ rhs 
			     :function 'mod-when-constraint
			     :id (new-id))))
    (push when-mod (system-when-equations *system-being-analyzed*))))


(defun construct-power-constraint (parent lhs rhs condition)
  (assert (and (var-p lhs)(var-p (second rhs))(integerp (third rhs))))
  (let ((constraint (make-power-constraint   :result lhs :base (second rhs) :condition condition
					     :function 'power-constraint-handler
					;*** tis may not be needed for qequal constraints.
					     :variables (list lhs (second rhs))
					     :id (new-id)
					     :base-polarity '+
					     :result-polarity '+
					     :exp (third rhs)
					     )))
    (push constraint (var-uses lhs))
    (push constraint (var-uses (second rhs)))
    (push constraint (model-constraints parent))
    (record-constraint constraint condition)
    constraint))



;; [11/ 7/2013 klenk] don't eliminate anything with these constraints
(defun construct-gt-constraint (parent lhs rhs condition)
  (let ((constraint (make-gt-constraint
		     :lhs lhs :rhs rhs
		     :function 'gt-constraint-handler
		     :variables (list lhs rhs)
		     :id (new-id))))
    (push constraint (var-uses lhs))
    (push constraint (var-uses rhs))
    (push constraint (model-constraints parent))
    (record-constraint constraint condition)
    constraint))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Handlers


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Place constraint handlers here

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; qequal


(defun qequal-constraint-handler (constraint datum-or-trans-set)
  (if (datum-p datum-or-trans-set)
      (qequal-constraint-handler-datum constraint datum-or-trans-set)
      (qequal-constraint-handler-trans-set constraint datum-or-trans-set)))

(defun qequal-constraint-handler-datum (constraint datum)
;  (format t "~% q ~a ~a" constraint datum)
  (cond ((discrete-var? (qequal-constraint-var1 constraint))
	 (qequal-discrete-handler-datum constraint datum))
	(t
	 (setf (constraint-waiting constraint) nil)
	 (let* ((sit (cell-situation (datum-cell datum)))
		(invert? (eq (qequal-constraint-polarity constraint) '-)))
	   (multiple-value-bind (val1 deriv1)
	       (simple-qvalue (qequal-constraint-var1 constraint) sit)
	     (multiple-value-bind (val2 deriv2)
		 (simple-qvalue (qequal-constraint-var2 constraint) sit)
	       (debug-print nil "~%q= constraint ~A val1=~A deriv1=~A val2=~A deriv2=~A"
			    constraint val1 deriv1 val2 deriv2)
;; [09/ 1/2012 klenk] The constraint may have been placed on the queue
;; [09/ 1/2012 klenk] because the condition is now active
	       (cond ((and (null val1)(null val2)) nil)
		     ((null val1)
		      (clobber (qequal-constraint-var1 constraint)
			       (create-q-quantity (qequal-constraint-var1 constraint)
						  (if invert? (q-invert val2) val2)
						  nil 
						  (when deriv2
						    (if invert? (q-invert deriv2) deriv2)))
			       sit (list (list constraint) datum))
		      )
		     ((null val2)
		      (clobber (qequal-constraint-var2 constraint)
			       (create-q-quantity (qequal-constraint-var2 constraint)
						  (if invert? (q-invert val1) val1)
						  nil 
						  (when deriv1
						    (if invert? (q-invert deriv1) deriv1)))
                               sit (list (list constraint) datum)))
		     ((and (null deriv1) deriv2)
		      (clobber-qderivs
		       (qequal-constraint-var1 constraint)
		       (if invert? (q-invert deriv2) deriv2)
		       sit
		       constraint))
		     ((and (null deriv2) deriv1)
		      (clobber-qderivs
		       (qequal-constraint-var2 constraint)
		       (if invert? (q-invert deriv1) deriv1)
		       sit 
		       constraint))
		     (t 
		      (and (eql val1 (if invert? (q-invert val2)))
			   (or 
			    (and (null deriv1)(null deriv2))
			    (eql deriv1 (if invert? (q-invert deriv2)))))))))))))

;;; Note: The datum can be in the trigger of the condition. 
;;; Johan extended it so that the justification includes both.
;;; But for complex logical conditions there can be arbitrarily many antecedent datums,
;;; so this is not completely general.  Also can var1 and var2 force true/false of
;;; the condition?
(defun qequal-discrete-handler-datum (constraint datum)
  (setf (constraint-waiting constraint) nil)
  (let* ((sit (cell-situation (datum-cell datum)))
	 (var1 (qequal-constraint-var1 constraint))
	 (var2 (qequal-constraint-var2 constraint))
	 (datum1 (discrete-datum var1 sit))
	 (datum2 (discrete-datum var2 sit)))
 ; (discrete-value (qequal-constraint-var2 constraint) sit)))
;; [06/26/2012 klenk] The :discrete clobber keyword just tells clobber to build a q-quantity
;; Johan - I've temporary added more tracing information: These justifications
;; sometimes will refer to a parent situation???? 
    (cond (datum1
	   (clobber (qequal-constraint-var2 constraint) 
		    (datum-quantity datum1) sit 
		    (list (list constraint 'datum1) datum datum1) 
	     :qualitative))
	  (datum2
	   (clobber (qequal-constraint-var1 constraint) 
		    (datum-quantity datum2) sit (list (list constraint sit (cell-situation (datum-cell datum2)) 'datum2 datum datum1) datum datum2) 
	     :qualitative))
;; [09/ 1/2012 klenk] Neither value may be known because the constraint may be
;; [09/ 1/2012 klenk] placed by the condition vars
	  (t nil))))

(defun qequal-constraint-handler-trans-set (constraint trans-set)
  (cond ((discrete-var? (qequal-constraint-var1 constraint))
	 (qequal-discrete-handler-trans-set constraint trans-set))
	(t  
	 (multiple-value-bind (var1-mag var1-deriv) (lookup-mag-deriv (qequal-constraint-var1 constraint) trans-set)
	   (multiple-value-bind (var2-mag var2-deriv) (lookup-mag-deriv (qequal-constraint-var2 constraint) trans-set)
	     (ecase (qequal-constraint-polarity constraint)
	       (+ (and (eq var1-mag var2-mag)
		       (eq var1-deriv var2-deriv)))
	       (- (and (eq var1-mag (q-invert var2-mag))
		       (eq var1-deriv (q-invert var2-deriv))))))))))

(defun qequal-discrete-handler-trans-set (constraint trans-set)
  (let ((blist (blist-for-constraint constraint trans-set)))
    (let ((v1 (val-from-blist (qequal-constraint-var1 constraint) blist))
          (v2 (val-from-blist (qequal-constraint-var2 constraint) blist))
          )
      ;; (format t "v1 is ~S, v2 is ~S, eql is ~S~%"
      ;;         v1 v2 (q-quantity-equal v1 v2))
      (q-quantity-equal v1 v2 :ignore-unknown-deriv? t))))
	
    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; deriv-constraint-handler

(defun deriv-constraint-handler (constraint datum-or-trans-set)
  (cond ((datum-p datum-or-trans-set)
	 (deriv-constraint-hanlder-datum constraint datum-or-trans-set))
	(t
	 (deriv-constraint-handler-trans-set constraint datum-or-trans-set))))

;;;**** this too is incomplete.
;;;
(defun deriv-constraint-hanlder-datum (constraint datum)
  (setf (deriv-constraint-waiting constraint) nil)
  (let* ((sit (cell-situation (datum-cell datum))))
    (multiple-value-bind (val1 deriv1)
	(simple-qvalue (deriv-constraint-var constraint) sit)
      (declare (ignore deriv1))
      (multiple-value-bind (val2 deriv2)
	 (simple-qvalue (deriv-constraint-deriv constraint) sit)
	(declare (ignore deriv2))
	(when (and val2 val1)
	  (clobber (deriv-constraint-var constraint)
		   (create-q-quantity (deriv-constraint-var constraint)
				      val1
				       nil 
				       (if (eq (deriv-constraint-polarity constraint) '-)
					   (simpleq->deriv (q-invert val2))
					   (simpleq->deriv val2)))
		    sit (list (list constraint) datum)))))))


(defun deriv-constraint-handler-trans-set (constraint trans-set)
  (let* ((blist (blist-for-constraint constraint trans-set))
	 (deriv (q-quantity-deriv
		 (possible-transition-new-value
		  (find (deriv-constraint-var constraint) trans-set
			:key #'possible-transition-variable)))))
    (ecase (if (eql (deriv-constraint-polarity constraint) '+)
	       deriv
	       (q-invert deriv))
      (Dec (eql (val-from-blist (deriv-constraint-deriv constraint) blist) 'Q-))
      (Std (eql (val-from-blist (deriv-constraint-deriv constraint) blist) 'Q0))
      (Inc (eql (val-from-blist (deriv-constraint-deriv constraint) blist) 'Q+)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; general-summer

;; [06/28/2012 klenk] Some issues with derivatives involve higher order constraints
;; [06/28/2012 klenk] consider A + B + C = 0
;; [06/28/2012 klenk] A,B,C are all 0
;; [06/28/2012 klenk] A and B are Std
;; [06/28/2012 klenk] C is Dec
;; [06/28/2012 klenk] This is valid because A or B could be Inc in the following interval
;; [06/28/2012 klenk] Therefore, if we are at an instant we should not evaluate any of the derivs
;; [06/28/2012 klenk] If there are no valid transitions to intervals, then the instant cannot exist
;; [06/28/2012 klenk] and will be removed by (remove-impossible-instant ...)

(defun general-summer (constraint datum-or-trans-set)
;  (check2-clobbered)
  (if (general-summer-constraint-results constraint) (error "stub"))

  (if (or
       (null datum-or-trans-set)
       (datum-p datum-or-trans-set))
      (general-summer-datum constraint datum-or-trans-set)
      (general-summer-trans-set constraint datum-or-trans-set)))

(defun general-summer-datum (constraint datum)
  (declare (ignore datum))
  (do nil (nil)
    (let ((next (pop (general-summer-constraint-waiting constraint))))
      (unless next (return nil))
      (ecase (datum-type next)
	(:qualitative (general-summer-one-datum next constraint))
	(:numeric (numeric-summer-one-datum next constraint) )
	(:symbolic (unless (general-summer-constraint-qr-only constraint)
		     (symbolic-summer-one-datum next constraint)))))))

;; [12/09/2011 klenk] This does not take into account previous equality values yet
;;; New version.  Does not cons, faster.
;;; [04/28/2014 Johan]
(defun general-summer-trans-set (constraint trans-set)
  (let ((sum 'Q0)
	(deriv-sum 'Q0))
    (dolist (pos-var (general-summer-constraint-pos-vars constraint))
      (multiple-value-bind (mag deriv) (lookup-mag-deriv pos-var trans-set)
;	(assert (and mag deriv))
	(setq sum (q-add sum mag))
	(setq deriv-sum (q-add deriv-sum deriv))))
    (dolist (neg-var (general-summer-constraint-neg-vars constraint))
      (multiple-value-bind (mag deriv) (lookup-mag-deriv neg-var trans-set)
;	(assert (and mag deriv))
	(setq sum (q-add sum (q-invert mag)))
	(setq deriv-sum (q-add deriv-sum (q-invert deriv)))
	;; If both are 'Q?, don't bother adding anymore.  Its consistent.
	(if (and (eq sum 'Q?) (eq deriv-sum 'Q?)) (return-from general-summer-trans-set t))
	))
    (and (or (eql sum 'Q0)(eql sum 'Q?))
	 (or ;;Need to figure out if we are in an instant here...
	  (eql deriv-sum 'Q0)
	  (eql deriv-sum 'Q?)))))


   

;;; Who creates the HOD summers?
(defun general-summer-one-datum (datum constraint)
  (debug-print nil "~% Invoking general-summer on ~a ~a~%" datum constraint)
  (general-summer-one-datum-val datum constraint)
  (general-summer-one-datum-dir datum constraint))
  
;;; For general-summer; (constraint-situation ...) applies to val.
(defun general-summer-one-datum-val (datum constraint)
  (let* ((situation (cell-situation (datum-cell datum)))
	 (unknown nil)
	 (sum 'Q0)
	 (antecedents nil)
	 (positives (general-summer-constraint-pos-vars constraint))
	 (negatives (general-summer-constraint-neg-vars constraint)))
;    (if (eq (constraint-situation constraint) situation) (return-from general-summer-one-datum-val nil))

    (dolist (var positives)
      (let ((next (simple-qvalue var situation)))
	(cond (next
	       (setq sum (q-add sum next))
	       (when (eq sum 'Q?) 
;		 (setf (constraint-situation constraint) situation)
		 (return-from general-summer-one-datum-val nil))
	       (setq antecedents (append (qualitative-datums var situation) antecedents))) 
	      ;; Nothing can be calculated from more than one unknown (unless they are =).
	      (unknown (return-from general-summer-one-datum-val nil))
	      (t (setq unknown var)))))
    (dolist (var negatives)
      (let ((next (simple-qvalue var situation)))
	(cond (next
	       (setq sum (q-add sum (q-invert next)))
	       (when (eq sum 'Q?) 
;		 (setf (constraint-situation constraint) situation)
		 (return-from general-summer-one-datum-val nil))
	       (setq antecedents (append (qualitative-datums var situation) antecedents)))
	      ;; Nothing can be calculated from more than one unknown (unless they are =).
	      (unknown (return-from general-summer-one-datum-val nil))
	      (t (setq unknown var)))))
    (cond (unknown 
;	   (setf (constraint-situation constraint) situation)
	   (clobber unknown
		    (if (member unknown positives) (q-invert sum) sum)
		    situation (cons (list constraint) antecedents)
				     :simple-qualitative))
	  ((eq sum 'Q0))
	  (t ;(setf (constraint-situation constraint) situation)
	   (contradiction 'general-summer-one-datum (cons constraint antecedents) situation))))
;  (check2-clobbered 'F)
  )


(defun general-summer-one-datum-dir (datum constraint)
;  (check2-clobbered)

 ; (format t "~% See0 ~a" datum)

  (let* ((situation (cell-situation (datum-cell datum)))
	 (unknown nil)
	 (sum 'Q0)
	 (antecedents nil)
	 (positives (general-summer-constraint-pos-vars constraint))
	 (negatives (general-summer-constraint-neg-vars constraint)))
;    (print-vars situation)

;; [06/28/2012 klenk] Only possible when there is an instant
;; [08/29/2012 klenk] The code said unless, but really this hsould be possible always
;    (when (eq (situation-type situation) :instant)
      (dolist (var positives)
	(let ((next (qderiv-simpleq var situation)))
;	  (format t "~% See1 d~a=~a in ~a" var next situation)
	  (cond (next
		 (setq sum (q-add sum next))
		 (if (eq sum 'Q?) (return-from general-summer-one-datum-dir nil))
		 (setq antecedents (append (qualitative-datums var situation) antecedents))) 
		;; Nothing can be calculated from more than one unknown (unless they are =).
		(unknown (return-from general-summer-one-datum-dir nil))
		(t (setq unknown var))))
	)
      (dolist (var negatives)
	(let ((next (qderiv-simpleq var situation)))
	  (cond (next
;		 (format t "~% See2 d~a=~a in ~a" var next situation)
		 (setq sum (q-add sum (q-invert next)))
		 (if (eq sum 'Q?) (return-from general-summer-one-datum-dir nil))
		 (setq antecedents (append (qualitative-datums var situation) antecedents)))
		;; Nothing can be calculated from more than one unknown (unless they are =).
		(unknown (return-from general-summer-one-datum-dir nil))
		(t (setq unknown var)))))
      (cond (unknown 
;	     (format t "~% Summer Clobbering deriv ~a with ~a in ~a (invert: ~a)" unknown sum situation (member unknown positives))
;	     (if (and (= (var-id unknown) 2) (= (situation-id situation) 2))
;		 (error "see"))
;	     (check2-clobbered 'H)
	     (clobber-qderivs unknown 
			      (simpleq->deriv 
			       (if (member unknown positives) 
				   (q-invert sum)
				   sum))
			      situation
			      constraint))
	    ((eq sum 'Q0))
	    (t (contradiction 'general-summer-one-datum antecedents situation))))
 ; (check2-clobbered 'G)
  )

(defun numeric-summer-one-datum (datum constraint)
  (setf (constraint-waiting constraint) nil)
  ;(warn "numeric-summer-one-datum (~s ~s):  if needed convert from create-constraints in v1" datum constraint)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Handle multiplication constraint


(defun handle-multiplication-constraint (constraint datum-or-trans-set)
;  (assert  datum-or-trans-set)
  (if (datum-p datum-or-trans-set)
      (multiply-handler-datum constraint datum-or-trans-set)
      (multiply-handler-trans-set constraint datum-or-trans-set)))

(defun multiply-handler-trans-set (constraint trans-set)
  (and (eql (ecase (multiply-constraint-polarity constraint)
	      (+ (lookup-mag-deriv (multiply-constraint-result constraint) trans-set))
	      (- (q-invert (lookup-mag-deriv (multiply-constraint-result constraint) trans-set))))
	    (reduce #'q-multiply (multiply-constraint-multiplicands constraint)
		    :key #'(lambda (arg)
			     (lookup-mag-deriv arg trans-set))))
       ;; [03/18/2012 klenk] Product rule (f*g)'=f'*g + f*g'
       (product-rule-for-deriv-trans-set constraint trans-set)))

	  
(defun product-rule-for-deriv-trans-set (constraint trans-set)
  ;;*** big assumption, leave this in:
  (assert (= (length (multiply-constraint-multiplicands constraint)) 2))
  (let ((result-deriv
	 (ecase (multiply-constraint-polarity constraint)
	   (+ (multiple-value-bind (mag deriv)
		  (lookup-mag-deriv (multiply-constraint-result constraint) trans-set)
		deriv))
	   (- (q-invert (multiple-value-bind (mag deriv)
			    (lookup-mag-deriv (multiply-constraint-result constraint) trans-set)
			  deriv) )))))
    (multiple-value-bind (arg1 arg1-deriv)
	(lookup-mag-deriv (first (multiply-constraint-multiplicands constraint)) trans-set)
      (multiple-value-bind (arg2 arg2-deriv)
	  (lookup-mag-deriv (second (multiply-constraint-multiplicands constraint)) trans-set)
	(member 
	 (q-subtract 
	  (q-add
	   (q-multiply arg1-deriv arg2)
	   (q-multiply arg2-deriv arg1))
	  result-deriv)
	 '(Q0 Q?))))))
       
;;; This is still here because the regular propagator calls it.  *** 
;;; Get rid of soon.
(defun product-rule-for-deriv (blist deriv-blist constraint)
  (assert (= (length (multiply-constraint-multiplicands constraint)) 2))
  (let ((arg1 (cdr (assoc (first (multiply-constraint-multiplicands constraint)) blist)))
	(arg1-deriv (cdr (assoc (first (multiply-constraint-multiplicands constraint)) deriv-blist)))
	(arg2 (cdr (assoc (second (multiply-constraint-multiplicands constraint)) blist)))
	(arg2-deriv (cdr (assoc (second (multiply-constraint-multiplicands constraint)) deriv-blist)))
	(result-deriv
	 (ecase (multiply-constraint-polarity constraint)
	   (+ (cdr (assoc (multiply-constraint-result constraint) deriv-blist)))
	   (- (q-invert (cdr (assoc (multiply-constraint-result constraint) deriv-blist)))))))
    (member 
     (q-subtract 
      (q-add
       (q-multiply arg1-deriv arg2)
       (q-multiply arg2-deriv arg1))
      result-deriv)
     '(Q0 Q?))))




(defun transition-to-zero (tran)
  (eq (q-quantity-value (possible-transition-new-value tran)) 'Q0))

(defun multiply-handler-datum (constraint &optional ignored-datum)
  (declare (ignore ignored-datum))
  (do nil (nil)
    (let ((next (pop (constraint-waiting constraint))))
      (unless next (return nil))
;; [09/12/2012 klenk] What is the point of this condition? I'm removing it for now 
      (if t ;(member next (cell-values (datum-cell next)))
	(case (datum-type next)
	  (:qualitative (handle-qmulti-constraint next constraint))
	  (:numeric (numeric-multiply-one-datum next constraint))
	  (:symbolic (symbolic-multiply-one-datum next constraint))
	  (t (error "Unknown datum type")))))))

(defun handle-qmulti-constraint (datum constraint)
  (handle-qmulti-constraint-val datum constraint)
  (handle-qmulti-constraint-dir datum constraint))

;;; Make more efficient when it works.
(defun handle-qmulti-constraint-val (datum constraint)
  (let* ((current-situation (cell-situation (datum-cell datum)))
	(result (simple-qvalue (multiply-constraint-result constraint) current-situation))
	(running-result 'Q+)
	(unknown nil))
    (dolist (var (multiply-constraint-multiplicands constraint))
      (let ((qvalue (simple-qvalue var current-situation)))
	(cond (qvalue (when (eq qvalue 'Q0)
			(cond ((null result) (clobber (multiply-constraint-result constraint) qvalue current-situation (list (list constraint) datum)))
			      ((not (eq result 'Q0)) (contradiction 'val-multiply (list datum) current-situation))
			      (t (return-from handle-qmulti-constraint-val nil))))
		      (setq running-result (q-multiply qvalue running-result))
		      )
	      (unknown (setq unknown :too-many))
	      (t (setq unknown var))
	      )))
    (setq running-result (if (eq (multiply-constraint-polarity constraint) '-) (q-invert running-result) running-result) )
    (cond ((eq unknown :too-many))
	  ((null unknown)
	   (cond ((null result)
		  (clobber (multiply-constraint-result constraint) 
			   running-result
			   current-situation 
			   (cons (list constraint)
				 (mapcar #'(lambda (var)
					     (qualitative-datum var current-situation))
					 (multiply-constraint-multiplicands constraint)))))
		 ((eq running-result result))
		 (t (contradiction 'val-multiply (list datum) current-situation))))
	  ((null result))
	  (t 
	     (clobber unknown 
		      (q-divide result running-result)
		      current-situation 
		      (cons (list constraint)
			    (cons (qualitative-datum (multiply-constraint-result constraint) current-situation)
				  (mapcar #'(lambda (var)
					      (qualitative-datum var current-situation))
					  (remove unknown (multiply-constraint-multiplicands constraint))))))))))
;xxxx


    ;; Easy case where there is only one OR 0 unknown.
;    (dolist (binding (constraint-variables constraint))
;      (let ((qvalue (simple-qvalue binding current-situation))
;	    (zeroresult)
;	(cond (qvalue (setq zero-result binding) (return nil))
;	      (unknown (return-from handle-qmulti-constraint-val nil))
;	      (t (setq unknown binding)))))
;    (cond 
;	  (unknown (qmulti-for-one-unknown-val unknown constraint current-situation))
;	  (t (qmulti-no-unknown-val constraint  current-situation)))))

;;;*** this does not rule out all cases*******
(defun handle-qmulti-constraint-dir (datum constraint)
  (unless (= (length (multiply-constraint-multiplicands constraint)) 2) (error "Not implemented yet"))
  (let ((current-situation (cell-situation (datum-cell datum)))
	(unknown))
    ;; Easy case where there is only one OR 0 unknown.
    (dolist (binding (constraint-variables constraint))
      (cond ((qderiv binding current-situation))
	    (unknown (setq unknown :too-many))
	    (t (setq unknown binding))))
    (cond ((eq unknown :too-many))
	   ;(new-handle-qmulti-dir constraint current-situation))
	  (unknown (qmulti-for-one-unknown-dir unknown constraint current-situation))
	  (t (qmulti-no-unknown-dir constraint current-situation)))))

;;; [05/26/2014 Johan] The qmulti code is incomplete.  See draft below.  This handles the case where
;;; one [Q0 : Std] as that is the easy case.  But there are more.

(defun new-handle-qmulti-dir (constraint current-situation)
  (let* ((result (multiply-constraint-result constraint))
	 (arg1)
	 (arg1-deriv)
	 (arg2)
	 (arg2-deriv)
	 (result-deriv)
	 (ignore)
	 (invert? (eq (multiply-constraint-polarity constraint) '-)))
    (multiple-value-setq (arg1 arg1-deriv) (lookup-mag-deriv-sit (first (multiply-constraint-multiplicands constraint)) current-situation))
    (multiple-value-setq (arg2 arg2-deriv) (lookup-mag-deriv-sit (second (multiply-constraint-multiplicands constraint)) current-situation))
    (multiple-value-setq (ignore result-deriv) (lookup-mag-deriv-sit result current-situation))
    (cond ((and (eq arg1 'Q0) (eq arg1-deriv 'Q0))
	   (and result-deriv (not (eq result-deriv 'Q0)) (contradiction 'new nil current-situation))
	   (clobber result
		    (create-q-quantity result 'Q0 nil 'Std)
		    current-situation
		    (list (list constraint) (qualitative-datum (first (multiply-constraint-multiplicands constraint)) current-situation))))
	  ((and (eq arg2 'Q0) (eq arg2-deriv 'Q0))
	   (and result-deriv (not (eq result-deriv 'Q0)) (contradiction 'new nil current-situation))
	   (clobber result
		    (create-q-quantity result 'Q0 nil 'Std)
		    current-situation
		    (list (list constraint) (qualitative-datum (second (multiply-constraint-multiplicands constraint)) current-situation)))))))

(defun qmulti-no-unknown-val (constraint sit)
  (let ((result (simple-qvalue (multiply-constraint-result constraint) sit))
	(multiplication-result
	 (multiply-constraint-args (multiply-constraint-multiplicands constraint) sit)))
    (unless (eql multiplication-result 
		 (if (eq (multiply-constraint-polarity constraint) '-) 
		     (q-invert result) 
		     result))
      (contradiction 'qmultiply constraint sit))))

(defun qmulti-no-unknown-dir (constraint sit)
  (unless (product-rule-for-deriv (blist-for-constraint-sit constraint sit)
				  (blist-for-constraint-derivs-sit constraint sit)
				  constraint)
      (contradiction 'qmultiply constraint sit)))
  
(defun multiply-constraint-args (args sit)
  (if (= (length args) 1)
      (simple-qvalue (car args) sit)
      (reduce #'(lambda (arg1 arg2)
		  (q-multiply (if (var-p arg1) (simple-qvalue arg1 sit) arg1)
			      (if (var-p arg2) (simple-qvalue arg2 sit) arg2)))
	      args)))

(defun qmulti-for-one-unknown-val (unknown constraint sit)
  (debug-print nil "~% qmulti-for-one-unknown ~a ~a ~a" unknown constraint sit)
  (let ((result (multiply-constraint-result constraint))
	(args (multiply-constraint-multiplicands constraint)))
    (cond ((eql unknown result)
	   (clobber unknown 
		    (if (eq (multiply-constraint-polarity constraint) '-)
			(q-invert (multiply-constraint-args args sit))
			(multiply-constraint-args args sit))
		    sit (cons (list constraint)
			      (mapcan #'(lambda (var) (copy-list (qualitative-datums var sit)))
				      args))))
	  ((member unknown args)
	   (let* ((result-value (simple-qvalue result sit))
		  (args-result (multiply-constraint-args (remove unknown args) sit))
		  (new-value (if (eq (multiply-constraint-polarity constraint) '-)
				 (q-invert (q-divide result-value args-result))
			       (q-divide result-value args-result))))
	     (unless (eq new-value 'Q?)
	       (clobber unknown 
			new-value
			sit
			(cons (list constraint)
			      (mapcan #'(lambda (var)(copy-list (qualitative-datums var sit)))
				      (cons result (remove unknown args))))))))
	  (t (error "unknown not listed in args")))))

;; [03/19/2012 klenk] We are not going to solve for vals here, just directions
;; [03/19/2012 klenk] So uknown will be a variable whose direction is unknown
;;;xxxxx delte soon.
;;;[05/26/2014 Johan] This is very incomplete. fix.***
;;; xy=z x'y+xy'=0.
(defun qmulti-for-one-unknown-dir (unknown constraint sit)
  (debug-print nil "~% qmulti-for-one-unknown-dir ~a ~a ~a" unknown constraint sit)
;  (assert (= (length (multiply-constraint-multiplicands constraint)) 2))
  (let* ((result (multiply-constraint-result constraint))
	 (arg1)
	 (arg1-deriv)
	 (arg2)
	 (arg2-deriv)
	 (result-deriv)
	 (ignore)
	 (invert? (eq (multiply-constraint-polarity constraint) '-)))
    (multiple-value-setq (arg1 arg1-deriv) (lookup-mag-deriv-sit (first (multiply-constraint-multiplicands constraint)) sit))
    (multiple-value-setq (arg2 arg2-deriv) (lookup-mag-deriv-sit (second (multiply-constraint-multiplicands constraint)) sit))
    (multiple-value-setq (ignore result-deriv) (lookup-mag-deriv-sit result sit))
;; [05/17/2012 klenk] Don't always know arg1 and arg2, therefore can't compute the unknown deriv
;    (when (and arg1 arg2)
      (let ((new-value (cond ((eql unknown result)
			      (q-add
			       (q-multiply arg1-deriv arg2)
			       (q-multiply arg2-deriv arg1)))
			     ((null arg1-deriv)
			      (q-divide 
			       (q-subtract result-deriv
					   (q-multiply arg2-deriv arg1))
			       arg2))
			     ((null arg2-deriv)
			      (q-divide 
			       (q-subtract result-deriv
					   (q-multiply arg1-deriv arg2))
			       arg1))
			     (t (error "qmulti-for-one-unknown-dir-dir: shouldn't happen.  unknown: ~A, result: ~A, arg1-deriv: ~A, arg2-deriv: ~A~%" unknown result arg1-deriv arg2-deriv)))))
	(debug-print nil "~% qmulti-result-for-one-unknown-result ~A from constraint ~a" new-value constraint)
	(unless (eq new-value 'Q?)
	  (dolist (qvalue (qualitative-values unknown sit))
;	    (assert (null (q-quantity-deriv qvalue)))
	    (clobber unknown 
		     (create-q-quantity unknown (q-quantity-value qvalue) 
					(q-quantity-qspace qvalue)
					(simpleq->deriv (if invert? (q-invert new-value) new-value)))
		     sit
		     (cons (list constraint)
			   (mapcan #'(lambda (var) (copy-list (qualitative-datums var sit)))
				   (remove unknown (multiply-constraint-variables constraint))))
		     ))))))

; I started to fix the above, but it will take hours to debug.
; (defun qmulti-dir (constraint sit)
;   (let* ((result (multiply-constraint-result constraint))
; 	 (arg1)
; 	 (arg1-deriv)
; 	 (arg2)
; 	 (arg2-deriv)
; 	 (result-deriv)
; 	 (answer)
; 	 (ignore)
; 	 (invert? (eq (multiply-constraint-polarity constraint) '-)))
;     (multiple-value-setq (arg1 arg1-deriv) (lookup-mag-deriv-sit (first (multiply-constraint-multiplicands constraint)) sit))
;     (multiple-value-setq (arg2 arg2-deriv) (lookup-mag-deriv-sit (second (multiply-constraint-multiplicands constraint)) sit))
;     (multiple-value-setq (ignore result-deriv) (lookup-mag-deriv-sit result sit))



;     ;; There are many cases of xy=z => x'y+xy'=z'  arg1=x, arg2=y result=z
;     (cond (arg1
; 	   (cond (arg2 
; 		  (cond (arg1-deriv
; 			 (cond (arg2-deriv
; 				(cond (result-deriv
; 				       (setq answer (q-add (q-multiply arg1-deriv arg2)
; 							   (q-multiply arg2-deriv arg1)))
; 				       (if answer (setq answer (q-invert answer)))
; 				       (unless (eq answer result-deriv)
; 					 (contradiction 'qmulti)))
; 				      (t (clobber 
				       



    




; ;; [05/17/2012 klenk] Don't always know arg1 and arg2, therefore can't compute the unknown deriv
;     (when (and arg1 arg2)
;       (let ((new-value (cond ((eql unknown result)
; 			      (q-add
; 			       (q-multiply arg1-deriv arg2)
; 			       (q-multiply arg2-deriv arg1)))
; 			     ((null arg1-deriv)
; 			      (q-divide 
; 			       (q-subtract result-deriv
; 					   (q-multiply arg2-deriv arg1))
; 			       arg2))
; 			     ((null arg2-deriv)
; 			      (q-divide 
; 			       (q-subtract result-deriv
; 					   (q-multiply arg1-deriv arg2))
; 			       arg1))
; 			     (t (error "qmulti-for-one-unknown-dir-dir: shouldn't happen.  unknown: ~A, result: ~A, arg1-deriv: ~A, arg2-deriv: ~A~%" unknown result arg1-deriv arg2-deriv)))))
; 	(debug-print nil "~% qmulti-result-for-one-unknown-result ~A" new-value)
; 	(unless (eq new-value 'Q?)
; 	  (dolist (qvalue (qualitative-values unknown sit))
; 	    (assert (null (q-quantity-deriv qvalue)))
; 	    (clobber unknown 
; 		     (create-q-quantity unknown (q-quantity-value qvalue) 
; 					(q-quantity-qspace qvalue)
; 					(simpleq->deriv (if invert? (q-invert new-value) new-value)))
; 		     sit
; 		     (cons (list constraint)
; 			   (mapcan #'(lambda (var)(copy-list (qualitative-datums var sit)))
; 				   (cons result (remove unknown (multiply-constraint-variables constraint)))))
; 		     )))))))


  
;;; Does not integrate Q0 Q+ Q-
;;; Can be much more efficient, by consuming all waiting.
;;; Multiply constraint has to be at the level of the original.****
;;;****** pop off all waiting or no*****

(defun numeric-multiply-one-datum (next constraint)
  (setf (constraint-waiting constraint) nil)
  ;(warn "numeric-multiply-one-datum (~s ~s):  if needed convert from create-constraints in v1" next constraint)
  )




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Handle qset-constraint-handler  constraint

(defun qset-constraint-handler (constraint datum-or-trans-set)
  (cond ((datum-p datum-or-trans-set)
	 (qset-constraint-handler-datum constraint datum-or-trans-set))
	(t (qset-constraint-handler-trans-set constraint datum-or-trans-set))))


;;; qset only sets full constant values.
(defun qset-constraint-handler-datum (constraint datum)
  (let ((situation (cell-situation (datum-cell datum))))
;    (if (eq (constraint-situation constraint) situation) (error "Should not call again?"))
    ;; [04/17/2014 Johan]
    ;; This assumes qset always sets both val and dir.
    (setf (constraint-situation-val constraint) situation)
    (setf (constraint-situation-dir constraint) situation)
    (setf (constraint-waiting constraint) nil)
    (let ((value (qset-constraint-constant constraint)))

;      (if (= (constraint-id constraint) 1603) (error "look at"))


      (cond ((discrete-var? (qset-constraint-var constraint))
	     (assert (member value (car (var-qspaces (qset-constraint-var constraint)))))
					;	   (let ((old (values-in-situation (qset-constraint-var constraint) (cell-situation (datum-cell datum)))))
					;	     (if old (error "look")))


	     (clobber (qset-constraint-var constraint)
		      value
		      (cell-situation (datum-cell datum))
		      (list (list constraint)) 
		      :discrete))
	    (t
	     (clobber (qset-constraint-var constraint)
		      (create-q-quantity-for-value value (qset-constraint-var constraint))
		      (cell-situation (datum-cell datum))
		      ;;** 'qset-constraint-handler-datum1
		      (list (list constraint)))
	     (when (numberp value)
	       (clobber (qset-constraint-var constraint)
			value
			(cell-situation (datum-cell datum))
			;; 'qset-constraint-handler-datum2
			(list (list constraint)))
	       :numeric))
	    ))))

;;; [4/17/2014 Johan] Needed because some values are not completely
;;; determined and therefore the constraint can be rerun.
;;; For qset-constraint's these can sometimes be determined at compile time.
(defun datum-completely-determined-p (quantity)
  (cond ((atom quantity) t)
	((consp quantity)
	 ;; Why isn't there a function for this?
	 (cond ((and (member (car quantity) '(Q- Q0 Q+) :test #'eq)
		     (member (cdr quantity) '(Inc Sty Dec) :test #'eq)))
	       (t (error "unimplemented"))))
	(t (error "unimplemented"))))


(defun create-q-quantity-for-value (value var)
  (cond ((symbolp value)
	 (create-q-quantity var value
			    (qspace-for-value var value)
			    'Std))
	((interval? value)
	 (create-q-quantity var value
			    (qspace-for-value var value)
			    'Std))
	((numberp value)
	 (if (= value 0)
	     (create-q-quantity var 'Q0
				(qspace-for-value var 'Q0)
				'Std)
	     (error "stub1: create-q-quantity-for-value for numbers (~s) not implemented" value)))
	(t (error "stub2: create-q-quantity-for-value (~s) not implemented" value))))

;; [12/09/2011 klenk] does not cope with refinement
;; [12/09/2011 klenk] returns t is satisfied and false otherwise
(defun qset-constraint-handler-trans-set (constraint trans-set)
  (let ((tran (find (qset-constraint-var constraint) trans-set :key #'possible-transition-variable)))
;    (assert tran)
    (cond ((and 
	    (not (discrete-var? (possible-transition-variable tran)))
	    (numberp (qset-constraint-constant constraint)))
	   (if (= (qset-constraint-constant constraint) 0)
	       (equal 'Q0 (q-quantity-value (possible-transition-new-value tran)))
	       (error "stub")))
	  (t
	   (equalp
	    (qset-constraint-constant constraint)
	    (q-quantity-value (possible-transition-new-value tran)))))))



;;;
;;

(defun mod-when-constraint (constraint datum-or-trans-set)
  (error "stub")
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Power constraint handler



(defun power-constraint-handler (constraint datum-or-trans-set)
  (assert datum-or-trans-set)
  (if (datum-p datum-or-trans-set)
      (power-constraint-handler-datum constraint datum-or-trans-set)
      (power-constraint-handler-trans-set constraint datum-or-trans-set)))


;; [04/11/2012 klenk] Not fully handled, but focusing on the simultiona aspects
;; [04/10/2012 klenk] constant integer exponent
;; [04/10/2012 klenk] Therefore three cases: (1) both mags and dirs known, (2) base mag and deriv known, 
;; [04/10/2012 klenk] (3) only base mag known, (4) result mag known
(defun power-constraint-handler-datum (constraint datum)
  (setf (constraint-waiting constraint) nil)

  (let* ((sit (cell-situation (datum-cell datum)))
	 (blist (blist-for-constraint-sit constraint sit))
	 (deriv-blist (blist-for-constraint-derivs-sit constraint sit))
	 (base (cdr (assoc (power-constraint-base constraint) blist)))
	 (base-deriv (cdr (assoc (power-constraint-base constraint) deriv-blist)))
	 (result (cdr (assoc (power-constraint-result constraint) blist)))
	 (result-deriv (cdr (assoc (power-constraint-result constraint) deriv-blist)))
	 (invert-base? (eql (power-constraint-base-polarity constraint) '-))
	 (invert-result? (eql (power-constraint-result-polarity constraint) '-)))
    (assert (and (integerp (power-constraint-exp constraint))
		 (>= (power-constraint-exp constraint) 0)))
    (assert (and (not invert-base?)(not invert-result?)))
;; [04/10/2012 klenk] Case 1: All known
    (cond ((and base base-deriv result result-deriv)
	   (unless (power-constraint-all-known? constraint base base-deriv result result-deriv)
	     (contradiction 'power-constraint (list base base-deriv result result-deriv) sit)))
;; [04/10/2012 klenk] Case 2: Base Mag and deriv known
;; [04/11/2012 klenk] Case 3: Only Base known
	  (base
	   (ecase base
	     (Q+ (clobber (power-constraint-result constraint)
			  (create-q-quantity (power-constraint-result constraint) base nil base-deriv)
			  sit (list (list constraint 'p1))))
	     (Q0 (clobber (power-constraint-result constraint)
			  (create-q-quantity (power-constraint-result constraint) base nil 'Q0)
			  sit (list (list constraint 'p2))))
	     (Q- (clobber (power-constraint-result constraint)
			  (create-q-quantity (power-constraint-result constraint) 
					     (if (evenp (power-constraint-exp constraint))
						 'Q+
						 base)
					     nil
					     (when base-deriv
					       (if (evenp (power-constraint-exp constraint))
						   (q-invert base-deriv)
						   base-deriv)))
			  sit (list (list constraint 'p3))))))
;; [04/11/2012 klenk] Case 4: Result mag known
	  (result
	   (unless (evenp (power-constraint-exp constraint))
	     (clobber (power-constraint-base constraint)
		      (create-q-quantity (power-constraint-base constraint) result
					 nil (unless (eq result-deriv 0) result-deriv))
		      sit (list (list constraint 'p4)))))))

  )


(defun power-constraint-handler-trans-set (constraint trans-set)
  (let ((blist (blist-for-constraint constraint trans-set))
	(deriv-blist (blist-for-constraint-derivs constraint trans-set))
	(invert-base? (eql (power-constraint-base-polarity constraint) '-))
	(invert-result? (eql (power-constraint-result-polarity constraint) '-)))
    (assert (and (integerp (power-constraint-exp constraint))
		 (>= (power-constraint-exp constraint) 0)))
    (assert (and (not invert-base?)(not invert-result?)))
    (power-constraint-all-known? 
     constraint 
     (cdr (assoc (power-constraint-base constraint) blist))
     (cdr (assoc (power-constraint-base constraint) deriv-blist))
     (cdr (assoc (power-constraint-result constraint) blist))
     (cdr (assoc (power-constraint-result constraint) deriv-blist)))))
	 


(defun power-constraint-all-known? (constraint base base-deriv result result-deriv)
  (if (evenp (power-constraint-exp constraint))
      (or (and (eq result 'Q+)
	       (or (and (eq base 'Q+)
			(eq base result)
			(eq base-deriv result-deriv))
		   (and (eq base 'Q-)
			(eq (q-invert base-deriv) result-deriv))))
	  (and (eq base 'Q0)
	       (eq base result)
	       (eq result-deriv 'Q0))
	       )
      (or (and (not (eq base 'Q0))
	       (eql base result)
	       (eql base-deriv result-deriv))
	  (and (eq base 'Q0)
	       (eq base result)
	       (eq result-deriv 'Q0)))))


  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; gt constraint handler



(defun gt-constraint-handler (constraint datum-or-trans-set)
  (assert datum-or-trans-set)
  (if (datum-p datum-or-trans-set)
      (gt-constraint-handler-datum constraint datum-or-trans-set)
      (gt-constraint-handler-trans-set constraint datum-or-trans-set)))


(defun gt-constraint-handler-datum (constraint datum)
  (setf (constraint-waiting constraint) nil)
  (let* ((sit (cell-situation (datum-cell datum)))
	 (blist (blist-for-constraint-sit constraint sit))
	 (lhs (cdr (assoc (gt-constraint-lhs constraint) blist)))
	 (rhs (cdr (assoc (gt-constraint-rhs constraint) blist))))
    (when (and lhs rhs)
      (unless (or (and (not (gt-constraint-invert? constraint))
		       (member (q-subtract lhs rhs) '(Q+ Q?)))
		  (and (gt-constraint-invert? constraint)
		       (member (q-subtract rhs lhs) '(Q+ Q?))))
	(contradiction 'gt-constraint (list lhs rhs (gt-constraint-invert? constraint))
		       sit)))))


(defun gt-constraint-handler-trans-set (constraint trans-set)
  (let* ((blist (blist-for-constraint constraint trans-set))
	 (lhs (cdr (assoc (gt-constraint-lhs constraint) blist)))
	 (rhs (cdr (assoc (gt-constraint-rhs constraint) blist))))
    (or (and (not (gt-constraint-invert? constraint))
	     (member (q-subtract lhs rhs) '(Q+ Q?)))
	(and (gt-constraint-invert? constraint)
	     (member (q-subtract rhs lhs) '(Q+ Q?))))))





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; ----------------------------------------------------------------------------
;;;; File name: constraints.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 01, 2011 15:03:07
;;;;   Purpose: Control for constraint propagation and condition evaluation and
;;;;            other general functions that work over all constraints
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Friday, June 21, 2013 at 08:42:36 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; propagation

;;; Breadth-first is preferred.
(defun propagate (datum justification situation)
  (debug-print nil "~% Propagate ~a by ~a" datum justification)
  (let* ((cell (datum-cell datum))
	 (var (cell-var cell)))
    (debug-print nil "~% Uses: ~a" (var-uses var))

    ;; Queue the specific constraints.
    (dolist (constraint (var-uses var))
      ;; Unless the constraint is already queued, or it is the reason for the propogation
      ;; But somewhere the convention for reflecting constraints was changed so justifications
      ;; are now of various inconsistent formats.  This needs to be cleaned up some day.
      (debug-print nil "~% var: ~a use: ~a waiting: ~a" var constraint (constraint-waiting constraint))

      (unless (or (constraint-waiting constraint)
		  (eq constraint (caar justification))
		  ;; This is needed for justifications from the symbolic solver which 
		  ;; look like: ((<handler> <constraint> <datum1> ... <datumn>)
		  (eq constraint (cadar justification))
		  ;; [2014 04 14 Johan]
		  ;; This assumes a particular constraint should only be applied once per situation
		  ;; to set some value.
;;; In progress.  This will not work on constraints which work only on val/drv.
		  (and (eq situation (constraint-situation-val constraint))
		       (eq situation (constraint-situation-dir constraint)))
		       
		  )
;	(when (eq (cell-situation cell) (constraint-situation constraint))
;	  (format t "~% ******** running ~a for a second time on ~a" constraint datum)
;	  (error "look")
;	  )

	(debug-print nil "~% Pushing2 ~a on system queue, justification: ~a" constraint
		     justification)
;	(and (= (constraint-id constraint) 2)
;	     (eq (caar justification) 'merge1)
;	     (print '**********************************))

	(push constraint (system-queue *system-being-analyzed*))
	(push datum (constraint-waiting constraint)))
;; Only for debugging.
;      (check-constraint-waiting 'D)
      )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Running constraints


;;; Run constraints associated with a particular time.
;; [06/25/2012 klenk] active-constraints do not need to have their conditions checked
(defun run-constraints (situation &optional active-constraints)
;; Only for debugging:
;  (check2-clobbered 'C)

;;   (check-constraint-waiting 'C)
  (case (catch :contradiction (run-constraints1 situation active-constraints) :succeed)
    (:succeed (confirm-uses-gone)
	      :succeed)
    (:fail (clear-constraints) :fail)
    (t (error "Impossible run-constraints result"))))

(defvar *foo* nil)

(defun confirm-uses-gone ()
  (let ((bad nil))
    (dolist (constraint (system-constraints *system-being-analyzed*))
      (if (constraint-waiting constraint) (push constraint bad)))
    (when bad
      (setq *foo* bad)
      (error "Booo"))))

;;; Since we don't have a TMS yet:
(defun clear-constraints ()
  (dolist (constraint (system-constraints *system-being-analyzed*))
    (setf (constraint-waiting constraint) nil))
  (setf (system-queue *system-being-analyzed*) nil)
  )

;; [08/27/2012 klenk] Active constraints are the complete set of constraints that result
;; [08/27/2012 klenk] from a discrete transition. If they exist then there is no need to call
;; [08/27/2012 klenk] constraint-active-p
;; [04/18/2014 klenk] Because the situation may be partial.  constaint-active-p may return unknown/nil for
;; [04/18/2014 klenk] a constraint in the set of active-constraints.
(defun run-constraints1 (situation active-constraints)
  (debug-print nil "~% Entering run-constraints1 on ~a" situation)
  ;; If this is common, optimize it.
  
;  (check2-clobbered 'A)
  (run-one-var-constraints situation active-constraints)
  	    
;  (debug-print nil "~% System queue at start is: ~a" (system-queue *system-being-analyzed*))
   
 ; (check2-clobbered 'B)

  ;; Do the case of 2 bindings are greater.
  (check-constraint-waiting 'A)
;  (debug-print nil "~% System queue is of length ~d" (length (system-queue *system-being-analyzed*)))

  (do nil ((null (system-queue *system-being-analyzed*)))
;    (check-constraint-waiting 'B)

;;    (debug-print nil "~% System queue is now: ~a" (system-queue *system-being-analyzed*))
; Commented out because isn't this just checking for optimization.
;    (assert (every #'constraint-waiting (system-queue *system-being-analyzed*)))
    (let ((constraint (pop (system-queue *system-being-analyzed*))))
      (debug-print nil "~% Running ~a, activity is: ~a" constraint 
		   (constraint-active-p constraint situation))
;      (if (= (constraint-id constraint) 1603) (error "look at"))
      (cond ((or;;**** not simplest form.*** for this (or ...)
	      (and active-constraints (member constraint active-constraints)) 
	      (and (not active-constraints) (constraint-active-p constraint situation)))

	     (let ((handler (constraint-function constraint)))
               (debug-print nil "~& Handler is ~S" handler)
	       (cond ((null handler) (error "Cannot handle"))
		     (t (funcall handler constraint (car (constraint-waiting constraint))))))
;	     (check-constraint-waiting 'F)
	     )
	    (t 
;	     (debug-print nil "~& Constraint ~A is not active in sit ~S" constraint situation)
	     (debug-print nil "~% Clearing waiting on ~a" constraint)
;	     (check-constraint-waiting 'E)
	     (setf (constraint-waiting constraint) nil)))
;      (check-constraint-waiting 'C)

;      (check2-clobbered 'E)

      )
    ))

;;; [2014 04 14 Johan] Broke up run constraints into smaller functions.
;;; Question: Active-constraints is probably useless.
;;; Creating fake cells and datums is also.
(defun run-one-var-constraints (situation active-constraints)
 (let* ((truth (make-cell :situation situation))
	 (datum (make-datum :cell truth)))
    (incf (system-datum-counter *system-being-analyzed*))
    (incf (system-cell-counter *system-being-analyzed*))
    ;; 1 unknowns need to be special cased. **** maybe 0 as well?
;    (print (list 'onevar situation))
    (dolist (constraint (active-one-var-constraints situation *system-being-analyzed* active-constraints))
;      (if (= (constraint-id constraint) 1603) (print (list 'firing1603 situation)))

      (unless nil ;(eq situation (constraint-situation constraint))
	(debug-print nil "~% Running One var Constraint: ~a (~d)" constraint (length (constraint-waiting constraint)))
	(let ((handler (constraint-function constraint)))
	  (cond ((null handler) (error "Missing handler"))
		(t 
					;*** is this wasting cpu cycles?
		 (setf (system-queue *system-being-analyzed*)
		   (delete constraint (system-queue *system-being-analyzed*)
			   :test #'eq :count 1
			   )) 
		 ;; Dx:
		 ;;(if (member  constraint (system-queue *system-being-analyzed*)) (error "no"))

		 (funcall handler constraint datum))))))))

;;; This is only used for debugging.  It checks the invariant that every constraint
;;; on the queue should have at least one datum wating for it.  Otherwise it
;;; should not be on the queue in the first place.
(defun check-constraint-waiting (ignore)
  (dolist (constraint (system-queue *system-being-analyzed*))
    (unless (constraint-waiting constraint) 
      (format t "~% system-queue = ~a" (system-queue *system-being-analyzed*))
      (format t "~% Constraint ~a has an empty constraint-wating" constraint)
      (error "invalid constraint-waiting on queue"))))

(defun contradiction (&optional reason antecedents situation)
  (unless situation (error "look"))
  (debug-print nil "~%Contradiction in ~A with antes ~A" situation antecedents)
;  (error "contradictions")
  (push (list :contradiction reason antecedents) (situation-trace situation))
  (setf (system-last-contradiction *system-being-analyzed*) (list reason antecedents situation))
;  (error "no")
  (unless situation (error "fix"))
;  (check2-clobbered)
  (throw :contradiction :fail))

;;; This is often called repeatedly so we cache it.
;;; [04/04/2014 Johan] Rewritten.  Ultimately we should flush this.
(defun active-constraints (situation &optional (system *system-being-analyzed*))
  (cond ((situation-active-constraints situation)
	 (copy-list (situation-active-constraints situation)))
	(t
	 (let ((actives (system-unconditional-constraints system)))
	   (dolist (constraint (system-conditional-constraints system))
	     (if (constraint-active-p constraint situation)
		 (push constraint actives)))
	   (setf (situation-active-constraints situation) actives)
	   (copy-list actives)))))

;;; [04/04/2014 Johan] A version of active-constraints that presumes the caller 
;;; will not change the returned value.
(defun active-constraints-safe (situation &optional (system *system-being-analyzed*))
  (cond ((situation-active-constraints situation))
	(t
	 (let ((actives (system-unconditional-constraints system)))
	   (dolist (constraint (system-conditional-constraints system))
	     (if (constraint-active-p constraint situation)
		 (push constraint actives)))
	   (setf (situation-active-constraints situation) actives)
	   actives))))

;; [12/02/2011 klenk] Unsure if I have to do anything with eliminated vars
(defun constraint-degree (constraint)
  (length (constraint-variables constraint)))

(defun constraints-by-degree (constraints degree)
  (remove-if-not #'(lambda (constraint) (= (constraint-degree constraint) degree)) constraints))

;; [12/02/2011 klenk] This may go away
(defun active-one-var-constraints (situation system active-constraints)
  (if active-constraints
      (remove-if-not #'(lambda (constraint)
			      (= (constraint-variable-count constraint) 1))
		     active-constraints)
      (remove-if-not #'(lambda (constraint)
			 (and (constraint-active-p constraint situation)
			      (= (constraint-variable-count constraint) 1)))
		     (system-constraints system))))

(defun constraint-active-p (constraint situation)
  (and (not (constraint-eliminated constraint))
       (or (null (constraint-condition constraint))
	   (ecase (evaluate-condition (constraint-condition constraint) situation)
	     (:true t)
	     (:false nil)
	     (:unknown (debug-print nil "~%Can't evaluate ~S with condition ~S in ~S; not enough info~%" 
				    constraint (constraint-condition constraint) situation)
		       nil)))))

;; [08/28/2013 klenk] This is the interface with previous callers
(defun evaluate-condition-tv (condition situation)
  (eq (evaluate-condition condition situation) :true))

;; [08/28/2013 klenk] This function will return :true, :false, :unknown
;;; [04/06/2014 Johan] saved some conses.
(defun evaluate-condition (condition situation)
;  (format t "~% Evaluating condition ~a" condition)
  (cond ((var-p condition)
	 (evaluate-discrete-condition condition :|true| situation)
;;;         (evaluate-condition (list '= condition :|true|) situation)
	 )
        (t
         (ecase (car condition)
           (>= 
            (evaluate->= (second condition) (third condition) situation))
           (<= 
            (evaluate->=  (third condition)(second condition) situation))
           (> 
            (evaluate-> (second condition) (third condition) situation))
           (<
            (evaluate-> (third condition) (second condition) situation))
           (q= 
	    (error "q= is no longer supported as a condition")
            (eql
             (evaluate-q=-arg (second condition) situation)
             (evaluate-q=-arg (third condition) situation)))
           ((== =)
	    (evaluate-discrete-condition (second condition)(third condition) situation))
           (not 
	    (ecase (evaluate-condition (second condition) situation)
	      (:true :false)
	      (:false :true)
	      (:unknown :unknown)))
           (and
	    ;; [04/27/2014 Johan] This needs to all go away.  But for now I improved it, with less calls to evalcuate-condition.
	    ;; Two state machine: true/unknown.  true&true->true, true&-false-> return false, true&unknown->unknown.
	    ;;                                   unknown&true->unknown, unknown&false->return false., unknown&unknown->unknown.
	    (let ((result :true))
	      (dolist (c (cdr condition))
		(case (evaluate-condition c situation)
		  (:false (return-from evaluate-condition :false))
		  (:unknown (setq result :unknown))))
	      result))


	    ; (cond ((every #'(lambda (c)
	    ; 		      (eq (evaluate-condition c situation) :true))
	    ; 		  (cdr condition))
	    ; 	   :true)
	    ; 	  ((some #'(lambda (c)
	    ; 		     (eq (evaluate-condition c situation) :false))
	    ; 		 (cdr condition))
	    ; 	   :false)
	    ;  (t :unknown)))	
           (or
	    (let ((result :false))
	      (dolist (c (cdr condition))
		(case (evaluate-condition c situation)
		  (:true (return-from evaluate-condition :true))
		  (:unknown (setq result :unknown))))
	      result))

            ; (cond ((some #'(lambda (c)
	    ; 		     (eq (evaluate-condition c situation) :true))
	    ; 		 (cdr condition))
	    ; 	   :true)
	    ; 	  ((some #'(lambda (c)
	    ; 		     (eq (evaluate-condition c situation) :unknown))
	    ; 		 (cdr condition))
	    ; 	   :unknown)
	    ; 	  (t :false)))
           (:terminal
            (error "unclear what this should mean for QRM")
	    (terminal-situation? situation))
	   (pre
	    (evaluate-pre-boolean-variable (second condition) situation))))))

(defun evaluate-pre-boolean-variable (var sit)
;; [04/27/2014 Johan] Commented out to save CPU time.
;;  (assert (and 
;;	   (var-p var)
;;	   (eq (var-fundamental-type var) :discrete)
;;	   (eq (var-type var) 'env2-names::|Boolean|)))
  (if (determine-pre-value var sit)
      (eql (determine-pre-value var sit) :true)
      (throw :not-enough-info nil)))

(defun terminal-situation? (sit)
  ;; how can we know? -- wcj, 6/20/12
  ;; I suppose if all derivatives are zero...
  (declare (ignore sit))
  nil)

;; [06/11/2012 klenk] Walk the tree and all var-p must have a value
;; [06/11/2012 klenk] Unfortunately this falls apart when we are missing a deriv, and we need it
;; [06/11/2012 klenk] NOT USED
(defun all-vars-known? (condition sit)
  (cond ((null condition) t)
	((var-p condition)
	 (values-in-situation condition sit))
	((consp condition)
	 (and (all-vars-known? (car condition) sit)
			       (all-vars-known? (cdr condition) sit)))
	(t t)))


(defun evaluate->= (lhs rhs situation)
  (let ((lhs-mag (evaluate-condition-arg lhs situation))
	(rhs-mag (evaluate-condition-arg rhs situation)))
    (if (and lhs-mag rhs-mag)
	(if (member (q-subtract lhs-mag rhs-mag) '(Q0 Q+))
	    :true
	    :false)
	:unknown)))

(defun evaluate-condition-arg (arg sit)
  (cond ((and (var-p arg)
	      (simpleqspace? (car (var-qspaces arg))))
	 (simple-qvalue arg sit))
	((or (and (numberp arg)
		  (= arg 0))
	     (and (symbolp arg)
		  (eql arg 'Q0)))
	 'Q0)
	((and (eql (car arg) 'abs)
	      (var-p (cadr arg)))
	 (let ((val (evaluate-condition-arg (cadr arg) sit)))
	   (if (eq val 'Q0)
	       val
	       'Q+)))
	(t (error "unhandled argument for  conditional ~A" arg))))
	     


(defun evaluate-> (lhs rhs situation)
  (let ((lhs-mag (evaluate-condition-arg lhs situation))
	(rhs-mag (evaluate-condition-arg rhs situation))
	(lhs-deriv (evaluate-condition-arg-deriv lhs situation))
	(rhs-deriv (evaluate-condition-arg-deriv rhs situation)))
    (declare (ignore lhs-deriv rhs-deriv))
    ;; Why are we computing derivs and not using them?
;    (format t "~% condition>  ~a : ~a" lhs-mag rhs-mag)

    (if (and lhs-mag rhs-mag)
	(if (member (q-subtract lhs-mag rhs-mag) '(Q+))
	    :true
	    :false)
	:unknown)))


(defun evaluate-condition-arg-deriv (arg situation)
  (cond ((and (var-p arg)
	      (simpleqspace? (car (var-qspaces arg))))
	 (qderiv-simpleq arg situation))
	((or (and (numberp arg)
		  (= arg 0))
	     (and (symbolp arg)
		  (eql arg 'Q0)))
	 'Q0)
	((and (eql (car arg) 'abs)
	      (var-p (cadr arg)))
	 (let ((val (evaluate-condition-arg-deriv (cadr arg) situation)))
	   (if (eq val 'Q0)
	       val
	       'Q+)))
	(t (error "unhandled argument for  conditional ~A" arg))))

(defun evaluate-discrete-condition (arg1 arg2 situation)
  (let ((lhs (evaluate-discrete-arg arg1 situation))
	(rhs (evaluate-discrete-arg arg2 situation)))
     (if (and lhs rhs)
	 (if (equal lhs rhs)
	     :true
	     :false)
	 :unknown)))


(defun evaluate-discrete-arg (arg sit)
  (cond ((discrete-var? arg)
         (discrete-value-symbol arg sit))
	((symbolp arg)
         arg)
	((integerp arg)
	 arg)
	((eq (car arg) 'pre)
	 (determine-pre-value (second arg) sit))
	(t
         nil)))

;; [08/30/2012 klenk] A little concerned about the behavior graph here.  The following
;; [08/30/2012 klenk] Is an excerpt from the Modelica book
;; Returns the left limit y(t_pre) of variable y(t) at a time instant t. At an event Instant, y(t_pre)) is the value of y after the most recent event iteration at time instant t. The value pre(y) can throught of as the predecessor value of y...
;;  The argument y must be a variable and not a general expression
;; The pre operator can only be applied if the following three conditions are fulfilled simultaneously:
;; 	1. The variable y had a type which is a subtype of Boolean, Integer, Real, or String
;; 	2. The variable y is a discrete-time variables
;; 	3. The operator is not used in a function
;; At the initial time pre(y) = y.start.
(defun determine-pre-value (var sit)
  (assert (and (discrete-var? var)(situation-parents sit)
	       ;(= (length (situation-parents sit)) 1)
	       ))
  (cond ;((null (situation-parents sit))
	 ;(discrete-value-symbol var sit))
	((= (length (situation-parents sit)) 1)
	 (discrete-value-symbol var (car (situation-parents sit))))
	(t
;; [09/04/2012 klenk] This is not executed currently due to the assert above
	 (let ((ret (discrete-value-symbol var (car (situation-parents sit)))))
	   (if (every #'(lambda (parent)
			  (eql ret (discrete-value-symbol var parent)))
		      (situation-parents sit))
	       ret
	       (error "Multiple disagreeing parents for pre. Should not be possible as discrete values don't change for continuous integration"))))))
  
;; [12/01/2011 klenk] This will be insuffecient, not sure how we want to rewrite the qsolver functions
(defun evaluate-q=-arg (arg sit)
  (cond ((var-p arg)
	 (when (qualitative-values arg sit)
	   (simple-qvalue arg sit)))
	((and (consp arg) 
	      (eq (car arg) '-)
	      (= (length arg) 2))
	 (q-invert (evaluate-q=-arg (second arg) sit)))
	((and (consp arg) 
	      (member (car arg) '(+ - * /)))
	 (reduce (ecase (car arg)
		   (+ #'q-add)
		   (- #'q-subtract)
		   (* #'q-multiply)
		   (/ #'q-divide))
		 (cdr arg) :key #'(lambda (arg) (evaluate-q=-arg arg sit))))
;; [12/01/2011 klenk] Do we need something thatchecks for landmark symbols?
	((and (consp arg) 
	      (eql (car arg) 'pre))
	 (evaluate-q=-arg  (second arg) (car (situation-parents sit))))
	(t arg))) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; [12/05/2011 klenk] This assumes that constraint-function returns t or nil when given a 
;; [12/05/2011 klenk] list of transitions instead of a datum
(defun inconsistent-by-constraint? (pos-trans-set constraint)
  ;; Remove this assert as its expensive
;;  (assert (every #'(lambda (var)
;;                     (find var pos-trans-set :key #'possible-transition-variable))
;;		 (constraint-variables constraint)))
  (unless 
      (and 
	   (funcall (constraint-function constraint)
		    constraint
		    pos-trans-set))
    t))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; constraint blist

  

;; [12/13/2011 klenk] simpleq blist for esasier constraint handling
;;***** too slow, and conses too much.
(defun blist-for-constraint (constraint pos-trans-set)
  (mapcar #'(lambda (var)
	      (let ((val
                     (possible-transition-new-value 
                      (find var pos-trans-set :key #'possible-transition-variable))))
		  (cons var
			(cond ((discrete-var? var) val)
			      (t
			       (val->simpleq val))
			      ))))
	  (constraint-variables constraint)))

(defun blist-for-constraint-sit (constraint sit)
  (mapcar #'(lambda (var)
	      (cons var (simple-qvalue var sit)))
	  (constraint-variables constraint)))


;;; Returns two values: mag, deriv 
;;; [04/28/2014 Johan]
(defun lookup-mag-deriv (var transitions)
  (dolist (transition transitions)
    (when (eq var (possible-transition-variable transition))
      (let ((val (possible-transition-new-value transition)))
	(return (values (if (discrete-var? var) val
			  (val->simpleq val))
			(deriv->simpleq (q-quantity-deriv val))))))))

;;;***** merg these two
(defun lookup-mag-deriv-sit (var sit)
  (values (simple-qvalue var sit)
	  (qderiv-simpleq var sit)))

;;*** flush;

  ; (dolist (transition transitions)
  ;   (when (eq var (possible-transition-variable transition))
  ;     (let ((val (possible-transition-new-value transition)))
  ; 	(return (values (if (discrete-var? var) val
  ; 			  (val->simpleq val))
  ; 			(deriv->simpleq (q-quantity-deriv val))))))))
			
(defun blist-for-constraint-derivs (constraint pos-trans-set)
  (mapcar #'(lambda (var)
	      (let ((val (possible-transition-new-value 
			    (find var pos-trans-set :key #'possible-transition-variable))))
		  (cons var (deriv->simpleq (q-quantity-deriv val))))) 
	  (constraint-variables constraint)))

(defun blist-for-constraint-derivs-sit (constraint sit)
  (mapcar #'(lambda (var)
	      (cons var (qderiv-simpleq var sit))) 
	  (constraint-variables constraint)))




(defun val-from-blist (var blist)
  (let ((ret (cdr (assoc var blist))))
    (assert ret)
    ret))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: clobber.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 01, 2011 10:25:06
;;;;   Purpose: assigns datums to situations
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Monday, November 18, 2013 at 13:27:22 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)


;;; Returns the type of the value/var 
(defun type-from-value (value var)
  (cond ((discrete-var? var)
	 :discrete)
	((simpleq-p value) :simple-qualitative)
	((numberp value) :numeric)
	((or (interval? value)
	     (q-quantity-p value))
	 :qualitative)
	((and (atom value)
	      (some #'(lambda (qspace) 
			(member value qspace))
		    (var-qspaces var))) :qualitative)
	((mode-var? var) :mode)

	(t (error "Unknown-type, value ~A, var ~A" value var))))


;; [12/01/2011 klenk] var is variable
;; [12/01/2011 klenk] value is an atom if a (landmark, mode name, or number) and a list if an interval
;; [05/25/2014 Johan] situation can either be a situation or 'global
(defun clobber (var value situation justification &optional supplied-type )

  (let ((type (or supplied-type (type-from-value value var))))
    (assert (and (var-p var) value type justification))
    (pushnew type (system-analyses *system-being-analyzed*))

    (when (eq type :numeric)
      (clobber-qvalue-by-numeric var value situation justification))

;; [12/01/2011 klenk] handle eliminated variables
;; [02/28/2012 klenk] Should only be necessary for mode changes and initial conditions
    (when (and (var-eliminated var)(var-equivalent-class var))
       (multiple-value-setq (var value)
	(update-eliminated-var var value type)))

;; [12/01/2011 klenk] Q+ and Q- don't exist internally anymore
    (when (eq type :simple-qualitative)
      (setq value (simpleq->interval value)
	    type :qualitative))

    (when (eq type :discrete)
      (if (not (q-quantity-p value))
	  (setq value (make-q-quantity :value value :qspace (car (var-qspaces var)) :deriv 'Std)
		type :qualitative)
	  (setq type :qualitative)))

    (when (eq type :qualitative)
      (assert (not (member value '(Q- Q+)))))
    (when (and (eq type :qualitative)
	       (not (q-quantity-p value)))
      (setq value (create-q-quantity var value nil nil)))
;    (assert (not (= (var-id var) 14)))
    (clobber-var var value situation justification type )))

;; [02/29/2012 klenk] takes a quantitative value and clobbers an appropriate :qualitative
(defun clobber-qvalue-by-numeric (var value situation justification)
  (clobber var (create-q-quantity-from-number var value) situation  justification :qualitative))

(defun update-eliminated-var (var value type)
  (let ((invert? (member var (equivalent-class-negatives (var-equivalent-class var))))
	(rep-var (equivalent-class-representative (var-equivalent-class var))))
    (cond ((eq type :simple-qualitative)
	   (values rep-var (if invert? (q-invert value) value)))
	  ((and (eq type :qualitative)
		(not (q-quantity-p value)))     
	   (values rep-var (if invert? (invert-interval value) value)))
	  ((and (eq type :qualitative)
		(q-quantity-p value))
	   (values rep-var (if invert? (invert-q-quantity value) value)))
	  ((eq type :numeric)
	   (values rep-var (if invert? (- value) value)))
	  (t (error "update-eliminated-var: unhandled update on ~A, value ~A, type ~A" var value type)))))


(defun ensure-justification (justification)
  (assert (or (equal justification '((:continuous-transition)))
	      (equal justification '((q0)))
	      (equal justification '((condition-constant)))
	      (equal justification '((init nil)))
	      (equal justification '((reinit)))
	      (equal justification '((plunk)))
	      (equal justification '((set-mode)))
	      (equal justification '((:state-var-discrete)))
	      (equal justification '((:discrete-var-discrete)))
	      (equal justification '((:unchanged-mode)))
	      (equal justification '((:unchanged-discrete)))
	      (equal justification '((:function)))
	      (equal justification '((symbolic-plunker)))
;	      (equal justification '((:qualitative)))
	      (constraint-p (caar justification))
	      (var-p (cadr justification))
	      (eq (caar justification) :init)
	      (eq (caar justification) :qualitative)
	      (eq (caar justification) 'multiply-inverse)
	      (eq (caar justification) 'symbolic-multiply-new-multiplicand)
	      (eq (caar justification) 'symbolic-summer-one-datum)
	      (eq (caar justification) 'symbolic-multiply-new-result)
	      (eq (caar justification) 'symbolic-multiply-result-known-1)	      
	      (eq (caar justification) 'symbolic-multiply-new-result-1)
	      
)))

(defun clobber-var (var value situation justification type )
;  (assert (not (var-eliminated var)))
;  (ensure-justification justification)
  (debug-print nil "~% Clobbering ~a with ~a by ~a in ~a" var value justification situation)
;  (and justification (cdr justification) (member (cadr justification) (cddr justification))
;       (error "lolk"))

  (let ((cell (retrieve-cell var situation)))
    ;; Create the cell if it does not exist.
    (unless cell
      (incf (system-cell-counter *system-being-analyzed*))
      (setq cell (make-cell :var var :situation situation))
      (store-cell var situation cell))

    ;; Not sure where the optimum place to do this is.  
;    (if (eq type :symbolic)
;        (error "clobber-var: symbolic types not handled, var ~A, value ~A, situation ~A - (setq value (maxima::$ratsimp value)))" var value situation))
    
    ;; Check whether we already know value, in which case we do nothing.
    (dolist (old-value (cell-values cell))
      (when (known-value? value old-value)
	
	(push justification (datum-justifications old-value))
;	(debug-print nil "~% Not queuing because value exists.")
	(return-from clobber-var nil)))

    ;; Contradiction handling.  This needs to be greatly generalized.
    ;; Also merging.
    (ensure-consistency-with-new-value cell value type justification var situation)

    ;; Merge [q0:nil] [nil:Std] for example.
    ;; Qualitative values can be merged.
    ;; Duplicates part of ensure ... redesign this***
    (when (eq type :qualitative)
      (cond ((null (q-quantity-value value))
	     (let ((old-datum))
	       (dolist (datum (cell-values cell))
		 (cond ((not (eq (datum-type datum) :qualitative)))
		       ((null (q-quantity-value datum)))
		       ((not (equal (q-quantity-qspace value) (q-quantity-qspace (datum-quantity datum)))))
		       (old-datum (error "Not possible"))
		       (t (setq old-datum datum))))
	       ;; We have to merge values here. is the list structure immutable?**
	       (when old-datum
		 (setf (cell-values cell) (remove old-datum (cell-values cell) :count 1))
		 (setq value (copy-q-quantity value))
		 (setf (q-quantity-value value) (q-quantity-value (datum-quantity old-datum)))
		 (setq justification (cons (list 'merge2 (caar justification)) (cons old-datum (cdr justification))))
		 )))
	    ((null (q-quantity-deriv value))
	     (let ((old-datum))
	       (dolist (datum (cell-values cell))
		 (cond ((not (eq (datum-type datum) :qualitative)))
		       ((null (q-quantity-deriv datum)))
		       ((not (equal (q-quantity-qspace value) (q-quantity-qspace (datum-quantity datum)))))
		       (old-datum (error "Not possible"))
		       (t (setq old-datum datum))))
	       ;; We have to merge values here. is the list structure immutable?**
	       (when old-datum
		 (setf (cell-values cell) (remove old-datum (cell-values cell) :count 1))
		 (setq value (copy-q-quantity value))
		 (setf (q-quantity-deriv value) (q-quantity-deriv (datum-quantity old-datum)))
		 (setq justification (cons (list 'merge1 (caar justification)) (cons old-datum (cdr justification))))
		 )))))



    (let ((new-value (create-datum cell value (list justification) type)))
      

      

      

      ;;**** may not be needed. Think.
;      (when (eq type :symbolic)
;        (error "clobber-var: symbolic types not handled, var ~A, value ~A, situation ~A - (setq value (maxima::$ratsimp value)))" var value situation)
;	(setf (datum-unknowns new-value) 
;	      (collect-unknown-cells value situation)))
;	)
      ;; Wire up as tms (move to tms soon)
      (dolist (antecedent (cdr justification))

	(push (cons new-value justification) (datum-consequences antecedent)))

;;; Johan [04/10/2011].  A cell can have multiple values: that is the whole point of the design.
      (push new-value (cell-values cell))

;; [03/18/2012 klenk] We don't need to propagate during envisionment
      
      (propagate new-value justification situation)


      )))


;; [12/16/2011 klenk] IF the datum is already there, ensure it has the deriv, if so then don't add 
;; [12/16/2011 klenk] If we are adding a value without a deriv, ensure the qspace and value are the same
(defun known-value? (value datum)
  (cond ((eq (datum-type datum) :qualitative)
	 (and (q-quantity-p value)
	      (q-quantity-equal value (datum-quantity datum) :ignore-unknown-deriv? t)))
	(t
	 (equal value (datum-quantity datum)))))

(defun create-datum (cell value justifications type)
  (case type
    (:qualitative 
;     (assert (q-quantity-p value))
     (incf (system-datum-counter *system-being-analyzed*))
     (make-datum :cell cell 
		 :quantity value 
		 :justifications justifications
                 :type type))
    (:discrete (error "Should be of type :qualitative with a q-quantity value"))
    (t 
     (incf (system-datum-counter *system-being-analyzed*))
     (make-datum :cell cell
                 :quantity value
                 :justifications justifications
                 :type type))))

;; [12/15/2011 klenk] This is where I'll have to put the refinement for derivs of q-quantities
;;; [05/16/2014 Johan] changed so that [Q0 :nil] and [nil:Std] do not contradict
;;; The previous version of this was incomprehensible to me.
(defun ensure-consistency-with-new-value (cell value type  justification  var situation)
  ;; documentation, dammit!
  ;; consistent indentation wouldn't hurt, either!
  (dolist (old-value (cell-values cell))
    (let ((old-quantity (datum-quantity old-value)))
      (ecase (datum-type old-value)
	(:qualitative
	 (case type
	   (:numeric (unless (compare-ok-numeric-qualitative-p value old-quantity)
		       (contradiction 'qual-quant (list justification old-quantity value var) situation)))
	   (:qualitative
	    ;; If old quantity val was nil, this should not cause a contradiction.
	    (when (equal (q-quantity-qspace value) (q-quantity-qspace old-quantity))
	      (if (and (q-quantity-value value) 
		       (q-quantity-value old-quantity)
		       (not (equal (q-quantity-value value) (q-quantity-value old-quantity))))
		  (contradiction 'clobber-var8a (list justification value old-quantity) situation))
	      (if (and (q-quantity-deriv value) 
		       (q-quantity-deriv old-quantity)
		       (not (equal (q-quantity-deriv value) (q-quantity-deriv old-quantity))))
		  (contradiction 'clobber-var8b (list justification value old-quantity) situation))
	      ;; If we get this far; remove the old one if its subsumed.
	      (and (q-quantity-value value) (q-quantity-deriv value)
		   (or (null (q-quantity-value old-quantity))
		       (null (q-quantity-deriv old-quantity)))
		   (setf (cell-values cell) (remove old-value (cell-values cell)))))
	    )
	   (:symbolic)
           (:discrete
            (unless (and (equal value (q-quantity-value old-quantity))
                         (member value (q-quantity-qspace old-quantity)))
              (contradiction 'clobber-var10 (list justification value old-quantity) situation)))
	   (t (contradiction 'clobber-var6 (list justification old-quantity (datum-type old-value) type) situation))
           ))
        (:numeric
         (case type
           (:qualitative
            (unless (compare-ok-numeric-qualitative-p old-quantity value)
              (contradiction 'clobber-var7 (list justification old-quantity) situation)))
           (:numeric 
            (unless (= value old-quantity)
              (contradiction 'clobber-var8 (list justification old-quantity) situation)))
           (t (format t "~% Numeric contradiction")
              (error "stub4 -- ensure-consistency-with-new-value, numeric contradiction, old type ~A, new type ~A"
                     (datum-type old-value) type))))
	;; [12/01/2011 klenk] Modes are a special case where we can overwrite them
        (:mode 
         (ecase type 
           (:mode (delete-value-from-cell old-quantity cell))))
        (:symbolic (case type
                     (:symbolic (if (equal (datum-justifications old-value) '(((symbolic-plunker))))
                                    (delete-value-from-cell old-quantity cell))
				(symbolic-substitutions value old-value situation
							(cdr justification)
							)
                                )
                     (t)))
        (:discrete 
	 ;; this seems wrong.  Values seem to be showing up both as
	 ;; raw symbols, and as qspaces.  Probably should do something about 
	 ;; that somewhere else -- wcj, 20.6.12
         (ecase type
           (:discrete
            (unless (equal value old-quantity)
              (contradiction 'clobber-var9 (list justification value old-quantity) situation)))
           (:qualitative
            (unless (and (equal (q-quantity-value value) old-quantity)
                         (member old-quantity (q-quantity-qspace value)))
              (contradiction 'clobber-var11 (list justification value old-quantity) situation)))
           ))
        ))))


(defun delete-value-from-cell (item cell)
  (setf (cell-values cell) (remove item (cell-values cell)  :key #'datum-quantity)))


(defun compare-ok-numeric-qualitative-p (quant qual)
  (let ((qual (q-quantity-value qual))) 
    (or (and (> quant 0.0) (equalp qual '(Q0 Inf+)))
	(and (< quant 0.0) (equalp qual '(Inf- Q0)))
	(and (equalp quant 0.0) (eq qual 'Q0)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Cells

(defun retrieve-cell (var situation)
;  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))
  (cond ((and (not (eq situation 'global))
	      (var-position var))
	 (if (< (var-position var) (length (situation-values situation)))
	     (situation-cell var situation)))
	((var-global-cell var))))

;; [12/01/2011 klenk] This code may assume that vars are the lowest ids...
(defun store-cell (var situation cell)
  (cond ((null (var-position var)) 
	 (cond ((not (eq situation 'global)) (error "Attempt to store a value in compacted out cell"))
	       ((var-global-cell var) (error "Is this right?"))
	       (t (setf (var-global-cell var) cell)))
	 )
	;;[04/17/2014 Johan] I do not understand why this is needed.
	((< (var-position var) (length (situation-values situation)))
	 (setf (situation-cell var situation) cell))
	((null (situation-values situation))
	 (setf (situation-values situation) 
	   (make-array (1+ (system-max-position *system-being-analyzed*))
		       :initial-element nil))
	 (setf (situation-cell var situation) cell))
	(t 
	 (format t "~% Does this ever happen: copying...")
	 (let ((new-values (make-array (1+ (system-max-position *system-being-analyzed*))
					 :initial-element nil))) ; rather than 0
	   (dotimes (i (length (situation-values situation)))
	     (setf (aref new-values i) (aref (situation-values situation) i)))
	     (setf (situation-values situation) new-values)
	     (setf (situation-cell var situation) cell)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Dealing with derivs for q-quantities

;; [03/19/2012 klenk] dir - Inc, Std, Dec and sets every known q-quantity to that value
;; [03/19/2012 klenk] Then it propogates for this var
;;; [05/16/2014 Johan] This was really problematic.  First, I think values should be immutable, and this used to side-effect the value, e.g., [Q0:nil]->[Q0:Dec], and Second there was no justification. Third it repropagates unencessarily in cases where val/dir is nil orignally.  I changed this code to hold immuntability.
(defun clobber-qderivs (var dir situation constraint)
;  (assert (not (var-eliminated var)))
  (debug-print nil "~% Clobbering deriv of ~a with ~a by ~a in ~a" var dir constraint situation)
  ;; Optimize the case of one qualitative value.
  (let* ((cell (retrieve-cell var situation))
	 (datums (if cell (cell-values cell)))
	 (qdatum))
    (cond ((null datums) 
	   ;; This happens if the value is not set, but the derivative is. This case was not handled before.
	   ;; Ensure cell exists.
	   (unless cell
	     (incf (system-cell-counter *system-being-analyzed*))
	     (setq cell (make-cell :var var :situation situation))
	     (store-cell var situation cell))
	   (let* ((new-quantity (make-q-quantity :qspace (car (var-qspaces var)) :deriv dir))
		  (new-datum (make-datum :cell cell :quantity new-quantity :justifications `(((clobber-qderivs ,constraint)))
					 :type :qualitative)))
	     (setf (cell-values cell) (list new-datum))
	     (propagate new-datum
			`((,constraint :set-deriv))
			situation)))
	  ((dolist (datum datums qdatum)
	     (cond ((null (eq (datum-type datum) :qualitative)))
		   (qdatum (error "Doubt this case happens though"))
		   (t (setq qdatum datum))))
	   (let* ((q-quantity (datum-quantity qdatum))
		  (q-quantity-deriv (q-quantity-deriv q-quantity)))
	     (when (and q-quantity-deriv
			(not (eql q-quantity-deriv dir)))
	       (contradiction 'clobber-derivs 
			      (list q-quantity-deriv dir var) situation))
	     ;; Now do the case where val is not nil, but dir is.
	     (let* ((new-quantity (copy-q-quantity q-quantity))
		    (new-datum (make-datum :cell (datum-cell qdatum) :quantity new-quantity :justifications `(((clobber-qderivs ,constraint) ,qdatum))
					   :type :qualitative)))
	       (setf (q-quantity-deriv new-quantity) dir)
	       (setf (cell-values cell) (cons new-datum (remove qdatum datums)))
	       (propagate new-datum
			  `((,constraint :set-deriv))
			  situation))))
		  (t (error "no qualitative datum stub")))))
	  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Retrieving Values

(defun numeric-value (var situation)
  (let ((datum (numerical-value var situation)))
    (if datum (datum-quantity datum))))

(defun numerical-value (var situation)
  (dolist (value (values-in-situation var situation))
    (if (eq (datum-type value) :numeric)
     (return value))))

(defun symbolic-datum (var situation)
  (let ((symbolic))
    (dolist (value (values-in-situation var situation))
      (assert (datum-type value) () "no type")
      (case (datum-type value)
	(:numeric (return-from symbolic-datum value))
	(:symbolic (setq symbolic value))))
    symbolic))

(defun symbolic-value (var situation)
  (let ((datum (symbolic-datum var situation)))
    (if datum (datum-quantity datum))))

(defun mode-datum (var situation)
  (dolist (value (values-in-situation var situation))
    (assert (datum-type value) () "no type")
    (when (eq (datum-type value) :mode)
      (return-from mode-datum value))))

(defun mode-value (var situation)
  (let ((datum (mode-datum var situation)))
    (if datum (datum-quantity datum))))

(defun discrete-datum (var situation)
  (dolist (value (values-in-situation var situation))
    (assert (datum-type value) () "no type")
    (when (eq (datum-type value) :qualitative)
      (return-from discrete-datum value))))

;; [08/30/2012 klenk] Returns a q-quantity
(defun discrete-value (var situation)
  (assert (discrete-var? var))
  (let ((datum (discrete-datum var situation)))
    (if datum 
        (datum-quantity datum))))

;; [08/30/2012 klenk] returns a symbol
(defun discrete-value-symbol (var situation)
  (when (discrete-value var situation)
    (q-quantity-value (discrete-value var situation))))

;; [12/01/2011 klenk] there is one for each qspace
;; [11/10/2013 Johan] I don't understand why there would ever be more than one.
;; [5/04/2014 Johan] Optimized.

(defun qualitative-datums (var situation)
;;;  (assert (not (var-eliminated var)))
  (let ((datums (values-in-situation var situation)))
    ;; Optimize the case where there is only one qualitative value.
    (cond ((null datums) nil)
	  ((dolist (datum datums t)
	     (unless (eq (datum-type datum) :qualitative) (return nil)))
	   datums)
	  ((cdr datums)
	   ;; General case.
	   (let ((results))
	     (dolist (datum datums)
	       (if (eq (datum-type datum) :qualitative) (push datum results)))
	     results))
	  ((eq (datum-type (car datums)) :qualitative)
	   datums))))
 
(defun qualitative-datum (var situation)
  (car (qualitative-datums var situation)))

(defun qualitative-value (var situation)
  (let ((datums (qualitative-datums var situation)))
    (cond ((cdr datums) (error "More than one qualitative values."))
	  (t (datum-quantity (car datums))))))

;; [12/18/2011 klenk] returns a list of q-qauntity
(defun qualitative-values (var situation)
  (cond ((var-eliminated var)
	 (let ((ret (qualitative-values 
		     (equivalent-class-representative (var-equivalent-class var))
		     situation)))
	   (if (member var (equivalent-class-negatives (var-equivalent-class var)))
	       (mapcar #'invert-q-quantity ret)
	       ret)))
	(t
	 (mapcar #'datum-quantity 
		 (qualitative-datums var situation)))))


(defun qualitative-value-in-qspace (var situation qspace)
  (let ((qvalues (qualitative-datums var situation)))
    (cond ((null qvalues) nil)
	  (t
	   (let ((ret (remove-if-not 
		       #'(lambda (q-quantity)
			   (equal (q-quantity-qspace q-quantity) qspace))
		       (mapcar #'datum-quantity qvalues))))
	     (assert (= (length ret) 1))
	     (car ret))))))
	   
;;; [05/07/2014 Johan] add global value check.
(defun values-in-situation (var situation)
  (let ((cell (or (var-global-cell var) (retrieve-cell var situation))))
    (if cell (cell-values cell))))

;; [02/ 4/2012 klenk] Returns multiple values, one for the Q+,Q0,Q-, and one for the deriv, Inc, Std, Dec
(defun simple-qvalue (var situation)
  (let ((qvalue (car (qualitative-values var situation))))
    (when qvalue
      (values (val->simpleq qvalue)
	      (q-quantity-deriv qvalue)))))

(defun qderiv (var situation)
  (let ((q-value (car (qualitative-values var situation))))
    (when q-value
      (q-quantity-deriv q-value))))

(defun qderiv-simpleq (var sit)
  (let ((dir (qderiv var sit)))
    (when dir (deriv->simpleq dir))))

(defun qspace-for-value (var val)
  (let ((val (if (interval? val) (car (remove 'Q0 val)) val)))
    (dolist (qspace (var-qspaces var)
             (error "unknown qspace for var: ~A  val: ~A" var val))
      (when (member val qspace)
	(return-from qspace-for-value qspace)))))
 


 
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: create-model.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: November 30, 2011 16:10:33
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Monday, November 18, 2013 at 17:34:41 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(defun create-situation-and-system (name model initial-conditions state-vars
				    allow-initial-ambiguity? success-fn
				    &key (debug? nil)
				    (eliminate? nil))
  (declare (ignore state-vars))
;; [12/ 7/2012 klenk] Hack for the moment, should be a slot
  (let* ((system (create-system model))
	 (initial-situation (create-situation :instant nil)))
;    (add-system-situation initial-situation)
    (setf (system-debug system) debug?)
    (setf (system-success-function system) success-fn)
    (create name model)
    (KCL system)
 ;   (propagate-all-qspaces)
    (when eliminate? (eliminate))
    ;; Always run compactor.
    (compactor)
    (process-initial-conditions initial-conditions initial-situation system name)
    (constrain-unconstrained-vars)
    (setq *2* initial-situation)
    (let ((sits (run-completer initial-situation nil)))
      (unless sits (error "Initial conditions are inconsistent"))
      (unless (or allow-initial-ambiguity? 
		  (= (length sits) 1))
	(error "initial situation ambiguous"))
      (values sits system))))


;; [12/ 6/2012 klenk] Add a q= identify constrtaint for any unconstrained var
;; [05/21/2014 Johan] Why would we want to do that?
(defun constrain-unconstrained-vars ()
  (dolist (var (quantity-vars))
    (unless (var-uses var)
      (make-identity-constraint var)))) 

(defun make-identity-constraint (var)
  (construct-qequal (car (system-models *system-being-analyzed*))
		    var var nil nil 'create-identity-constraint))

(defun create-system (name &optional debug?)
;; [12/06/2011 klenk] Read macro here or something
 ; (setq maxima::$ratprint t)
  (setq *system-being-analyzed*
	(make-system :id 0 
		     :new-instants (make-hash-table-situation 10000 0)
		     :new-intervals (make-hash-table-situation 10000 0)
		     :name name 
		     :top-models (make-hash-table :test #'eq)
		     :key-hash-table (make-hash-table :test #'equal)
		     :key-counter -2000 
		     :max-cell -1
		     :max-position -1
		     :debug debug?))
  (setf (system-global-situation *system-being-analyzed*)
	(create-situation :interval nil))
  *system-being-analyzed*)

(defun create (name type &optional (view :qualitative))
  (if (gethash name (system-top-models *system-being-analyzed*))
      (format t "~% Redefining top model ~a" name))
  (let ((model (create-model type nil nil name view)))
    (setf (gethash name (system-top-models *system-being-analyzed*))
      model)
    (insert-external-parameters model)
  ))

(defun top-models ()
  (let ((top-models))
    (maphash #'(lambda (key value) 
		 (declare (ignore key))
		 (push value top-models))
	     (system-top-models *system-being-analyzed*))
    top-models))

(defun create-model (name &optional parent terminals local-name 
				    (view :qualitative))
  (declare (ignore view))
  (let ((prototype (gethash name *model-library*)))
    (unless prototype (error "~a is not in the model-library" name))
    (let ((model (make-model :id (new-id)
			     :local-name local-name
			     :parent parent
			     :prototype prototype)))
      (push model (system-models *system-being-analyzed*))

      ;; Create the internal nodes.
      (dolist (name (metamodel-internal-nodes prototype))
	(push (create-node name) (model-nodes model)))
      (collect-prototype prototype)      
      (map-external-terminals model (metamodel-all-terminals prototype) terminals)
      (create-components model (metamodel-all-components prototype))
      (find-or-create-variables model (metamodel-all-variables prototype))
      (create-landmarks model (metamodel-variables prototype))
      (create-fixed-parameters prototype model) ;;numeric pararmeters ignored for qualitative simulation
      (when (metamodel-modes prototype)
	(create-modes model))
      (create-equations model (metamodel-all-equations prototype) nil)
       model)))

;;; A standard order matters for terminal-mapping.
;;; left-to-right then yourself.
(defun collect-prototype (prototype)
  (setf (metamodel-all-terminals prototype) nil)
  (setf (metamodel-all-variables prototype) nil)
  (setf (metamodel-all-equations prototype) nil)
  (setf (metamodel-all-components prototype) nil)
  
  (collect-prototype-1 prototype prototype nil)
  (setf (metamodel-all-terminals prototype) (nreverse (metamodel-all-terminals prototype)))
  )

(defun collect-prototype-1 (prototype base-prototype stack)
  (dolist (superclass (metamodel-superclasses prototype))
    ;; Do all children.
    (let ((supermodel (gethash superclass *model-library*)))
      (when (and supermodel (not (member superclass stack)))
	(collect-prototype-1 supermodel base-prototype (cons prototype stack)))))
  (dolist (own-equation (metamodel-equations prototype))
    (cond ((member own-equation (metamodel-all-equations base-prototype)) 
	   (error "Duplicate equation"))
	  (t (push own-equation (metamodel-all-equations base-prototype)))))
  ;; Add own variables.
  (dolist (own-variable (metamodel-variables prototype))
    (cond ((member own-variable (metamodel-all-variables base-prototype)
		   :test #'(lambda (var1 var2) (eql (car var1)(car var2))))
	   (setf (metamodel-all-variables base-prototype)
		 (remove own-variable (metamodel-all-variables base-prototype)
			 :test #'(lambda (var1 var2) (eql (car var1)(car var2)))))
	   (push own-variable (metamodel-all-variables base-prototype))
	   )
	  (t (push own-variable (metamodel-all-variables base-prototype)))))
  ;; Now add your own terminals.
  (dolist (own-terminal (metamodel-external-variables prototype))
    (cond ((member own-terminal (metamodel-all-terminals base-prototype)) 
	   (error "Duplicate terminal"))
	  (t (push own-terminal (metamodel-all-terminals base-prototype)))))
  ;; Now add your own components
  (dolist (own-component (metamodel-body prototype))
    (push own-component (metamodel-all-components base-prototype)))
  )


;;; This must create real terminals.  Except in the case where there is no body.
;;; (<name> <type>) <type> can be :linear, :electrical
(defun map-external-terminals (model oterminal-names onodes)
  (do ((terminal-names oterminal-names (cdr terminal-names))
       (nodes onodes (cdr nodes)))
      (nil)
    (and (null terminal-names) (null nodes) (return nil))
    ;; Collect all the remaining
    (when (eq (car terminal-names) '&rest) 
      ;; Create a terminal for each remaining node.
      (let ((rest))
	(dolist (node nodes)
	  (push (create-terminal node model (intern (concatenate 'string 
						      (string (caadr terminal-names))
						      "-"
						      (string (node-name node)))
						    +env2-names+))
		rest))
	(push (cons (caadr terminal-names) rest) (model-bindings model)))
      (return-from map-external-terminals nil))
    (unless terminal-names 
      (format t "~% Not enough external terminals supplied for ~a." model)
      (format t "~% Supplied: ~a" oterminal-names)
      (format t "~% Needed; ~a" onodes)
      (error "Ran out of terminals."))
    ;; If not enough nodes are supplied this creates them.  Is this the right design decision?
    ;; It is right at least for the top-level.
    (unless nodes 
      (format t "~% Not enough external terminals supplied for ~a." model)
      (format t "~% Needed: ~a" oterminal-names)
      (format t "~% Supplied; ~a" onodes)
      (error "Ran out of nodes"))
    (create-terminal (car nodes) model (car terminal-names))))

(defun create-terminal (node model terminal-name)
  (let ((new-terminal (make-terminal :id (new-id) :node node :parent model)))
    (cond ((atom terminal-name)
	   (setf (terminal-name new-terminal) terminal-name)
	   (setf (terminal-type new-terminal) (node-type node)))
	  (t (unless (eq (node-type node) (cadr terminal-name))
	       (error "Terminal type mismatch"))
	     (setf (terminal-name new-terminal) (car terminal-name)
		   (terminal-type new-terminal) (cadr terminal-name))))
    (push new-terminal (node-terminals node))
    (push new-terminal (model-terminals model))
    new-terminal))

(defun create-node (triple)
  (let ((new-node (make-node :id (new-id)
			     :name (car triple)
			     :type (cadr triple)
			     :conservation-p (not (eq (third triple) :no-kcl)))))
    (push new-node (system-nodes *system-being-analyzed*))
    new-node))

;;; Create models of the subcomponents of a model.
(defun create-components (model components)
  (when components
    (create-let* model components)))

;;; Eg. (let* ((m (ideal-mass t1 t2))
;;;            (s (ideal-spring t1 t2))))
(defun create-let* (parent components)
  (dolist (binding components)
    (push (create-component parent (cadr binding) (car binding))
	  (model-components parent))))

(defun create-component (parent descriptor local-name)
;; [09/08/2011 klenk] allows us to branch on model primatives
  (cond ((eql (car descriptor) 'sensor)
	 (create-sensor-component parent descriptor local-name))
	(t
	 (create-model (car descriptor)
		       parent
		       (mapcar #'(lambda (terminal-name)
				   (or (find-named-node parent terminal-name)
				       (error "Cannot find node ~a in parent ~a" terminal-name parent)))
			       (cdr descriptor))
		       local-name))))


;; [12/ 1/2011 klenk] Not sure what to do about sensors now that we are going to get rid
;; [12/ 1/2011 klenk] of explicit landmakrs
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Sensor Components
;;; (sensor pos-sensor-node door position (Closed Open))
;;; Create a component that has a variable external terminal at <arg1>, it will set the value of this terminal
;;; to the <arg3> of the <arg2> relative to current mode, the list of possible modes is <arg4> 
(defun create-sensor-component (parent descriptor local-name)
  (destructuring-bind (primative external-node component-name var-name landmarks)
      descriptor
    (declare (ignore primative))
    (let ((sensor (make-model :id (new-id)
			      :local-name local-name
			      :parent parent))
	  (component (find-locally-named-component parent component-name))
	  )
      (map-external-terminals sensor '((out :variable)) (list (find-named-node parent external-node)))
      (create-landmark-sensor-vars sensor component var-name landmarks (find-named-node parent external-node))
      (create-sensor-modes sensor landmarks)
      (push sensor (system-models *system-being-analyzed*))
      sensor)))

;; [12/ 6/2011 klenk] THIS IS WRONG, NEED TO RETHINK SENSORS, WAIT UNTIL SEPT DEMO
(defun create-landmark-sensor-vars (sensor  component var-name landmarks out-node)
  (let ((out-var (find-or-create-simple-variable sensor 'out out-node)))
    (push (cons 'out out-var) (model-variables sensor))
    ;; [09/08/2011 klenk] the local variables for this should be bound directly to the landmarks
    (dolist (landmark landmarks)
      (cond ((eql landmark 'Q) 
	     (push (cons 'Q (find-locally-named-variable component var-name))(model-variables sensor)))
	    (t
	     (push (cons landmark (find-locally-named-variable component landmark)) (model-variables sensor)))))))

(defun create-sensor-modes (sensor landmarks)
  (push sensor (system-mode-components *system-being-analyzed*))
  ;; Create a variable to represent the mode (>> mode D ...)
  (let ((mode-var (create-var sensor 'mode :type :mode :fundamental-type :mode)))
    (setf (model-mode sensor) mode-var)
    (push (cons 'mode mode-var) (model-variables sensor))
    (push mode-var (system-variables *system-being-analyzed*))
    (push mode-var (system-active-variables *system-being-analyzed*))
    (dolist (landmark landmarks)
      (add-sensor-mode-to-model landmark sensor))))

(defun add-sensor-mode-to-model (landmark sensor)
  (push (make-mode :name landmark 
		   ;; [09/ 5/2011 klenk] Replace references with actual variables
		   :entry nil
		   :initial nil
		   ;; [09/ 5/2011 klenk] Sets up the mode constraints
		   :equations 
		   (create-equations sensor `((q= out ,landmark)
					      (q= (deriv out 1) (deriv ,landmark 1)))
				     (list '== (model-mode sensor) landmark))		   
		   :parent sensor)
	  (model-modes sensor)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Creating variables

(defun quantity-var? (var)
  (and (not (mode-var? var))
       (not (discrete-var? var))))

;; [06/08/2012 klenk] These come from XML input.
;; [06/08/2012 klenk] the qspace slot includes the different enumerations
(defun discrete-var? (var)
  (and (var-p var)
       (or (var-discrete-var? var)
	   (eql (var-fundamental-type var) :discrete))
      ))

(defun discrete-vars (&optional (system *system-being-analyzed*))
  (remove-if-not #'discrete-var?
		 (system-active-variables system)))

(defun flow? (var)
  (eql (var-fundamental-type var) :flow))

;;; 
;;; [04/07/2014 Johan] Never changes after first time called so cache it.
(defun quantity-vars (&optional (system *system-being-analyzed*))
  (or (system-quantity-vars system)
      (let ((quantity-vars
	     (remove-if #'(lambda (var)
			    (or (var-global-cell var)
				(var-eliminated var)
				(mode-var? var)
				(discrete-var? var)))
			(system-active-variables system))))
	(setf (system-quantity-vars system) quantity-vars)
	quantity-vars)))

    

;; [04/ 3/2014 klenk] discrete-var-names is a list of strings that correspond to the var local names of the variables 
;; [04/ 3/2014 klenk] identified by Bill's python script as having discrete-changes
(defun discrete-names->continuous-vars (discrete-var-names &optional (system *system-being-analyzed*))
  (mapcar #'var-local-name
	  (remove-if #'(lambda (var)
			 (pprint var)
			 (or (dummy-var? var)
			     (var-fixed? var)
			     (member (var-local-name var) discrete-var-names :test #'string=)))
		     (quantity-vars system))))

(defun fixed-parameters (&optional (system *system-being-analyzed*))
  (remove-if #'var-eliminated
	     (remove-if-not #'var-fixed? (system-active-variables system))))

(defun parameters (&optional (system *system-being-analyzed*))
  (remove-if-not #'var-fixed? (quantity-vars system)))


(defun all-vars (&optional (system *system-being-analyzed*))
  (append (quantity-vars system)
	  (mode-vars system)))


(defun full-name (object) 
  (if (member :omc (system-analyses *system-being-analyzed*))
      (var-local-name object)
      (cons '>> (full-name-1 object))))  

(defun full-name-1 (object)
  (when object
    (case (type-of object)
	(var
	 (cond ((var-local-name object) 
		(cons (var-local-name object) (full-name-1 (var-parent object))))
	       ;; Funky name.
	       ((eq (var-fundamental-type object) :through)
		(cond ((var-terminal object)
		       (cons (or (var-type object) 'through)
			     (cons (terminal-name (var-terminal	 object)) (full-name-1 (var-parent object)))))
		;;**** not quite invertable.  Need to pick up name.
		      (t (cons 'through (full-name-1 (var-parent object))))))
	       ((eq (var-fundamental-type object) :mode)
		(cons 'mode (full-name-1 (var-parent object))))
	       (t (error "no name")
		  )))
	(model
	 (cond ((null (model-parent object)) (list (model-local-name object)))
	       ((model-local-name object)
		(cons (model-local-name object) (full-name-1 (model-parent object))))
	       (t (cons (metamodel-name (model-prototype object))
			(full-name-1 (model-parent object))))))
	(t (error "Unknown object type ~a" (type-of object))))))

(defun find-or-create-variables (model variables)
  (dolist (description variables)
    (let ((var 
	   (cond ((qml-v2? description)
		  (find-or-create-variable-v2 model description))
		 (t
		  (find-or-create-variable model description)))))
      (cond ((listp var) (error "should not be a list ~A" var))
	    (var 
	     (push (cons (car description) var) (model-variables model))
	     (assert (not (member var (system-variables *system-being-analyzed*))))
	     (push var (system-variables *system-being-analyzed*))
	     (push var (system-active-variables *system-being-analyzed*))
	     )
	    (t (error "creating extra variables"))))))

(defun qml-v2? (description)
  (not (listp (second description))))

;; [01/30/2012 klenk] Descprition is (v voltage :landmarks (Q VBat))
(defun find-or-create-variable-v2 (model description)
    (cond ((find-locally-named-variable  model (car description)))
	  (t (create-var model
			 (car description)
			 :fundamental-type (if (member :flow description) 
					       :flow
					       :var)))))


;; [01/30/2012 klenk] We should be able to delete the following code up until the function to create-landmarks

;;; A description will look like (f (force t1 t2))
;; [09/ 5/2011 klenk] Returns a variable. If it is an eliminated variable, build eclass
(defun find-or-create-variable (model description)
  (let ((terminals (mapcar #'(lambda (terminal-name)
			       (or (find-named-node model terminal-name t)
				   (if (eq terminal-name 'ground) (find-ground))
				   (error "unknown terminal ~A" terminal-name)
				   (return-from find-or-create-variable nil)))
			   (cdadr description))))
    ;; This is hand jammed until I figure out a better design.
    ;; **** case on fundamental-type is a better design.
    (case (caadr description)
      ;;*** wrong, momentum is the dual.
      ((current force torque heat-flow-rate)
       (unless (= (length terminals) 1) (error "Through variables have only one terminal"))
       (find-or-create-through-variable model (car description) (car terminals) (caadr description)))
      ((voltage distance angular-velocity angular-position velocity temperature time) 
       (unless (= (length terminals) 2) (error "Across variables have only one terminal"))
       (find-or-create-across-variable model (caadr description) (car description) (first terminals) (second terminals)))
      (boolean (unless (car terminals) (error "foo"))
	       (find-or-create-boolean-variable model (car description) (car terminals) (caadr description)))
      (variable (find-or-create-simple-variable model (car description) (car terminals) ))
      (t (error "Unknown variable type: ~a" (caadr description))))))


;;; Only one variable associated with a node.
(defun find-or-create-simple-variable (parent local-name node)
  (cond ((node-variable node))
	(t (create-simple-variable parent local-name node))))

(defun create-simple-variable (parent local-name node)
  (let ((variable (create-var parent
			      local-name
			      :fundamental-type :single;*** is this right?
			      )))
    (push variable (system-variables *system-being-analyzed*))
    (push variable (system-active-variables *system-being-analyzed*))
    (setf (node-variable node) variable)
    variable))


(defun find-or-create-boolean-variable (parent local-name node type)
  (dolist (terminal (model-terminals parent))
    (when (eq (terminal-node terminal) node)
      (return (cond ((terminal-variable terminal))
		    (t (create-boolean-variable parent local-name terminal type)))))))

(defun create-boolean-variable (parent local-name terminal type)
  (let ((variable (create-var parent
			      local-name
			      :type type
			      :fundamental-type :single
			      :terminal terminal
			      )))
;    (if (= (var-id variable) 11) (error "look"))
    (push variable (system-variables *system-being-analyzed*))
    (push variable (system-active-variables *system-being-analyzed*))
    (setf (terminal-variable terminal) variable)
    variable))

;;; Force is a through variable, so its associated with a terminal.
;;;**** this works for all through variables.
;;;**** but need to check type match, otherwise a buggy model could say (current t1) = (force t1).
(defun find-or-create-through-variable (parent local-name node type)
  (dolist (terminal (model-terminals parent))
    (when (eq (terminal-node terminal) node)
      (return
	(cond ((terminal-through-variable terminal)
;	       (format t "~% Not checking for consistency yet.")
	       (terminal-through-variable terminal))
	      ;; We need to create the variable.
	      (t (create-through-variable parent local-name terminal type)))))))

;;; Do not canonicalize.
;;; type is voltage distance ...
;;; Sometime we want to unify so one can refer to any derivative order.
(defun find-or-create-across-variable (parent type local-name terminal1 terminal2)
  (assert (and (typep terminal1 'node)(typep terminal2 'node)))
  ;; Look up variable locally, if there check for consistency and return.
  (let ((variable (find-locally-named-variable parent local-name)))
    (cond (variable variable)
	  (t
	   (let ((across-variable (retrieve-across-variable type terminal2 terminal1)))
	     (cond (across-variable
		    (when (eql (second across-variable) '-)
		      (error "All across variables should be measured in the same direction ~A t1: ~A t2: ~A" across-variable terminal1 terminal2))
						   
		    (car across-variable))
		   (t (create-across-variable parent type local-name terminal1 terminal2))))))))


(defun create-across-variable (parent type local-name node1 node2)
  (let ((variable (create-var parent
			      local-name
			      :fundamental-type :across
			      :node+ node1
			      :node- node2)))
    (setf (var-type variable) type)
    (push variable (system-variables *system-being-analyzed*))
    (push variable (system-active-variables *system-being-analyzed*))
    ;; These + - are polarities, not qualitative values.
    (let ((table (assoc node2 (node-across-variables node1))))
      ;; If table exists, its easy.
      (cond (table
	     (rplacd table (cons (list variable '+) (cdr table)))
	     (setq table (assoc node1 (node-across-variables node2)))
	     (rplacd table (cons (list variable '-) (cdr table)))
	     variable)
	    (t
	     (push (cons node2 (list (list variable '+))) (node-across-variables node1))
	     (push (cons node1 (list (list variable '-))) (node-across-variables node2))
	     variable)))))

(defun create-through-variable (parent local-name terminal type)
  (let ((variable (create-var parent
			      local-name
			      :type type
			      :fundamental-type :through
			      :terminal terminal
			      )))
    (push variable (system-variables *system-being-analyzed*))
    (push variable (system-active-variables *system-being-analyzed*))
    (setf (terminal-through-variable terminal) variable)
    variable))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Setting up the quantity space for a variable

(defun create-landmarks (model var-defs)
  (assert model)
  (dolist (var-def var-defs)
    (let ((landmark-defs (second (member :landmarks var-def)))
	  (var (find-locally-named-variable model (car var-def))))
      (cond ((null landmark-defs)
	     (setf (var-qspaces var) (list *simple-qspace*)))
	    (t (create-qspace var landmark-defs))))))

(defun create-qspace (var landmarks)
  (unless (member 'Inf- landmarks) (push 'Inf- landmarks))
  (unless (member 'Inf+ landmarks) (setf landmarks (append landmarks '(Inf+))))
  (when (member 'Q landmarks) (setf landmarks (subst 'Q0 'Q landmarks)))
  (setf (var-qspaces var) (list landmarks)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; modes

(defun mode-var? (var)
  (and (var-p var)
       (eq (var-type var) :mode)))

(defun mode-vars (&optional (system *system-being-analyzed*))
  (remove-if #'(lambda (var)
		 (not (mode-var? var)))
	     (system-active-variables system)))

;;; For now very simple:
(defun create-modes (model)
  (push model (system-mode-components *system-being-analyzed*))
  ;; Create a variable to represent the mode (>> mode D ...)
  (let ((variable (create-var model
			     'mode
			     :type :mode
			     :fundamental-type :mode)))
    (push (cons 'mode variable) (model-variables model))
    (push variable (system-variables *system-being-analyzed*))
    (push variable (system-active-variables *system-being-analyzed*))
    (setf (model-mode model) variable)
    (dolist (mode (metamodel-modes (model-prototype model)))
      (add-mode-to-model model mode variable))))



(defun add-mode-to-model (model mode var)
  (push (make-mode :name (mode-name mode) 
		   ;; [09/ 5/2011 klenk] Replace references with actual variables
		   :entry (process-mode-conditions (mode-entry mode) model)
		   :initial (process-mode-initials (mode-initial mode) model)
		   ;; [09/ 5/2011 klenk] Sets up the mode constraints
		   :equations
		   (when (mode-equations mode)
		     (create-equations model (mode-equations mode) 
				       (list '== var (mode-name mode))))
		   :parent model)
	  (model-modes model)))

;; [10/23/2011 klenk] conditions is a logical expression or a list of expressions
(defun process-mode-conditions (conditions model)
  (when (listp (car conditions)) (setq conditions (cons 'and conditions)))
  (let ((ret (process-mode-conditions-1 conditions model)))
    (cond ((equal ret '(and)) nil)
	  (t ret))))

(defun process-mode-conditions-1 (conditions model)
  (cond ((null conditions) nil)
	((member (car conditions) '(and or))
	 (cons (car conditions)
	       (mapcar #'(lambda (condition) 
			   (process-mode-conditions-1 condition model))
		       (cdr conditions))))
	((member (car conditions) '(q= not == = > < >= <=))
	 (parse-equation-1  conditions model nil))
	((eql (car conditions) 'qIn)
	 (parse-equation-1 conditions model nil ))
	(t (assert nil))))

;; [10/26/2011 klenk] still need to remove and's introduced by qIn's
(defun process-mode-initials (initials model &aux ret)
  (dolist (initial initials ret)
    (ecase (car initial)
      ((q= == qIn) (push (parse-equation-1 initial model nil) ret))
      )))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Quantitative Model

;;; **** called too often.
(defun insert-external-parameters (model)
  ;; They will all look like (= (>> R R1) 10000)
  (dolist (assignment (metamodel-external-parameters (model-prototype model)))
    (let ((parameter (eval (second assignment))))
      (cond ((null parameter) (error "No such parameter"))
	    (t 
	       (error "stub for setting quantitative values")
	       )))))
   
;; [01/30/2012 klenk] (name :value <value>) <value> may be overwritten during model construction
;; [01/30/2012 klenk] This results in creating a constraint
(defun create-fixed-parameters (prototype model)
  (dolist (parameter (metamodel-fixed-parameters prototype))
    (let ((var (create-var model (car parameter) 
			   :fixed? t
			   :why-fixed 'create-fixed-parameters
			   :fundamental-type :fixed-parameter))
	  (constant (cadr (member :value parameter))))
      (push var (system-variables *system-being-analyzed*))
      (push var (system-active-variables *system-being-analyzed*))
      (push (cons (car parameter) var) (model-variables model))
      (when constant
	(let ((quantity (if (simpleq-p constant) (simpleq->interval constant) constant)))
	  (if *use-global*
	      (clobber-global var quantity)
	    (construct-qset model var 
			    (if (simpleq-p constant)
				(simpleq->interval constant)
			      constant)
			    nil nil )))))))

;; [03/16/2012 klenk] parameters are fixed values for simulation
;; [06/06/2012 klenk] deprecated
(defun parameter-p (var)
  (var-fixed? var)
;  (eq (var-fundamental-type var) :fixed-parameter)
  )

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; looking up named entities

(defun get-root-model (comp)
  (let ((parent (model-parent comp)))
    (cond (parent (get-root-model parent))
	  (t comp))))


;;; Accessing.
(defmacro >> (&rest args) `(lookup ',args))

(defun lookup (path)
  (setq path (reverse path))
  (let ((parent (gethash (car path) (system-top-models *system-being-analyzed*))))
    ;; If parent is not supplied.  Default it to a single top-model assuming one exists.
    (cond (parent (lookup-1 (cdr path) parent))
	  (t 
	   (let ((top-models (top-models)))
	     (cond ((null top-models) (error "No top models."))
		   ((> (length (top-models))
		       1)
		    (error "No way to select among top-models."))
		   (t (lookup-1 path (car top-models))))))
	   )))

(defun lookup-1 (path parent)
  (cond ((null parent) (lookup (reverse path)))
	(t
	 (dolist (name path)
	   (case (type-of parent)
	     (model
	      (let ((next))
		;; [11/12/2011 klenk] This leades to name collisions between terminals and variables
		(cond ((setq next (find-locally-named-component parent name)) (setq parent next))
		      ((setq next (find-named-component parent name)) (setq parent next))
		     ((setq next (find-locally-named-variable parent name)) (setq parent next))
		     ((setq next (find-named-node parent name)) (setq parent next))
		     ((setq next (find-named-terminal parent name t)) (setq parent next))
		     (t (error "Cannot find ~a of ~a" name parent)))))
	    (terminal
	     ;; *** this is a temp kludge.
	     (if (eq name 'current) (setq parent (terminal-through-variable parent))))
            (t (error "Unknown parent type: ~a" (type-of parent)))))
	 parent)))


(defun find-locally-named-component (parent local-name)
  (dolist (component (model-components parent))
    (if (eq local-name (model-local-name component))
        (return component))))

(defun find-named-component (parent local-name)
  (dolist (component (model-components parent))
    (when (model-prototype component)
      (if (eq local-name (metamodel-name (model-prototype component)))
	  (return component)))))

(defun find-locally-named-variable (parent local-name)
  (and (every #'listp (model-variables parent))
       (cdr (assoc local-name (model-variables parent)))))

;;; Needs to work for multi-physics.
(defun find-ground ()
  (dolist (node (system-nodes *system-being-analyzed*))
    (if (eq (node-name node) 'ground) (return node))))


(defun find-named-node (model name &optional nil-ok)
  (dolist (node (model-nodes model))
    (if (eq (node-name node) name) (return-from find-named-node node)))
  (dolist (terminal (model-terminals model))
    (if (eq (terminal-name terminal) name) (return-from find-named-node (terminal-node terminal))))
  ;; Almost always a failure.
  (cond (nil-ok nil)
	(t
	 (format t "~% model ~a does not have a node named ~a" model name)
	 (error "no such name")))
  )


(defun find-named-terminal (model name &optional error-ok)
  (dolist (terminal (model-terminals model))
    (if (eq name (terminal-name terminal))
	(return-from find-named-terminal terminal)))
  (unless error-ok (error "No terminal named ~a of model ~a" name model)))

(defun across-variable (node2 node1)
  (cadr (assoc node2 (node-across-variables node1))))

(defun retrieve-across-variable (type node2 node1)
  (dolist (var (cdr (assoc node2 (node-across-variables node1))))
    (if (eq (var-type (car var)) type) (return var))))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Process initial conditions



(defun process-initial-conditions (initial-conditions initial-situation system name)
  (process-prototype-initial-conditions system initial-situation name
					(remove-trailing-system-names initial-conditions name)))

;; [09/27/2011 klenk] Either this or be clear about if the system-top-model name needs to be in
;; [09/27/2011 klenk] the initial condition specification
(defun remove-trailing-system-names (ics name)
  (mapcar #'(lambda (ic)
	      (list (car ic)
		    (remove name (second ic) :from-end t :count 1)
		    (third ic)))
	  ics))
		     
(defun process-prototype-initial-conditions (system initial-situation name analyze-conditions)
  (declare (ignore name))
  (dolist (model (system-models system))
    (let* ((prototype (if model (model-prototype model)))
	   (initial-conditions (if prototype (metamodel-initial-conditions prototype))))
      (dolist (ic (append initial-conditions 
			  (when  (gethash (model-local-name model) (system-top-models system))
			    analyze-conditions)))
	(debug-print nil "~% ic = ~A " ic)
	(ecase  (car ic)
	  ;; [09/09/2011 klenk] Johan's initial conditions, in the future we should make sure it uses the correct operator
	  (= (let* ((the-var 
                     (cond 
                       ((var-p (second ic))(second ic))
                       ((atom (second ic))(find-locally-named-variable  model (second ic)))
                       (t
                        (ecase (car (second ic))
                          (>> (eval (second ic)))
                          (deriv 
                           (var-deriv (eval (second (second ic)))))))))
                    (the-value
                     (cond ((discrete-var? the-var)
                            ;; variables are discrete, but every discrete *value* is qualitative
                            (create-q-quantity the-var (third ic) (qspace-for-value the-var (third ic)) 'Std))
                           (t
                            (if (simpleq-p (third ic))
                                (simpleq->interval (third ic))
                                (third ic))))))
	       (clobber the-var the-value initial-situation '((init nil)))))
	  ((qIn q=) (let ((equation (parse-equation-1 ic model nil)))
		      (clobber (second equation) (third equation) initial-situation '((init nil)))))
	  (== (let ((equation (parse-equation-1 ic model nil)))
		(set-mode (second equation) (third equation)  initial-situation))))
	)
      )))

(defun set-mode (var mode-name situation)
  (clobber var mode-name situation '((set-mode)) :mode)
  (clobber-mode-initials 
   (mode-initial (get-mode (var-parent var) mode-name))
   situation))

;; [09/09/2011 klenk] returns the mode-object
(defun get-mode (component mode-name)
  (find mode-name (model-modes component) :key #'mode-name))

(defun clobber-mode-initials (initial-conditions situation)
  (dolist (ic initial-conditions)
    (ecase (car ic)
      ((q= qIn) 
       (cond ((or (simpleq-p (third ic))
		  (interval? (third ic)))
	      (clobber (second ic) (third ic) situation '((init nil))))
	     ((var-p (third ic))
	      (clobber (second ic)  (simple-qvalue (third ic) situation)
		       situation '((init nil))))
	     (t (error "clobber-mode-initials: shouldn't happen, ic is ~A, (third ic) is ~A" ic (third ic)))))
      (== (set-mode (second ic) (third ic)  situation))
      )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; component model library

(defun lookup-model (name)
  (gethash (intern name :env2) *model-library*))   ; may switch to +env2-names+ once v1 switches

(defun defmetamodel-1 (name pairs)
;  (if (gethash name *model-library*)
;      (format t "~% Overwriting model: ~a" name))
  (let ((meta-model (make-metamodel :name name)))
    (setf (gethash name *model-library*) meta-model)
    (do ((pairs pairs (cddr pairs)))
	  ((null pairs))
	(case (car pairs)
	  (:parent (error "stub"))
	  ((:superclasses :extends) (setf (metamodel-superclasses meta-model) (cadr pairs)))
;; [09/08/2011 klenk] Initial conditions should go away, but I'm nervous about Johan's models
	  (:external-parameters (setf (metamodel-external-parameters meta-model) (cadr pairs)))
	  (:initial-conditions (setf (metamodel-initial-conditions meta-model) (cadr pairs)))
	  (:initial (setf (metamodel-initial-conditions meta-model) (cadr pairs)))
	  (:modelica (setf (metamodel-modelica meta-model) (cadr pairs)))
;	  (:view (setf (metamodel-view meta-model) (cadr pairs)))
;	  (:sensors (setf (metamodel-sensors meta-model) (cadr pairs)))
	  (:external-terminals (setf (metamodel-external-variables meta-model) (cadr pairs)))
;; [09/08/2011 klenk] Landmarks are defined in variable defintions
	  ((:fixed-parameters :parameters) (setf (metamodel-fixed-parameters meta-model) (cadr pairs)))
	  (:source (setf (metamodel-source meta-model) (cadr pairs)))
	  (:variables (setf (metamodel-variables meta-model) (cadr pairs)))
	  (:equations (setf (metamodel-equations meta-model) (cadr pairs)))
;; [09/08/2011 klenk] What does this mean?
;	  (:internal-terminals  (setf (metamodel-internal-terminals meta-model) (cadr pairs)))
	  (:internal-nodes (setf (metamodel-internal-nodes meta-model) (cadr pairs)))
	  (:mode (push (parse-mode (cadr pairs)) (metamodel-modes meta-model)))
;	  (:connectors (setf (metamodel-connectors meta-model) (cadr pairs)))
	  ((:components :body)  (setf (metamodel-body meta-model) (cadr pairs)))
	  (:succeess-conditions  (setf (metamodel-success-conditions meta-model) (cadr pairs)))
	  (:failure-conditions  (setf (metamodel-failure-conditions meta-model) (cadr pairs)))
	  
;	  (:cstate (push (parse-cstate (cadr pairs)) (metamodel-cstates meta-model) ))
;	  (:components (setf (metamodel-components meta-model) (cadr pairs)))
	  
	  (:failure (push (cadr pairs) (metamodel-failures meta-model)))
    	  (t (error "Unknown meta model slot name: ~a" (car pairs)))))))

;;; Looks like 
;(stuck :entry ((q= PistonParallel Q0)
;		     (q= w Q0))
;	     :initial ()
;	     :equations ((q= tor Q0)
;			 (q= (deriv tor 1) Q0)))
;;; Variables may also be referenced by (>> x y) where y is a local component
(defun parse-mode (description)
  (let ((mode (make-mode :name (first description))))
    (do ((description (cdr description) (cddr description)))
	((null description))
      (case (car description)
	(:entry (setf (mode-entry mode)(second description)))
	(:initial (setf (mode-initial mode) (second description)))
	(:equations (setf (mode-equations mode) (second description)))
	(t (warn "old mode definition ~A ignored" description))))
    mode))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: ctl.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 28, 2011 15:59:33
;;;;   Purpose: Checks ctl expressions against envisionment
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, December 29, 2011 at 16:23:21 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; CTL queries

;; (until (form) (form))
;; (next (form))
;; [12/28/2011 klenk] Given a situation and an CTL expression, This function returns
;; [12/28/2011 klenk] The trajectories which satisify it.
;; [12/28/2011 klenk] a simple trajectory for a particular variable can be specified using
;; [12/28/2011 klenk] until's.
;; [12/28/2011 klenk] (exists-until (= v1 Q+) (exists-until (= v1 Q0) (exists-globally (= v1 Q-))))
(defun trajectories-satisfying (sit ctl)
  (trajectories-satisfying-1 sit (parse-ctl ctl)))

(defun parse-ctl (ctl)
  (cond ((ctl-binary-operator? (car ctl))
	 (list (car ctl)
	       (parse-ctl (second ctl))
	       (parse-ctl (third ctl))))
	((ctl-unary-operator? (car ctl))
	 (list (car ctl)
	       (parse-ctl (second ctl))))
	((logical-operator? (car ctl))
	 (cons (car ctl)
	       (mapcar #'parse-ctl (rest ctl))))
	(t
	 (parse-equation-1 ctl nil nil))))

(defun logical-operator? (op)
  (member op '(and or)))

(defun ctl-unary-operator? (op)
  (member op '(exists-next exists-globally exists-eventually
	       always-next always-globally always-eventually)))

(defun ctl-binary-operator? (op)
  (member op '(exists-until exists-release
	       always-until always-release)))

;; [12/29/2011 klenk] trajectory is the set of parents absord in the current ctl clause
;; [12/29/2011 klenk] This prevents loops on the same ctl expression
(defun trajectories-satisfying-1 (sit ctl &optional trajectory)
  (ecase (car ctl)
    (exists-until (handle-exists-until sit ctl trajectory))
    (= (handle-= sit ctl))
    (and (handle-and sit ctl))))

(defun handle-exists-until (sit ctl trajectory)
  (let (ret)
    (cond ((trajectories-satisfying-1 sit (second ctl))
	   (dolist (child (situation-children sit) ret)
	     (debug-print nil "~% Sit : ~A Child: ~A Trajectory: ~A" sit child trajectory)
	     (unless (member child trajectory)
	       (dolist (child-path (trajectories-satisfying-1 child ctl (cons sit trajectory)))
		 (debug-print nil "~% Sit : ~A Child: ~A Child-Path: ~A" sit child child-path)
		 (when child-path
		   (push (cons sit child-path) ret))))))
	  ((null trajectory) nil)
	  ((trajectories-satisfying-1 sit (third ctl)))
	  (t nil))))

(defun handle-= (sit form)
  (when (condition-satisfied? form sit)
    (list (list sit))))

(defun handle-and (sit form)
  (when (condition-satisfied? form sit)
    (list (list sit))))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: debug.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December  6, 2011 08:46:21
;;;;   Purpose: repository for useful debugging code and functions
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Monday, November 18, 2013 at 17:42:57 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

;;; Only print out the msg if either the global debug flag is set
;;; or the local is set.  So by hand we can print some error msgs conditionally.


;; [12/15/2011 klenk] prints the situation values out to stream
;; [12/15/2011 klenk] fixed-parameters? reduce the amount of output
(defun print-vars (situation &key (stream t) (fixed-parameters? nil)
		   (hide-pins? nil)(vars (system-variables *system-being-analyzed*)))
  (let ((*print-pretty* nil)
	(situation (if (numberp situation) (situation situation) situation)))
    (dolist (var vars)
      (cond 
	    ((or (var-eliminated var)
		 (and hide-pins?
		      (pin-var? var))))
	    ((and (parameter-p var)
		  (not fixed-parameters?)
		  ))
	    ((var-global-cell var))
	    (t
	     (print-single-var situation var stream ))))
    (dolist (var (system-variables *system-being-analyzed*))
      (if (and (var-eliminated var)
	       (listp (var-eliminated var)))
	  (format stream "~% ~a = ~a ~a" (full-name var) (cdr (var-eliminated var)) (full-name (car (var-eliminated var))))
	))))

(defun pin-var? (var)
  (and (var-parent var)
       (model-prototype (var-parent var))
       (eql (metamodel-name (model-prototype (var-parent var))) 'pin)))



(defun print-single-var (situation var stream)
  (let ((value (retrieve-cell var situation)))
    (format stream "~% ~3d ~vA " (var-id var) (var-max-width) (full-name var))
    (display-value  value  stream )))

(defun var-max-width ()
  (apply #'max (mapcar #'(lambda (var)
			   (length (format nil "~A" (full-name var))))
		       (system-variables *system-being-analyzed*))))



(defun display-value (cell stream )
  (cond ((null cell) (format stream "nil" ))
	(t
	 (dolist (datum (cell-values cell))
	   (cond ((eq (datum-type datum) :qualitative)
		  (format stream "~a" (datum-quantity datum)))
		 ((eq (datum-type datum) :symbolic)
		  (symbolic-display-= (cell-var cell) (datum-quantity datum) stream))
		 (t 
		  (format stream "~a " (datum-quantity datum))))))))

(defun p-or-n-var? (var)
  (and (member (model-local-name (var-parent var)) '(p n))
       (not (and (eql (var-local-name var) 'i)
		 (eql (model-local-name (var-parent var)) 'n)))))

(defun print-varss (situations &key (stream t) (fixed-parameters? nil)(hide-pins? nil)
		    (vars (system-variables *system-being-analyzed*)))
  (let ((*print-pretty* nil)
	(situations (if (every #'numberp situations)(apply #'situations situations)situations)))
    (format stream "~% vars for sits: ")
    (dolist (sit situations)
      (format stream " ~A" sit))
    (dolist (var vars)
      (cond ((or (var-eliminated var)
		 (and hide-pins? 
		      (pin-var? var))))
	    ((and (not fixed-parameters?)
		  (parameter-p var)))
	    ((eq (var-type var) :mode) 
	     (format stream "~% Mode ~a" var)
	     (let ((same) (result))
	       (dolist (situation situations)
		 (let ((mode  (mode-value var situation)))
		   (cond ((null result) (setq same mode))
			 (same (unless (equal same mode) (setq same nil))))
		   (push mode result)))
	       (cond (same (format stream " ~a across." same))
		     (t (dolist (quantity (reverse result))
			  (format stream " ~a " quantity))))))
	    (t
	     (format stream "~% ~3d ~vA " (var-id var) (var-max-width)(full-name var))
	     (let ((same) (result))
	       (dolist (situation situations)
		 (let* ((values (qualitative-values var situation)))
		   (cond ((null result) (setq same values))
			 (same (unless (q-quantity-equal (car same) (car values))
				 (setq same nil))))
		   (push values result)))
	       (cond (same (format stream " ~a across." same))
		     (t 
		      (dolist (values (reverse result))
			  (format stream " ~a " values))))))))
    (dolist (var (system-variables *system-being-analyzed*))
      (if (and (var-eliminated var)
	       (listp (var-eliminated var)))
	  (format stream "~% ~a = ~a ~a" (full-name var) (cdr (var-eliminated var)) (full-name (car (var-eliminated var))))
	))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Accessors for debuging

(defun situation (n)
  (dolist (situation (system-situations *system-being-analyzed*))
    (if (equal n (situation-id situation))
	(return situation))))

(defun situations (&rest ids)
  (let (ret)
    (dolist (situation (system-situations *system-being-analyzed*))
      (if (member (situation-id situation) ids)
	  (push situation ret)))
    ret))

(defun lookupv (varid &optional (system *system-being-analyzed*))
  "varid can be a number or a string"
  (dolist (var (system-variables system))
    (when (or (and (numberp varid)
		   (= (var-id var) varid))
	      (and (stringp varid)
		   (stringp (var-local-name var))
		   (string= (var-local-name var) varid)))
      (return var))))

(defun lookupc (constraint-id  &optional (system *system-being-analyzed*))
  (dolist (constraint (system-constraints system))
    (if (= (constraint-id constraint) constraint-id) (return constraint))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Describe constraint


(defun describe-constraints (situation)
  (dolist (constraint (system-constraints *system-being-analyzed*))
    (describe-constraint constraint situation)))

(defun describe-constraint (constraint sit)
  (if (and (constraint-active-p constraint sit)
	   (not (constraint-eliminated constraint)))
      (case (type-of constraint)
	(deriv-constraint
	 (print (list 'deriv-constraint=
		      (values-in-situation (deriv-constraint-var constraint) sit)
		      (values-in-situation (deriv-constraint-deriv constraint) sit))))

	(qequal-constraint (describe-qequal-constraint constraint sit))
	(qset-constraint 
	 (print (list 'qset constraint (qset-constraint-var constraint) 
		      (qset-constraint-constant constraint))))
	(multiply-constraint (describe-multiply constraint sit))
	(general-summer-constraint (describe-summer constraint sit))
	(t (error "unknown constraint type ~a" (type-of constraint))))))

(defun describe-multiply (constraint situation)
  (format t "~% Multiply constraint: ~a polarity: ~a" constraint (multiply-constraint-polarity constraint))
  (let ((deriv (multiply-constraint-result constraint)))
    (format t "~%   Product: ~a =~a" deriv (values-in-situation deriv situation)))
  (dolist (deriv (multiply-constraint-multiplicands constraint))
    (format t "~%   Multiplicand: ~a =~a" deriv (values-in-situation deriv situation))))

(defun describe-qequal-constraint (constraint situation)
  (format t "~% q= constraint: ~a polarity: ~a" constraint (qequal-constraint-polarity constraint))
  (let ((deriv1 (qequal-constraint-var1 constraint))
        (deriv2 (qequal-constraint-var2 constraint)))
    (format t "~%   ~a = ~a " deriv1 (values-in-situation deriv1 situation))
    (format t "~%   ~a = ~a " deriv2 (values-in-situation deriv2 situation))))

(defun describe-summer (constraint situation)
  (unless (constraint-eliminated constraint)
    (format t "~% summer ~a" constraint)
    (dolist (pvar (general-summer-constraint-pos-vars constraint))
      (format t "~% + ~a = ~a " pvar (values-in-situation pvar situation)))
    (dolist (nvar (general-summer-constraint-neg-vars constraint))
      (format t "~% - ~a = ~a " nvar (values-in-situation nvar situation)))))

(defun print-summer (constraint)
  (format t "~%0 = ")
  (dolist (var (constraint-variables constraint))
    (if (member var (general-summer-constraint-pos-vars constraint))
	(format t "+ v(~A) " (var-id var))
	(format t "- v(~A) " (var-id var)))))


(defun print-transition-set (set &optional (stream t))
  (let (( *print-circle* nil))
    (dolist (tran set)
      (print-transition tran stream))))

;; [12/12/2011 klenk] MAKE THE FORMATING EVEN
(defun print-transition (tran stream)
  (format stream "~%  ~A -> ~A : var(~A) " 
	  (possible-transition-old-value tran)
	  (possible-transition-new-value tran)
	  (var-local-name (possible-transition-variable tran))))

(defun print-differences (from to &optional (stream t) 
			  &key (ignore-std-derivs? nil)(ignore-all-derivs? nil))
  (when (numberp from) (setq from (situation from)))
  (when (numberp to) (setq to (situation to)))
  (dolist (var (system-variables *system-being-analyzed*))
    (unless (or (parameter-p var) (mode-var? var)
		(pin-var? var)(var-eliminated var))
      (let ((from-vs (qualitative-values var from))
	    (to-vs (qualitative-values var to)))
	(unless (and (= (length from-vs) (length to-vs))
		     (every #'(lambda (from-v)
				(member from-v to-vs 
					:test #'(lambda (from-val to-val)
						  (or (q-quantity-equal from-val to-val)
						      (and (equal (q-quantity-value from-val) 
								  (q-quantity-value to-val))
							   (or ignore-all-derivs?
							    (and ignore-std-derivs?
								 (eql (q-quantity-deriv to-val)
								      'Std))))))))

			    from-vs))
	  (format stream "~% ~a changes from ~a to ~a" var from-vs to-vs)))
      )))

(defun print-discrete-transition-sequence (from)
  (assert (= (length (situation-children from)) 1))
  (let ((child (car (situation-children from))))
    (unless (eq (situation-type child) :interval)
      (format t "~%~A To: ~A" from child)
      (print-differences from child t :ignore-all-derivs? t)
      (print-discrete-transition-sequence child))))

(defun find-all-discrete-transition-ambigutities (root )
  "Find an instant with multiple child instants with :discrete-transitions on the trace"
  (let ((dts (find-all-discrete-transitions root)))
  (remove-if-not #'(lambda (dt1)
		     (some #'(lambda (dt2)
			       (and (eq (car dt1) (car dt2))
				    (not (eq (cdr dt1) (cdr dt2)))))
			   dts))
		 dts)))

(defun find-all-discrete-transitions (sit)
  "returns a list of pairs where the car of each pair is the start of a discrete transition and the cdr is the end of it"
  (let (ret)
    (labels ((walk-tree (sit discrete-parent visited)
	       (cond ((member sit visited) ;; there should not be graphs within discrete-transitions
			(assert (null discrete-parent)))
		       ((member :discrete-transition-end (situation-trace sit))
			(assert discrete-parent)
			(push (cons discrete-parent sit) ret)
			(dolist (child (situation-children sit))
			  (walk-tree child nil (cons sit visited))))
		       ((member :discrete-transition-start (situation-trace sit))
			(assert (null discrete-parent))
			(dolist (child (situation-children sit))
			  (walk-tree child sit (cons sit visited))))
		       (t 
			(dolist (child (situation-children sit))
			  (walk-tree child discrete-parent (cons sit visited)))))))
      (walk-tree sit nil nil))
    ret))
 
	
;; [04/28/2014 klenk] Assumes that duplicates only occur across situation types
(defun duplicate-sits ()
  (let (ret)
    (dolist (sit (total-situations) ret)
      (let* ((state1 (collect-state sit))
	     (table (if (eq (situation-type sit) :instant)
			(system-new-intervals *system-being-analyzed*)
			(system-new-instants *system-being-analyzed*)))
	     (old-sit (gethash-situation state1 table)))
	(when old-sit (push (list sit old-sit) ret))))))


(defun num-sits-by-depth ()
  (let ((ret (make-hash-table))
	(max-depth 0))
    (dolist (sit (total-situations))
      (cond ((gethash (situation-depth sit) ret)
	     (setf (gethash (situation-depth sit) ret)
		   (1+ (gethash (situation-depth sit) ret))))
	    (t 
	     (when (> (situation-depth sit) max-depth)
	       (setf max-depth (situation-depth sit)))
	     (setf (gethash (situation-depth sit) ret) 1) 
		   )))
    (dotimes (i (1+ max-depth))
      (format t "~% depth: ~A  number: ~A" i (gethash i ret)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Run All Constraints
;;; Runs all the constraints on a situation
;;; Assumes the situation is fully specified
;; [08/06/2012 klenk] Todo: extend to partial sits

(defun run-all-constraints (sit)
  (dolist (constraint (system-constraints *system-being-analyzed*))
    (unless (constraint-eliminated constraint)
      (push (car (qualitative-datums (car (constraint-variables constraint)) sit))
	    (constraint-waiting constraint))
      (push constraint (system-queue *system-being-analyzed*))))
  (run-constraints sit)
  )


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; MAC commands



(defun dot->pdf ()
  (asdf:run-shell-command 
   (format nil "dot -O -Tpdf  ~A" (merge-pathnames "envisioner/v2/graph.dot" cl-user::*my-meta-path*))))

(defun open-envisionment-in-preview ()
  (asdf:run-shell-command
   (format nil "open ~A" (merge-pathnames "envisioner/v2/graph.dot.pdf" cl-user::*my-meta-path*))))
    
      
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Summarize Scaling

(defun summarize-scaling ()
  (list :name (system-name *system-being-analyzed*) 
	:sits (length (total-situations))
	:qvars (length (quantity-vars *system-being-analyzed*))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Tracing functions

(defun trace-model-construction ()
  (trace create-model parse-equation-1 parse-equation-1-atom
	 ))

(defun untrace-model-construction ()
  (untrace create-model parse-equation-1 parse-equation-1-atom))
  
(defun trace-envisioner ()
  (trace envisioner next-situations filter-global-situations create-next-sit-interpretations
	 pairwise-constraint-filtering local-constraint-filtering
	 find-possible-transitions))

(defun untrace-envisioner ()
  (untrace envisioner next-situations filter-global-situations create-next-sit-interpretations
	 pairwise-constraint-filtering local-constraint-filtering
	 find-possible-transitions))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;;  Modified: Wednesday, May 07, 2014 at 15:43:08 by klenk
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: web-ui.lisp
;;;;    System: envisioner v2
;;;;    Author: Bill Janssen <janssen@parc.com>
;;;;   Created: 4 June 2012
;;;;   Purpose: GML output generation
;;;; ----------------------------------------------------------------------------
;;;;  USAGERIGHTS: meta-x
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;;;
;;; Our simulation class.  This takes a Modelica model along with libraries, parameters,
;;; etc. and runs the simulations.  It then takes the simulation results and builds
;;; a qualitative abstraction for that simulation.  It includes callback handlers to
;;; retrieve its JSON version of the envisionment, and to retrieve specific simulation
;;; trajectories.
;;;

(defclass simulation (callback-provider)
  ((libraries :initarg :libraries :initform nil :accessor simulation-libraries)
   (openmodelicahome :initarg :openmodelicahome :initform nil :accessor simulation-openmodelicahome)
   (omc-parameters :initarg :omc-parameters :initform nil :accessor simulation-omc-parameters)
   (variables :initarg :variables :initform nil :accessor simulation-variables)
   (parameters :initarg :parameters :initform nil :accessor simulation-parameters)
   (results :initform nil :accessor simulation-results)
   (json :initform nil :accessor simulation-json :documentation "Cache of the json form of the results")
   (current-mode :initform nil :accessor simulation-current-mode)
   (percent-done :initform nil :accessor simulation-percent-done)
   (build-dir :initarg :build-dir :initform nil :accessor simulation-build-dir)))

(defmethod simulation-model-name ((self simulation))
  (callback-provider-name self))

(defmethod initialize-instance :after ((self simulation) &rest initargs)
  (declare (ignore initargs))
  (if (and (simulation-openmodelicahome self) (not (probe-file (simulation-openmodelicahome self))))
      (error "Specified OPENMODELICAHOME ~A does not exist." (simulation-openmodelicahome self)))

  ;; now define all the HTTP callbacks we use

  ;; first, the "/" top-level.  We use a generic status page, but we have
  ;; to fill in the model name.
  (add-callback self "/"
                #'(lambda (request parameters)
                    (declare (ignore request parameters))
                    (setf (hunchentoot:content-type*) "text/html")
                    (cl-ppcre:regex-replace-all
                     "MODEL-NAME"
                     (read-entirely "envisioner/v2/ui/status-page.html")
                     (simulation-model-name self))))

  ;; how far along is the process of running the simulations and generating the
  ;; qualitative abstraction?  The Javascript calls back every second for this
  ;; info.
  (add-callback self "/status"
                #'(lambda (request parameters)
                    (declare (ignore request parameters))
                    (setf (hunchentoot:content-type*) "text/x-json")
                    (format nil "{\"mode\": \"~A\", \"percent\": ~A}"
                            (simulation-current-mode self)
                            (simulation-percent-done self))))

  ;; Generic launching page once the envisionment is ready.  Again, we
  ;; have to pass along the model name.
  (add-callback self "/gamma-demo"
                #'(lambda (request parameters)
                    (declare (ignore request parameters))
                    (setf (hunchentoot:content-type*) "text/html")
                    (cl-ppcre:regex-replace-all
                     "MODEL-NAME"
                     (read-entirely "envisioner/v2/ui/gammapage.html")
                     (simulation-model-name self))))

  ;; This retrieves the JSON summarization of the envisionment.
  (add-callback self "/current"
                #'(lambda (request parameters)
                    (declare (ignore request parameters))
                    (setf (hunchentoot:content-type*) "text/x-json")
                    (simulation-json self)))

  ;; Find and return the simulation columns corresponding to the specified
  ;; parameter values
  (add-callback self "/gamma-data"
                #'(lambda (request parameters)
                    (declare (ignore request))
                    (let ((model-parameters
                           (map 'list #'(lambda (x)
                                          (cons (car x) (float (read-from-string (cdr x)))))
                                parameters)))
                      (setf (hunchentoot:content-type*) "text/x-json")
                      (let ((hash (params->values model-parameters
                                                  (simulation-variables self)
                                                  (simulation-results self))))
                        (with-output-to-string (foo)
                          (generate-csv-json-stream foo hash))))))
  )

(defmethod run ((self simulation) &key &allow-other-keys)
  "Do all the simulations, and construct the envisionment from the
simulation results."
  (labels ((permute-params (&rest params)
             ;; params is a list of (name (val1 val2 val3...)) lists.
             ;; return params-lists which are the cartesian product of all
             ;; the values of all of the params
             (if (null params)
                 '(())
                 ;; else
                 (let ((param-name (first (car params)))
                       (param-values (second (car params))))
                   (apply #'append (mapcar #'(lambda (v)
                                               (mapcar #'(lambda (sublist) (cons (cons param-name v) sublist))
                                                       (apply #'permute-params (cdr params))))
                                           param-values)))
                 ))

           (run-deterministic-sampling (simulation &key callback)
             (let ((model-name (simulation-model-name simulation))
                   (result-filename (symbol-name (gensym)))
                   (omc-parameters (simulation-omc-parameters simulation)))
               (let ((params-list (apply #'permute-params (simulation-parameters simulation)))
                     (stop-time (if (assoc :stop-time omc-parameters)
                                    (cdr (assoc :stop-time omc-parameters))
                                    75))
                     (step-size (if (assoc :step-size omc-parameters)
                                    (cdr (assoc :step-size omc-parameters))
                                    .1))
                     (build-dir (or (simulation-build-dir simulation)
                                    (merge-pathnames (concatenate 'string model-name "/") *temporary-directory*))))
                 ; (format t "simulation-build-dir: ~A, *temporary-directory* ~A, model-name ~A~%" (simulation-build-dir simulation) *temporary-directory* model-name)
                 (multiple-value-bind (build-dir-pathspec created-p)
                     (ensure-directories-exist build-dir :verbose t)
                   ;(format t "build-dir: ~A, pathspec: ~A, created-p: ~A~%" build-dir build-dir-pathspec created-p)
                   (omc-csv 
                    nil
                    (simulation-model-name simulation)
                    :libraries (simulation-libraries simulation)
                    :openmodelicahome (simulation-openmodelicahome simulation)
                    :params-lists params-list
                    :directory build-dir-pathspec
                    :specified-result-filename result-filename
                    :callback callback
                    :stop-time stop-time :step-size step-size)))))
           )

    ;; now build the system
    (let ((results (run-deterministic-sampling
                    self
                    :callback #'(lambda (mode percent)
                                  (setf (simulation-current-mode self) mode)
                                  (setf (simulation-percent-done self) percent)))))
      (setf (simulation-results self) results)
      (format t "Mapping csvs into qualitative trajectories~%")
      (setf (simulation-current-mode self) "Building system...")
      (setf (simulation-percent-done self) -1)
      (build-param-envisionment-from-csvs
       results
       :limit-to-vars (simulation-variables self)
       :system-name (simulation-model-name self)
       :model-name (simulation-model-name self)
       :callback #'(lambda (mode percent)
                     (format t "mode: ~A, percent: ~A~%" mode percent)
                     (setf (simulation-current-mode self) mode)
                     (setf (simulation-percent-done self) percent)))
      (situation-coloring)
      (setf (simulation-json self) 
            (with-output-to-string (the-message)
              (generate-json the-message
                             (system-initial-situations *system-being-analyzed*))
              the-message))
      (format t "~% Label success and failure")
      (setf (simulation-current-mode self) "Evaluating situations...")
      (setf (simulation-percent-done self) -1)
      (situation-coloring)
      (setf (simulation-current-mode self) "Preparing envisionment...")
      (setf (simulation-percent-done self) 100)
      )))

;;;
;;; A server class that can support multiple simulations, distinguished
;;; by model-name.  Each URL that's specific to a simulation has the form
;;; /MODEL-NAME/..., so that toplevel element is used to dispatch to a particular
;;; simulation.  Non-specific elements, such as /d3.v3.js, are handled by a static
;;; file hander, relative to the envisioner/v2/ui/ directory.
;;;

(defclass simserver (uiserver)
  ())

(defmethod initialize-instance :after ((self simserver) &rest initargs &key &allow-other-keys)
  (declare (ignore initargs))
  (setf (hunchentoot:acceptor-document-root self)
        (merge-pathnames "envisioner/v2/ui/" cl-user::*my-meta-path*)))

(defmethod add-simulation ((self simserver) (sim simulation))
  (setf (gethash (simulation-model-name sim) (uiserver-providers self)) sim))

(defmethod add-new-simulation-from-json-string ((self simserver) data)
  "Given a UISERVER and DATA \"some string with JSON data in it\",
create a simulation and then add it to the UI server."
  (when data
    (let* ((json-data (json:decode-json-from-string data))
           (sim (make-instance
                 'simulation
                 :name (cdr (assoc :model json-data))
                 :libraries (cdr (assoc :libraries json-data))
                 :openmodelicahome (cdr (assoc :openmodelicahome json-data))
                 :variables (cdr (assoc :variables json-data))
                 :parameters (cdr (assoc :parameters json-data)))))
      (add-simulation self sim)
      (run sim))))

(defmethod run ((self simserver) &key (continue nil))
  (declare (ignore continue))
  (format t "simserver run method~%")
  (call-next-method)
  ;; process the simulations
  (format t "simserver run method (again)~%")
  (maphash #'(lambda (key value)
               (declare (ignore key))
               (when (typep value 'simulation)
                 (run value)))
           (uiserver-providers self)))

(defmethod root-content ((self simserver) path parameters)
  (declare (ignore parameters))
  (hunchentoot:log-message* :warning "root-content simserver, path is ~A, parameters is ~A~%" path parameters)
  (cond ((string-equal path "/")
         ;; Generate a list of all the simulations known
         (values "text/html"
                 (with-output-to-string (out)
                   (format out "<HTML><BODY>~%")
                   (format out "Models:~%<br>~%<ul>~%")
                   (maphash #'(lambda (model-name sim)
                                (declare (ignore sim))
                                (format out "<LI><A HREF=\"/~A/\">~A</A></LI>~%"
                                        model-name model-name))
                            (uiserver-providers self))
                   (format out "</UL></BODY></HTML>~%"))))
        ((and (eq (hunchentoot:request-method*) :post)
              (string-equal path "/-add-model"))
         ;; post of new model -- add in a simulation for it
         (let ((data-octets (hunchentoot:raw-post-data)))
           (add-new-simulation-from-json-string
            self
            ;; Use the quicklisp function here just to save some coding
            (ql-http::ascii-subseq data-octets 0 (length data-octets))))
         (values "text/plain" "OK"))
        ((string-equal path "/-ping")
         ;; respond to /-ping with bare "t"
         (values "text/plain" "OK"))
        (t
         (let ((full-path (merge-pathnames (if (equal "/" path) #p"index.html" (subseq path 1))
                                           (hunchentoot:acceptor-document-root self))))
           (hunchentoot:log-message* :warning "calling handle-static-file with path ~S~%" full-path)
           (hunchentoot:handle-static-file full-path)))))
          

;;;
;;; Some testing code
;;;

;; on pippin: (test-simulation '("/Users/wjanssen/projects/meta/META/envisioner/v2/packaging/sim.json" "/Users/wjanssen/projects/meta/META/envisioner/v2/packaging/rlc-series.json") 8002)


(defvar *uiserver* nil)

(defun test-simulation (filenames port)
  (declare (special *uiserver*))
  (let ((server (make-instance 'simserver :port port)))
    (dolist (filename filenames)
      (with-open-file (f filename :direction :input)
        (let ((json-data (json:decode-json f)))
          (add-simulation server
                          (make-instance
                           'simulation
                           :name (cdr (assoc :model json-data))
                           :libraries (cdr (assoc :libraries json-data))
                           :openmodelicahome (cdr (assoc :openmodelicahome json-data))
                           :variables (cdr (assoc :variables json-data))
                           :parameters (cdr (assoc :parameters json-data)))))))
    (setf *uiserver* server)
    (run server :continue t)
    server))

;;;-*- Mode: Lisp;  -*-

;;;; Prefix to Infix Conversion

;; [07/24/2013 klenk] I took this file form russel and norvig's AIMA.  Need to check the
;; [07/24/2013 klenk] liscensing to ensure it is fair
;; [07/24/2013 klenk] The other option is to rewrite OpenModelica's XML dumper for when
;; [07/24/2013 klenk] equations

(in-package :env2)

(defparameter *infix-ops* 
  '((([ list match ]) ({ elts match }) (|(| nil match |)|))
    ((*) (/))
    ((+) (-))
    ((<) (>) (<=) (>=) (=) (/=))
    ((not not unary) (~ not unary))
    ((booleanvector))
    ((and) (& and) (^ and))
    ((or) (\| or))
    ((=>))
    ((<=>))
    ;((|,|))
    )
  "A list of lists of operators, highest precedence first.")

(defun ->prefix (infix)
  "Convert an infix expression to prefix."
  (when (stringp infix) (setf infix (string->infix infix)))
  ;; INFIX is a list of elements; each one is in prefix notation.
  ;; Keep reducing (most tightly bound first) until there is only one 
  ;; element left in the list.  Example: In two reductions we go:
  ;; (a + b * c) => (a + (* b c)) => ((+ a (* b c)))
  (loop 
    (when (not (length>1 infix)) (return (first infix)))
    (setf infix (reduce-infix infix))))

(defun reduce-infix (infix)
  "Find the highest-precedence operator in INFIX and reduce accordingly."
  (dolist (ops *infix-ops* (error "Bad syntax for infix expression: ~S" infix))
    (let* ((pos (position-if #'(lambda (i) (assoc i ops)) infix
                             :from-end (eq (op-type (first ops)) 'MATCH)))
           (op (when pos (assoc (elt infix pos) ops))))
      (debug-print nil "~% reduce-infix ~a ~a" pos op)
      (when pos
        (return
         (case (op-type op)
           (MATCH (reduce-matching-op op pos infix))
           (UNARY (replace-subseq infix pos 2 
                                  (list (op-name op) 
                                        (elt infix (+ pos 1)))))
           (BINARY (replace-subseq infix (- pos 1) 3
                                   (list (op-name op)
                                         (elt infix (- pos 1)) 
                                         (elt infix (+ pos 1)))))))))))

(defun op-token (op) (first op))
(defun op-name (op) (or (second op) (first op)))
(defun op-type (op) (or (third op) 'BINARY))
(defun op-match (op) (fourth op))

(defun replace-subseq (sequence start length new)
  (nconc (subseq sequence 0 start) (list new)
         (subseq sequence (+ start length))))

(defun reduce-matching-op (op pos infix)
  "Find the matching op (paren or bracket) and reduce."
  ;; Note we don't worry about nested parens because we search :from-end
  (let* ((end (position (op-match op) infix :start pos))
         (len (+ 1 (- end pos)))
         (inside-parens (remove-commas (->prefix (subseq infix (+ pos 1) end)))))
    (cond ((not (eq (op-name op) '|(|)) ;; handle {a,b} or [a,b]
           (replace-subseq infix pos len 
                           (cons (op-name op) inside-parens))) ; {set}
          ((and (> pos 0)  ;; handle f(a,b)
                (function-symbol? (elt infix (- pos 1))))
           (handle-quantifiers
            (replace-subseq infix (- pos 1) (+ len 1)
                           (cons (elt infix (- pos 1)) inside-parens))))
          (t ;; handle (a + b)
           (assert (length=1 inside-parens))
           (replace-subseq infix pos len (first inside-parens))))))
                    
(defun remove-commas (exp)
  "Convert (|,| a b) to (a b)."
  (cond ((eq (op exp) '|,|) (nconc (remove-commas (arg1 exp) )
                                   (remove-commas (arg2 exp))))
        (t (list exp))))

(defun handle-quantifiers (exp)
  "Change (FORALL x y P) to (FORALL (x y) P)."
  (if (member (op exp) '(FORALL EXISTS))
    `(,(op exp) ,(butlast (rest exp)) ,(last1 exp))
    exp))

;;;; Tokenization: convert a string to a sequence of tokens
      
(defun string->infix (string &optional (start 0))
  "Convert a string to a list of tokens."
  (multiple-value-bind (token i) (parse-infix-token string start)
    (cond ((null token) nil)
          ((null i) (list token))
          (t (cons token (string->infix string i))))))

(defun parse-infix-token (string start)
  "Return the first token in string and the position after it, or nil."
    (let* ((i (position-if-not #'whitespace? string :start start))
           (ch (if i (char string i))))
      (cond ((null i) (values nil nil))
            ((find ch "+-~()[]{},") (values (intern (string ch)) (+ i 1)))
            ((find ch "0123456789") 
	     (read-from-string  string nil nil :start start))
            ((symbol-char? ch) (parse-span string #'symbol-char? i))
            ((operator-char? ch) (parse-span string #'operator-char? i))
            (t (error "unexpected character: ~C" ch)))))

(defun parse-span (string pred i)
  (let* ((j (position-if-not pred string :start i))
	 (span (subseq string i j)))
    (values (if (str-is-op? span)
		(intern (string-upcase span))
		span)
	    j)))
;    (values (make-logic-symbol (subseq string i j)) j)))

(defun str-is-op? (str)
  (member (intern (string-upcase str)) (flatten *infix-ops*))) 

(defun make-logic-symbol (string)
  "Convert string to symbol, preserving case, except for AND/OR/NOT/FORALL/EXISTS."
  (cond ((find string '(and or not forall exists) :test #'string-equal))
        ((lower-case-p (char string 0)) 
	  (concat-symbol "$" (string-upcase string)))
	((equal string "Nil") '|Nil|)
        (t (intern (string-upcase string))))
  )
            
(defun operator-char? (x) (find x "<=>&^|*/,"))

(defun symbol-char? (x) (or (alphanumericp x) (find x "$!?%.()")))

(defun function-symbol? (x) 
  (and (symbolp x) (not (member x '(and or not ||)))
       (alphanumericp (char (string x) 0))))

(defun whitespace? (ch)
  (find ch " 
"))

;;;; from other AIMA files

(defun last1 (lst)
  (first (last lst)))

(defun length=1 (lst)
  (and (consp lst)(null (cdr lst))))

(defun length>1 (lst)
  (and (consp lst)(cdr lst)))

(defun op (exp) "Operator of an expression" (if (listp exp) (first exp) exp))
(defun args (exp) "Arguments of an expression" (if (listp exp) (rest exp) nil))
(defun arg1 (exp) "First argument" (first (args exp)))
(defun arg2 (exp) "Second argument" (second (args exp)))

(defun concat-symbol (&rest args)
  "Concatenate the args into one string, and turn that into a symbol."
  (intern (format nil "~{~a~}" args)));;;;  Modified: Tuesday, November 19, 2013 at 19:11:34 by klenk
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: initial-conditions-omc.lisp
;;;;    System: PARC QM Envisioner, v2
;;;;    Author: Matt Klenk
;;;;   Created: 8/2/2013
;;;;   Purpose: Given a system, we determine the initial situations by 
;;;;            running omc   
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;;; Very simple helper function to do vignettes.

(defun envision-vignette (modelname)
  (envision-model-from-modelica 
   modelname 
   (merge-pathnames (format nil "modelica/vignettes/~a.mo" modelname)
		    cl-user::*my-meta-path*)))


(defvar *logging-parse-xml-errors* nil
  "Set to T to log parse errors instead of signalling them")

(defvar *translation-errors* '()
  "List of errors that were found during the translation process.")

(defvar *expand-constraints-of-type* '(:higher-order :continuity :landmarks)
  "These constraints were evaluting the Klenk et al. AAAI-2014 paper")


(defun handle-exception (c)
  (declare (special *logging-parse-xml-errors*))
  (if *logging-parse-xml-errors*
      (let ((restart (find-restart 'ignore-error)))
        (note-exception c)
        (when restart
          (invoke-restart restart)))
      (error c)))

(defun envision-model-from-modelica (modelname modelfile 
				     &key 
				     (libraries (list "Modelica"))
				     (debug? nil)
				     (pseudo-state-vars nil)
				     (landmark-orders nil)
				     (eliminate? t)
				     (terminate-on-success-failure? t)
				     (depth nil)
                                     (omcbinary nil)
                                     (openmodelicahome nil)
				     (use-cache? nil)
				     (extra-equations nil)
                                     (allow-initial-ambiguity? nil)
                                     (rewrites-file nil)
				     (logging-parse-errors nil)
                                     (translation-only? nil)
				     (csv-stop-time nil))
  "Performs an envisionment of the modelica model MODELNAME which is defined by 
   MODELFILE and LIBRARIES.  DEBUG? sets the system flag for output to stdout.
   PSUEDO-STATE-VARS is a list of modelica variables names that should be constant in 
   discrete transitions or :all if all variables should be treated this way.
   LANDMARK-ORDERS takes lists of landmark var ids that should be ordered.  NB: In the 
   future, we need to determine these automatically from the initial conditions.
   When TERMINATE-ON-SUCCESS-FAILURE?, the envisionment does not expand nodes that are 
   marked with :success or :failure.  The result of this function is an envisionment
   stored on the returned system object.  When USE-CACHE?, do not call omc again.
   EXTRA-CONSTRAINTS is a list of prefix notation equations with string variables for
   arguements. Strings must be string= to var-local-name of variables.  When CSV-STOP-TIME
   is not nil, we generate a csv-guided envisionment of the simulation from 0 to CSV-STOP-TIME"
  (declare (special *translation-errors* *logging-parse-xml-errors*))
  (let ((*translation-errors* nil)
	(*logging-parse-xml-errors* logging-parse-errors))
    (handler-bind ((expression-parse-xml-error #'handle-exception)
                   (parse-xml-error #'handle-exception)
                   (mode-equation #'handle-exception)
                   (unhandled-operator #'handle-exception)
                   (invalid-tree-or-vars #'handle-exception)
                   (if-expression #'handle-exception)
                   (serious-condition #'handle-exception))
      (multiple-value-bind (system initial-conditions)
          (create-system-from-modelica modelfile modelname
                                       :libraries  libraries
                                       :debug? debug?
                                       :omcbinary omcbinary
                                       :openmodelicahome openmodelicahome
                                       :use-cache? use-cache?
                                       :rewrites-file rewrites-file
                                       :extra-equations extra-equations
				       :csv-stop-time csv-stop-time)   
          (when system
            (setf (system-success-function system) #'modelica-success-fn
                  (system-terminate-on-success-failure? system) terminate-on-success-failure?)
	    (setf (system-initial-conditions system) initial-conditions)

            (mark-pseudo-state-vars pseudo-state-vars)


            (propagate-fixed-vars)
            (add-landmark-constraints
             (or landmark-orders
                 (figure-landmark-constraints system initial-conditions :debug? debug?)))
            (delete-unconstrained-vars)

            (add-higher-deriv-equalities)
;;; [05/22/2014 Johan] Moved eliminator to later otherwise compactor will not know ics.
            (when eliminate? (eliminate))
            (let ((sits 
                   (restart-case 
                       (create-initial-sits 
                        (add-$dummy-inits
                         (remove-unnecessary-initial-conditions initial-conditions))
                        system)
                     (ignore-error () nil))))
              (cond (*translation-errors*
                     (write-translation-errors-to-file)
                     *translation-errors*)
                    (translation-only? *translation-errors*)
                    (t
                     (assert (or allow-initial-ambiguity? (and sits (= (length sits) 1))))
                     (setf (system-initial-situations system) sits)
                     (envision sits depth))
                    )))))))


(defvar *last-xml* nil)
(defvar *last-ics* nil)
(defvar *last-csv-file* nil)

(defun create-system-from-modelica (modelfile modelname
                                    &key
                                    (libraries nil)
                                    (omcbinary nil)
                                    (openmodelicahome nil)
                                    (debug? nil)
				    (use-cache? nil)
                                    (rewrites-file nil)
				    (extra-equations nil)
				    (csv-stop-time nil)) 	
  "Use omc to create the XML DAE and get the initial conditions for the
   model specified by MODELNAME, loading MODELFILE if specified, and the
   LIBRARIES if specified. When use-cache?, do not call omc again."
  (unless use-cache?
    (multiple-value-setq (*last-ics* *last-csv-file*)
      (initial-conditions-by-om-sim
       modelfile modelname
       :libraries libraries
       :omcbinary omcbinary
       :openmodelicahome openmodelicahome
       :stop-time csv-stop-time))
    (setq *last-xml* (omc-get-xml-dae
		      modelfile modelname
		      :libraries libraries
		      :omcbinary omcbinary
		      :rewrites rewrites-file
		      :openmodelicahome openmodelicahome
		      :clean-up? nil)))
  (multiple-value-bind (system ics)
      (create-system-from-om-results
       *last-xml*
       *last-ics*
       :debug? debug?
       :extra-equations extra-equations)
    (when csv-stop-time 
      (setf (system-match-qstates system) *last-csv-file*))
    (values system ics )))
  	  
	  
		

;; Must run simulation for initial values
(defun initial-conditions-by-om-sim (modelfile modelname 
				     &key 
				     (libraries nil)
                                     (debug? nil)
                                     (omcbinary nil)
                                     (openmodelicahome nil)
                                     (stop-time nil))
  (declare (ignore debug?))
  (if modelfile
      (setq libraries (append libraries (list modelfile))))
  (omc-initial-values modelname
		      :libraries libraries
		      :omcbinary omcbinary
		      :openmodelicahome openmodelicahome
		      :clean-up? nil
		      :stop-time stop-time))
  

;;;;;;;;;;;;new functions for building the model from the parse
(defun create-system-from-om-results (xmlfile initial-conditions-from-sim
				      &key 
				      (debug? nil)
				      (extra-equations nil))
  "given an xmlfile and an s-expr of initial conditions, return a system object
   with all of the constraints and an expanded set of initial-conditions"
  (let* ((parse 
;; [03/27/2014 klenk] removed a call to add bind expression here, initialization
;; [03/27/2014 klenk] should all be handled in merge-ics
	   (parse-om-xml-dae-dump xmlfile :ignore-errors? debug?)
	   )
	 (system (setq *system-being-analyzed* 
		       (create-system (get-system-name-from-parse parse) debug?)))
	 (top-model (add-top-models system)))
    (setf (system-xml-parse system) parse)
    (push :omc (system-analyses system))
;; [08/ 6/2013 klenk] Process all equations and variables into lisp form
    (multiple-value-bind (vars-hash-table initial-conditions)
        (process-variables parse top-model)
      (multiple-value-bind (mode-equations conditional-equations initial-conditions)
	  (preprocess-conditional-equations 
	   (cdr (assoc :modes parse))
	   vars-hash-table
;; [03/27/2014 klenk] We should delete simplify-initial-conditions
	   (merge-ics (simplify-initial-conditions initial-conditions vars-hash-table)
                      initial-conditions-from-sim vars-hash-table)
	   top-model)
	(let ((when-equations (preprocess-when-equations (cdr (assoc :when-equations parse))
					vars-hash-table initial-conditions top-model)))
	  (multiple-value-bind (lisp-form-equations initial-conditions)
	      (preprocess-equations 
	       (append (mapcar #'(lambda (eqn) (cdr (assoc :lisp-form eqn)))
			       (cdr (assoc :equations parse)))
		       extra-equations)
	       vars-hash-table initial-conditions top-model)
;; [08/ 6/2013 klenk] create constraints
	    (vars->system vars-hash-table system top-model)
	    (create-constraints-for-equations-from-xml 
	     (remove-duplicates 
	      (append lisp-form-equations mode-equations) :test #'equal)
	     ;;***xxx system-variables?
	     top-model (system-variables system) initial-conditions)
	    (create-conditional-constraints 
	     (append conditional-equations)
	     top-model initial-conditions)
	    (create-when-structs when-equations top-model)
	    (add-$der-constraints system)
	    (propagate-discrete-information-through-constraints system)

	    
;; [08/ 6/2013 klenk] If we hit this assertion then we need to perfrom
;; [08/ 6/2013 klenk] simplify-initial-conditions
;; [05/09/2013 Johan] I commented this out because it does not allow q-quantities.
;	    (assert (every #'(lambda (ic)
;			       (and (or (numberp (third ic))
;					(eql (third ic) 'Q+)
;                                        (symbolp (third ic)))
;				    (fifth ic)))
;			   initial-conditions))
	    (let ((ics (add-dummy-variables-ics 
			initial-conditions 
			(dummy-vars system)
			initial-conditions-from-sim)))
	      (dolist (ic ics)
		(when (var-fixed? (car ic))
		  (push (cons (car ic) (third ic))
			(system-parameters *system-being-analyzed*))))
	      (values system ics))
	 ))))))

;;; these don't seem like equations.  these bind expressions are initial values
;; (defun add-bind-expressions-to-equations (parse)
;;   (dolist (var (cdr (assoc :variables parse)) parse)
;;     (when (and (cdr (assoc :continuous var))
;; 	       (cdr (assoc :known? var))
;; 	       (cdr (assoc :initial-value var))
;; 	       (listp (cdr (assoc :initial-value var))))
;;       (if (contains-if? (cdr (assoc :initial-value var)))
;; 	  (nconc (assoc :modes parse)
;; 		 (list (list (cons :lisp-form (list '= 
;; 						    (cdr (assoc :name var))
;; 						    (cdr (assoc :initial-value var))
;; 						    )))))
;; 	  (nconc (assoc :equations parse)
;; 		 (list (list (cons :lisp-form (list '= 
;; 						    (cdr (assoc :name var))
;; 						    (cdr (assoc :initial-value var))
;; 						    )))))
;; 	  ))))



(defun vars->system (vars-hash-table system top-model)
  "Adds the vars to the system-variables slot"
  (maphash #'(lambda (key value)
	       (declare (ignore key))
	       (push value (system-variables system))
	       (push value (system-active-variables system))
	       (push value (model-variables top-model)))
	   vars-hash-table)
  )
    	 
(defun add-top-models (system)
      (let ((model (make-model :id (new-id) :local-name (system-name system))))
	(push model (system-models system))
	(setf (gethash (model-local-name model) (system-top-models system))
	      model)
	model))    

(defun merge-ics (from-parse from-sim vars-hash-table)
  "FROM-PARSE ics are 5-tuples (<var> :start <value> :fixed <boolean>)
   FROM-SIM ics are var-name value-string pairs.
   SYSTEM is used to get the variable objects

   Note that value-string might be a number (integer or float), a string,
   a boolean, or an enumeration value, depending on the type of the Modelica
   variable.

   Returns FROM-PARSE form."
   (add-initial-conditions-from-parse 
    from-parse 
    (create-ics-from-sim from-sim from-parse vars-hash-table)))
   

(defun create-ics-from-sim (from-sim from-parse vars-hash-table)
  (let (ret)
    (dolist (ic from-sim ret)
      (let ((var (gethash (car ic) vars-hash-table)))
	(when var
	  (let ((ic-value (cond ((member (var-fundamental-type var)
					 '(:across :through :time :variable))
				 (cdr ic))
				((eq (var-fundamental-type var) :fixed-parameter)
;; [11/18/2013 klenk] Fixed parameters are computed from the knownvariables list in the XML
				 nil)
				((eq (var-type var)'env2-names::|Boolean|)
				 (assert (or (numberp (cdr ic))(stringp (cdr ic))))
				 (if (or (and (numberp (cdr ic))
					      (not (= (cdr ic) 0)))
					 (and (stringp (cdr ic))
					      (string-equal (cdr ic) "true")))
				     :|true|
				     :|false|))
				((eq (var-fundamental-type var) :discrete)
				 ;; integer or enumeration
				 ;; [08/27/2013 klenk] We can't do these because there does not appear to be a clear mapping
				 ;; [08/27/2013 klenk] between number and enumerated type
				 (format t "~% ignoring initial value of discrete variable from simulation results ~A"
				       var)
				 nil
				 )
				(t
				 (print var)
				 (error "Unknown type")))))
	    (when (and ic-value
		       (find var from-parse :key #'car)
		       (not (equalp (third (find var from-parse :key #'car)) ic-value)))
	      (format t "~% Using initial value for ~a from simulation ~a as opposed to model ~a"
		      var ic-value (third (find var from-parse :key #'car)))
	      (format t "~% Using initial value from simulation instead of model value for ~A"
		    var))
	    (when ic-value (push (list var :start ic-value :fixed? t :why-fixed 'create-ics-from-sim) ret))))))))

(defun add-initial-conditions-from-parse (from-parse ics)
  (dolist (ic from-parse ics)
    (unless (member (car ic) ics :key #'car)
      (push ic ics))))

(defun add-dummy-variables-ics (ics variables ics-from-om-sim)
  (dolist (dummy variables)
    (restart-case
        (let ((val (determine-dummy-ics dummy ics ics-from-om-sim)))
          (if val
              (push (list dummy :start val :fixed? t :why-fixed 'add-dummy-variables-ics) ics)
              (format t "Unable to determine value for ~A" dummy)))
      (ignore-error () nil)
      ))
  ics)

;; [11/19/2013 klenk] ARE WE SCREWED BECAUSE WE DON'T HAVE THE SITS HERE
;; [11/19/2013 klenk] Is there any extra information in ics-from-om-sim at this point?
;; [04/ 8/2014 klenk] ics-from-om-sim is used for derivative variables
(defun determine-dummy-ics (var ics ics-from-om-sim)
  "determines the numeric value for the var usings the ics"
  (let ((exp (cond ((listp var) var)
		   ((and (dummy-var? var)
			 (not (dummy-deriv? var)))
		    (var-type var))
		   ((var-p var) var)
		   ((numberp var) var)
		   (t (error "stub")))))
    (cond ((and (dummy-var? var)
		(dummy-deriv? var))
	   (cdr (find (d/dt->der exp) ics-from-om-sim :key #'car :test #'string=)))
	  ((and (var-p var)
		(not (dummy-var? var)))
	   (cond ((third (find var ics :key #'car)))
		 ((cdr (find (var-local-name var)
			     ics-from-om-sim :key #'car :test #'string=)))

		 ((and ($der-var? var)
		       (cdr (find ($der-var->der-str var)
				  ics-from-om-sim :key #'car :test #'string=))))
		 ((and (var-fixed? var)
		       (eq (var-fundamental-type var) :discrete))
		  ;; [05/21/2014 Johan] 
		  (cond (*use-global* (q-quantity-value (discrete-value var 'global)))
			(t (let ((constraint (find-if #'(lambda (constraint)
							  (and (qset-constraint-p constraint)
							       (null (constraint-condition constraint))))
						      (var-uses var))))
			     (assert constraint)
			     (qset-constraint-constant constraint)))))
		 (t (error "determine-dummy-ics: shouldn't happen; non-dummy var ~A, no initial value found" var))))
	  (t (determine-dummy-ics-from-exp exp ics ics-from-om-sim)))))

(defun determine-dummy-ics-from-exp (exp ics ics-from-om-sim)
  (cond ((numberp exp) exp)
	((not (listp exp)) (error "unable to determine var type ~A" exp))
	((and (eq (car exp) '-)
	      (= (length exp) 2))
	 (let ((arg (determine-dummy-ics (second exp) ics ics-from-om-sim)))
	   (when arg (- arg))))
	((eq (car exp) 'deriv)
	 (determine-dummy-ics (var-deriv (second exp)) ics ics-from-om-sim))
	      
	((and (= (length exp) 3)
	      (member (car exp) '(+ - / *)))
	 (let ((lhs (determine-dummy-ics (second exp) ics ics-from-om-sim))
	       (rhs (determine-dummy-ics (third exp) ics ics-from-om-sim)))
	   (cond ((and 
		   lhs rhs
		   (eq (car exp) '/)
		   (= rhs 0))
		  0)
		 ((and lhs rhs)
		  (apply (car exp) (list lhs rhs))
		  ))))
	((and (= (length exp) 4)
	      (eq (car exp) 'if))
	 (if (dummy-ics-condition? (second exp) ics ics-from-om-sim)
	     (determine-dummy-ics (third exp) ics ics-from-om-sim)
	     (determine-dummy-ics (fourth exp) ics ics-from-om-sim)))
	((and (= (length exp) 4)
	      (eq (car exp) :tempinterpol1))
	 (determine-dummy-temp-interpol1 exp ics ics-from-om-sim)) 
	(t (error "unable to compute initial dummy value for exp ~A" exp))))

(defun dummy-ics-condition? (condition ics ics-from-om-sim)
  (cond ((var-p condition)
	 (equal (eval-dummy-ics-arg condition ics ics-from-om-sim)
		:|true|))
	(t
	 (assert (= (length condition) 3))
	 (let ((lhs (eval-dummy-ics-arg 
		       (second condition) ics ics-from-om-sim))
	       (rhs (eval-dummy-ics-arg 
		       (third condition) ics ics-from-om-sim)))
	   (ecase (car condition)
	     (= (equal lhs rhs))
	     (< (< lhs rhs))
	     (> (> lhs rhs))
	     (>= (>= lhs rhs))
	     (<= (<= lhs rhs))
	     (and (and lhs rhs))
	     (or (or lhs rhs))
	     ))))) 

(defun eval-dummy-ics-arg (arg ics ics-from-om-sim)
  (cond ((numberp arg) arg)
	((and (var-p arg)
	      (third (find arg ics :key #'car))))
	((and (var-p arg)
	      (dummy-var? arg))
	 (determine-dummy-ics arg ics ics-from-om-sim))
	((and (var-p arg)
	      (cdr (find (var-local-name arg)
			 ics-from-om-sim :key #'car :test #'string=))))
	((and (listp arg)
	      (logical-operator? (car arg)))
	 (dummy-ics-condition? arg ics ics-from-om-sim))
	((listp arg)
	 (determine-dummy-ics-from-exp arg ics ics-from-om-sim)) 
	((and (symbolp arg)
	      (member arg (list (intern "true" :keyword)
				(intern "false" :keyword))))
	 arg)
	(t (error "unhandled dummy-ics-arg ~A" arg))))

(defun logical-operator? (op)
  (member op '(< > <= >= = or and)))


(defun determine-dummy-temp-interpol1 (exp ics ics-from-om-sim)
  (let ((input-table (third exp)) 
	(table (make-array (array-dimensions (third exp))))
	(u (determine-dummy-ics (second exp) ics ics-from-om-sim))
	(icol (fourth exp)))
    (dotimes (i (car (array-dimensions table)))
	(dotimes (j (cadr (array-dimensions table)))
	  (setf (aref table i j)
		(determine-dummy-ics (car (aref input-table i j)) ics ics-from-om-sim))))
    (modelica-tempinterpol1 u table icol))) 
     
    
(defun figure-landmark-constraints (system ics &key (debug? nil))
  "Look for constraints of the form

        dummyXX = foo - bar

   where foo is a continuous variable and bar is constant (a parameter).
   Collect all such bars for foo as its landmarks, sorted in order from
   0.

   Returns hash table mapping variables to a list of (name . value) conses,
   in order.
  "
  (labels
      ((dummify-constraint (pos-vars neg-vars)
         (let ((dummy
                (remove-if
                 #'null
                 (mapcar
                  #'(lambda (var)
                      ;; (format t "~&Var: ~A ~A~%" var (if (var-fixed? var) "fixed" "variable"))
                      (if (and (stringp (var-local-name var))
                               (> (length (var-local-name var)) 5)
                               (string-equal (subseq (var-local-name var) 0 5) "dummy")
                               (not (var-fixed? var)))
                          var))
                  (concatenate 'list pos-vars neg-vars))))
               (adds nil)
               (subs nil))
           (when (and (= (length dummy) 1)
                      (member (car dummy) pos-vars))
             ;; only one dummy
             (setq dummy (car dummy))
             (setq adds neg-vars)
             ;; subtract all the other pos-vars from each side
             (dolist (v pos-vars)
               (if (not (eq v dummy))
                   (push v subs)))
             (values dummy adds subs))))

       (find-constants (variable set negate?)
         (let ((result nil))
         (dolist (v (remove-if #'(lambda (x) (eq x variable)) set))
           (if (var-fixed? v)
               (push (cons (if negate? '- '+) v) result)))
         result))
       )

    (let ((triples nil)
          (parameters (system-parameters system))
          (landmarks (make-hash-table)))
      (dolist (constraint (system-constraints system))
        ;; only look at summer constraints
        (when (equal (type-of constraint) 'general-summer-constraint)
          (restart-case
              (let ((pos-vars (general-summer-constraint-pos-vars constraint))
                    (neg-vars (general-summer-constraint-neg-vars constraint))
                    variable)
                (if debug? (format t "~&Constraint: ~A - ~A~%" pos-vars neg-vars))
                (multiple-value-bind (dummy adds subs)
                    (dummify-constraint pos-vars neg-vars)
                  (when dummy
                    (if debug? (format t "~&  Dummy: ~A~%" dummy))
                    (dolist (v (concatenate 'list adds subs))
                      (if (and (not variable) (not (var-fixed? v)))
                          (setq variable v)
                          ))
                    (if variable
                        (let ((constants
                               (concatenate 'list
                                        ;(find-constants variable adds t)
                                            (find-constants variable subs nil))))
                          (if debug? (format t "~&    Variable: ~A~%" variable))
                          (when constants
                            (assert (= (length constants) 1))
                            (if debug? (format t "~&      Constants: ~A~%" constants))
                            (pushnew (list dummy variable (car constants)) triples))))))
                )
            (ignore-error () nil)
            )))
      (dolist (triple triples)
        (restart-case
            (let ((dummy (first triple))
                  (variable (second triple))
                  (constant (third triple))
                  (existing nil))
              (setq existing (gethash variable landmarks))
              (if (not (member constant existing
                               :test #'(lambda (x y) (eq (car y) (cdr x)))))
                  (let ((total-value 0))
                    (let ((op (car constant))
                          (var (cdr constant)))
                      (let ((value
                             (or (let ((v2 (assoc var parameters)))
                                   (if v2 (cdr v2)))
                                 (let ((v2 (find var ics :key #'car)))
                                   (if v2 (cadr (member :start v2))))))
                            )
                        (cond ((eq op '+)
                               (setq total-value (+ value total-value)))
                              ((eq op '-)
                               (setq total-value (- value total-value))))))
                    (if (not (zerop total-value))
                        (setf (gethash variable landmarks)
                              (sort (cons (list (cdr constant) total-value dummy) existing)
                                    #'(lambda (x y)
                                        (< (second x) (second y)))))))))
          (ignore-error () nil)
          ))
      (let ((ordered-ids nil))
        (maphash #'(lambda (key value)
                     (if debug?
                         (format t "~&Landmarks for ~A: ~S~%" key value))
                     (if (> (length value) 1)
                         (push (mapcar #'(lambda (triple) (var-id (third triple))) value) ordered-ids)))
                 landmarks)
        (if debug?
            (format t "~&ordered-ids is ~S~%" ordered-ids))
        ordered-ids)
      )))
                                    
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: graph-display.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December  6, 2011 09:06:09
;;;;   Purpose: graphviz output generation
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, November 29, 2012 at 11:29:14 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


;; [08/02/2012 klenk] We currently use d3 for all graphical displays.
(defun display-envisionment (roots state-vars &optional depth)
;   (create-and-display-graphviz-out roots state-vars depth)
  (warn "no longer using zgraph, graphical displays go through d3")
   )

(defun create-and-display-graphviz-out (initial-sits state-vars depth)
  (out-graphviz-dot initial-sits state-vars (merge-pathnames "envisioner/v2/graph.dot" cl-user::*my-meta-path* depth))
  (dot->pdf)
  (open-envisionment-in-preview))

;; [03/18/2012 klenk] When depth not nil then all knows will be displayed
;; [03/18/2012 klenk] When state-vars is null, then all variables will be displayed
;; [03/ 7/2014 klenk] state-vars can be :id-only and :none
(defun out-graphviz-dot (roots state-vars outfilespec 
			 &key 
			 (depth)
			 (successor-fn #'situation-children))
  (let ((*print-pretty* nil)
	(state-vars (or state-vars (system-statevars *system-being-analyzed*))))
    (with-open-file (out outfilespec 
			 :direction :output
			 :if-exists :supersede
			 :if-does-not-exist :create)
      (format out (string-graphviz-dot roots state-vars depth successor-fn)))))


;; [03/ 7/2014 klenk] returns all intervals that follow from this situation
(defun intervals-only (sit)
  (remove-duplicates (intervals-only-1 sit)))

(defun intervals-only-1 (sit)
  (flatten
   (mapcar #'(lambda (child)
	       (cond ((eq (situation-type child) :interval)
		      child)
		     ((situation-children child) (intervals-only-1 child))
		     (t child)))
	   (situation-children sit))))

(defun string-graphviz-dot (roots state-vars &optional depth successor-fn)
  (let ((ret (make-array '(0) :element-type 'base-char
			 :fill-pointer 0 :adjustable t)))
    (with-output-to-string (out ret)
      (format out "digraph G {~%")
    (create-legend out state-vars)
    (do ((stack roots stack)
	 (all-nodes roots all-nodes))
	((null stack) all-nodes)
      (let* ((sit (pop stack))
	     (next-sits (funcall successor-fn sit))
	     (new-sits 
	      (remove-if #'(lambda (s) (member s all-nodes)) next-sits)
	       ))
	(unless (and depth (> (situation-depth sit) depth))
	  (format out "Sit~A [label=\"~A\",color=\"~A\",shape=~A,style=filled];~%" 
		  (situation-id sit)
		  (situation-string sit state-vars)
		  (cond ((eq (situation-status sit) :success)
			 "#CCFF33") ;; better for colorblind people
					;		       'green)
			((eq (situation-status sit) :failure)
			 'red)
			((not (situation-complete sit))
		       'magenta)
			((null (situation-children sit))
			 'cyan)
			(t 'gray))
		  (cond ((eq (situation-status sit) :success)
			 "house")  ; thumbs up, house points upward, sort of
			((eq (situation-status sit) :failure)
		       "invhouse")  ; thumbs down, downward pointing shape
			(t (case (situation-type sit)
			     (:instant "box")
			     (:interval "ellipse")
			     (t (assert nil))))))
	  (dolist (next-sit (set-difference next-sits new-sits))
	    (format out "Sit~A -> Sit~A;~%" (situation-id sit) (situation-id next-sit)))
	  (dolist (new-sit new-sits)
	    (format out "Sit~A -> Sit~A;~%" (situation-id sit) (situation-id new-sit))
	    (push new-sit stack)
	    (push new-sit all-nodes)))))
    (format out "}~%"))
    (coerce ret 'simple-string)))

(defun create-legend (out vars)
  (unless (eq vars :none)
  (format out "Legend [label=\"<id>")
    (unless (eq vars ':id-only)
      (dolist (var vars)
	(format out "~A" (full-name var))
	(unless (eq var (car (last vars)))
	  (format out " , "))))
    (format out "\",color=black,shape=box];~%")))

(defun remove-last (lst)
  (subseq lst 0 (1- (length lst))))
    
;; [12/12/2011 klenk] This may be too much information
(defun situation-string (situation state-vars)
  (if (eq state-vars :none)
      ""
      (format nil "<~A> ~A"
	      (situation-id situation)
	      (with-output-to-string (stream)
		(if (eq state-vars :id-only)
		    ""
		    (dolist (var state-vars)
		      (display-var-value var situation stream)
		      (unless (eql var (car (last state-vars)))
			(format stream " , "))))))))
  
(defun display-var-value  (var situation stream)
  (cond ((mode-var? var) (format stream " ~A" (mode-value var situation)))
	(t 
	 (dolist (qvalue (qualitative-values var situation))
	   (cond ((simpleqspace? (q-quantity-qspace qvalue))
		  (format stream "[~A : ~A]" 
			  (val->simpleq qvalue)
			  (q-quantity-deriv qvalue)))
		 (t
		  (format stream "~A" (q-quantity-value qvalue))
			  
		  ))))))

(defun get-viz-var (spec)
  (ecase (car spec)
    (>> (eval spec))
    (deriv (when (= (third spec) 1)
	     (var-deriv (eval (second spec)))))
    (mode (eval (cons '>> spec)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: gml-output.lisp
;;;;    System: envisioner v2
;;;;    Author: janssen
;;;;   Created: 16 May 2012
;;;;   Purpose: GML output generation
;;;; ----------------------------------------------------------------------------
;;;;  Modified: $Revision$
;;;; ----------------------------------------------------------------------------

(in-package :env2)



(defun display-envisionment-gml (roots state-vars &optional depth)
  (create-and-display-gml-out roots state-vars depth))

(defun create-and-display-gml-out (initial-sits state-vars depth)
  (declare (ignore depth))
  (let ((graph-pathname (get-tempfile-pathname :extension "gml")))
    (generate-gml graph-pathname initial-sits state-vars)
    (open-envisionment-in-cytoscape graph-pathname)))

(defun open-envisionment-in-cytoscape (graph-pathname)
  #+(or macos darwin)
  (asdf:run-shell-command "/usr/bin/open -a cytoscape '~A'" 
                          (namestring graph-pathname))
  )

(defun generate-gml (outfilespec roots &optional state-vars depth)
  ;; state-vars is a list of vars to be displayed
  ;; depth is an envisionment depth; situations deeper than depth will not be shown
  (labels ((walk-envisionment (out roots state-vars &optional depth)
             (format out "graph [~%")
             (do ((stack roots stack)
                  (all-nodes roots all-nodes))
                 ((null stack) all-nodes)
               (let* ((sit (pop stack))
                      (next-sits (situation-children sit))
                      (new-sits 
                       (remove-if #'(lambda (s) (member s all-nodes)) next-sits)
                        ))
                 (unless (and depth (> (situation-depth sit) depth))
                   (format out "  node [~%    id ~a~%    label \"<~A>\"~%"
                           (situation-id sit) (situation-id sit))
                   (format out "    situation [~%      status \"~a\"~%      complete ~a~%      type \"~a\"~%      childrenp ~a~%~a    ]~%"
                           (situation-status sit)
                           (if (situation-complete sit) 1 0)
                           (situation-type sit)
                           (if (null (situation-children sit)) 0 1)
                           (display-situation-vars sit state-vars))
                   (format out "    graphics [~%      type \"~a\"~%      fill \"~a\"~%    ]~%"
                           (ecase (situation-type sit)
                             (:instant "box")
                             (:interval "ellipse"))
                           (cond ((eq (situation-status sit) :success)
                                  "#CCFF33") ;; better for colorblind people
					;		       'green)
                                 ((eq (situation-status sit) :failure)
                                  "#FF0000")
                                 ((not (situation-complete sit))
                                  "#FFFFFF")
                                 ((null (situation-children sit))
                                  "#FF00FF")
                                 (t "#C0C0C0"))
                           )
                   (format out "  ]~%")
                   (dolist (next-sit (set-difference next-sits new-sits))
                     (format out "  edge [~%    source ~a~%    target ~a~%"
                             (situation-id sit)
                             (situation-id next-sit))
                     (format out "    graphics [~%      type \"line\"~%      arrow \"last\"~%    ]~%")
                     (format out "  ]~%")
                     )
                   (dolist (new-sit new-sits)
                     (format out "  edge [~%    source ~a~%    target ~a~%"
                             (situation-id sit)
                             (situation-id new-sit))
                     (format out "    graphics [~%      type \"line\"~%      arrow \"last\"~%    ]~%")
                     (format out "  ]~%")
                     (push new-sit stack)
                     (push new-sit all-nodes)))))
             (format out "]~%"))

           (display-situation-vars (situation state-vars)
             (with-output-to-string (stream)
               (format stream "      vars [~%")
               (dolist (var (or state-vars (situation-vars situation)))
                 (display-var-value var situation stream))
               (format stream "      ]~%")))
           
           (display-var-value  (var situation stream)
             (format stream "        v \"~A = " (var-local-name var))
             (if (mode-var? var)
                 (format stream "~A\"" (mode-value var situation))
                 ;; else
                 (dolist (qvalue (qualitative-values var situation))
                   (if (simpleqspace? (q-quantity-qspace qvalue))
                       (format stream "~A\""
                               (val->simpleq qvalue))
                       ;; else
                       (format stream "[~A : ~A]\""
                               (q-quantity-value qvalue)
                               (q-quantity-qspace qvalue)))))
             (format stream "~%"))

           (situation-vars (situation &key (fixed-parameters? nil) (hide-pins? nil))
             (declare (ignore situation))
             (let ((var-list))
               (dolist (var (system-active-variables *system-being-analyzed*))
                 (cond 
                   ((and hide-pins? (pin-var? var)))
                   ((and (parameter-p var) (not fixed-parameters?)))
                   (t (push var var-list))))
               var-list))
           )

    (let ((*print-pretty* nil))
      (with-open-file (out outfilespec 
                       :direction :output
                       :if-exists :supersede
                       :if-does-not-exist :create)
        (walk-envisionment out roots state-vars depth)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: json-output.lisp
;;;;    System: envisioner v2
;;;;    Author: janssen
;;;;   Created: 16 May 2012
;;;;   Purpose: GML output generation
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, September 12, 2012 at 14:07:39 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;; [06/08/2012 klenk] All the subgraph stuff and abstraction will migrate to js when I get a chance.
(defparameter *subgraph* nil "This is for debugging. When non-nil it is a list of situations")

(defun generate-json (outfilespec roots &optional state-vars depth)
  ;; state-vars is a list of vars to be displayed
  ;; depth is an envisionment depth; situations deeper than depth will not be shown
  (labels ((situation-vars (&key (fixed-parameters? nil) (hide-pins? nil))
             (let ((var-list))
               (dolist (var (system-variables *system-being-analyzed*))
                 (cond 
                   ((and hide-pins? (pin-var? var)))
                   ((and (parameter-p var) (not fixed-parameters?)))
                   (t (push var var-list))))
               (sort var-list #'string-lessp :key #'var-local-name)))
           
           (get-var-names (e &optional (level 0))
             (cond ((listp e)
                    (mapcar #'(lambda (x) (get-var-names x (+ level 1))) e))
                   ((var-p e)
                    (let ((n (var-local-name e)))
                      (if (and (> (length n) 4)
                               (equal "dummy" (subseq n 0 5)))
                          (get-var-names (var-type e) (+ level 1))
			   n)))
                   (t e)))
		  
           (get-violation-suggestions ()
             (let ((sits (total-situations)))
               (when (= 1 (length sits))
                 (if (find-violations (car sits))
                     (let ((suggestions (analyze-violations (car sits))))
                       (if suggestions
                           ;; we use a list in case we are ever able to handle more than one
                           ;; situation at a time
                           (list (cons (car sits) suggestions))))))))

           (get-var-value (var situation)
             (cond ((mode-var? var)
                    (mode-value var situation))
                   ((discrete-var? var)
                    (q-quantity-value (discrete-value var situation)))
                   (t
                    (let ((rvalue))
                      (dolist (qvalue (qualitative-values var situation))
                        (if (simpleqspace? (q-quantity-qspace qvalue))
                            (push (cons (val->simpleq qvalue)
                                        (q-quantity-deriv qvalue))
                                  rvalue)
                            ;; else
                            (push (cons (q-quantity-value qvalue) (q-quantity-qspace qvalue))
                                  rvalue)
                            ))
                      rvalue))
                   ))

           (find-conditions ()
             (let ((constraints (system-constraints *system-being-analyzed*))
                   (conditions)
                   (condition-id-counter 1))
               ;; find all conditions on constraints
               (dolist (constraint constraints)
                 (let ((c (constraint-condition constraint)))
                   (if c
                       (unless (member c conditions :test #'equal)
                         (push c conditions)))))
               (setq conditions
                     (mapcar #'(lambda (c)
                                 (prog1
                                     (cons (format nil "condition~d" condition-id-counter) c)
                                   (incf condition-id-counter)))
                             ;; conditional contraints come in pairs -- the condition and its inverse
                             (remove-if #'(lambda (c) (or (not (listp c)) (eq (car c) 'not))) conditions)))
               
               conditions))

           (rewrite-condition (c)
             ;; Our conditions are frequently of the form (>= (- v1 v2) 0.0).
             ;; Rewrite that to "v1 >= v2".
             (let ((result
                    (cond ((and (listp c)
                                (= (length c) 3)
                                (member (first c) '(>= > < <= == <>))
                                (member (third c) '(0.0 0))
                                (listp (second c))
                                (eq (car (second c)) '-)
                                (eq (length (second c)) 3))
                           (rewrite-condition (list (first c) (rewrite-condition (second (second c))) (rewrite-condition (third (second c))))))
                          ((and (listp c)
                                (= (length c) 3)
                                (member (first c) '(+ -))
                                (member (third c) '(0.0 0))
                                (listp (second c)))
                           (rewrite-condition (second c)))
                          ((and (listp c)
                                (= (length c) 3)
                                (member (first c) '(>= > < <= == <>))
                                (stringp (second c))
                                (stringp (third c)))
                           (format nil "~A ~A ~A" (second c) (first c) (third c)))
                          (t
                           c))))
               result))

           (figure-diffs (s1 s2 vars)
             ;; figure out what the state transitions are between s1 and s2
             ;; in terms of variables and their values
             (let ((diffs))
               (dolist (var vars)
                 (let ((val1 (get-var-value var s1))
                       (val2 (get-var-value var s2)))
                   (if (not (equal val1 val2))
                       (push (list (var-local-name var) val1 val2) diffs))))
               diffs))

           (figure-condition-diffs (s1 s2 conditions)
             ;; figure out what the state transitions are between s1 and s2
             ;; in terms of variables and their values
             (let ((diffs))
               (dolist (c conditions)
                 (let ((cname (car c))
                       (val1 (not (null (evaluate-condition-tv (cdr c) s1))))
                       (val2 (not (null (evaluate-condition-tv (cdr c) s2)))))
                   (if (not (equal val1 val2))
                       (push (list cname val1 val2) diffs))))
               diffs))

                  
           (true-list-p (x)
             (and (listp x) (null (cdr (last x)))))

           (json-encode-diff-value (v)
             (cond ((eq v t)
                    "true")
                   ((eq v nil)
                    "false")
                   ((true-list-p v)
                    (if (= (length v) 1)
                        (json-encode-diff-value (car v))
                        (concatenate 'string
                                     (reduce #'(lambda (a n)
                                                 (if a
                                                     (concatenate 'string a ", " n)
                                                     n))
                                             (mapcar #'json-encode-diff-value v)))))
                   (t
                    (format nil "~A" v))))

           (find-interesting-parameters (situations)
             "Make a list of all parameters found in the situation trace slots,
              along with their min and max values: '((param-name (min . max)) ...)"
             (let ((sit-hash (make-hash-table :test #'equal))
                   (interesting-parameters nil))
               (dolist (sit situations)
                 (format nil "find-interesting-parameters: doing situation ~A~%" sit)
		 (dolist (params-list (situation-trace sit))
		   (when (eq (car params-list) :params)
                     ;(format t "params-list: ~A~%" params-list)
		     (dolist (p (third params-list))
                       ;(format t "~A~%" p)
		       (let ((param-name (car p))
			     (param-val (cdr p))
			     (vals (gethash (car p) sit-hash)))
			 ;; add the value if it's not already there
			 (setf (gethash param-name sit-hash) (adjoin param-val vals :test #'equal)))))))
               (maphash #'(lambda (k v)
                            ;(format t "  parameter ~A: ~A~%" k v)
                            (push (list k (sort v #'<)) interesting-parameters))
                        sit-hash)
               interesting-parameters))

           (walk-envisionment (out roots state-vars depth)
             (let ((nodes)
                   (edges)
                   (vars (or state-vars (situation-vars)))
                   (conditions (find-conditions))
                   (suggestions (get-violation-suggestions))

                   ;; list of (name (min . max)) values
                   (interesting-parameters (find-interesting-parameters roots)))

               (format t "Suggestions: ~S~%" suggestions)
               (do ((stack roots stack)
                    (all-nodes roots all-nodes))
                   ((null stack) all-nodes)
                 (let* ((sit (pop stack))
                        (next-sits (situation-children sit))
                        (new-sits 
                         (remove-if #'(lambda (s) (member s all-nodes)) next-sits)
                          ))
                   (unless (and depth (> (situation-depth sit) depth))
                     (push sit nodes)
                     (dolist (next-sit (set-difference next-sits new-sits))
                       (push (cons sit next-sit) edges))
                     (dolist (new-sit new-sits)
                       (push (cons sit new-sit) edges)
                       (push new-sit stack)
                       (push new-sit all-nodes)))))
               (format t "conditions: ~A~%" conditions)
               (format out "{~%")
               (format out "  \"model_generator\": \"Open Modelica, version 1.9.1+ with PARC extensions\",~%")
               (format out "  \"model\": \"~A\",~%" (system-name *system-being-analyzed*))
               (format out "  \"envisioner\": { \"major_version\": ~A, \"minor_version\": ~A, \"tag\": ~A, \"revision\": ~A },~%"
                       *envisioner-major-version* *envisioner-minor-version*
                       (or (and *envisioner-version-tag* (format nil "~S" *envisioner-version-tag*)) "null")
                       (or (and *envisioner-vcs-revision* (format nil "~S" *envisioner-vcs-revision*)) "null"))
               (format out "  \"parameters\": {~%")
               ;; now print that list to output
               (reduce #'(lambda (pvalue key-value-pair)
                           (let ((p-name (first key-value-pair))
                                 (values (second key-value-pair)))
                             ;; we only use those where there's some separation between min and max
                             (when (and values (not (equal (first values) (car (last values)))))
                               (if pvalue (format out ",~%"))
                               (format out "    \"~A\": [" p-name)
                               (reduce #'(lambda (nvalue newvalue)
                                           (if nvalue (format out ", "))
                                           (format out "~A" newvalue)
                                           t)
                                       values :initial-value nil)
                               (format out "]")
                               t)))
                       interesting-parameters :initial-value nil)
               (format out "~%    },~%")
               (format out "  \"variables\": {~%")
               (reduce #'(lambda (avalue var)
                           (if avalue (format out ",~%"))
                           (format out "    \"~a\": {\"type\": ~a, \"state\": ~A, \"qspaces\": [~%"
                                   (var-local-name var)
                                   (json:encode-json-to-string
                                    (format nil "~a" (get-var-names (var-type var))))
                                   (if (member var (system-statevars *system-being-analyzed*)) "true" "false"))
                           (reduce #'(lambda (cvalue qspace)
                                       (if cvalue (format out "~%"))
                                       (format out "      [")
                                       (reduce #'(lambda (bvalue bvar)
                                                   (if bvalue (format out ", "))
                                                   (format out "\"~A\"" 
							   (cond ((symbolp bvar)
								  (symbol-name bvar))
								 (t bvar)))
                                                   t)
                                               qspace :initial-value nil)
                                       (format out "]")
                                       t)
                                   (var-qspaces var) :initial-value nil)
                           (format out "]}")
                           t)
                       vars :initial-value nil)
               (dolist (c conditions)
                 (format t "get-var-names(~a) => ~a~%" (car c) (get-var-names (cdr c)))
                 (format out ",~%    \"~a\": { \"type\": ~a, \"qspaces\": [[\"true\", \"false\"]] }"
                         (car c)
                         (json:encode-json-to-string (format nil "~a" (rewrite-condition (get-var-names (cdr c)))))))
               (format out "~%  },~%")
               (format out "  \"situations\": [~%")
               (reduce #'(lambda (avalue sit)
                           (if avalue (format out ",~%"))
                           (format out "    { \"id\": ~a,~%" (situation-id sit))
                           (format out "      \"status\": ~a,~%      \"complete\": ~a,~%"
                                   (let ((status (situation-status sit)))
                                     (cond ((eq status :success)
                                            "\"success\"")
                                           ((eq status :failure)
                                            "\"failure\"")
                                           (t "null")))
                                   (if (situation-complete sit) "true" "false"))
                           (format out "      \"type\": \"~a\",~%      \"children\": ~a,~%"
                                   (situation-type sit)
                                   (if (null (situation-children sit)) "false" "true"))
                           (format out "      \"initial\": ~a"
                                   (if (member sit (system-initial-situations *system-being-analyzed*)) "true" "false"))
                           (let ((suggs (find sit suggestions :key #'car)))
                             (when suggs
                               (format out ",~%      \"suggestions\": {")
                               (let ((sugg (cdr suggs)))
                                 (let ((violation-var (cell-var (datum-cell (first sugg)))))
                                   (format out "~&        ")
                                   (format out "~S: [~%" (var-local-name violation-var))
                                   (format out "~{~&          ~A~^,~}"
                                           (mapcar #'(lambda (change)
                                                       (format nil "{\"variable\": ~S, \"change\": ~S}"
                                                               (var-local-name (first change))
                                                               (if (eq (cdr change) 'Q+) "increase"
                                                                   (if (eq (cdr change) 'Q-) "decrease"))))
                                                   (rest sugg)))
                                   (format out "~&        ]")))
                               (format out "}")))
			   (write-parameters-parents-json out sit)
			   (let ((sit-vars (display-situation-vars sit state-vars conditions)))
                             (if (not (null sit-vars))
                                 (format out ",~%~a" sit-vars)))
                           (format out "    }")
                           t)
                       nodes :initial-value nil)
               (format out "~%  ],~%  \"transitions\": [~%")
               (reduce #'(lambda (avalue edge)
                           (if avalue (format out ",~%"))
                           (let ((sit (car edge))
                                 (next-sit (cdr edge)))
                             (format out "    { \"from\": ~a, \"to\": ~a"
                                     (situation-id sit) (situation-id next-sit))
                             (let ((diffs (append (figure-diffs sit next-sit vars)
                                                  (figure-condition-diffs sit next-sit conditions))))
                               (when diffs
                                 (format out ", \"diffs\": [~%")
                                 (reduce #'(lambda (avalue diff)
                                             (if avalue (format out ",~%"))
                                             (format out "      { \"var\": \"~A\", \"from\": \"~A\", \"to\": \"~A\" }"
                                                     (first diff)
                                                     (json-encode-diff-value (second diff))
                                                     (json-encode-diff-value (third diff)))
                                             t)
                                         diffs :initial-value nil)
                                 (format out "~%      ]")
                                 ))
                             (format out " }"))
                           t)
                       edges :initial-value nil)
               (format out "~%  ]~%}~%")))

           (display-situation-vars (situation state-vars conditions)
             (with-output-to-string (stream)
               (format stream "      \"vars\": [~%")
               (reduce #'(lambda (avalue var)
                           (if avalue (format stream ",~%"))
                           (display-var-value var situation stream)
                           t)
                       (or state-vars (situation-vars))
                       :initial-value nil)
               (dolist (c conditions)
                 (format stream ",~%        { \"name\": \"~a\", \"value\": \"~a\" }"
                         (car c) (json-encode-diff-value
                                  (not (null (evaluate-condition-tv (cdr c) situation))))))
               (format stream "~%        ]~%")))
           
           (display-var-value  (var situation stream)
             (let ((v (get-var-value var situation)))
               ;; (format t "~S: ~A: ~A~%" situation (var-local-name var) v)
               (format stream "        { \"name\": \"~A\", \"value\": \"~A\" }"
                       (var-local-name var) (json-encode-diff-value v))))
           )

    (let ((*print-pretty* nil))
      (if (and (streamp outfilespec) (output-stream-p outfilespec))
          (walk-envisionment outfilespec roots state-vars depth)
          ;; else
          (with-open-file (out outfilespec 
                           :direction :output
                           :if-exists :supersede
                           :if-does-not-exist :create)
            (walk-envisionment out roots state-vars depth))))))


(defun write-parameters-parents-json (out sit)
  (let ((param-sets (remove-if-not #'(lambda (param-set)
				       (and (consp param-set)
					    (eq (car param-set) :params)))
		   (situation-trace sit))))
    (when param-sets
      (format out ",~%      \"parameters\": [~%")
      (dolist (param-set param-sets)
	(write-parameters-parent-json out (second param-set)
				      (third param-set)
				      (fourth param-set)
				      (equalp (car (last param-sets)) param-set)))
      (format out "]"))))

(defun write-parameters-parent-json (out parent-id param-set start-time last?)
  (format out "        [~A,{~%" parent-id)
  (dolist (param param-set)
    (format out "          \"~A\": ~A" (car param) (cdr param))
    (if (equalp param (car (last param-set)))
	(format out "} , ~4f ]" (cdr start-time))
	(format out ",~%")))
  (unless last?
    (format out ",~%")))


(defun generate-json-subgraph (outfilespec situations state-vars)
   (labels ((situation-vars (&key (fixed-parameters? nil) (hide-pins? nil))
	      (let ((var-list))
		(dolist (var (system-variables *system-being-analyzed*))
		  (cond 
		    ((and hide-pins? (pin-var? var)))
		    ((and (parameter-p var) (not fixed-parameters?)))
		    (t (push var var-list))))
		(sort var-list #'string-lessp :key #'var-local-name)))
	   (get-var-names (e &optional (level 0))
	      (cond ((listp e)
		     (mapcar #'(lambda (x) (get-var-names x (+ level 1))) e))
		    ((var-p e)
		     (let ((n (var-local-name e)))
		       (if (and (> (length n) 4)
				(equal "dummy" (subseq n 0 5)))
			   (get-var-names (var-type e) (+ level 1))
			   n)))
		    (t e)))
	    (get-var-value (var situation)
	      (if (mode-var? var)
		  (mode-value var situation)
		  ;; else
		  (let ((rvalue))
		    (dolist (qvalue (qualitative-values var situation))
			    (if (simpleqspace? (q-quantity-qspace qvalue))
				(push (val->simpleq qvalue)
				      rvalue)
				;; else
				(push (cons (q-quantity-value qvalue) (q-quantity-qspace qvalue))
				      rvalue)
				))
		    rvalue)))

		  (find-conditions ()
		    (let ((constraints (system-constraints *system-being-analyzed*))
			  (conditions)
			  (condition-id-counter 1))
		      ;; find all conditions on constraints
		      (dolist (constraint constraints)
			(let ((c (constraint-condition constraint)))
			  (if c
			      (unless (member c conditions :test #'equal)
				(push c conditions)))))
		      (setq conditions
			    (mapcar #'(lambda (c)
					(prog1
					    (cons (format nil "condition~d" condition-id-counter) c)
					  (incf condition-id-counter)))
				    ;; conditional contraints come in pairs -- the condition and its inverse
				    (remove-if #'(lambda (c) (eq (car c) 'not)) conditions)))
               
		      conditions))

		  (rewrite-condition (c)
		    ;; Our conditions are frequently of the form (>= (- v1 v2) 0.0).
		    ;; Rewrite that to "v1 >= v2".
		    (if (and (= (length c) 3)
			     (eq (first c) '>=)
			     (member (third c) '(0.0 0))
			     (listp (second c))
			     (eq (car (second c)) '-)
			     (eq (length (second c)) 3))
			(format nil "~a >= ~a" (second (second c)) (third (second c)))
			c))

		  (figure-diffs (s1 s2 vars)
		    ;; figure out what the state transitions are between s1 and s2
		    ;; in terms of variables and their values
		    (let ((diffs))
		      (dolist (var vars)
			(let ((val1 (get-var-value var s1))
			      (val2 (get-var-value var s2)))
			  (if (not (equal val1 val2))
			      (push (list (var-local-name var) val1 val2) diffs))))
		      diffs))

		  (figure-condition-diffs (s1 s2 conditions)
		    ;; figure out what the state transitions are between s1 and s2
		    ;; in terms of variables and their values
		    (let ((diffs))
		      (dolist (c conditions)
			(let ((cname (car c))
			      (val1 (not (null (evaluate-condition-tv (cdr c) s1))))
			      (val2 (not (null (evaluate-condition-tv (cdr c) s2)))))
			  (if (not (equal val1 val2))
			      (push (list cname val1 val2) diffs))))
		      diffs))

		  (json-encode-diff-value (v)
		    (cond ((eq v t)
			   "true")
			  ((eq v nil)
			   "false")
			  ((listp v)
			   (if (= (length v) 1)
			       (json-encode-diff-value (car v))
			       (concatenate 'string
					    (reduce #'(lambda (a n)
							(if a
							    (concatenate 'string a ", " n)
							    n))
						    (mapcar #'json-encode-diff-value v)))))
			  (t
			   (format nil "~A" v))))
	    (graph-subgraph (out situations state-vars)
		    (let ((nodes)
			  (edges)
			  (vars (or state-vars (situation-vars)))
			  (conditions (find-conditions)))
		      (dolist (sit situations)
			(let ((next-sits 
			       (remove-if-not #'(lambda (s)
						  (member s situations))
					      (situation-children sit))))
			    (push sit nodes)
			    (dolist (next-sit next-sits)
			      (push (cons sit next-sit) edges))))
			      
		      (format t "conditions: ~A~%" conditions)
		      (format out "{~%")
		      (format out "  \"model_generator\": \"Open Modelica, version 1.8.1+ with PARC extensions\",~%")
		      (format out "  \"model\": \"~A\",~%" (system-name *system-being-analyzed*))
		      (format out "  \"envisioner\": { \"major_version\": ~A, \"minor_version\": ~A, \"tag\": ~A, \"revision\": ~A },~%"
			      *envisioner-major-version* *envisioner-minor-version*
			      (or (and *envisioner-version-tag* (format nil "~S" *envisioner-version-tag*)) "null")
			      (or (and *envisioner-vcs-revision* (format nil "~S" *envisioner-vcs-revision*)) "null"))
		      (format out "  \"variables\": {~%")
		      (reduce #'(lambda (avalue var)
				  (if avalue (format out ",~%"))
				  (format out "    \"~a\": ~a"
					  (var-local-name var)
					  (json:encode-json-to-string
					   (format nil "~a" (get-var-names (var-type var)))))
				  t)
			      vars :initial-value nil)
		      (dolist (c conditions)
			(format t "get-var-names(~a) => ~a~%" (car c) (get-var-names (cdr c)))
			(format out ",~%    \"~a\": ~a"
				(car c)
				(json:encode-json-to-string (format nil "~a" (rewrite-condition (get-var-names (cdr c)))))))
		      (format out "~%  },~%")
		      (format out "  \"situations\": [~%")
		      (reduce #'(lambda (avalue sit)
				  (if avalue (format out ",~%"))
				  (format out "    { \"id\": ~a,~%" (situation-id sit))
				  (format out "      \"status\": ~a,~%      \"complete\": ~a,~%"
					  (let ((status (situation-status sit)))
					    (cond ((eq status :success)
						   "\"success\"")
						  ((eq status :failure)
						   "\"failure\"")
						  (t "null")))
					  (if (situation-complete sit) "true" "false"))
				  (format out "      \"type\": \"~a\",~%      \"children\": ~a,~%"
					  (situation-type sit)
					  (if (null (situation-children sit)) "false" "true"))
				  (format out "      \"initial\": ~a"
					  (if (member sit (system-initial-situations *system-being-analyzed*)) "true" "false"))
				  (let ((sit-vars (display-situation-vars sit state-vars conditions)))
				    (if (not (null sit-vars))
					(format out ",~%~a" sit-vars)))
				  (format out "    }")
				  t)
			      nodes :initial-value nil)
		      (format out "~%  ],~%  \"transitions\": [~%")
		      (reduce #'(lambda (avalue edge)
				  (if avalue (format out ",~%"))
				  (let ((sit (car edge))
					(next-sit (cdr edge)))
				    (format out "    { \"from\": ~a, \"to\": ~a"
					    (situation-id sit) (situation-id next-sit))
				    (let ((diffs (append (figure-diffs sit next-sit vars)
							 (figure-condition-diffs sit next-sit conditions))))
				      (when diffs
					(format out ", \"diffs\": [~%")
					(reduce #'(lambda (avalue diff)
						    (if avalue (format out ",~%"))
						    (format out "      { \"var\": \"~A\", \"from\": \"~A\", \"to\": \"~A\" }"
							    (first diff)
							    (json-encode-diff-value (second diff))
							    (json-encode-diff-value (third diff)))
						    t)
						diffs :initial-value nil)
					(format out "~%      ]")
					))
				    (format out " }"))
				  t)
			      edges :initial-value nil)
		      (format out "~%  ]~%}~%")))
		  

		  (display-situation-vars (situation state-vars conditions)
		    (with-output-to-string (stream)
		      (format stream "      \"vars\": [~%")
		      (reduce #'(lambda (avalue var)
				  (if avalue (format stream ",~%"))
				  (display-var-value var situation stream)
				  t)
			      (or state-vars (situation-vars))
			      :initial-value nil)
		      (dolist (c conditions)
			(format stream ",~%        { \"name\": \"~a\", \"value\": \"~a\" }"
				(car c) (json-encode-diff-value
					 (not (null (evaluate-condition-tv (cdr c) situation))))))
		      (format stream "~%        ]~%")))
           
		  (display-var-value  (var situation stream)
		    (let ((v (get-var-value var situation)))
		      ;; (format t "~S: ~A: ~A~%" situation (var-local-name var) v)
		      (format stream "        { \"name\": \"~A\", \"value\": \"~A\" }"
			      (var-local-name var) (json-encode-diff-value v))))
		  )
	   (let ((*print-pretty* nil))
	     (assert (and (streamp outfilespec) (output-stream-p outfilespec)))
	     (graph-subgraph outfilespec situations state-vars))))


(defun generate-csv-json (outfile hash)
  (with-open-file (out outfile
		       :direction :output
		       :if-exists :supersede
		       :if-does-not-exist :create)
    (generate-csv-json-stream out hash)))

;; d3 significant digits algorithm
;;     r: function(x, p) {
;;       return (x = d3.round(x, d3_format_precision(x, p))).toFixed(Math.max(0, Math.min(20, d3_format_precision(x * (1 + 1e-15), p))));
;;     }

(defun generate-csv-json-stream (stream hash)
  (format stream "{")
  (let ((first? t))
    (maphash #'(lambda (var values)
                 (when first?
                   (format stream "  \"time\": [")
                   (reduce #'(lambda (previous-value value)
                               (when (not (equal previous-value (first value)))
                                 (if previous-value (format stream ", "))
                                 (format stream "~,6f" (float (first value))))
                               (first value))
                           values :initial-value nil)
                   (format stream "]")
                   (setq first? nil))
                 (if (not first?) (format stream ",~%"))
                 (format stream " \"~A\": [" (var-local-name var))
                 (reduce #'(lambda (previous-value value)
                             (when (not (equal previous-value (first value)))
                               (if previous-value (format stream ", "))
                               (format stream "~,6f" (float (second value))))
                             (first value))
                         values :initial-value nil)
                 (format stream "]"))
             hash))
  (format stream "~%}~%")
  )
	      
(defun get-variables-as-json-for-parameters (params)
  (let ((hash (params->values params)))
  (with-output-to-string (foo)
    (generate-csv-json-stream foo hash))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: eliminator.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 01, 2011 10:13:46
;;;;   Purpose: TBD, but should contain code to eliminate redundant qualitative variables
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Friday, November 15, 2013 at 09:14:27 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;


;;; Copyright (c) 2011, Palo Alto Research Center Incorporated.
;;; Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA).

;;; Permission is hereby granted, free of charge, to any person obtaining a
;;; copy of this data, including any software or models in source or binary
;;; form, as well as any drawings, specifications, and documentation
;;; (collectively "the Data"), to deal in the Data without restriction,
;;; including without limitation the rights to use, copy, modify, merge,
;;; publish, distribute, sublicense, and/or sell copies of the Data, and
;;; to permit persons to whom the Data is furnished to do so, subject to
;;; the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included
;;; in all copies or substantial portions of the Data.
;;;
;;; THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;; THE AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS
;;; BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
;;; ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
;;; CONNECTION WITH THE DATA OR THE USE OR OTHER DEALINGS IN THE DATA.

;;; This is a very simple simplifier of qualitative constraint networks.  It can be generalized in many ways.
;;;  Or maybe the new solver will eliminatethe need for this?
;;; This can be run on every situation also.  But this version skips all conditional expressions.

(in-package :env2)

;; [02/28/2012 klenk] This code creates equiv-classes and then substitutes the reprepresentative vars
;; [02/28/2012 klenk] into the constraints. Therefore, no vars in constraints should be eliminated
(defun eliminate ()
  (construct-equivalences)
  (compute-representatives)
  (perform-substitutions)
  (check-constraints)
; [04/17/2014] compactor now gets called in caller.
  (compactor)
  )

;;; Get rid of all constants possible.
(defun constant-propagation ()
  (dolist (var (system-active-variables *system-being-analyzed*))
    (cond ((null (var-global-cell var)))
	  ((var-uses var) 
	   (format t "~% Constant ~a not substituted out." var)
	   (error "stub")))))
  

;;; Only use for debugging:
(defun non-eliminated-system-constraints (&optional (system *system-being-analyzed*))
  (remove-if #'constraint-eliminated (system-constraints system)))

(defun check-constraints ()
  (dolist (constraint (non-eliminated-system-constraints *system-being-analyzed*))
    (dolist (var (constraint-variables constraint))

      (restart-case
          (when (var-eliminated var)
            (format t "~% Constraint ~a has an eliminated variable ~a"
                    constraint var))
        (ignore-error () nil)))

    (restart-case
        (progn
          (assert (every #'(lambda (var) (not (var-eliminated var))) (constraint-variables constraint)))
          (case (type-of constraint)
            (general-summer-constraint 
             
             (assert (every #'(lambda (var) (not (var-eliminated var))) (general-summer-constraint-pos-vars constraint)))
             (assert (every #'(lambda (var) (not (var-eliminated var))) (general-summer-constraint-neg-vars constraint))))
            (multiply-constraint 
             (assert (every #'(lambda (var) (not (var-eliminated var))) (multiply-constraint-multiplicands constraint)))
             (assert (not (var-eliminated (multiply-constraint-result constraint)))))
            (qequal-constraint 
             (assert (and (not (var-eliminated (qequal-constraint-var1 constraint)))
                          (not (var-eliminated (qequal-constraint-var2 constraint))))))
            (qset-constraint
             (assert (not (var-eliminated (qset-constraint-var constraint)))))
            (deriv-constraint
             (assert (and (not (var-eliminated (deriv-constraint-var constraint)))
                          (not (var-eliminated (deriv-constraint-deriv constraint))))))
            (power-constraint
             (assert (and (not (var-eliminated (power-constraint-base constraint)))
                          (not (var-eliminated (power-constraint-result constraint))))))
            (interpolation
             (assert (not (some #'var-eliminated (interpolation-variables constraint)))))
            (gt-constraint
             (assert (not (some #'var-eliminated (list (gt-constraint-rhs constraint)
                                                       (gt-constraint-lhs constraint))))))
            (t 
             (error "Unknown type ~a" (type-of constraint)))))
      (ignore-error () nil))
    ))

(defun construct-equivalences ()
  (dolist (constraint (non-eliminated-system-constraints *system-being-analyzed*))
    (unless (or (constraint-eliminated constraint) (constraint-condition constraint))
      (case (type-of constraint)
	(general-summer-constraint (find-equivalent-general-summer constraint))
;; [08/21/2012 klenk] This is not allowed for quantitative/symbolic analysis
;; [02/27/2012 klenk] If one is constant, then yes
	(multiply-constraint (find-equivalent-multiply constraint))
	(qequal-constraint  (qequal-constraint-equiv constraint))
	(interpolation)
	(qset-constraint)
	(deriv-constraint)
	(power-constraint) 
	(gt-constraint)
	(t (error "Unknown constraint type: ~a" constraint))))))

;;; This turns general-summers of two args into equivalents.
(defun find-equivalent-general-summer (constraint)
  (let ((positives (general-summer-constraint-pos-vars constraint))
	(negatives (general-summer-constraint-neg-vars constraint)))
      (cond ((and (null negatives)
		  (= (length positives) 2))
	     (when (add-equivalent (car positives) (cadr positives) '- constraint 'find-equivalent-general-summer)
	       (unrecord-constraint constraint)
	       (setf (constraint-eliminated constraint) 'find-equivalent-general-summer)))
	    ((and (null positives)
		  (= (length negatives) 2))
	     (when (add-equivalent (car negatives) (cadr negatives) '- constraint 'find-equivalent-general-summer)
	       (unrecord-constraint constraint)
	       (setf (constraint-eliminated constraint) 'find-equivalent-general-summer)))
	    ((and (null (cdr negatives)) (null (cdr positives)))
	     (when (add-equivalent (car negatives) (car positives) '+ constraint 'find-equivalent-general-summer)
	       (unrecord-constraint constraint)
	       (setf (constraint-eliminated constraint) 'find-equivalent-general-summer))))))

;; [02/27/2012 klenk] V=IR , if R is a fixed parameter, then this is basically a qequal constraint
;; [09/12/2012 klenk] This code assumes that the fixed parameter is a positive value. This does not work for brake_test_2.
;; [09/12/2012 klenk] In order for this to work, we would need to know the value of the fixed parameter.
;; [09/12/2012 klenk] Perhaps we add a slot to var in the future, but for now, I'm commenting this part out of the eliminator
;; [11/ 1/2013 klenk] Now parameters are stored on the system object, so we have access to them
;; [04/06/2014 Johan] This doesn't do anything anymore so I commented it out
;;  completely.
(defun find-equivalent-multiply (constraint)
;  (let* ((args (multiply-constraint-multiplicands constraint))
;	 (result (multiply-constraint-result constraint))
;	 (params (remove-if-not #'parameter-p args))
;	 (param-val  (cdr (assoc (car params) 
;				 (system-parameters *system-being-analyzed*))))
;	 (c-polarity (multiply-constraint-polarity constraint)))

;; This destroys symbolic reasoning also.  So long as param-val is > 0 this adds an 
;; equivalent.  What we need is like v1 distinguish between different types of
;; equivalents.  But not today.
    ;; (when (and (= (length args) 2)
    ;; 	       (= (length params) 1)
    ;; 	       (numberp param-val))
    ;;   (when (add-equivalent (car (remove-if #'parameter-p args)) result  
    ;; 			    (if (>= param-val 0)
    ;; 				c-polarity
    ;; 				(invert-polarity c-polarity))
    ;; 			    constraint
    ;; 			    'find-equivalent-multiply
    ;; 			    )
;; This destroys symbolic reasoning:
;;	(dolist (param (remove-if-not #'parameter-p args))
;;   	  (setf (var-uses param) (remove constraint (var-uses param)))
;;   	  (unless (var-uses param) (setf (var-eliminated param) :equivalent-multiply)))
;;   	(setf (constraint-eliminated constraint) 'find-equivalent-multiply)
;	)
      )

(defun qequal-constraint-equiv (constraint)
;; [02/27/2012 klenk] Not sure why we have to do this
;; [02/28/2012 klenk] We take care of this later
  ;; The constraint is gone as its completely subsumed by equivalences.
;    (setf (var-uses (qequal-constraint-var1 constraint)) (remove constraint (var-uses (qequal-constraint-var1 constraint)))
;	  (var-uses (qequal-constraint-var2 constraint)) (remove constraint (var-uses (qequal-constraint-var2 constraint))))
  (let ((var1 (qequal-constraint-var1 constraint))
	(var2 (qequal-constraint-var2 constraint)))

    (cond ((eq var1 var2)
	   (unrecord-constraint constraint)
	   (setf (constraint-eliminated constraint) 'qequal-constraint-equiv))
	  ;; If both are known to be global.  Presumably equal.
	  ((and (var-global-cell var1) (var-global-cell var2))
	   (unrecord-constraint constraint)
	   (setf (constraint-eliminated constraint) 'qequal-constraint-equiv))
	  ((add-equivalent var1 
			   var2
			   (qequal-constraint-polarity constraint)
			   constraint
			   'qequal-constraint-equiv)
	   (unrecord-constraint constraint)
	   (setf (constraint-eliminated constraint) 'qequal-constraint-equiv))
	  (t nil))))

(defun invert-polarity (polarity)
  (cond ((eq polarity '+) '-)
	((eq polarity '-) '+)
	(t (error "Impossible polarity"))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Adding and merging equivalent classes

(defun add-equivalent (var1 var2 polarity constraint reason)
;; [02/27/2012 klenk] Don't add equivalent classes for non-simple variables yet
  (when (and (simpleq-var? var1)
	     (simpleq-var? var2))
    (assert (not (eq var1 var2)))
    (let ((class1 (var-equivalent-class var1))
	  (class2 (var-equivalent-class var2)))
      
      (debug-print nil "~% Merging ~a and ~a ~a" var1 polarity var2)
      (cond (class1
	   (cond ((eq class1 class2)
					;		  (check-for-consistency var1 var2 class1 polarity)
		  (push constraint (equivalent-class-constraints class1)))
		 (class2
		  ;; Merging class2 into class1.
		  ;; Need to decide whether a flip is called for.
		  (push constraint (equivalent-class-constraints class1))
		  (if (eq polarity '+)
		      (if (member var1 (equivalent-class-positives class1))
			  (if (member var2 (equivalent-class-positives class2))
			      (merge-classes class1 class2)
			    (merge-classes-flip class1 class2))
			(if (member var2 (equivalent-class-negatives class2))
			    (merge-classes class1 class2)
			  (merge-classes-flip class1 class2)))
		    ;; polarity is -
		    (if (member var1 (equivalent-class-positives class1))
			(if (member var2 (equivalent-class-positives class2))
			    (merge-classes-flip class1 class2)
			  (merge-classes class1 class2))
		      (if (member var2 (equivalent-class-negatives class2))
			  (merge-classes-flip class1 class2)
			(merge-classes class1 class2))))
		  ;;*** this should auto happen ow.delete.::
		  (push `(:merge ,class1 ,class2 ,var1 ,var2 ,reason) (equivalent-class-history class1))
		  (setf (var-equivalent-class var2) class1))
		 ((eq polarity '-)
		  (cond ((member var1 (equivalent-class-positives class1))
			 (push var2 (equivalent-class-negatives class1))
			 (push constraint (equivalent-class-constraints class1))
			 (setf (var-equivalent-class var2) class1))
			((member var1 (equivalent-class-negatives class1))
			 (push var2 (equivalent-class-positives class1))
			 (push constraint (equivalent-class-constraints class1))
			 (setf (var-equivalent-class var2) class1))
			(t (error "should never happen"))))

		 ((eq polarity '+)
		  (cond ((member var1 (equivalent-class-positives class1))
			 (push var2 (equivalent-class-positives class1))
			 (push constraint (equivalent-class-constraints class1))
			 (setf (var-equivalent-class var2) class1))
			((member var1 (equivalent-class-negatives class1))
			 (push var2 (equivalent-class-negatives class1))
			 (push constraint (equivalent-class-constraints class1))
			 (setf (var-equivalent-class var2) class1))
			(t (error "should never happen"))))
		 (t (error "Unrecognized polarity.")) ))
	  ;; var1 has no class, var2 does.
	  (class2 (cond
		    ((eq polarity '-)
		     (cond ((member var2 (equivalent-class-positives class2))
			    (push var1 (equivalent-class-negatives class2))
			    (push constraint (equivalent-class-constraints class2))
			    (setf (var-equivalent-class var1) class2))
			   ((member var2 (equivalent-class-negatives class2))
			    (push var1 (equivalent-class-positives class2))
			    (push constraint (equivalent-class-constraints class2))
			    (setf (var-equivalent-class var1) class2))
			   (t (error "should never happen"))))
		    ((eq polarity '+)
		     (cond ((member var2 (equivalent-class-positives class2))
			    (push var1 (equivalent-class-positives class2))
			    (push constraint (equivalent-class-constraints class2))
			    (setf (var-equivalent-class var1) class2))
			   ((member var2 (equivalent-class-negatives class2))
			    (push var1 (equivalent-class-negatives class2))
			    (push constraint (equivalent-class-constraints class2))
			    (setf (var-equivalent-class var1) class2))
			   (t (error "should never happen"))))
		    (t (error "Unrecognized polarity.")))) 
	  ((eq polarity '+)
	   (let ((class (make-equivalent-class :positives (list var1 var2) :constraints (list constraint) :id (new-id) :history (list reason))))
	     (push class (system-var-equivalent-classes *system-being-analyzed*))
	     (setf (var-equivalent-class var1) class)
	     (setf (var-equivalent-class var2) class)))
	  ((eq polarity '-)
	   (let ((class (make-equivalent-class :positives (list var1)
					       :negatives (list var2)
					       :constraints (list constraint)
					       :id (new-id)
					       :history (list reason)
					       )))
;	     (if (= (equivalent-class-id class) 22) (error "look"))

	     (push class (system-var-equivalent-classes *system-being-analyzed*))
	     (setf (var-equivalent-class var1) class)
	     (setf (var-equivalent-class var2) class)))
	  (t (error "Unrecognized polarity"))))))

(defun merge-classes (class1 class2)
  ;; These could be nconc's, but appends are safer.
  (setf (equivalent-class-constraints class1)
	(append (equivalent-class-constraints class1) (equivalent-class-constraints class2)))
					;  (check-for-duplicates (equivalent-class-positives class1) 'test1)
  ;; took 4 hours to find this bug. - sy
					;(setf (equivalent-class-negatives class1)
  ;(append (equivalent-class-negatives class1) (equivalent-class-negatives class2)))
  (setf (equivalent-class-merged class2) (list :merge class1 class2))
  ;; Make sure all point to the new equivalent class.
  (dolist (old-positive (equivalent-class-positives class2))
    (push old-positive (equivalent-class-positives class1))
    (setf (var-equivalent-class old-positive) class1))
  (dolist (old-negative (equivalent-class-negatives class2))
    (push old-negative (equivalent-class-negatives class1))
    (setf (var-equivalent-class old-negative) class1)))

;; what's the difference? - sy
(defun merge-classes-flip (class1 class2)
  (setf (equivalent-class-merged class2) (list :merge class1 class2))
  (setf (equivalent-class-constraints class1)
    (append (equivalent-class-constraints class1) (equivalent-class-constraints class2)))
  (dolist (old-negative (equivalent-class-negatives class2))
    (push old-negative (equivalent-class-positives class1))
    (setf (var-equivalent-class old-negative) class1))
  (dolist (old-positive (equivalent-class-positives class2))
    (push old-positive (equivalent-class-negatives class1))
    (setf (var-equivalent-class old-positive) class1))
  ;(check-for-duplicates (equivalent-class-positives class1) 'test9)
  )

;; [06/06/2012 klenk] This ensures that the representive is from the positive of the class
;; [09/11/2013 klenk] The representative must be the car of the positives
(defun compute-representatives ()
  (dolist (class (system-var-equivalent-classes *system-being-analyzed*))
;    (format t "~% Representive for ~a is ~a" class (equivalent-class-representative class)) 
    (cond ((equivalent-class-representative class)
	   (assert (member (equivalent-class-representative class)(equivalent-class-positives class))))
	  (t
	   ;; Try to choose a non-dummy, symbolic-state-var to eliminate.
	   ;; Try to choose a non-global also.
	   (let ((positives (equivalent-class-positives class))
		 (negatives (equivalent-class-negatives class))
		 (ncount 0)
		 (pcount 0)
		 (nstate-var)
		 (pstate-var))
	     (dolist (p positives) 
	       (cond ((var-global-cell p) (make-all-global positives negatives p) (go NEXT))
		     ((var-symbolic-state-var? p) (incf pcount) (unless pstate-var (setq pstate-var p)))))
	     (dolist (n negatives) 
	       (cond ((var-global-cell n) (make-all-global negatives positives n)  (go NEXT))
		     ((var-symbolic-state-var? n) (incf ncount) (unless nstate-var (setq nstate-var n)))))
;	     (format t "~% statevars: ~d ~d" ncount pcount)
	     (cond ((> (+ ncount pcount) 1)
		    (format t "~%Stub: A state variable is being eliminated.")		    
		    ;; Stub: Needs to be fixed later
		    (error "bad")
		    (setf (equivalent-class-representative class) (car (equivalent-class-positives class))))
		   ;; Pick the global as the representative.
		   ((= pcount 1) (setf (equivalent-class-representative class) pstate-var))
		   ((= ncount 1) 
		    (setf (equivalent-class-representative class) nstate-var)
		    ;; Swap negatives and positives.
		    (psetf (equivalent-class-positives class) 
			   (cons nstate-var (remove nstate-var 
						    (equivalent-class-negatives class)))
			   (equivalent-class-negatives class) (equivalent-class-positives class)))
		   ;; No state vars involved so this is the easy case, make sure a positive is selected as the representative.
		   ;; But do not select a dummy.
		   (t (let ((pvar (dolist (var (equivalent-class-positives class)) 
				    (unless (var-dummy? var) 
				      (return var)))))
			;; Just make that one the representative.
			(cond (pvar (setf (equivalent-class-representative class) (car (equivalent-class-positives class))))
			      (t (let ((nvar (dolist (var (equivalent-class-negatives class)) (unless (var-dummy? var) (return var)))))
				   (cond (nvar 
					  (setf (equivalent-class-representative class) nvar)
					  (psetf (equivalent-class-positives class) (equivalent-class-negatives class)
						 (equivalent-class-negatives class) (equivalent-class-positives class)))
					 ;; Only dummies, so give up.
					 ((equivalent-class-positives class) 
					  (setf (equivalent-class-representative class) (car (equivalent-class-positives class))))
					 (t (setf (equivalent-class-positives class) (equivalent-class-negatives class))
					    (setf (equivalent-class-negatives class) nil
						  (equivalent-class-representative class) (car (equivalent-class-positives class))))))
				 ))))))))
    (determine-fixed? class)
    (determine-state-var? class)
    NEXT))

;;; *remove global above

;;; [05/28/2014 Johan]
;;; Don't even bother eliminating if there is a global.  Just set them all.
(defun make-all-global (positives negatives global)
  (let* ((pvalue (qualitative-value global 'global))
	 (nvalue (invert-q-quantity pvalue))) 
    (dolist (p positives) (unless (or (eq p global) (var-global-cell p)) (clobber-global p pvalue)))
    (dolist (n negatives) (unless (var-global-cell n) (clobber-global n nvalue)))))

;; [03/16/2012 klenk] if any of the class vars are fixed, then all should be fixed

(defun determine-fixed? (class)
  (when (or (some #'var-fixed? (equivalent-class-positives class))
	    (some #'var-fixed? (equivalent-class-negatives class)))
    (dolist (var (equivalent-class-positives class))
      (unless (var-fixed? var)
	(make-var-fixed var (list 'determine-fixed? class))))
    (dolist (var (equivalent-class-negatives class))
      (unless (var-fixed? var)
	(make-var-fixed var (list 'determine-fixed? class))))))

;;; [05/07/2014 Johan] Could combine these two slots.
(defun make-var-fixed (var reason)
  (setf (var-why-fixed var) reason)
  (setf (var-fixed? var) t))

;; [09/17/2012 klenk] If any of the vars are state vars then this is a state var
;; Johan - This is going to cause problems with the symbolic solver because
;; this seems to create more statevars for it.
(defun determine-state-var? (class)
  (when (or (some #'var-state-var? (equivalent-class-positives class))
	    (some #'var-state-var? (equivalent-class-negatives class)))
    (setf (var-state-var? (equivalent-class-representative class)) t)))

    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun perform-substitutions ()
  (dolist (class (system-var-equivalent-classes *system-being-analyzed*))
    ;; Only subtitute active equivalent classes.
    (unless (equivalent-class-merged class)
      (let ((rep (equivalent-class-representative class)))
	(when rep
	  (dolist (elim (equivalent-class-positives class))
	    (restart-case
		(unless (eq rep elim)
		  (substitute-var rep elim '+))
	      (ignore-error () nil)))
	  (dolist (elim (equivalent-class-negatives class))
	    (restart-case
		(substitute-var rep elim '-)
	      (ignore-error () nil)))
        )))))

(defun substitute-var (var elim polarity)
  (debug-print nil "~% Replace ~a by ~a polarity ~a"
	       elim var polarity)
  (if (var-global-cell elim) (error "Cannot yet eliminate a global"))
  (if (var-eliminated var) (error "Replacement is eliminated too"))
  (setf (var-eliminated elim) (cons var polarity))
  (setf (system-active-variables *system-being-analyzed*)
    (delete elim (system-active-variables *system-being-analyzed*) :test #'eq :count 1))
  (if (eq var elim) (error "eliminating yourself"))
  (if (var-symbolic-state-var? elim) (error "eliminating a symbolic state var"))
  (dolist (constraint (var-uses elim))
    (unless (constraint-eliminated constraint)
      (debug-print nil "~%    ~a" constraint)
      (case (type-of constraint)
	(general-summer-constraint (eliminate-from-var-summer var elim constraint polarity))
	(multiply-constraint (eliminate-from-var-multiply var elim constraint polarity))
	(qequal-constraint (eliminate-from-qequal-constraint var elim constraint polarity))
	(qset-constraint (eliminate-from-qset-constraint var elim constraint polarity))
	(deriv-constraint (eliminate-from-deriv-constraint var elim constraint polarity))
	(power-constraint (eliminate-from-power-constraint var elim constraint polarity))
	(gt-constraint (eliminate-from-gt-constraint var elim constraint polarity))
	(t (error "Unknown type ~a" (type-of constraint))))))
  nil)

;;; Eliminate a var.
(defun eliminate-from-qequal-constraint (var elim constraint polarity)
  (push (list 'eliminate var elim) (constraint-source constraint))
  (cond ((eq elim (qequal-constraint-var1 constraint))
	 (setf (qequal-constraint-var1 constraint) var)
	 (add-constraint constraint var))
	((eq elim (qequal-constraint-var2 constraint))
	 (setf (qequal-constraint-var2 constraint) var)
	 (add-constraint constraint var))
	(t (error "Badly formed equal-constraint: elim ~A, constraint ~A" elim constraint)))
  (if (eq polarity '-)
      (setf (qequal-constraint-polarity constraint)
	(if (eq (qequal-constraint-polarity constraint) '-) '+ '-)))
  (setf (qequal-constraint-variables constraint) (list (qequal-constraint-var1 constraint) (qequal-constraint-var2 constraint)))
  ;; The qequal-constraint won't add any inferences if its vars are the same.
  (when (eq (qequal-constraint-var1 constraint) (qequal-constraint-var2 constraint))
;; (error "stub-flush this"))
    (unrecord-constraint constraint)
    (setf (qequal-constraint-eliminated constraint) 'eliminate-form-qequal-cosntraint)
    )
  )


;;; [03 05 2011] Johan added.
(defun eliminate-from-qset-constraint (var elim constraint polarity)
  (assert (eq elim (qset-constraint-var constraint)))
  (setf (qset-constraint-var constraint) var)
  (if (eq polarity '-) 
      (setf (qset-constraint-constant constraint) 
	    (q-invert (qset-constraint-constant constraint))))
  (setf (qset-constraint-variables constraint) (list var))
  (add-constraint constraint var))


;;; For now this does no side effects.  Later that can be optimized to do side effects.
;;; Above comment is only partially correct.
(defun eliminate-from-var-summer (var elim constraint polarity)
  (debug-print nil "~% Eliminating ~a from ~a" elim constraint)
  ;; For debugging trace what happened to the summer.
  (push `(eliminate-from-var-summer ,var ,elim ,constraint ,polarity)
	(general-summer-constraint-history constraint))


  (let ((positives (general-summer-constraint-pos-vars constraint))
	(negatives (general-summer-constraint-neg-vars constraint)))

    ;;; [05/30/2014 Johan] 
    ;; First handle cases of x+ ... = x+ ...
    ;;; These cases are extremely rare.   And all the cases are obscure.  Can only really debug with an example.
    ;; This may well get integrated in to the not yet constructed simplifier.
    (cond ((member var positives) 
	   (cond ((member elim positives)
		  (case polarity
		    (- (cond ((general-summer-constraint-qr-only constraint) (remove-constraint constraint) (return-from eliminate-from-var-summer nil))
			     (t (setq positives (remove var positives))
				(setq positives (remove elim positives))
				(setf (var-uses elim) (remove constraint (var-uses elim)))				
				(setf (var-uses var) (remove constraint (var-uses var))))))
		    ;;; x+x case.
		    (+ (error "x+x case"))))
		 (t (error "sub99"))))
	  ((member var negatives) (error "stiub"))

;	  ((and (eq polarity +) (member var negatives :test #'equal))
;	   (error "stub1"))
;	  ((and (eq polarity -) (member var positives :test #'equal))
;	   (error "stub2"))

	  ((member elim positives :test #'equal) 
	   (push constraint (var-uses var))	   
	   (setq positives (remove elim positives :test #'equal))
	   (case polarity (+ (push var positives)) (- (push var negatives)) (t (error "Unknown polarity"))))
	  ((member elim negatives :test #'equal)
	   (push constraint (var-uses var))
	   (setq negatives (remove elim negatives :test #'equal))
	   (case polarity (+ (push var negatives)) (- (push var positives)) (t (error "Unknown polarity"))))
	  (t (error "Variable to be eliminated ~a is not a variable of summer ~a"
		    elim constraint)))
    (if *use-global*
	(when (= 1 (+ (length positives) (length negatives)))
	  (multiple-value-bind (val deriv)
	      (simple-qvalue (car (or positives negatives)) 'global)
	    (unless (and (eq val 'Q0) (eq deriv 'Std))
	      (error "Inconsistent model, or missing clobber"))
	    (remove-constraint constraint)
	    (return-from eliminate-from-var-summer nil))
	  ))
    (setf (general-summer-constraint-pos-vars constraint) positives
	  (general-summer-constraint-neg-vars constraint) negatives
          (general-summer-constraint-variables constraint) (append positives negatives))))

;;; **** This is incomplete.  For example a=a*c
(defun eliminate-from-var-multiply (var elim constraint polarity)
  (unless (member constraint (var-uses var))
     (add-constraint constraint var))
  (if (eq polarity '-)
      (setf (multiply-constraint-polarity constraint) 
	    (invert-polarity (multiply-constraint-polarity constraint))))
  (let ((slot))
    (if (eq elim (multiply-constraint-result constraint))
	(setf (multiply-constraint-result constraint) var))
    (if (setq slot (member elim (multiply-constraint-multiplicands constraint)))
	(rplaca slot var)))
  ;; Soon uneccessary:
  (setf (multiply-constraint-variables constraint)
	(cons (multiply-constraint-result constraint)
	      (multiply-constraint-multiplicands constraint))))

;; [02/28/2012 klenk] elim is either the var or the deriv
;; [4/17/2014 Johan] soon to be dead code.
(defun eliminate-from-deriv-constraint (var elim constraint polarity)
  (unless (member constraint (var-uses var))
     (add-constraint constraint var))
  (if (eq polarity '-)
      (setf (deriv-constraint-polarity constraint) 
	    (invert-polarity (deriv-constraint-polarity constraint))))
  (cond ((eql elim (deriv-constraint-var constraint))
	 (setf (deriv-constraint-var constraint) var)
	 )
	((eql elim (deriv-constraint-deriv constraint))
	 (setf (deriv-constraint-deriv constraint) var)
	 )
	(t (error "unknown variable to eliminate")))
  (setf (deriv-constraint-variables constraint)
    (list (deriv-constraint-var constraint) (deriv-constraint-deriv constraint)))
  (when (find-equivalent-deriv-constraint constraint)
    (setf (constraint-eliminated constraint) 'eliminate-from-deriv-constraint)
    (remove-constraint constraint)))


;;; [04/17/2014 Johan] checks if existing deriv constraint. Soon to be dead code as it will be replaced by qequals or equals?
;;; or general-equals.
(defun find-equivalent-deriv-constraint (constraint)
  (dolist (old (var-uses (deriv-constraint-var constraint)))
    (when (and (not (eq old constraint))
	       (deriv-constraint-p old)
	       (null (constraint-condition old))
	       (eq (deriv-constraint-deriv old) (deriv-constraint-deriv constraint)))
      (unless (eq (deriv-constraint-polarity constraint) (deriv-constraint-polarity old))
	(error "x=dy/dt, and x=-dy/dt?"))
      (return t))))

;; [04/12/2012 klenk] 
(defun eliminate-from-power-constraint (var elim constraint polarity)
  (push (list 'eliminate var elim) (constraint-source constraint))
  (cond ((eq elim (power-constraint-base constraint))
	 (setf (power-constraint-base constraint) var)
	 (if (eq polarity '-)
	     (setf (power-constraint-base-polarity constraint)
		   (invert-polarity (power-constraint-base-polarity constraint)))))
	((eq elim (power-constraint-result constraint))
	 (setf (power-constraint-result constraint) var)
	 (if (eq polarity '-)
	     (setf (power-constraint-base-polarity constraint)
		   (invert-polarity (power-constraint-base-polarity constraint)))))
	(t (error "Badly formed equal-constraint")))
  (add-constraint constraint var)
  (setf (power-constraint-variables constraint) (list (power-constraint-base constraint) (power-constraint-result constraint)))
    )

(defun eliminate-from-gt-constraint (var elim constraint polarity)
  (when (eq polarity '-)
    (setf (gt-constraint-invert? constraint)
	  (not (gt-constraint-invert? constraint)))) 
  (cond ((eql elim (gt-constraint-lhs constraint))
	 (setf (gt-constraint-lhs constraint) var))
	((eql elim (gt-constraint-rhs constraint))
	 (setf (gt-constraint-rhs constraint) var))
	(t (error "Shouldn't happen")))
  (setf (gt-constraint-variables constraint) 
	(sublis (list (cons elim var)) (gt-constraint-variables constraint)))
  (add-constraint constraint var))


(defun add-constraint (constraint var)
  (assert (not (member constraint (var-uses var))))
  (push constraint (var-uses var)))


;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: equations.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: November 30, 2011 18:58:28
;;;;   Purpose: code to parse equations and generate constraints therefrom
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, February 06, 2013 at 15:08:09 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;;; Much of the code in this file is sick or dead.


;;; Constructs constraints the propagator can use.  The input can be a single equation
;;; or a set of equations in usual Lisp prefix form.
(defun create-equations (parent equations condition &optional ics)
  (cond ((null equations))
	(t (mapcar #'(lambda (equation)
		      (parse-equation equation parent condition ics))
		   equations))))

;; [09/ 5/2011 klenk] Currently only parse-q-equation is possible
(defun parse-equation (equation parent condition &optional ics)
  (let ((constraint (parse-q-equation equation parent condition ics)))
    (dolist (var (vars-in-condition condition) constraint)
      (pushnew constraint (var-uses var)))))

(defun vars-in-condition (condition)
  (remove-if-not #'var-p (flatten condition)))
	    
;; [04/09/2012 klenk] q= equations don't appear to work with v2 intervals
;;; This does not return a value, rather it constructs the needed constraints.
;; [12/17/2013 klenk] ics is only used for the modelica table functions
(defun parse-q-equation (equation parent condition &optional ics)
  (format nil "~% parse-q-equation: ~a, condition: ~a" equation condition)
  (unless (or (atom condition)(atom (car condition))) (break))

  ;; equation is a lisp form, parent is a model struct, condition is lisp form of a mode assignment
  (multiple-value-bind (equation-object bindings)
      (parse-equation-1 equation parent nil ics)
    (declare (ignore bindings))
    (cond ((atom equation-object)
	   (if condition (error "Stub"))
	   equation-object)
	  ((set-mode-equation? equation-object)
	   (construct-set-mode-constraint parent (second equation-object) (third equation-object) condition)) 
          ;; q= x y  (deprecated form)
          ((and (listp equation-object)
                (eq (car equation-object) 'q=)
                (atom (second equation-object))
                (atom (third equation-object)))
           (construct-pair parent (second equation-object) (third equation-object) condition nil))
          ;; q= x (- y).  (deprecated form)
          ((and (listp equation-object)
                (eq (car equation-object) 'q=)
                (atom (second equation-object))
                (listp (third equation-object))
                (eq (car (caddr equation-object)) '-)
                (null (cddr (caddr equation-object)))
                (atom (cadr (caddr equation-object))))
           (construct-pair parent (second equation-object) (cadr (third equation-object)) condition t))
          ;; q= (-x) (- y)  (deprecated form)
          ((and (listp equation-object)
                (eq (car equation-object) 'q=)
                (listp (second equation-object))
                (eq (car (cadr equation-object)) '-)
                (null (cddr (cadr equation-object)))
                (atom (cadr (cadr equation-object)))
                (listp (third equation-object))
                (eq (car (caddr equation-object)) '-)
                (null (cddr (caddr equation-object)))
                (atom (cadr (caddr equation-object))))
           (construct-pair parent (cadr (second equation-object)) 
                           (cadr (third equation-object)) condition nil))
          ;; (q= (-x) y)  (deprecated form)
          ((and (listp equation-object)
                (eq (car equation-object) 'q=)
                (listp (second equation-object))
                (eq (car (second equation-object)) '-)
                (atom (third equation-object)))
           (construct-pair parent (second (second equation-object)) 
                           (third equation-object) condition t))

;;;if not of the above then it is a variable size constraint
          ;; deprecated q= form
          ((and (listp equation-object)
                (eq (car equation-object) 'q=))
           (construct-qarithmatic-constraint 
            parent (second equation-object) (third equation-object) condition))

          ;; primary branch -- process an "equals" constraint equation
          ((eq '= (car equation-object))
	   ;; [04/18/2014 Johan] sometimes we have an (= x x).
	   ;; These should probably be caught earlier, but there is no need to do more here.
	   (unless (equal (second equation-object) (third equation-object))
	     (process-= parent equation-object condition ics))
           )

          ;; process a connection
          ((eq 'connect (car equation-object))
           (construct-connect-constraints parent
                                          (second equation-object)
                                          (third equation-object)
                                          condition
                                          ))
;; [12/ 6/2012 klenk] This is where the Modelica When Operator should be evaluated
	  ((eq 'mod-when (car equation-object))
           (construct-mod-when-constraint parent
					  (second equation-object)
					  (third equation-object)
					  condition
					  ))
;; [11/ 7/2013 klenk] logic constraints
	  ((eq '> (car equation-object))
           (construct-gt-constraint parent
				    (second equation-object)
				    (third equation-object)
				    condition
				    ))
          (t (error "unknown equation ~A, with condition ~A, on ~A" equation-object condition parent)))))

(defun set-mode-equation? (equation)
  (and 
   (listp equation)
   (eql (car equation) '==)
   (typep (second equation) 'var)
   (eql (var-type (second equation)) :mode)))

;; [11/30/2011 klenk] replace variables in equations with objects
;; [11/30/2011 klenk] remaining symbols are either operators, mode names, or interval/landmarks
;; [12/ 6/2011 klenk] Bindings don't really appear to be used, but I am nervous about axing it right now.
;; [12/ 6/2011 klenk] Many of these cases are the same
(defun parse-equation-1 (equation parent bindings &optional ics)
  (cond ((atom equation) 
	 (parse-equation-1-atom equation parent bindings))
	((interval? equation) equation)
	(t
	 (case (car equation)
	   ((= < > >= <=) ;;************** is this necessary
	    (list (car equation)
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   ((== qIn q=) 
	    (list (car equation)
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
;; [11/30/2011 klenk] May need to create another variable if the variable does not have a 
;; [11/30/2011 klenk] derivative yet
	   (deriv 
	    (let ((var (parse-equation-1 (second equation) parent bindings ics)))
	      (cond ((var-deriv var))
		    (t (create-deriv-for-var var parent)))))
	   (>> 
	    (if parent 
		(lookup-1 (reverse (cdr equation)) parent)
		(lookup (cdr equation))))
	   (mode (lookup-1 (reverse equation) parent))
	   (- (if (cddr equation) 
		  (list (car equation)
			(parse-equation-1 (second equation) parent bindings ics)
			(parse-equation-1 (third equation) parent bindings ics))
		  (let ((var (parse-equation-1 (second equation) parent bindings ics)))
		    (cond ((null var) (error "No such variable: ~a" (second equation)))
			  ((listp var) (error "stuibaesrf"))
			  (t 
			   (values (list '- var) (cons var bindings)))))))
	   ((+ * /) (cons (car equation)
			 (mapcar #'(lambda (var)
				     (parse-equation-1 var parent bindings ics))
				 (rest equation))))
	   (not 
	    (list 'not (parse-equation-1 (second equation) parent bindings ics)))
	   (pre (list 'pre (parse-equation-1 (second equation) parent bindings ics)))
	   (connect 
	    (list 'connect 
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   (power
	    (assert (integerp (third equation)) () "Unexpected 'power' operator, third element of equation is not an integer; equation is ~A" equation)
	    (list 'power 
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   (mod-when
	    (list 'mod-when
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   (and 
	    (assert (= (length equation) 3)) 
	    (list 'and
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   (if
	    (assert (= (length equation) 4))
	    (if (and (var-p (second equation))
		     (var-fixed? (second equation)))
		(let ((ic (find (second equation) ics :key #'car)))
		  (if (eql (intern "true" :keyword) (third ic))
		      (third equation)
		      (fourth equation)))
		(error 'if-expression :value equation :var parent)))
	   (reinit
	    (assert (= (length equation) 3)) 
	    (list 'reinit
		  (parse-equation-1 (second equation) parent bindings ics)
		  (parse-equation-1 (third equation) parent bindings ics)))
	   (t 
;; [08/21/2012 klenk] Modelica functions will be handled elsewhere
	    (if (modelica-fn? (car equation))
		equation
		(error "Unknown equation operator: ~a" (car equation))))))))

(defun parse-equation-1-atom (equation parent bindings)
  (cond ((member equation '(Q- Q0 Q+)) (values (simpleq->interval equation) bindings))
	((var-p equation) equation)

	((find-locally-named-variable parent equation ))
	(t ;; This is a landmark or a mode name
	 equation)))
	 

(defun create-deriv-for-var (parent-var parent)
  (declare (ignore parent))
  (cond ((var-deriv parent-var))
	(t
	 ;; Poor choice of name.  Maybe don't use this??
	 (let ((var (create-var (var-parent parent-var)
				(intern (format nil "d~A/dt" (var-local-name parent-var))
					;; What is +env2-names+ ?
					+env2-names+))))
	   (setf (var-type var) 
		 (format nil "d~A/dt" (var-local-name parent-var)))
	   ;; These do not yield computational errors.  Just print outs may 
	   ;; print confusing derivative names.
	   (if (var-integral var) (error "Unimplemented case of higher-order derivative names"))
	   (if (var-deriv var) (error "Unimplemented case of higher-order derivative names"))


	   (setf (var-integral var) parent-var)
	   (setf (var-deriv parent-var) var)
	   ;; Only when a variable has an explicitly deriv construction should it be  state-var.
	   ;; I'm not sure this is absolutely right for non-Modelica imported models.
	   ;; This needs more analysis.
	   (pushnew parent-var (system-symbolic-state-vars *system-being-analyzed*))
	   (setf (var-symbolic-state-var? parent-var) t)
	   (push var (system-variables *system-being-analyzed*))
	   (push var (system-active-variables *system-being-analyzed*))
	   (push (cons (var-local-name var) var) (model-variables (var-parent parent-var)))
	   (construct-deriv-constraint parent-var var (var-parent parent-var))
	   var
	   ))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; this should be the primary method for creating constraints 

(defun boolean? (rhs)
  (member rhs (list (intern "false" :keyword)(intern "true" :keyword))))

(defun process-= (parent equation-object condition &optional ics)
  (if (and (not (listp equation-object)) (not (eq (car equation-object) '=)))
      (error "Malformed ="))
;  (format t "~% process-= ~a ~a" equation-object condition)
  (let ((lhs (second equation-object))
	(rhs (third equation-object)))
    (cond ((or (and (numberp lhs)
		    (= lhs 0))
	       (eql lhs 'Q0))
	   (construct-summer-from-exp rhs condition parent))
	  ((mode-var? lhs)
	   (error "Should we require a == for mode vars")
	   (construct-set-mode-constraint parent lhs rhs condition))
	  ((and (var-p lhs)(var-p rhs))
	   ;; [11/10/2013 qequal only does qualitative summer.  
	   (unless (or (discrete-var? lhs) (discrete-var? rhs))
	     (unless (eq lhs rhs) 
	       (construct-summer  (list lhs) (list rhs) condition 
				  (list 'process-= lhs rhs))))
	   ;; So following line should be deleted.
	   (construct-qequal parent lhs rhs condition nil 'process-=))
	  ((and (var-p lhs)(simpleq-p rhs))
	   (construct-qset parent lhs (simpleq->interval rhs) condition nil))
	  ((and (var-p lhs)(boolean? rhs))
	   (construct-qset parent lhs rhs condition nil))
	  ((and (var-p lhs)
		(or (interval? rhs)
		    (numberp rhs)
		    (landmark-for-var? rhs lhs)
		    (discrete-var? lhs)))
	   (construct-qset parent lhs rhs condition nil))
      ;;*** This needs to be generalized soon ***
      ;; pattern v = i R (= v (* i R))
	  ((or (and (listp rhs)
		    (member (car rhs) '(* + - /)))
	       (and (listp lhs)
		    (member (car lhs) '(* + - /))))
	   (construct-qarithmatic-constraint parent lhs rhs condition))
	  ((and (var-p lhs)(listp rhs)(eql (car rhs) 'power))
	   (construct-power-constraint parent lhs rhs condition))
	  ((and (var-p lhs)(modelica-fn? (car rhs)))
	   (construct-constraints-for-modelica-fn lhs rhs condition ics))
	  (t 
           (format t "unhandled equation-object ~s in process-=~%" equation-object)
	   (error "under construction")))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: envisioner.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: November 30, 2011 16:09:44
;;;;   Purpose: where the rubber meets the road -- given a qualitative model,
;;;;            generate an envisionment graph, a set of all possible future states
;;;;            of the system, alternating instance and interval
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Monday, November 18, 2013 at 15:04:01 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)


(defun analyze (name model initial-conditions 
		&key (display? t) (debug?)
		(evaluation-fn)
		(success-condition)
		(failure-condition)
		(visualization)
		(allow-initial-ambiguity?)
		(max-depth)
		(eliminate? t))
  (multiple-value-bind (initial-sits system)
      (create-situation-and-system name model initial-conditions visualization 
				   allow-initial-ambiguity?
				   (or evaluation-fn
				       #'(lambda (sit)
					   (evaluate-situation-wrt 
					    sit
					    success-condition
					    failure-condition)))
				   :debug? debug?
				   :eliminate? eliminate?)
    (envision initial-sits max-depth)
    ;; Display the envisionment using state variables on zgraph.
    (out-graphviz-dot initial-sits 
		      (mapcar #'get-viz-var visualization)
		      (merge-pathnames "envisioner/v2/graph.dot" cl-user::*my-meta-path*))
    (if display? (display-envisionment initial-sits (mapcar #'get-viz-var visualization)))
    (values (car initial-sits) system)
    ))


;; [01/25/2013 klenk] Takes a sits and expands every sit by depth.
(defun expand-envisionment-by (sits &key (depth 2)(nodes nil))
  (assert (null nodes))
  (setf (system-match-qstates *system-being-analyzed*) nil)
  (dolist (sit sits)
    (unless (some #'(lambda (parent) (discrete-transition? parent sit))(situation-parents sit)) 
      (envisioner (list sit) (+ (1- (situation-depth sit)) depth)))))


(defparameter *demo-output* nil)

;;; [04/09/2014 Johan] initials should be fully filled out situations.  No more
;;; changes to situation-state.
(defun envision (initial-sits depth)
  (setq *removed-sits* nil)
  (when *demo-output* (format t "~% Beginning Simulation"))
  (pushnew :qualitative (system-analyses *system-being-analyzed*))
  (dolist (initial initial-sits)
    (add-system-situation initial))
  (setf (system-initial-situations *system-being-analyzed*) initial-sits )
  (setf (system-depth-bound *system-being-analyzed*) depth)
  (when (system-match-qstates *system-being-analyzed*)
    (add-csv-filter-information (system-match-qstates *system-being-analyzed*) 
				*system-being-analyzed*))
  (envisioner initial-sits depth)
  (add-chatter-boxes)
  (when *demo-output* (format t "~% Simulation Complete: ~A" (summary-env2)))
  initial-sits)

(defun envisioner (start-sits depth)
  (let ((situations-explored 0))
    (setf (system-situation-queue *system-being-analyzed*) (copy-list start-sits))
    (do nil (nil)
      (let ((current-situation (pop (system-situation-queue *system-being-analyzed*))))
	(incf situations-explored)
	(when (and *demo-output* (= (mod situations-explored 500) 0))
	  (format t "~% Situations Explored: ~A Success: ~A Failure: ~A" situations-explored (length (success-situations))(length (fail-situations))))
	(debug-print nil "~% Looking at Sit: ~A Queue length: ~a"
		     current-situation (length (system-situation-queue *system-being-analyzed*)))
	(cond (current-situation
	       (when (and depth current-situation (> (situation-depth current-situation) depth) )
		 ;; [04/17/2014 Johan] Push the situation back on the queue in case we want to
		 ;; to pursue more later.
		 (push current-situation (system-situation-queue *system-being-analyzed*))
		 (return nil))
	       (unless (and 
			(member (update-success-function current-situation)
				'(:success :failure))
			(system-terminate-on-success-failure? *system-being-analyzed*)
			)
		 (setf (system-situation-queue *system-being-analyzed*) 
		   (nconc (system-situation-queue *system-being-analyzed*) 
			  (next-situations current-situation nil)))
		 ))
	      (t (return nil)))))))

(defun update-success-function (situation)
  (when (and (or (null (situation-status situation)) (eq (situation-status situation) :maybe))
          (system-success-function *system-being-analyzed*))
    (case (funcall (system-success-function *system-being-analyzed*) situation)
      (:success (setf (situation-status situation) :success))
      (:failure (setf (situation-status situation) :failure))
      (t (setf (situation-status situation) :maybe)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; [12/01/2011 klenk] No such thing as ambiguous situation anymore, all handled in the completer
(defmethod next-situations (situation &optional debug?)
  (let ((*debug?* debug?))
    (debug-print debug? "~%--- Step 1: Next Sitautions for ~A" situation)
    (debug-print debug? "~% ~A" (with-output-to-string (stream) (print-vars situation :stream stream)))
;    (when (system-debug *system-being-analyzed*) (break)) 
;; [05/30/2012 klenk] this is not the conditional equation version
    (cond ((mode-transition? situation)
	   (next-situations-discrete-modes situation ))
	  (t 
	   (next-situations-continuous situation )))))

(defvar *mode-transitions-enabled?* t)

(defun mode-transition? (situation)
  (and *mode-transitions-enabled?* 
       (eql (situation-type situation) :instant)
       (some #'(lambda (component)
		 (next-component-mode component situation))
	     (system-mode-components *system-being-analyzed*))))

(defun next-component-mode (component instant)
  (let* ((mode-var (model-mode component))
	 (current-mode (mode-value mode-var instant)))
    (assert current-mode)
    (find-if #'(lambda (mode-spec)
		 (and (not (eql (mode-name mode-spec) current-mode))
		      (condition-satisfied? (mode-entry mode-spec) instant)))
	     (model-modes component))))



;; [12/02/2011 klenk] Below is an implementation of the core QSIM algorithm
;; [12/05/2011 klenk] Returns a list of situations
(defun next-situations-continuous (situation)
  (debug-print nil "~% next-situations-continuous ~A" situation)
  (let* ((possible-transitions (find-possible-transitions situation)) ;; Step 2
;; [12/02/2011 klenk] Mode changes do not happen during continuous transitions
	 
	 ;; [04/30/2014 Johan]
	 (active-constraints (active-constraints situation))
	 (next-sits
          ;; [05/29/2012 klenk] how does this play with higher order transitions
          (catch :no-possible-children 
	    (debug-print nil "~% There are ~d possible transitions" (length possible-transitions))

	    (local-constraint-filtering possible-transitions active-constraints) ;; Kuipers Step 3.

            (filter-global-situations ;; Step 6
             (create-next-sit-interpretations ;; Step 5
              (arc-consistency active-constraints))  ;; Step 4
             situation))))
    (debug-print nil "~% sit ~A next-sits ~A" situation next-sits)
    (cond ((and (or (eq next-sits :no-possible-children)
		    (null (situation-children situation)))
		(eq (situation-type situation) :instant))
	   (remove-impossible-instant situation))
	  ((listp next-sits) next-sits)
	  (t nil))))

	 

;; [12/02/2011 klenk] Step 2
;; [12/02/2011 klenk] Finds the possible next values for all variables
(defun find-possible-transitions (situation)
  "Find any transition of a continuous quantity reaching a limit point,
based on its derivative."
  (debug-print nil "~%--- Step 2: Finding possible transition for vars, situation ~S" situation)
  ;; Clear the cache.
  (dolist (var (system-active-variables *system-being-analyzed*))
    (setf (var-value var) nil)
    (setf (var-deriv-value var) nil)
    (setf (var-possible-transitions var) nil))

  (let ((changes)
	(parent-type (situation-type situation)))
    (dolist (var (system-active-variables *system-being-analyzed*))
      (debug-print nil "~% find-possible-transitions:  Considering variable ~a global ~a" var (var-global-cell var))
      (unless (or ;(var-global-cell var) note that globals might not be substituted out.
		  (var-eliminated var)
		  (var-output-var? var))
	(dolist (qvalue (qualitative-values var situation))
;	  (format t "~% looking at qvalue ~S for var ~S~%" qvalue var)
	  (dolist (change (transitions var parent-type qvalue))
;	    (format t "    ~S  (~A)~%" (print-transition change nil) (finite-transition? change))
	    (debug-print nil " ~A " (print-transition change nil))  
	    (when (finite-transition? change)
	      (setq changes (add-possible-transition var change changes)))))))
    (setq changes (add-output-vars-changes changes))
    (dolist (var (system-active-variables *system-being-analyzed*))
      (unless (or  (var-possible-transitions var)) (error "no transitions"))
;;; Just for debugging.
;      (unless (cdr (var-possible-transitions var))
;	(format t "~% ~a has one transition ~a" var (var-possible-transitions var)))
      )
    changes)

  )

;; [06/ 5/2013 klenk] output vars are computed as a result to changes in the input quantity space
;; [06/ 5/2013 klenk] The input variables to every output variables is assumed to be in changes
;; [06/ 5/2013 klenk] To clean this up, a simple ordering is required

;; [06/ 5/2013 klenk] No need to worry about constraint active output-vars are dummy variables for
;; [06/ 5/2013 klenk] function expressions and thus always active
;;; [04/07/2014 Johan] Rewrote to cons less.
(defun add-output-vars-changes (changes)
  (dolist (var (quantity-vars))
    (when (var-output-var? var)
      (dolist (change (output-var-changes var changes))
	(setq changes (add-possible-transition var change changes)))))
  changes)

;;; [05/02/2014 Johan] Detect duplicates.
(defun add-possible-transition (var transition changes)
  (dolist (old-transition (var-possible-transitions var))
    (cond ((equalp (possible-transition-new-value old-transition)
		   (possible-transition-new-value transition))
	   (return-from add-possible-transition changes))))
  (push transition (var-possible-transitions var))
  (cons transition changes))
  
  


(defun finite-transition? (trans)
  (not (member (q-quantity-value (possible-transition-new-value trans)) '(Inf- Inf+))))

;; [12/01/2011 klenk] Kuipers approch from AIJ 86 article. This is basically a lookup table.
;; [12/02/2011 klenk] returns a set of possible transitions for the variable
(defun transitions (var type qvalue)
    (cond ((or (parameter-p var) (var-fixed? var) (var-global-cell var))
           (list (make-identity-transition var qvalue)))
	  ((discrete-var? var)
           ;; discrete variables only change at instants see next-situation-discrete
           (list (make-identity-transition var qvalue)))
	  (t
	   (ecase type
	     (:instant (possible-transitions-instant var qvalue ))
	     (:interval (possible-transitions-interval var qvalue))))))
	

;; [06/25/2012 klenk] Bill had a clever solution to put this allow for all transitions 
;; [06/25/2012 klenk] of discrete vars into instants
;; ((discrete-var? var)
;;            ;; discrete variables transition discontinuously.
;;            ;; So any value in the qspace could become active at
;;            ;; this instant.
;;            (let ((new-transitions))
;;              (dolist (v qspace)
;;                (push (make-pos-trans var old-value (create-q-quantity var v qspace nil))
;;                      new-transitions))
;;              new-transitions))

	      
;;;; Instant -> Interval Transitions
;; P1 <l1,std> -> <l1,std>
;; P2 <l1,std> -> <(l1,l2),inc>
;; P3 <l1,std> -> <(l0,l1),dec>
;; P4 <l1,inc> -> <(l1,l2),inc>
;; P5 <(l1,l2),inc> -> <(l1,l2),inc>
;; P6 <l1,dec> -> <(l0,l1),dec>
;; P7 <(l1,l2),dec> -> <(l1,l2),dec>
;;; P8,9,10 - added because we will let a deriv go to 0 while in an interval
(defun possible-transitions-instant (var old-value)
  (let ((value (q-quantity-value old-value))
	(qspace (q-quantity-qspace old-value)) 
	(deriv (q-quantity-deriv old-value)))
    (cond ((and (interval? value) (not (eql deriv 'Std)))  ;;P5 and P7
	   (list (make-identity-transition var old-value)))
	  ((and (interval? value) (eql deriv 'Std))  ;;P8,9,10
	   (list (make-identity-transition var old-value)
		 (make-pos-trans var old-value (create-q-quantity var value qspace 'Inc))
		 (make-pos-trans var old-value (create-q-quantity var value qspace 'Dec))))
          
	  ((and (eql deriv 'Std) (not (interval? value)))  ;;P1,2,3
           (list (make-identity-transition var old-value)
                 (make-pos-trans var old-value 
                                 (create-q-quantity var (list value (landmark-above value qspace)) qspace 'Inc))
                 (make-pos-trans var old-value
                                 (create-q-quantity var (list (landmark-below value qspace) value ) qspace 'Dec))))
	   ((and (not (interval? value)) (eql deriv 'Inc)) ;P4
	    (list (make-pos-trans var old-value 
				 (create-q-quantity var (list value (landmark-above value qspace)) qspace 'Inc))))
	   ((and (not (interval? value)) (eql deriv 'Dec)) ;P6
	    (list (make-pos-trans var old-value
				 (create-q-quantity var (list (landmark-below value qspace) value) qspace 'Dec))))
	   (t (error "Should cover all cases")))))

;;;; Interval to Instant Transitions without landmark identification (I7,I9)
;; I1 <l1,std> -> <l1,std>
;;;;;; Added I1b <(l1,l2),std> ->  <(l1,l2),std> 
;; I2 <(l1,l2),inc> -> <l2,std>
;; I3 <(l1,l2),inc> -> <l2,inc>
;; I4 <(l1,l2),inc> -> <(l1,l2),inc>
;; I5 <(l1,l2),dec> -> <l1,std>
;; I6 <(l1,l2),dec> -> <l1,dec>
;; I7 <(l1,l2),dec> -> <(l1,l2),dec>
;; I8-modified <(l1,l2),inc> -> <(l1,l2),std> ;;; these states are illegal according to the instant transitions
;; I9-modified <(l1,l2),dec> -> <(l1,l2),std> ;;; we can probably just add to transitions here
(defun possible-transitions-interval (var old-value )
  (let ((value (q-quantity-value old-value))
	(qspace (q-quantity-qspace old-value)) 
	(deriv (q-quantity-deriv old-value))) 
    (cond 
          ((and (not (interval? value)) (eql deriv 'Std)) ;;I1
           (list (make-identity-transition var old-value)))
	  ((and (interval? value) (eql deriv 'Std)) ;;I1-b
	   (list (make-identity-transition var old-value)))
	  ((and (interval? value) (eql deriv 'Inc)) ;; I2,3,4,8
	   (list (make-identity-transition var old-value)
		 (make-pos-trans var old-value 
				 (create-q-quantity var value qspace 'Std))
		 (make-pos-trans var old-value
				 (create-q-quantity var (cadr value) qspace deriv))
		 (make-pos-trans var old-value 
				 (create-q-quantity var (cadr value) qspace 'Std))))
	  ((and (interval? value) (eql deriv 'Dec)) ;; I5,6,7,9
	   (list (make-identity-transition var old-value)
	       (make-pos-trans var old-value 
			       (create-q-quantity var value qspace 'Std))
	       (make-pos-trans var old-value
			       (create-q-quantity var (car value) qspace deriv))
	       (make-pos-trans var old-value 
			       (create-q-quantity var (car value) qspace 'Std))))
	  (t (error "Should cover all cases")))))

(defun make-identity-transition (var old-value)
  (make-pos-trans var old-value old-value))

;; [12/02/2011 klenk] maybe add type (P1,P2...etc) at some point
;; [05/03/2014 Johan] Modified to cache them.  Note only new-val is significant.  So this structure can be simplified soon.
;;;
(defun make-pos-trans-old (var old-val new-val)
  (debug-print nil "~&make-pos-trans ~S ~S ~S~%" var old-val new-val)
  (let ((table (var-transition-table var))
	(key new-val)
	(transition))
    (unless table (setf (var-transition-table var) (setq table (make-hash-table :test #'equalp))))
    ;; This cons could be saved with a cache.***
    (setq transition (gethash key (var-transition-table var)))
    (unless transition
      (setq transition (make-possible-transition :id (new-id) :variable  var :old-value old-val :new-value new-val ))
      (setf  (gethash key (var-transition-table var)) transition))
    transition))

;;; Not worth creating hash-table.
;;; An a-list is sufficient.
(defun make-pos-trans (var old-val new-val)
  (debug-print nil "~&make-pos-trans ~S ~S ~S~%" var old-val new-val)
  (let ((table (var-transition-table var))
	(transition))
    (cond ((null table)
	   (setq transition (make-possible-transition :id (new-id) :variable  var :old-value old-val :new-value new-val ))
	   (setf (var-transition-table var) (list (cons new-val transition)))
	   transition)
	  ((setq transition (assoc new-val table :test #'equalp))
	   (cdr transition))
	  (t (setq transition (make-possible-transition :id (new-id) :variable  var :old-value old-val :new-value new-val))
	     (push (cons new-val transition) (var-transition-table var))
	     transition))))

;; [05/24/2012 klenk] temporary to understand discrete transitions
(defparameter *removed-sits* nil)

;; [03/18/2012 klenk] Remoevs this instant from the envisionment
;; [03/18/2012 klenk] Likely more effecient to do this after the entire envisionment has been created
(defun remove-impossible-instant (sit)
  (debug-print nil "~% Removing Impossible Situation: ~A Parents: ~A" sit (situation-parents sit))
;  (if (eq sit *s*) (error "no"))
  (push sit *removed-sits*)
;; [3/29/2014 Johan] Added for debugging.  
  (push :remove-impossible-instant (situation-trace sit))
  (dolist (parent (situation-parents sit))
    (setf (situation-children parent) (remove sit (situation-children parent))))
  ;;******** remove???? conses like mad for no reaosn.
  (remove-situation sit)
  nil)


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Step 3 - expanded because our constraints have different numbers of variables
;; [12/02/2011 klenk] This is not the usual constraint satisfaction way of handling this problem
;; [12/02/2011 klenk] Are we just blindly following Kuipers here....


;; [12/02/2011 klenk] returns a list of constraint-consistent-sets-pairs
;; pos-trans is all possible transitions.  Constraints is all active-transitions
(defun local-constraint-filtering (pos-trans constraints)
  ;;; special case degree 1 constraints
  (debug-print nil "~%--- Step 3: create consistency sets")
  (let* ((pos-trans (filter-pos-trans-by-one-var-constraints pos-trans constraints)))
    (constraints-consistency-sets pos-trans constraints)))

;;; This removes all transitions which conflict with one-var constraints.
;;; pos-trans is a particular possible transition.
(defun filter-pos-trans-by-one-var-constraints (pos-trans constraints)
  (let* ((one-var-constraints (constraints-by-degree constraints 1)))
    ;; Ok to clobber incoming list.
    (delete-if #'(lambda (pos-tran)
		   (some #'(lambda (constraint)
			     (when (and (member (possible-transition-variable pos-tran)
						(constraint-variables constraint)) 
					(inconsistent-by-constraint? (list pos-tran) constraint))
;			       (print pos-tran)
;			       (print constraint)
;			       (error "not sure this is used")
			       (debug-print nil "~%Inconsistent by one var constraint ~A"
					    (print-transition pos-tran nil))
			       t))
			 one-var-constraints))
	       pos-trans)))

;(defun consistent-transitions-for-constraints (constraints pos-trans-set)
;  (mapcar #'(lambda (constraint)
;	      (consistent-transitions-for-constraint pos-trans-set))
;	  constraints))

;; [12/05/2011 klenk] pos-trans is set of possible transitions
;; [12/05/2011 klenk] returns a list of constraint with the consistency slot filled
;; [12/05/2011 klenk] returns nil if no transitions satisfy the constraint;;;probably should throw an error to next-situations

;;; This now works by side-effect. The constraint construct slot is the list of transitions it is consistent with.
(defun constraints-consistency-sets (pos-trans constraints)
  (mapc #'(lambda (constraint)
	      (let ((consistent-set (constraint-consistency-sets pos-trans constraint)))
		(cond (consistent-set
		       (debug-print nil "~% Constraint ~A has consistency set of size: ~A"
				    constraint (length consistent-set))
		       (when (system-debug *system-being-analyzed*)
			 (dolist (set consistent-set)
			   (print-transition-set set)))
		       (setf (constraint-consistent-transitions constraint) consistent-set))
		      (t (debug-print nil "~% Unable to find consistency-set for ~A" constraint)
			 (throw :no-possible-children :no-possible-children)
			 (error "should just return nil")
			 ))))
	constraints)
  nil)

;;; Finds all the sets consistent with the constraint.
;;; pos-trans is all possible transitions.
;;; This computes power set of all possible transitions affecting the constraint.
(defun constraint-consistency-sets (pos-trans constraint)
  (let* ((constraint-variables)
	 (local-transitions))

;;; Construct a list of transitions only affecting ths constraint.
;;; **** This can be merged wit below.
	 ;; *** Why not call inconsistent-by-constraint? inside the loop?
    (setq constraint-variables (constraint-variables constraint))

    (dolist (possible-transition pos-trans)
      (if (member (possible-transition-variable possible-transition) constraint-variables :test #'eq)
	  (push possible-transition local-transitions)))

    (all-transition-sets local-transitions constraint)))
  
;; [12/05/2011 klenk] pos-trans is a list of possible transitions, this returns a list of sets in which each set
;; [12/05/2011 klenk] contains a one transition for each variable in pos-trans

(defvar *sets*)

;;; [04/22/2014 Johan] experiment. This should be a bit faster and far fewer conses.
;;; [04/22/2014 Johan] notice this constructs a power set, which is probably a mistake ***

(defun all-transition-sets (pos-trans constraint)
  ;; Group per variable.
  ;; As an a-list  ((var trans trans trans ...) (var ..))
  (let ((table)
	(*sets* nil))
    (dolist (trans pos-trans)
      (let* ((var (possible-transition-variable trans))
	     (slot (assoc var table :test #'eq)))
	(cond ((null slot) (push (list var trans) table))
	      (t (rplacd slot (cons trans (cdr slot)))))))
    (all-transition-sets-1 table nil constraint)
    *sets*))

(defun all-transition-sets-1 (table base constraint)
  (cond (table (dolist (pos-trans-for-var (cdar table))
		 (all-transition-sets-1 (cdr table) (cons pos-trans-for-var base) constraint)))
	((inconsistent-by-constraint? base constraint))
	(t (push base *sets*))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Step 4 Pairwise filtering
;;; For each pair of adjacent constraints, delete and set that includes a transition that is not in any transition in an adjacent constraint

;; [12/05/2011 klenk] returns the set of constraintss
;; [05/01/2014 Johan] otherwise known as arc-consistency.
(defun arc-consistency (constraints)
  (debug-print nil "~%--- Step 4: Pairwise Constraint Filtering")
  (let ((queue constraints))
    ;; Set up adjacents:
    (adjacent-constraints constraints)
    (do nil ((null queue)
	     (sort constraints #'constraint<))
      (let* ((constraint (pop queue))
	     (propagate? nil))
	(dolist (adj-constraint (constraint-adjacents constraint))
	  (let ((filter-results (filter-constraint-by-adj-constraint constraint adj-constraint)))
	    (unless filter-results
	      (debug-print nil "~% ~A has no more consistent sets" constraint)
	      (return-from arc-consistency
		(mapc #'(lambda (constraint)
			  (setf (constraint-consistent-transitions constraint) nil))
		      constraints)))
	    (unless (equal (constraint-consistent-transitions constraint) filter-results)
	   ;   (format t "~% Constraint ~a by adjacent  ~a reduced from" constraint adj-constraint)
;	      (print-constraint-table (constraint-consistent-transitions constraint))
;	      (format t "~% to:")
;	      (print-constraint-table filter-results)

	      (setf propagate? t)
	      (setf (constraint-consistent-transitions constraint) filter-results))))
	    
	(when propagate?
	  ;;*** perhaps mark the constraint it was most recently satisfied against to avoid
	  ;; repeats?
	  (dolist (adj-constraint (constraint-adjacents constraint))
	    (pushnew adj-constraint queue)))))))

(defun print-constraint-table (transitions)
  (print (mapcar #'possible-transition-variable (car transitions)))
  (dolist (transition transitions)
    (print (mapcar #'possible-transition-new-value transition))))

(defun constraint< (c1 c2)
  "Arrange for 'short' constraints to appear near one another, to reduce the branching factor."
  (let ((l1 (length (constraint-consistent-transitions c1)))
	(l2 (length (constraint-consistent-transitions c2))))
    (if (/= l1 l2)
	(<  l1 l2)
      (< (constraint-id c1)     ; ID is tie-breaker
	 (constraint-id c2)))))


;; [12/05/2011 klenk] takes a list of constraints and returns an adjacency list
;;; [04/25/2014 Johan] A lot of CPU time is taken here.
;;; This returns a list of lists ((constraint1 adj1 adj2 ...)...). adjn shares a variable. with constraint1.

;;; In the new scheme, adjacent constraints are cached on the constraint.
(defun adjacent-constraints (constraints)
  (dolist (constraint constraints)
    (setf (constraint-adjacents constraint) nil))
  (do ((constraints constraints (cdr constraints)))
      ((null (cdr constraints)))
    (dolist (constraint2 (cdr constraints))
      (when (adjacent-constraints? (car constraints) constraint2)
	(push (car constraints) (constraint-adjacents constraint2))
	(push constraint2 (constraint-adjacents (car constraints)))))))

;;; [04/25/2014 Johan] Checks whether two constraints share any variables.
;;; *** This can be done much faster if constraint-variables are kept sorted***
(defun adjacent-constraints? (cons1 cons2)
; Original:
;  (some #'(lambda (var)
;	    (find var (constraint-variables cons2)))
;	(constraint-variables cons1)))
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))
  (dolist (var1 (constraint-variables cons1))
    (if (member var1 (constraint-variables cons2) :test #'eq) (return t))))

(defun filter-constraint-by-adj-constraint (constraint adj-constraint)
  (remove-if
   #'(lambda (trans-set)
       (unless (set-consistent-with-constraint? trans-set adj-constraint)
	 (debug-print nil "~%Pairwise filter constraint ~A adj-constraint ~A removed: ~A"
		      constraint adj-constraint 
		      (with-output-to-string (stream)
			(print-transition-set trans-set stream)))
	 t))
   (constraint-consistent-transitions constraint)))

;; [12/05/2011 klenk] If the trans-set assigns a transition to a variable that is not possible in the adj-constraint
;; [12/05/2011 klenk] Then it is inconsisent
;;; [05/02/2014 Johan] This is poor man's arc-consistency.
(defun set-consistent-with-constraint? (trans-set constraint)
  '(format t "~% Checking whether ~a is consistent with ~a"
	  
    (mapcar #'(lambda (transition) 
		(cons (possible-transition-variable transition)
		 (possible-transition-new-value transition)))
     trans-set)
    constraint)

;  (error "look")

  (dolist (tran trans-set t)
    (when (find (possible-transition-variable tran) (constraint-variables constraint))
      (unless (some #'(lambda (constraint-tran-set)
			(find tran constraint-tran-set))
		    (constraint-consistent-transitions constraint))
	(return-from set-consistent-with-constraint? nil)))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Step 5 - Generate global interpretations
;; [12/05/2011 klenk] An interpretation is a set of transitions, a global interpretation includes every variable

;; [12/05/2011 klenk] depth-first-assignment of variables using the constraint transition sets
;; returns a list of interpretations
;; [02/24/2012 klenk] interpretations is misleading it is actually a single intrepretation.
;; [02/24/2012 klenk] They all get mapcan'ed together at the end
;;; Notice the constraints are ordered such that the ones with fewer possibilities come first.
;;; nconc is bad here.
;;; [05/01/2014 Johan] Avoid recursion if not needed.
;;;**** we can store the unwinds in the constraints.********* so unwinds do not need to cons.
(defun create-next-sit-interpretations (constraints &optional interpretation)
;  (print constraints)
;  (error "look1")


  (let ((unwinds))
    (do ((constraints constraints (cdr constraints)))
	((null constraints) 
	 ;; Construct by hand as an experiment.
;;;	 (check-new interpretation)
	 (unwind unwinds) 
	 (list interpretation))
      (let* ((constraint (car constraints))
	     (pos-tran-sets (sets-consistent-with-interpretation interpretation constraint)))
	(cond ((null pos-tran-sets) (unwind unwinds) (return nil))
	      ((cdr pos-tran-sets) 
	       (let ((interpretations
		      (mapcan #'(lambda (pos-tran-set)
				 ;; [12/19/2011 klenk] nconc should be alright here
				 ;; [02/24/2012 klenk] There are indeed duplicates here. What to do about them?
				 (let ((new-interpretation)
				       (new-unwinds)
				       (result))
				   (multiple-value-setq (new-interpretation new-unwinds)
				     (extend-interpretation pos-tran-set interpretation))
				   (setq result (create-next-sit-interpretations (cdr constraints) new-interpretation))
				   (unwind new-unwinds)
				   result)
				   )
			      pos-tran-sets)))
		 (unwind unwinds)
		 (return interpretations)))
	      (t (let ((new-unwinds))
		   (multiple-value-setq (interpretation new-unwinds)
		     (extend-interpretation (car pos-tran-sets) interpretation))
		   (setq unwinds (nconc new-unwinds unwinds))))
		     ;; [02/24/2012 klenk] There are indeed duplicates here. What to do about them?
	      )))))

(defun check-new (interpretation)
  (let ((new-interp))
    (dolist (var (system-active-variables *system-being-analyzed*))
      (and (var-value var) (push var new-interp)))
    (unless (= (length interpretation) (length new-interp))
      (error "no"))
    interpretation))

(defun unwind (vars)
  (dolist (var vars) 
;    (print (list 'unwind var))
    (setf (var-value var) nil)))

;;; This should perform better than union.
(defun extend-interpretation (a b)
  (let ((unwinds)
	(new-b b))
    (dolist (transition a)
      (let* ((var (possible-transition-variable transition))
	     (old-value (var-value var)))
	;; Could get rid of this cons to by using a stack or linked th
	(cond ((null old-value) (push var unwinds)
;				(print (list 'setting var (possible-transition-new-value transition)))
				(setf (var-value var) (possible-transition-new-value transition)))
				  
	      (old-value ;(unless (equalp old-value (possible-transition-new-value transition))
					; (error "Should be handled earlier"))
	       ))))
    ;; This part will go away soon.

    (dolist (a-element a)
      (unless (member a-element b :test #'eq) (push a-element new-b)))
    (values new-b unwinds)))

;;; This extends the current interpretation with every possible row
;;; of the constraint.  There may be none.

(defun sets-consistent-with-interpretation (interpretation constraint)
  (remove-if #'(lambda (pos-tran-set)
		 (inconsistent-transition-sets? interpretation pos-tran-set)) 
	     (constraint-consistent-transitions constraint)))

;;; [4/25/2014 Johan] A lot of CPU time is spent here so I optimized it a bit.
;;; This just checks whether the "interpretion"
;;; This can be optimized a lot more.*****
;;; Is there a possible-transition which does not occur in the interpretation, but who's variable does: rule this out.
;;; i.e., want
;;; Typically the intepretation is big, pos-tran-set small.
;;; pos-tran-set is a line in the constraint table.
(defun inconsistent-transition-sets? (interpretation pos-tran-set)
  (let ((r1 (inconsistent-transition-sets-1? interpretation pos-tran-set))
	(r2 (inconsistent-transition-sets-2? interpretation pos-tran-set)))
    (unless (eq r1 r2)
      (print (list 'r1 r1 'r2 r2))
      (error "mismatch"))


    r1))

(defun inconsistent-transition-sets? (interpretation pos-tran-set)
  ;; Equivalent to be below.
  (dolist (transition pos-tran-set) 
    (let ((old-value (var-value (possible-transition-variable transition))))
;      (print (list 'compare transition old-value (possible-transition-new-value transition)))

      (and old-value 
	   (not (equalp old-value (possible-transition-new-value transition)))
	   (return t)))))
  


(defun inconsistent-transition-sets-2? (interpretation pos-tran-set)
;;; Original
  ; (some #'(lambda (tran)
  ; 	    (and (find tran interpretation :test #'(lambda (t1 t2)
  ; 						     (eq (possible-transition-variable t1)
  ; 							 (possible-transition-variable t2))))
  ; 		 (not (find tran interpretation))))
  ; 	pos-tran-set))

  (dolist (possible-transition pos-tran-set)
    (let ((possible-transition-variable (possible-transition-variable possible-transition)))
      ;; If there is a transition involving some interpretation variable.
      ;;**** this can be optimized in many ways.
      (dolist (interpretation-transition interpretation)
	(cond ((eq possible-transition interpretation-transition)
	       (return nil))
	      (t (when (eq possible-transition-variable (possible-transition-variable interpretation-transition))
		   (unless (member possible-transition interpretation :test #'eq) ;**** this member only needs to look at tail.
;		     (format t "~% Fail because of conflicting transitions: ~a ~a" possible-transition interpretation-transition)
		     (return-from inconsistent-transition-sets-2? t)))))))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Step 6 Filter Global Situations
;;; check for no-change , cycle, or divergence
;; [12/05/2011 klenk] we aren't going to prune no-changes yet as they may be useful for mode changes...

(defun filter-global-situations (interpretations parent)
  (debug-print nil "~% --- Step 5:  Create global Interpretations results in ~A interpretations" 
	       (length interpretations))
  (debug-print nil "~% --- Step 6:  Filter ~A global situation interpretations" 
	       (length interpretations))
  (let (ret)
    (dolist (interpretation interpretations)
      (let* ((sit (make-situation-from-interpretation interpretation parent ))
	     (old-sit (find-situation sit)))

	(debug-print nil "~% filter-global-situations looking at ~a ~a" sit old-sit)

;; [01/25/2013 klenk] Only one trajectory when matching-qstates
	(cond ((and ret (system-match-qstates *system-being-analyzed*))
	       (debug-print t "~%Exit1 ~A" old-sit)
;	       (if (= (situation-id sit) 791) (error "one"))

	       nil)
	      ((system-match-qstates *system-being-analyzed*)
	       (debug-print nil "~%Exit2 ~A" old-sit)
;	       (if (= (situation-id sit) 791) (error "two"))
	       (dolist (sit (filter-situation-against-csv sit old-sit parent))
		 (push sit ret)))
	;; [12/13/2011 klenk] What about the empty transition to an instant for discrete changes...needs to go here
	      ((and (eql (situation-type parent) :interval)
		    (situation-equal sit parent))
	       (debug-print nil "~%Ignoring no change interval->instant sit ~A" sit)
	       (setf (situation-complete parent) :possible-terminal-interval)
;	       (if (= (situation-id sit) 791) (error "three"))
	       nil)
	      (old-sit 
	       (debug-print nil "~%Found old sit ~A" old-sit)
;	       (if (= (situation-id sit) 791) (error "four"))
	       (pushnew old-sit (situation-children parent))
	       (push parent (situation-parents old-sit))
;;	       (when (discrete-transition? parent sit)
;; [06/04/2012 klenk] looking for multiple entrances to the same discrete transition
;;		 (assert
;;		  (every #'(lambda (p1)
;;			     (equal 
;;			      (active-constraints p1)
;;			      (active-constraints parent)))
;;			 (situation-parents old-sit))))
;; [05/29/2012 klenk] Put the situation back on the queue to catch higher-order derivs
	       (when (and (eql (situation-type old-sit) :instant)
			  (not (quiescence? old-sit))
			  (not (discrete-transition? parent sit))
			  nil)
		 (push old-sit ret)))

 	      ((divergent? sit)
;	       (if (= (situation-id sit) 791) (error "five"))
	       (debug-print nil "~%Divergent situation ~A" sit)
	       (when (valid-infinite-aysmptotic-apprach? sit)
		 (add-system-situation sit)
;		 (push sit (system-situations *system-being-analyzed*))
		 (push sit (situation-children parent))
		 ))
	      ((quiescence? sit)
;	       (if (= (situation-id sit) 791) (error "six"))
	       (debug-print nil "~%Quiescence situation ~A" sit)
	       (add-system-situation sit)
	       (push sit (situation-children parent))
	       (setf (situation-complete sit) t)
	       (update-success-function sit)
	       )
	      ((violates-higher-order-continuity? parent sit)
;	       (if (= (situation-id sit) 791) (error "seven"))
	       ;(error "sit ~A" sit)
	       (debug-print nil "~%Violates higher order continuity situation ~A" sit )
	       nil)
	      ((discrete-transition? parent sit)
	       (debug-print nil "~%Discrete transition ~A creating right instants" sit)
	       ;; [04/09/2014 Johan and Matt] Lots of subtlelty here.  If we change
	       ;; the type of sit, then old-sit might have been found. there can
	       ;; be instants and intervals with the same key.  If there is an old-sit,
	       ;; of the changed type, use that instead of the new thing we created.
	       ;;*** reclaim old sit?
	       (change-situation-type sit :instant)
	       (setq old-sit (find-situation sit))
	       (cond (old-sit
		      (pushnew :discrete-transition-start (situation-trace old-sit))
		      (pushnew old-sit (situation-children parent))
		      (push parent (situation-parents old-sit))
		      (when (and (eql (situation-type old-sit) :instant)
				 (not (quiescence? old-sit))
				 (not (discrete-transition? parent sit))
				 nil)
			(push old-sit ret)))
		     (t (add-system-situation sit)
			(push :discrete-transition-start (situation-trace sit))
			(push sit (situation-children parent))
			(let ((right-instants (next-situations-discrete sit
									(active-constraints sit)
					;(newly-active-constraints sit parent)
									)))
;			  (assert (= (length right-instants) 1))
			  (dolist (right-instant right-instants)
			    (push :discrete-transition-end (situation-trace right-instant))
			    ;; [09/07/2012 klenk] Each of these right instants will begin a continuous integration step
			    (push right-instant ret))))))
	      (t
	       (debug-print nil "~%New situation ~A added to queue" sit)
	       (add-system-situation sit)
	       (push sit (situation-children parent))
	       (push sit ret)))))
    (unless (and (eql (situation-complete parent) :possible-terminal-interval)
		 (= (length interpretations) 1))
      (setf (situation-complete parent) t))
;; [04/15/2014 klenk] for debugging csv-tracker
;;    (when (system-match-qstates *system-being-analyzed*)
;;      (assert ret))
    ret
    ))

;; [01/23/2013 klenk] If the situation is the one we are looking for, then return it
;; [01/23/2013 klenk] If we are excepting an event
;; [01/23/2013 klenk]    If discrete-transition? - run it
;; [01/23/2013 klenk]    If instant - return it
;; [01/23/2013 klenk]    If interval - it must match the next qualitative abstraction
(defun filter-situation-against-csv (sit old-sit parent)
  (cond 
;; [01/23/2013 klenk] End of CSV file
    ((= (car (system-match-qstates *system-being-analyzed*))
	(length (system-match-qstates *system-being-analyzed*)))
     nil)
;; [01/23/2013 klenk] Modelica Event Expected
    ((in-event? *system-being-analyzed*)
     (cond ((discrete-transition?  parent sit)
	    (debug-print nil "~%Discrete transition ~A creating right instants" sit)
;	    (setf (situation-type sit) :instant)
	    (change-situation-type sit :instant)
	    (add-system-situation sit)
	    (push sit (situation-children parent))
	    (next-situations-discrete sit (active-constraints sit)))
;; [01/25/2013 klenk] Let all instants through
	   ((eql (situation-type sit) :instant) 
	    (cond  (old-sit
		    (pushnew old-sit (situation-children parent))
		    (pushnew old-sit (situation-children parent))
		    (list old-sit))
		   (t 
		    (push sit (situation-children parent))
		    (add-system-situation sit)
		    (list sit))))
;; [01/25/2013 klenk] Check interval against next csv state
	   ((eql (situation-type sit) :interval)
	    (incf (car (system-match-qstates *system-being-analyzed*)))
	    (filter-situation-against-csv sit old-sit parent))
	   (t (error "in-event: shouldn't happen; not a discrete transition, and situation type (~A) is neither :instant nor :interval" (situation-type sit)))))
;; [01/23/2013 klenk] Continuous Transition Expected
    ((qstate-matches-sit? 
      (elt (system-match-qstates *system-being-analyzed*)
	   (car (system-match-qstates *system-being-analyzed*)))
      sit)
     (incf (car (system-match-qstates *system-being-analyzed*)))
     (debug-print nil "~%New situation ~A added to queue" sit)
     (cond  (old-sit
	     (pushnew old-sit (situation-children parent))
	     (list old-sit))
	    (t 
	     (pushnew sit (situation-children parent))
	     (add-system-situation sit)
	     (cond ((discrete-transition?  parent sit)
		    (assert (or  
;			     (null (situation-parents 
;				    (car (situation-parents parent))))
			     (in-event? *system-being-analyzed*)))
		    (next-situations-discrete sit (active-constraints sit)))
		   (t (list sit))))))
    (t nil)))

    

;;; This will always return a non-interned situation.
(defun make-situation-from-interpretation (interpretation parent)
  (let ((new-sit (create-situation (ecase (situation-type parent)
				     (:instant :interval)
				     (:interval :instant))
				    parent
				   )))

    (push :continuous-transition  (situation-trace new-sit))
    ;;*** this appears necessary?************************???????????????????????????? WHY SHOULD NOT CONSTRAINTS SET THEM?
;    (if (>= (situation-id new-sit) 791) (error "look"))

    (dolist (var (system-active-variables *system-being-analyzed*))
      (when (and 
	     (var-fixed? var)
	     (not (var-eliminated var)))
        (dolist (val (qualitative-values var parent))
          (clobber var val new-sit '((:continuous-transition1)) :qualitative))))

    (dolist (tran interpretation)
      ;; Do not clobber some twice.**** cleanup.
      (let ((var (possible-transition-variable tran)))
	(unless (and 
		 (var-fixed? var)
		 (not (var-eliminated var)))


	  (clobber var (possible-transition-new-value tran) new-sit
		   '((:continuous-transition2)) :qualitative))))

;; [06/12/2012 klenk] Sometimes parameters are only used under certain circumstances
;;; [05/03/2014 Johan] At this point all variables should be known.      
;;; Only for debugging.
    ;;**** THIS IS NECESSARY***********  WHY NOT STOP
    (clear-constraints)


    new-sit))

;; [12/05/2011 klenk] Inf+ or Inf- is one of the variables
(defun divergent? (sit)
  (some #'(lambda (var) 
	    (some #'(lambda (qvalue) 
		      (member (q-quantity-value qvalue) '(Inf- Inf+)))
		  (qualitative-values var sit)))
	(quantity-vars *system-being-analyzed*)))

;; [12/05/2011 klenk] every var's deriv is zero
(defun quiescence? (sit)
  (and
   (every #'(lambda (var)
	      (let ((qvals (qualitative-values var  sit)))
;; [04/ 2/2013 klenk] Must propogate dummy times
		(or (and (eq (var-fundamental-type var) :time)
			 (equal (q-quantity-value (car qvals)) '(Q0 Inf+))
			 (eql (q-quantity-deriv (car qvals)) 'Inc))
		    (eql (q-quantity-deriv (car qvals)) 'Std)
		    (and (var-deriv var)
			 (or (and (equal (q-quantity-value (car qvals)) '(Inf- Q0))
				  (eql (q-quantity-deriv (car qvals)) 'Dec))
			     (and (equal (q-quantity-value (car qvals)) '(Q0 Inf+))
				  (eql (q-quantity-deriv (car qvals)) 'Inc)))))))
	  (quantity-vars *system-being-analyzed*))
   (not (mode-transition? sit))))

;; [05/29/2012 klenk] Currently we are just looking at the equations, nothing about setting initial values ala when
;;; [04/05/2014 Johan] changed to use active-constraints-safe instead.
(defun discrete-transition? (parent child)
  (or (not (equal (active-constraints-safe parent)
		  (active-constraints-safe child)
		  ))
      (when-event? child parent)))

(defun when-event? (child parent)
  (some #'(lambda (mod-when)
	    (and (not (evaluate-condition-tv (mod-when-trigger mod-when)  parent))
		 (evaluate-condition-tv (mod-when-trigger mod-when)  child)))
	(system-when-equations *system-being-analyzed*)
	))

;(defun active-constraint-sets (child parent)
;  (append (sort (active-constraints parent) #'< :key #'constraint-id)
;	  (sort (active-constraints child) #'< :key #'constraint-id)
;	  ))

;; [09/07/2012 klenk] Returns a values list of the constraints no longer active
;; [09/07/2012 klenk] and the constraints which just became active
;;; [4/4/2014 Johan] rewritten to save conses and not use active-constraints
;;; 
(defun constraint-difference (child parent)
  (let ((old) (new))
    (dolist (constraint (system-constraints *system-being-analyzed*))
      (cond ((constraint-active-p constraint parent)
	     (unless (constraint-active-p constraint child)
	       (push constraint old)))
	    ((constraint-active-p constraint child) (push constraint new))))
    (values old new)))

;; [12/12/2011 klenk] From Appendix A.2 Every var must be at a landmark and if that landmark is finite
;; [12/12/2011 klenk] its direction of change must be steady. MEK: I actuually don't care if it is finite or not
;; [12/12/2011 klenk] The chagne must be steady.
(defun valid-infinite-aysmptotic-apprach? (sit)
  (error "there should be no divergent situations yet")
  (dolist (var (quantity-vars *system-being-analyzed*) t)
    (unless (and (some #'(lambda (qvalue)
			   (not (interval? (q-quantity-value qvalue))))
		       (qualitative-values var sit))
		 (or (not (var-deriv var))
		     (eql (simple-qvalue (var-deriv var) sit) 'Q0)))
      (return-from valid-infinite-aysmptotic-apprach? nil))))

;;Taken from 84 AAAI paper on higher order derivs. Rule 5 - Every derivative is continuous
(defun violates-higher-order-continuity? (parent sit)
  (let ((grand-parents (situation-parents parent)))
;; [06/ 6/2013 klenk] This is a check to make sure there was not a discrete transition
;; [06/ 6/2013 klenk] either through a change in condition or change in an input variable
    (when (and
	   (notany #'(lambda (constraint)
		       (and (modelica-fn-constraint? constraint)
			    (constraint-active-p constraint sit)
			    (output-vals-violated-higher-order-continuity? constraint parent sit)))
		   (system-constraints *system-being-analyzed*)) 
;; [06/ 6/2013 klenk] Discrete transition
	   (and (eq (situation-type sit) :interval)
		grand-parents
		(every #'(lambda (sit) (eq (situation-type sit) :interval)) grand-parents))) 
      (dolist (var (quantity-vars *system-being-analyzed*) nil)
	(when (and (eql (q-quantity-deriv (car (qualitative-values var sit))) 'Std)
		   (eql (q-quantity-deriv (car (qualitative-values var parent))) 'Std)
		   (every #'(lambda (gp)
			      (not (eql (q-quantity-deriv (car (qualitative-values var gp))) 'Std)))
			  grand-parents))
	  (return-from violates-higher-order-continuity? t))))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; evaluation function

;; [12/27/2011 klenk] THIS IS NOT LTL RIGHT NOW
(defun evaluate-situation-wrt (sit success failure)
  (cond ((condition-satisfied? success sit)
	 :success)
	((condition-satisfied? failure sit)
	 :failure)
	(t :maybe)))

(defun condition-satisfied? (ltl sit)
  (cond ((null ltl) nil)
	((eql (car ltl) 'and)
	 (every #'(lambda (condition)
		    (condition-satisfied? condition sit))
		(cdr ltl)))
	((eql (car ltl) 'or)
	 (some #'(lambda (condition)
		   (condition-satisfied? condition sit))
	       (cdr ltl)))
	((eql (car ltl) 'not)
	 (not (condition-satisfied? (cadr ltl) sit)))
	(t (condition-satisfied-atom? ltl sit))))

;; [12/06/2011 klenk] These eql will have to be expanded a bit
(defun condition-satisfied-atom? (ltl sit)
  (let ((equations (parse-equation-1 ltl (car (top-models)) nil)))
    (ecase (car ltl)
      ((q= qIn =) 
       (some #'(lambda (q-quantity)
		 (equal (q-quantity-value q-quantity)  (third equations)))
	     (qualitative-values (second equations) sit)))
      (> (let ((q-quantity (qualitative-value-in-qspace (second equations) sit 
							(qspace-for-value (second equations) (third equations)))))
	   (and (equal (q-quantity-value q-quantity)  (third equations))
		(equal (q-quantity-deriv q-quantity)  'Inc))))
      (< (let ((q-quantity (qualitative-value-in-qspace (second equations) sit 
							(qspace-for-value (second equations) (third equations)))))
	   (and (equal (q-quantity-value q-quantity)  (third equations))
		(equal (q-quantity-deriv q-quantity)  'Dec))))
      (== (eql (mode-value (second equations) sit) (third equations)))
      )))



	    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-

;;; All the functions associated with maintaining interning situations.  A lot
;;; of the cpu time is spent here.


(in-package :env2)

;;; Finds a situation like the values at new-time.  Will do an exact match for now.
;;; switch to approx. later.
;;; [04/04/2014 Johan] This will not scale.

(defun find-parent-situation (new-situation)
  (let ((new-state (collect-state new-situation)))
    (dolist (old-situation (situation-parents new-situation))
      (unless (eq new-situation old-situation)
	(unless (situation-state old-situation) (collect-state old-situation))
	(and (equalp new-state (situation-state old-situation))
	     (return-from find-parent-situation old-situation))))))

;;; [04/07/2014 Johan] This is the main function to add a situation.  Don't push on
;;; to system-situations.
(defun add-system-situation (situation)
  (debug-print nil "~% add-system-situation ~a of type ~a" situation (situation-type situation))

;; Quick test.
;  (when (find-situation situation)
;    (format t "~% Adding situation ~a which is the same as ~a"
;	    situation (find-situation situation))

    ;(error "Adding duplicate situation")
;    )

  ;; Just a diagnostic for now.
;  (let ((o (find-situation situation) ))
;    (when o
;      (unless (eq (situation-type situation) (situation-type o))
;	(error "Clobberd type?"))
;      (if (= (situation-id situation) 8572) (error "8572"))
;      (return-from add-system-situation nil)))

  ;; Eventually this will go away:
;  (cond ((member situation (system-situations *system-being-analyzed*))
;	 (error "no1")))
;  (let ((old1 (find-situation situation)))
;    (print (list 'old1 old1))
;    (when old1
;      (print (list situation old1))
;      (error "Adding old1")))

;  (let ((old (gethash (collect-state situation)
;		      (if (eq (situation-type situation) :instant)
;			  (system-instants *system-being-analyzed*)
;			(system-intervals *system-being-analyzed*)))))
;    (when old
;      (print (list 'old-but-not? situation old))
;      (error "no2")))
;  (unless (collect-state situation) (error "must"))

  (push situation (system-situations *system-being-analyzed*))
  (puthash-situation (collect-state situation) situation
		     (if (eq (situation-type situation) :instant)
			 (system-new-instants *system-being-analyzed*)
		       (system-new-intervals *system-being-analyzed*))))



;;; not complete.****
(defun remove-situation (sit)
  (debug-print t "~% remove-situation ~a" sit)
  (setf (system-situations *system-being-analyzed*) 
	(remove sit (system-situations *system-being-analyzed*))))

(defun change-situation-type (sit type)
  (debug-print nil "~% change-situation ~a type from ~a to ~a" sit (situation-type sit) type)
  (cond ((eq type (situation-type sit)))
	((find-situation sit) (error "Cannot change the type of an interned situation"))
	(t (setf (situation-type sit) type))))

;;; Designed for debugging.  This checks whether a situation has been interned.
(defun situation-is-interned (situation)
  (eq situation (find-situation situation)))

(defun find-situation-compare (new-situation)
  (let ((r1 (find-situation-old new-situation))
	(r2 (find-situation-new new-situation)))
    (unless (eq r1 r2) 
      (format t "~% Old ~a, New ~a" r1 r2)
      (error "mismatch in find-situation"))
    r1))

;;; Sequential lookup version.
(defun find-situation-older (new-situation)
  (let ((new-state (collect-state new-situation))
	(situations (total-situations)))
    (dolist (old-situation situations)
      (unless (situation-state old-situation) (collect-state old-situation))
      (and (eq (situation-type new-situation) (situation-type old-situation))
	   (states-equal new-state (situation-state old-situation))
	   (return-from find-situation-older old-situation)))))

;;; Throw
;;; **** TODO Throw away new-situation????******* if old one is there.
;;; Rename this to find-situation-new to debug.
(defun find-situation-old (new-situation)
  (let* ((new-state (collect-state new-situation))
	 (table (if (eq (situation-type new-situation) :instant)
		    (system-instants *system-being-analyzed*)
		  (system-intervals *system-being-analyzed*)))
	 (old-situation (gethash new-state table))
	 )

    old-situation))

(defun find-situation (new-situation)
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))
  (let* ((new-state (collect-state new-situation))
	 (table (if (eq (situation-type new-situation) :instant)
		    (system-new-instants *system-being-analyzed*)
		  (system-new-intervals *system-being-analyzed*)))
	 (old-situation (gethash-situation new-state table))
	 )

    old-situation))

;;; [04/07/2014 Johan] Checks whether the state portion (not type) is the same.
;;; use this function, as this functionality may be redesigned in the future.
;;; reverted because too much code looks at situation-state directly.  
;;; Another project to get rid of all of those and have one unified table.
(defun situation-equal (sit1 sit2)
  (equalp (situation-state sit1) (situation-state sit2)))

;;;***** We now know they are all integers, so this can be sped up.
;;; arrayts.
(defun states-equal (new old)
  (equalp new old))

;;; [04/07/2014 Johan] 
;;; In new scheme, first entry of state is its type --- doesn't work.  To much code looks at situation-state
;;; reverted back to original.
(defun collect-state (situation)
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))
  (cond ((situation-state situation))
	(t (let ((vars (system-collect-vars *system-being-analyzed*))
		 (state)
		 (size))
	     (unless vars
	       (dolist (var (system-variables *system-being-analyzed*))
		 (cond ((var-eliminated var))
		       ((parameter-p var))
		       ((mode-var? var) (push var vars))
		       ((var-global-cell var))
		       (t (push var vars))))
	       (setq vars (reverse vars));;** why?
	       (setf (system-collect-vars *system-being-analyzed*) vars)
	       (setq size (length vars))
	       (setf (system-state-size *system-being-analyzed*) size)
	       )
	     (unless size (setq size (system-state-size *system-being-analyzed*)))
	     ;; Start simple.
;	     (dolist (var vars)
;	       (push (extract-key var situation) state))
;	     (setf (situation-state situation) state)
;	     state
	     (let ((key (make-array size :element-type '(signed-byte 16))))
	       (dotimes (i size)
		 (setf (aref key i) (extract-key (pop vars) situation)))
	       (setf (situation-state situation) key)
	       key)


	     ))))

;;; Very important note:
;;;  hash-blarrs depends critically its compiled and so the hash is mod fixnums.
;;;  If you remove the declaration, it will return negative bignums.
(defun hash-situation (vector size &aux (hash 0) 
					(len (system-state-size *system-being-analyzed*)))
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0))
	   (fixnum hash len))
  (do ((i 0 (1+ i)))
      ((= i len))
    (declare (fixnum i))
    (setq hash (+ (the fixnum (* 3 hash)) (the fixnum (aref vector i)))))
  (if (>= hash 0)
      (the fixnum (rem hash size))
    (the fixnum
      (rem (the fixnum (- (the fixnum hash)
					; Don't do this:  It produces -1s.
					;(the fixnum most-positive-fixnum
					;)
			  most-negative-fixnum
			  ))
	   (the fixnum size)))))


;;; Experimenting for now.

;;; Experimenting for now.



;;*** note: check if this is not called n times on same situation



;;*** note: check if this is not called n times on same situation
;; **** by temporarily having a slot for has.
;;**** how keep from creating bignums?
(defun situation-hash (key)
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0))
	   )
  (print (list 'callingsituationhash))
  (let (
	(size (system-state-size *system-being-analyzed*))
	(hash 0))
    (declare (fixnum size hash))

    (dotimes (i size)
      (setf hash (+ (the fixnum (* 3 hash)) (aref key i))))
      


    (print (list 'hash hash))
    hash))
      






;;; [04/15/2014 Johan]
;;; Return key element hash will use.
(defun extract-key (var situation)
  (cond ((mode-var? var) 
	 (error "stub2")
	 (mode-value var situation))
	(t (let ((qualitative-values (qualitative-values var situation)))
	     (unless qualitative-values (error "no value"))
	     (cond ((cdr qualitative-values)
		    (error "stub1")
		     (mapcar #'(lambda (value)
				 (collect-state-value value))
			     qualitative-values))
		   (t (collect-state-value (car qualitative-values))))))))

;;; *** note cons can be recycled.
(defun collect-state-value (original-value)
  (let ((value (q-quantity-value original-value))
	(deriv (q-quantity-deriv original-value)))
    (cond ((numberp value)
	   (let ((new-value (cons value deriv)))
	     (cond ((gethash new-value (system-key-hash-table *system-being-analyzed*)))
		   ((setf (gethash new-value (system-key-hash-table *system-being-analyzed*))
		      (decf (system-key-counter *system-being-analyzed*)))))))
	  ((eq value :false) -1000)
	  ((eq value :true) -1001)
	  ((eq value :unknown) -1002)
	  ((eq value 'Q0)
	   (cond ((eq deriv 'Inc) -1003)
		 ((eq deriv 'Dec) -1004)
		 (-1005)))
	  ((equal value '(Inf- Q0))
	   (cond ((eq deriv 'Inc) -1006)
		 ((eq deriv 'Std) -1007)
		 (-1008)))
	  ((equal value '(Q0 Inf+))
	   (cond ((eq deriv 'Inc) -1009)
		 ((eq deriv 'Std) -1010)
		 (-1011)))
	  (t (let ((new-value (cons value deriv)))
	       (cond ((gethash new-value (system-key-hash-table *system-being-analyzed*)))
		     ((setf (gethash new-value (system-key-hash-table *system-being-analyzed*))
			(decf (system-key-counter *system-being-analyzed*))))))))))
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: env-analysis.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 14, 2011 15:17:45
;;;;   Purpose: general-purpose analysis of an envisionment graph
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, June 07, 2012 at 12:52:02 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


(defun check-modes-for-terminals (sit)
  (let (success)
    (dolist (mode-var (mode-vars))
      (case (mode-value mode-var sit)
;; [02/28/2012 klenk] Diode
	(success (setq success t))
	(fail (return-from check-modes-for-terminals :fail))))
    (if success :success :maybe)))

;; [03/01/2011 klenk] Added to access information about the envisionment
(defun sroot (&optional (system *system-being-analyzed*))
  (car (last (system-initial-situations system))))

(defun initial-situtations (&optional (system *system-being-analyzed*))
  (system-initial-situations system))

;; change system to envisionment-graph at somepoint
(defun success-situations ()
  (remove-if-not #'(lambda (situation)
		     (eq (situation-status situation)
			 :success))
		 (total-situations )))

(defun fail-situations ()
  (remove-if-not #'(lambda (situation)
		     (eq (situation-status situation)
			 :failure))
		 (total-situations )))

(defun terminal-situations ()
  (remove-if #'situation-children (total-situations )))

(defun total-situations ()
  (system-situations *system-being-analyzed*))

(defun num-edges ()
  (let ((count 0))
    (dolist (sit (total-situations) count)
      (setf count (+ count (length (situation-children sit))))))) 


(defun summary-env ()
   (dolist (sit (append (success-situations ) (fail-situations )))
     (assert (not (situation-children sit))))
   (list :total (length (total-situations ))
	 :success (length (success-situations ))
	 :fail (length (fail-situations ))
	 :terminal (length (terminal-situations ))
	 :edges (num-edges)))

(defun summary-env2 ()
  (list :total (length (total-situations ))
	 :success (length (success-situations ))
	 :fail (length (fail-situations ))
	 :implicit-failures (- (length (terminal-situations ))
			       (length  (fail-situations ))
			       (length (success-situations)))
	 :edges (num-edges)))

(defun all-failure-or-success? (summary)
  (= (- (getf summary :terminal)
	(getf summary :success)
	(getf summary :fail))
     0))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; graph-walks

(defun shortest-path-to-sit (sit)
  (reverse (shortest-path-to-sit-1 sit)))

;; [12/22/2011 klenk] Returns one of the shortest paths to the root
(defun shortest-path-to-sit-1 (sit)
  (cond ((situation-parents sit)
	 (cons sit (shortest-path-to-sit-1
		    (car 
		     (remove-if-not #'(lambda (parent)
					(= (situation-depth parent)
					   (1- (situation-depth sit))))
				    (situation-parents sit))))))
	(t (list sit))))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; querying the envisionment


; Returns a list of situations where the velocity is 0 and its derivative is 0

(defun situations-satisfying (logical-form)
  (let ((bound-form (parse-equation-1 logical-form nil nil)))
    (remove-if-not 
     #'(lambda (sit)
	 (condition-satisfied? bound-form sit))
     (total-situations))))


;; [05/30/2012 klenk] Input is a list of var q-quantity-pairs
(defun situations-satisfying-q-quanities (pairs &optional (sits (total-situations)))
  (remove-if-not 
   #'(lambda (sit)
       (every #'(lambda (pair)
		  (let ((var (car pair))
			(signature (cdr pair)))
		    (some #'(lambda (q-quantity)
			      (q-quantity-matches? q-quantity signature))
			  (qualitative-values var sit))))
	      pairs))
   sits))
   

;; [06/07/2012 klenk] sits is a set of sitautions representating a subgraph of the envisionment
;; [06/07/2012 klenk] This is useful to display
(defun prune-subgraph-to-initial-sits (sits)
  (let ((ret (remove-if-not #'(lambda (sit)
				(or
				 (member sit (system-initial-situations *system-being-analyzed*))
				 (some #'(lambda (parent)
					   (member parent sits))
				       (situation-parents sit))))
			    sits)))
  (if (equal ret sits)
      ret
      (prune-subgraph-to-initial-sits ret))))
  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: kirchoff.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December  1, 2011 09:10:00
;;;;   Purpose: find all loops in "circuit" necessary for KCL and KVL, and add
;;;;            constraints derived therefrom
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, March 21, 2012 at 16:07:20 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; KCL

(defun KCL (system)
  (mapc #'kcl-node (system-nodes system))
  (mapc #'kcl-model (system-models system)))


(defun KCL-constraint? (constraint) 
  (and (listp constraint)
       (eql (car constraint) 'KCL)))

;;; Installs the KCL constraint for models.
;;; For multi-discipline components, KCL applies to each discipline.
;;; All currents sume to 0, all torques some to zero.  Etc.
(defun kcl-model (model)
  (let ((kcl-constraints (remove-if-not #'KCL-constraint? (model-constraints model))))
    (create-kcl-constraints (mapcar #'cdr kcl-constraints) model)
    (setf (model-constraints model) (remove-if #'KCL-constraint? (model-constraints model)))))

(defun create-kcl-constraints (pairs model)
  (dolist (group (identify-groups-from-paths  
		  (floyd-warshall pairs) 
		  (remove-duplicates (flatten pairs))))
    (construct-summer group nil nil model)
    ))
    


;; [02/01/2012 klenk] Pairs of connector components
(defun floyd-warshall (pairs)
  (let ((comps (remove-duplicates (flatten pairs)))
	(hash (make-hash-table :test #'equal)))
    (dolist (comp1 comps)
      (dolist (comp2 comps)
	(dolist (comp3 comps)
	  (let ((connected? (or (gethash (cons comp2 comp3) hash)
				(adj? comp2 comp3 pairs)
				(and (gethash (cons comp2 comp1) hash)
				     (gethash (cons comp1 comp3) hash)))))
	    (setf (gethash (cons comp3 comp2) hash) connected?)
	    (setf (gethash (cons comp2 comp3) hash) connected?)
	    ))))
      hash))

(defun identify-groups-from-paths (hash comps)
  (let (visited groups)
    (dolist (comp1 comps groups)
      (unless (member comp1 visited)
	(push comp1 visited)
	(let ((group (list comp1)))
	  (dolist (comp2 comps (push group groups))
	    (when (and (not (eql comp1 comp2))
		       (gethash (cons comp1 comp2) hash))
	      (push comp2 group)
	      (push comp2 visited)
	      )))))))


(defun adj? (elt1 elt2 pairs)
  (some #'(lambda (pair)
	    (or (and (eql elt1 (car pair))
		     (eql elt2 (cadr pair)))
		(and (eql elt2 (car pair))
		     (eql elt1 (cadr pair)))))
	pairs))
  
;; [02/01/2012 klenk] rosetta code version
(defun flatten (structure)
  (cond ((null structure) nil)
        ((atom structure) `(,structure))
        (t (mapcan #'flatten structure))))

;;; The through type associated with this discipline.
;;;**** add the other disciplines.
(defun through-type (discipline)
  (case discipline
    (:electrical :current)
    (:rotational :torque)

    (:linear :force)
    (:x-linear :x-force)
    (:y-linear :y-force)

;; [02/18/2011 klenk] assumes temp-diff as the across variable
    (:thermal :heat-flow-rate)
    (:temporal )
    (:variable :variable)
    (t (error "Unknown type"))))

(defun kcl-node (n)
  (unless (eq (node-type n) :variable)
    (kcl-general (node-terminals n) n (through-type (node-type n)))))


;; [04/06/2011 klenk] If there is no type as with temporal nodes, then don't create a KCL node
(defun kcl-general (terminals model type)
  (when (and terminals type)
    (let* ((vars))
      (dolist (terminal terminals)
	(cond ((terminal-through-variable terminal) (push (terminal-through-variable terminal) vars))
	      ;; We may need to generalize this some day when a model can have a body and equations.
	      ((metamodel-body (model-prototype (terminal-parent terminal))))
	      (t
	       (push (create-through-variable (terminal-parent terminal)
					      nil
;;; [2011 03 17] Johan
;;;					      (get-new-var-name) This makes it hard to debug.  Leave as nil so the >> printer can show what the variable is.
					      terminal
					      type)
		     vars))))
      ;; Again this may need to be generalized.	 Right now no vars means no need to write KCL at all.
      (unless vars (return-from kcl-general nil))
      (if (cdr vars)
	  (construct-summer vars nil nil (list 'KCL terminals))
	  (format t "~% Node ~a has only one through variable connected to it, this is probably a bug." model)))
    ))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Very simplistic kvl for now
;;; Notice this is sound but not complete for qualitative values.  See my thesis.  This
;;; **** not done for each discipline independently.
(defvar *cycles* nil)

;;; variable types are not thought out here.
;;; in (1) different types of stuff.
;;; in (2) different orders of derivative.
;;; there is error checking code though to indicate when there is a problem.
(defun construct-kvls (system)
  (let ((nodes 
	 (remove-if #'variable-node? 
                  (system-nodes system)))
                (*cycles* nil))
    ;; Clear the marks for spanning tree.
    (mapc #'(lambda (node) (setf (node-mark node) nil
                                                                (node-in-parent node) nil)
                                    )
                  nodes)
    ;; The graph can have disconnected components.
    ;; Any unmarked node will not be in any cycle basis.
    (dolist (node nodes)
      (setq *cycles* nil)
      (unless (node-mark node)
                (construct-cycles node)
    ))))


(defun variable-node? (node)
  (eq (node-type node) :variable))

;; Return canonicalized result (var . polarity).  Ascending id, first polarity is always positive.
(defun construct-loop (cycle)
  (let ((type nil)
	(result))
    (do ((tail cycle (cdr tail)))
	((null tail))
      (let ((across (assoc (or (second tail) (car cycle)) (node-across-variables (car tail)))))
	(cond ((null across) (error "missing across variable - impossible"))
	      ((cddr across) (error "Multiple across variable types not implemented"))
	      ;; across should look like (node (var  polarity)...)
	      (t (let ((var (car (cadr across)))
		       (polarity (cadr (cadr across))))
		   (cond ((null type) (setf type (var-type var)))
			 ((eq type (var-type var)))
			 (t (error "Multiple types not implemented")))
		   (push (cons var polarity) result))))))
    (sort (copy-tree result) #'(lambda (a1 a2) (< (var-id (car a1)) (var-id (car a2)))))
    ))

(defun canonicalize-result (result)
  (copy-tree (if (eq (cdar result) '+) 
		 result
	       (mapcar #'(lambda (pair) (cons (car pair) (invert-polarity (cdr pair)))) result)))
  )



;;; Construct all cycles involving nodes reachable from the start node.
(defun construct-cycles (node)
  (construct-spanning-tree node)
  ;; *cycles* now contains a set of edges expressed as across variables with polarity.
  ;; This is the cycle basis.
  ;; Although it is sufficient KVL for normal equations, it is not enough for qualitative algebra.
  ;; *** is subsumption check needed at all?
;  (format t "~% Cycle basis of ~d cycles" (length *cycles*))
;  (dolist (cycle *cycles*) (print cycle))
  (when *cycles*
    (let ((processed (list (car *cycles*)))
	  (table (make-hash-table :test #'equal))
	  (stack (cdr *cycles*)))
      (setf (gethash (car processed) table) :processed)
      (do nil ((null stack) processed)
	(dolist (p processed)
	  (let ((add (add-cycles (car stack) p)))
	    (when (and add (not (gethash add table)))
					;	    (push (list 'add (car stack) p add) *x*)
	      (setf (gethash add table) :stack)
;	      (print (list 'foundadd add))
	      (push add stack)))
	  (let ((sub (sub-cycles (car stack) p)))
	    (when (and sub (not (gethash sub table)))
					;	    (push (list 'sub (car stack) p sub) *x*)
	      (setf (gethash sub table) :stack)
;	      (print (list 'founsub sub))
	      (push sub stack))))
	(push (pop stack) processed))
;      (format t "~% Now ~d cycles" (length processed))
;      (dolist (cycle processed)
;	(print cycle))
;      (maphash #'(lambda (key val) 
;		   (print (list 'kv key val)))
;	       table)
 ;     (error "stop")
;      (error "stop")
      (construct-kvls-from-cycles processed))))

;;; Not called???:
(defun construct-kvls-from-cycles (cycles)
  (dolist (cycle cycles)
    (let ((positives)
	  (negatives))
      (dolist (var cycle)
	(if (eq (cdr var) '-) (push (car var) negatives)
	  (push (car var) positives)))
     (construct-summer positives negatives nil 'kvl))))

;;; One can do the whole scan in one pass, and then cons if there is a result to be add.
;;; Many inefficiencies here.

(defun add-cycles (cycle1 cycle2)
;  (print (list 'add cycle1 cycle2))
  (let ((result) (common))
    (do nil (nil)
      (cond ((null cycle1)
	     (if (null cycle2) (return nil))
	     ;; reconc is probably faster, this is safer.
	     (push (cons (caar cycle2) (cdar cycle2)) result)
	     (pop cycle2))
	    ((null cycle2)
	     (push (cons (caar cycle1) (cdar cycle1)) result)
	     (pop cycle1))
	    ((< (var-id (caar cycle1)) (var-id (caar cycle2)))
	     (push (cons (caar cycle1) (cdar cycle1)) result)
	     (pop cycle1))
	    ((> (var-id (caar cycle1)) (var-id (caar cycle2)))
	     (push (cons (caar cycle2) (cdar cycle2))
		   result)
	     (pop cycle2))
	    ;; Now they must be =
	    ((eq (cdar cycle1) (cdar cycle2)) (return-from add-cycles nil))
	    (t (setq common t)
	       (pop cycle1) (pop cycle2))))
    (when (and common (check-cycle result))
      (setq result (nreverse result))
;      (print (list 'add result))
      (canonicalize-result result))))

;;; Same as add-cycles except polarity comparison.
(defun sub-cycles (cycle1 cycle2)
;  (print (list 'sub cycle1 cycle2))
  (let ((result) (common))
    (do nil (nil)
      (cond ((null cycle1)
	     (if (null cycle2) (return nil))
	     ;; reconc is probably faster, this is safer.
	     (push (cons (caar cycle2) (invert-polarity (cdar cycle2))) result)
	     (pop cycle2))
	    ((null cycle2)
	     (push (cons (caar cycle1) (cdar cycle1)) result)
	     (pop cycle1))
	    ((< (var-id (caar cycle1)) (var-id (caar cycle2)))
	     (push (cons (caar cycle1) (cdar cycle1)) result)
	     (pop cycle1))
	    ((> (var-id (caar cycle1)) (var-id (caar cycle2)))
	     (push (cons (caar cycle2) (invert-polarity (cdar cycle2)))
		   result)
	     (pop cycle2))
	    ;; Now they must be =
	    ((not (eq (cdar cycle1) (cdar cycle2)))
	     (return-from sub-cycles nil))
	    (t (setq common t)
	       (pop cycle1) (pop cycle2))))
    (when (and common (check-cycle result))
      (setq result (nreverse result))
      (canonicalize-result result))))

;;**** no need to return result.
(defun construct-spanning-tree (node)
  (cond ((node-mark node) nil)
	(t (setf (node-mark node) :stack)
	   (mapc #'(lambda (to-node)
		     (case (node-mark (car to-node))
		       (:stack nil)
		       (:complete (construct-kvl-loop node (car to-node)) nil)
		       (t (setf (node-in-parent (car to-node)) node)
			  (construct-spanning-tree (car to-node)))))
		 (node-across-variables node)
		 )
	   (setf (node-mark node) :complete))))

;;; Edge from from to to is added to spanning graph.
;;; This is the easy case; not general yet.
(defun construct-kvl-loop (from to)
  ;; from is on stack.
  ;; to is not.
  (let ((cycle (list to)))
    (do ((parent (node-in-parent to) (node-in-parent parent)))
	((eq parent from) (push parent cycle))
      (cond ((null parent) (error "incomplete"))
	    (t (push parent cycle))))
    
    (push (construct-loop cycle) *cycles*)

    )
  )

;;; Need better algorithm.
;;; returns t if ok.
(defun check-cycle (pairs)
  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))
  (let ((single)
	(double))
    (dolist (pair pairs)
      (cond ((member (var-node+ (car pair)) double)
;	     (format t "~% Node ~a occurs > 2 times" (var-node+ (car pair)))
	     (return-from check-cycle nil))
	    ((member (var-node+ (car pair)) single)
	     (setq single (remove (var-node+ (car pair)) single))
	     (push (var-node+ (car pair)) double))
	    (t (push (var-node+ (car pair)) single)))
      (cond ((member (var-node- (car pair)) double)
;	     (format t "~% Node ~a occurs > 2 times" (var-node- (car pair)))
	     (return-from check-cycle nil))
	    ((member (var-node- (car pair)) single)
	     (setq single (remove (var-node- (car pair)) single))
	     (push (var-node- (car pair)) double))
	    (t (push (var-node- (car pair)) single))
	    ))
    (null single)))
    
      

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: modelica-operators.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: 8/11/2012
;;;;   Purpose: analogous models to systems using modelica operators
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Tuesday, December 17, 2013 at 17:34:12 by klenk
;;;; ----------------------------------------------------------------------------


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; The CombiTable1D is used by some models and results in different XML than temp interpolation 1

;Modelica.Blocks.Tables.CombiTable1D table1(table = [0,0;10,0;20,10;2000,10]) "if the input is below 10, then the output is 0. If the input is between 10 and 20 then the output is between 0 and 10 otherwise it is 10";

;; ;KNOWN VARIABLE IDS
;; ;Table arguments
;; kvar-13 = table1[1,1] = 0
;; kvar-12 = table1[1,2] = 0
;; kvar-11 = table1[2,1] = 10
;; kvar-10 = table1[2,2] = 0
;; kvar-9 = table1[3,1] = 20
;; kvar-8 = table1[3,2] = 10
;; kvar-7 = table1[4,1] = 2000
;; kvar-6 = table1[4,2] = 10

;; ;ORDERED VARIABLE IDS
;; var-6 = table1.u[1] = continuous input to the table
;; var-7 = table1.y[1] = continuous output from the table

;; ;EQUATIONS
;; Equation-1 : inertia1.J * inertia1.a = table1.y[1] - fixed1.flange.tau
;; Equation-2 : table1.u[1] = ramp1.offset + (if time < ramp1.startTime then 0.0 else if time < ramp1.startTime + ramp1.duration then (time - ramp1.startTime) * ramp1.height / ramp1.duration else ramp1.height)
;; Equation-3 : table1.y[1] = Modelica.Blocks.Tables.CombiTable1D.tableIpo(table1.tableID, table1.columns[1], table1.u[1])


;; ;;;;;;;;;;;;;;;;;;
;; What does this mean qualitatively?
;; - Consider only 2 column tables first.
;; - A table with n rows will have n-1 behaviors
;; - Each behavior is one of the following
;; - M+ : der(u[1]) = der(y[1]), y[1] - upper-landmark = Q-, y[1] - lower-landmark = Q+...
;; - M- : der(u[1]) = -der(y[1]), y[1] - upper-landmark = Q-, y[1] - lower-landmark = Q+...
;; - Fixed Output : y[1] - landmark = 0, u[1] - upper-landmark = Q-, u[1] - lower-landmark = Q+

;; Using explicit landmark variables, we would keep the input and output variables derivatives properly related, and we would be able to determine the interval of the value just using conditional equations. Unclear how to model across components...

(in-package :env2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; [08/21/2012 klenk] The code should migrate to construct constraints or something

(defparameter *modelica-fn-names* '("Modelica.Math.tempInterpol1"))
(defparameter *modelica-fns* '(:tempinterpol1))

(defun modelica-fn? (op)
  (member op *modelica-fns*))

(defun modelica-fn-constraint? (constraint)
  (interpolation-p constraint))

(defun output-var-changes (var changes)
  (let ((constraint (find-if #'modelica-fn-constraint? (var-uses var))))
    (ecase (type-of constraint)
      (interpolation (output-var-changes-for-interpolation var constraint changes))
      )))

(defun output-vals-violated-higher-order-continuity? (constraint parent sit)
  (some #'(lambda (var)
	    (assert (= (length (qualitative-values var parent))
		       (length (qualitative-values var sit)) 
		       1))
	    (and (eql (q-quantity-deriv (car (qualitative-values var sit))) 'Std)
		 (eql (q-quantity-deriv (car (qualitative-values var parent))) 'Std)
		 (every #'(lambda (gp)
			    (not (eql (q-quantity-deriv (car (qualitative-values var gp))) 'Std)))
			(situation-parents parent))))
	(output-vars-for-constraint constraint)))

(defun input-vars-for-constraint (constraint)
  (ecase (type-of constraint)
    (interpolation (list (interpolation-u constraint)))))

(defun output-vars-for-constraint (constraint)
  (ecase (type-of constraint)
    (interpolation (list (interpolation-y constraint)))))

(defun output-var-changes-for-interpolation (var constraint changes)
  (mapcar #'(lambda (change)
;; [05/02/2014 Johan] This creates duplicate transitions.
;	      (format t "~% Creating a trans for ~a from ~a for var ~a" var change (possible-transition-variable change))
	      (make-pos-trans 
	       var
	       nil ;; this is the result of a function, we don't care what the output is
	       (create-q-quantity-for-input constraint 
					    (possible-transition-new-value change))))
	  (remove-if-not #'(lambda (change)
			     (eql
			      (possible-transition-variable change)
			      (interpolation-u constraint)))
			 changes)))

(defun construct-constraints-for-modelica-fn (lhs rhs condition ics)
  (ecase (car rhs)
    (:tempinterpol1
     (construct-interpolation1 lhs rhs condition ics))
    
    ))




(defun handle-interpolation (constraint datum-or-trans-set)
  (if (or
       (null datum-or-trans-set)
       (datum-p datum-or-trans-set))
      (interpolation-datum constraint datum-or-trans-set)
      (interpolation-trans-set constraint datum-or-trans-set)))

(defun interpolation-datum (constraint datum)
  (when (eq (datum-type datum) :symbolic) (error "interpolate stub"))
  (let* ((sit (cell-situation (datum-cell datum)))
	 (u-vals (qualitative-values (interpolation-u constraint) sit))
	 (y-vals (qualitative-values (interpolation-y constraint) sit)))
    (setf (constraint-waiting constraint) nil)
    (cond ((and (= (length u-vals) 1)
		(= (length y-vals) 1)
		(fully-specified-qvalue? (car u-vals))
		(fully-specified-qvalue? (car y-vals)))
	   (vals-satisfy-interpolation? (car u-vals) (car y-vals) constraint))
	  ((and (= (length u-vals) 1)
		(null y-vals)
		(fully-specified-qvalue? (car u-vals)))
	   (set-y-value-from-input (car u-vals) constraint sit)))))

(defun set-y-value-from-input (u-val constraint sit)
    (let ((y-val (create-q-quantity-for-input constraint u-val)))	
    (clobber (interpolation-y constraint)
	     y-val
	     sit
	     '((:function)))))

(defun create-q-quantity-for-input (constraint u-val)
  (let ((entry (find (q-quantity-value u-val)
		     (interpolation-table constraint)
		     :key #'first :test #'equalp)))
    (assert entry)
    (create-q-quantity (interpolation-y constraint)
		       (second entry)
		       nil
		       (determine-output-deriv 
			(q-quantity-deriv u-val)
			(third entry)))))

(defun determine-output-deriv (input-deriv deriv-polarity)
  (cond ((eql deriv-polarity 'Std) 'Std)
	((eql deriv-polarity '-) (q-invert input-deriv))
	(t input-deriv)))

;; [06/ 5/2013 klenk] This should be expanded to allow y-val to be subset of 
;; [06/ 5/2013 klenk] y-val-for-input
(defun vals-satisfy-interpolation? (u-val y-val constraint)
  (let ((y-val-for-input (create-q-quantity-for-input constraint u-val)))
    (q-quantity-equal y-val y-val-for-input)))


(defun interpolation-trans-set (constraint trans-set)
  (vals-satisfy-interpolation? 
   (possible-transition-new-value 
    (find (interpolation-u constraint) trans-set :key #'possible-transition-variable))
   (possible-transition-new-value 
    (find (interpolation-y constraint) trans-set :key #'possible-transition-variable))
   constraint))
   
  


(defun construct-interpolation1 (result-var rhs condition ics)
  (assert (var-p result-var))
  (let ((array (third rhs)))
    (assert (and (arrayp array)
		 (= (length (array-dimensions array)) 2)
		 (= (cadr (array-dimensions array)) 2)))
    (cond ((= (car (array-dimensions array)) 1)
	   (construct-interpolation1-constant (array->list array) result-var condition))
	  ((numberp (second rhs))
	   (error "not done")
	   (construct-interpolation1-from-constant-input
	    (eliminate-qualitatively-redundant-rows 
	     (array->list
	      (replace-interpolation-array-with-reals array ics)))
	    (second rhs) result-var condition array))
	  (t
	   (construct-interpolation1-from-reduced-rows
	    (eliminate-qualitatively-redundant-rows 
	     (maybe-add-x-crossing
	      (array->list
	       (replace-interpolation-array-with-reals array ics))))
	    (second rhs) result-var condition array)
	   ))))

(defun maybe-add-x-crossing (lst)
  (assert (> (length lst) 1))
  (cond ((explicit-x-zero-in-table? lst) lst)
	((x-zero-in-table? lst)
	 (let* ((pos 
		 (position (find-if #'(lambda (elt) (> (car elt) 0)) lst)
			   lst :test #'equalp))
		(y (interpolate 
		    (nth (1- pos) lst)
		    (nth pos lst)
		    0))
		(tail (nthcdr (1- pos) lst)))
	   (rplacd tail
		   (cons (list 0 y)
			 (cdr tail)))))
	((x-zero-above-table? lst)
	 (let ((y (interpolate 
		   (nth (- (length lst) 2) lst)
		   (last lst)
		   0)))
	   (nconc lst (list (list 0 y)))))
	((x-zero-below-table? lst)
	 (let ((y (interpolate 
		   (car lst)
		   (second lst)
		   0)))
	   (nconc (list (list 0 y)) lst)))
	(t (error "x-zero not found"))))

(defun explicit-x-zero-in-table? (lst)
  (find 0 lst :key #'car :test #'=))

(defun x-zero-in-table? (lst)
  (and (< (caar lst) 0)
       (> (caar (last lst)) 0)))

(defun x-zero-above-table? (lst)
  (< (caar (last lst)) 0))

(defun x-zero-below-table? (lst)
  (> (caar lst) 0))

(defun interpolate (pt1 pt2 x)
  (+ (cadr pt2) 
     (* (slope pt1 pt2)
	(- x (car pt2)))))

(defun slope (pt1 pt2)
  (/ (- (cadr pt2)(cadr pt1))
     (- (car pt2)(car pt1))
     ))
    

(defun interpolation-equation? (eqn)
  (and (listp eqn) 
       (eq (car eqn) '=)
       (var-p (second eqn))
       (listp (third eqn))
       (interpolation-expression? (third eqn))))

(defun interpolation-expression? (exp)
  (eql (car exp) :tempinterpol1))

(defun replace-interpolation-array-with-reals (array ics)
  (let* ((array-ret (make-array (array-dimensions array))))
    (destructuring-bind (rows cols)
	  (array-dimensions array)
	(dotimes (row rows)
	  (dotimes (col cols)
	    (let ((value (third (find (car (aref array row col)) ics :key #'car))))
	      (assert (numberp value))
	      (setf (aref array-ret row col) value)))))
    array-ret))



;; [12/17/2013 klenk] Array is the modelica array of the table of variables that are 
;; [12/17/2013 klenk] fixed.  Assumes that the first col is the input and the second col
;; [12/17/2013 klenk] is the output. 
(defun construct-interpolation1-from-reduced-rows (rows input result condition array)
  (setf (var-output-var? result) t)
  (create-var-qspace-for-rows input (mapcar #'car rows))
  (create-var-qspace-for-rows result (mapcar #'cadr rows))
  (let ((constraint (make-interpolation :u input :y result :condition condition
					:id (new-id) :function #'handle-interpolation
					:table
					(enumerate-input-output-mapping 
					 rows input
					 )
					:symbolic-table array)))
    (push constraint (var-uses input))
    (push constraint (var-uses result))
    (record-constraint constraint condition)
    (setf (constraint-variables constraint) (list input result))
    constraint))

;; [06/ 6/2013 klenk] Single entry tables are constants
(defun construct-interpolation1-constant (rows result condition)
  (make-var-fixed result 'construct-interpolation1-constant)
  (construct-summer (list result)
		    (cadar rows)
		    condition 'construct-tempinterpol1)
;; [12/17/2013 klenk] Symbolic code works better with summers
  ;; (construct-qset (car (top-models)) result 
  ;; 		  (cond ((> (cadar rows) 0) '(Q0 Inf+))
  ;; 			((= (cadar rows) 0) 'Q0)
  ;; 			((< (cadar rows) 0) '(Inf- Q0)))
  ;; 		  condition
  ;; 		  nil)
  )


(defun construct-interpolation1-from-constant-input (rows input result condition array)
  (make-var-fixed result 'construct-interpolation1-constant-input)
  (break)

  
  )

;; [05/24/2013 klenk] ((0 2)(5 10)...) => 
;; [06/ 4/2013 klenk] (((-inf Q0)(-inf 2)  +)
;; [06/ 4/2013 klenk]  (Q0 2 +)
;; [06/ 4/2013 klenk]  ((Q0 5)(2 10) +)
;; [06/ 4/2013 klenk]  (5 10 STD)
;; [06/ 4/2013 klenk]  ...
(defun enumerate-input-output-mapping (rows input)
  (assert (apply #'< (mapcar #'car rows)))
  (let ((table (table-intervals-below (car rows)(second rows)))
	(last-entry (car rows)))
;; [06/ 4/2013 klenk] On each iteration, add the point from the previous row and then interval
    (dolist (row (cdr rows)
	       (sublis '((0 . Q0)) 
		       (add-entries-for-output-zero-crossings
			(reverse (add-table-intervals-above table last-entry))
			input)
		       :test #'equalp))
      (push (append last-entry (list 'Std))
	    table)
      (push 
       (cons (list (car last-entry)(car row))
	     (ecase (qualitative-dir (second last-entry) (second row))
	       (Inc (list (list (cadr last-entry)(cadr row)) '+))
	       (Std (list (cadr last-entry) 'Std))
	       (Dec (list (list (cadr row)(cadr last-entry)) '-))))
       table)
      (setf last-entry row))))

;; [06/ 6/2013 klenk] Output intervals must be computeable by interval->simpleq
;; [06/ 6/2013 klenk] (-5 5) needs to become three entries, (-5 0) 0 (0 5)
;; [06/ 6/2013 klenk] the input variable is need to modify its qspace
(defun add-entries-for-output-zero-crossings (table input)
  (let ((ret))
    (dolist (row table (reverse ret))
      (if (output-zero-crossing? row)
	  (let ((new-landmark (intern (format nil "LANDMARK-~A" (new-id)) :env2))
		(ul (caar row))
		(uu (cadar row))
		(yl (caadr row))
		(yu (cadadr row))
		(deriv (third row)))
	    (update-input-qspace ul new-landmark input)
	    (ecase deriv
	      (+ (push (list (list ul new-landmark)
			     (list yl 0)
			     deriv)
		       ret)
		 (push (list new-landmark 0 deriv) ret)
		 (push (list (list new-landmark uu)
			     (list 0 yu)
			     deriv)
		       ret))
	      (- (push (list (list ul new-landmark)
			     (list 0 yu)
			     deriv)
		       ret)
		 (push (list new-landmark 0 deriv) ret)
		 (push (list (list new-landmark uu)
			     (list yl 0)
			     deriv)
		       ret))))
	  (push row ret)))))

(defun update-input-qspace (l-before new-landmark var)
  (let* ((l-before (if (equalp 0 l-before) 'Q0 l-before))
	 (pos (1+ (position l-before (car (var-qspaces var)) :test #'equalp))))
#+clozure    (setf (nthcdr pos (car (var-qspaces var)))
	       (cons new-landmark (nthcdr pos (car (var-qspaces var)))))
#+allegro (setf-nthcdr pos (car (var-qspaces var))
		       (cons new-landmark (nthcdr pos (car (var-qspaces var)))))
    (var-qspaces var)))

;;; (setf (nthcdr pos old) new) in CCL.
(defun setf-nthcdr (pos old new)
  (cond ((= 0 pos) new)
	(t (let ((tail (nthcdr (1- pos) old)))
	     (cond (tail (rplacd tail new))
		   (t (error "nthcdr nil")))))))



(defun output-zero-crossing? (row)
  (let ((output-val (second row)))
    (and (interval? output-val)
	 (or (and (positive-table-val? (second output-val))
		  (negative-table-val? (first output-val)))
	     (and (positive-table-val? (first output-val))
		  (negative-table-val? (second output-val)))))))

(defun positive-table-val? (val)
  (or (and (numberp val)
	   (> val 0))
      (eq val 'Inf+)))

(defun negative-table-val? (val)
  (or (and (numberp val)
	   (< val 0))
      (eq val 'Inf-)))


(defun add-table-intervals-above (table last-row)
  (let* ((deriv-polarity (third (car table)))
	 (output-interval (extrapolate-output-interval-above deriv-polarity (second last-row))))
    (push (append last-row (list deriv-polarity)) table)
    (cond ((or (> (car last-row) 0)
	       (= (car last-row) 0))
	   (push (list (list (car last-row) 'Inf+)
		       output-interval
		       deriv-polarity)
		 table))
	  (t 
	   (push (list (list (car last-row) 0) output-interval deriv-polarity) table)
	   (push (list 0 output-interval deriv-polarity) table)
	   (push (list (list (car last-row) 'Inf+) output-interval deriv-polarity) table)))
  table))


;; [06/ 4/2013 klenk] this will generate the mappings for all the input intervals before row1
(defun table-intervals-below (row1 row2)
  (let* ((dir (qualitative-dir (second row1)(second row2)))
	 (output-interval (extrapolate-output-interval-below dir (second row1)))
	 (deriv-polarity (deriv-polarity dir)))
    (cond ((or (< (car row1) 0)
	       (= (car row1) 0))
	   (list 
	    (list (list 'Inf- (car row1))
		  output-interval
		  deriv-polarity)))
	  (t 
	   (list 
	    (list (list 0 (car row1))
		  output-interval deriv-polarity)
	    (list 0 output-interval deriv-polarity)
	    (list  
	     (list 'Inf- 0)
	     output-interval deriv-polarity))))))

(defun deriv-polarity (qualitative-dir)
      (ecase qualitative-dir
	(Inc '+)
	(Std 'Std)
	(Dec '-)))

;; [06/ 5/2013 klenk] This dir is generated by qualitative-dir
(defun extrapolate-output-interval-below (dir y)
  (ecase dir
    (Inc (list 'Inf- y))
    (Std y)
    (Dec (list y 'Inf+))))

;; [06/ 5/2013 klenk] dir is read from the table
(defun extrapolate-output-interval-above (dir y)
  (ecase dir
    (- (list 'Inf- y))
    (Std y)
    (+ (list y 'Inf+))))




;; [05/24/2013 klenk] Assumes that var only has one qspace and it is simple
(defun create-var-qspace-for-rows (var landmarks)
  (let* ((landmarks (sort (remove-duplicates landmarks) #'<))
	 (negs (remove-if-not #'(lambda (num) (< num 0)) landmarks))
	 (pos (remove-if-not #'(lambda (num) (> num 0)) landmarks)))
    (assert (and (= (length (var-qspaces var)) 1)
		 (simpleqspace? (car (var-qspaces var)))))
    (setf (var-qspaces var)
	  (list (append '(Inf-)
			negs
			'(Q0)
			pos
			'(Inf+))))))

(defun array->list (array)
  (let (ret)
    (destructuring-bind (rows cols)
	(array-dimensions array)
      (declare (ignore cols))
      (dotimes (row rows (reverse ret))
	(push (list (aref array row 0)
		    (aref array row 1))
	      ret)
	))))
	       
(defun eliminate-qualitatively-redundant-rows (table)
;  (format t "~% table : ~A" table)
  (let ((ret-table (list (car table)))
	(dir nil)
	(last-entry nil))
    (dolist (row (cdr table)
	     (if last-entry 
		 (reverse (push last-entry ret-table))
		 ret-table))
;      (format t "~%------- ~%  ret-table : ~a ~%  last-entry : ~a ~% dir : ~a ~% row : ~a" ret-table last-entry dir row) 
      (cond ((null last-entry)
	     (setf last-entry row
		   dir (qualitative-dir (second (car ret-table)) (second row))))
	    ((eql dir (qualitative-dir (second last-entry) (second row)))
	     (setf last-entry row))
	    (t 
	     (push last-entry ret-table)
	     (setf last-entry row dir (qualitative-dir (second last-entry) (second row))))
	    ))))


(defun qualitative-dir (n1 n2)
  (cond ((= n1 n2) 'Std)
	((> n1 n2) 'Dec)
	((< n1 n2) 'Inc)))

;;;;;;;
;;; lisp implementation of the modelica table function

;; function tempInterpol1 "Temporary function for linear interpolation (will be removed)"
;;   extends Modelica.Icons.Function;
;;   extends Modelica.Icons.ObsoleteModel;
;;   input Real u "input value (first column of table)";
;;   input Real table[:,:] "table to be interpolated";
;;   input Integer icol "column of table to be interpolated";
;;   output Real y "interpolated input value (icol column of table)";
;; protected
;;   Integer i;
;;   Integer n "number of rows of table";
;;   Real u1;
;;   Real u2;
;;   Real y1;
;;   Real y2;
;; algorithm
;;   n:=size(table, 1);
;;   if n <= 1 then 
;;     y:=table[1,icol];
;;   else
;;     if u <= table[1,1] then 
;;       i:=1;
;;     else
;;       i:=2;
;;       while (i < n and u >= table[i,1]) loop
;;               i:=i + 1;
;;       end while;
;;       i:=i - 1;
;;     end if;
;;     u1:=table[i,1];
;;     u2:=table[i + 1,1];
;;     y1:=table[i,icol];
;;     y2:=table[i + 1,icol];
;;     assert(u2 > u1, "Table index must be increasing");
;;     y:=y1 + ((y2 - y1) * (u - u1)) / (u2 - u1);
;;   end if;
;;   // Search interval
;;   // Supports duplicate table[i, 1] values
;;   // in the interior to allow discontinuities.
;;   // Interior means that
;;   // if table[i, 1] = table[i+1, 1] we require i>1 and i+1<n
;;   // Get interpolation data
;;   // Interpolate
;;   annotation(Documentation(info = "<html>

;; </html>"));
;; end tempInterpol1;

(defun modelica-tempinterpol1 (u table icol)
  "u is a REAL, table is a 2D array of REALS, icol is modelica the colomn being computed which means we need the indexes are off"
  (let ((icol (1- icol))
	(size (car (array-dimensions table))))
    (if (<= size 1)
	(aref table 0 icol)
	(do ((i 1 (1+ i)))
	    ((or (< i size)
		 (>= u (aref table i 0)))
	     (+ (aref table (1- i) icol)
		(/ (* (- (aref table i icol)
			 (aref table (1- i) icol))
		      (- u 
			 (aref table (1- i) 0)))
		   (- (aref table i 0)
		      (aref table (1- i) 0)))))))))
;;;;  Modified: Thursday, September 26, 2013 at 12:22:31 by klenk
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: omc.lisp
;;;;    System: PARC QM Envisioner, v2
;;;;    Author: Bill Janssen
;;;;   Created: 2/7/2012
;;;;   Purpose: Run OMC to generate the CSV file for the simulation of a model,
;;;;            and return the filename of the CSV file
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(proclaim '(special *temporary-directory*))

(defun run-shell-command (control-string args &key env directory)
  "Interpolate ARGS into CONTROL-STRING as if by FORMAT, and
synchronously execute the result using a Bourne-compatible shell, with
output to ASDF:*VERBOSE-OUT*.  Returns the shell's exit code.
If ENV is provided, it should be an alist of VAR/VALUE pairs to
put in the environment before executing the subprocess.

If ENV is specified, it should be an alist that will be added to the
environment of the process before the command is run.  If DIRECTORY is
specified, it should be a directory to make the 'current directory'
before the command is run."

  (let ((command (apply 'format nil control-string args)))
                                        ; (format t "Command: ~A, Env: ~A~%" command env)
    #+clozure
    (let* ((program (cond
                      ((asdf::os-unix-p) "/bin/sh")
                      ((asdf::os-windows-p) (asdf::strcat "CMD /C " command)) ; BEWARE!
                      (t (error "Unsupported OS"))))
           (program-args 
            (if (asdf::os-unix-p)
                (list "-c" (if directory
                               (concatenate 'string (format nil "cd ~S && " (namestring directory)) command)
                               command))
                '()))
           (result (nth-value 1 (ccl:external-process-status
                                 (ccl:run-program program program-args
                                                  :input nil :output asdf:*verbose-out* :wait t
                                                  :env env))))
           )
      (format t "~%Command ~S, env ~S, result ~S~%" (cons program program-args) env result)
      result
      )

    #+allegro
;    (let ((result (excl::run-shell-command  command :environment env :directory directory)))
    (let ((result (excl::run-shell-command  command)))

      (format t "~%Command ~S, env ~S, result ~S~%" command env result)

;      (error "foo")
      result
      )
    
    #-(or clozure allegro)
    (error "please port run-shell-command to this Lisp environment")
    ))

(defun process-libraries-list (libs openmodelicahome)
  (let* ((openmodelicahome (if  openmodelicahome openmodelicahome (asdf::getenv "OPENMODELICAHOME")))
	 (additional-library-directories
	  (if libs
	      (cond 
          ((asdf::getenv "OPENMODELICALIBRARY")
            (list (asdf::getenv "OPENMODELICALIBRARY")))
          ((pathnamep openmodelicahome)
		        (list (namestring (merge-pathnames  (pathname "lib/omlibrary/")
							openmodelicahome))))
		      ((stringp openmodelicahome)
		        (list (namestring (merge-pathnames (pathname "lib/omlibrary/")
							(pathname openmodelicahome)))))
		      (t
		        (error "keyword OPENMODELICAHOME must be specified if libraries are used")))))
	 libraries
	 file-names)
  (dolist (lib libs)
      (if (and (stringp lib)(string= lib "Modelica"))
	  (push (list lib) libraries)
	  (cond ((and (stringp lib) (string-ends-with lib ".mo"))
		 (push (truename lib) file-names))
		((and (pathnamep lib) (string-ends-with (namestring lib) ".mo"))
		 (push lib file-names))
		((probe-file (truename lib))
		 (print lib)
		 (if (asdf::directory-pathname-p (probe-file lib))
                 ;; we need to handle this insane idea of naming the library directories "foo 1.3"
		     ;; (which of course lisp sees as a file called "foo 1" with an extension of "3")
		     ;; Is there even a way to get this name back out of a Lisp pathname?  ASDF.
		     
;; [09/03/2013 klenk] component-name-to-pathname-components has annoying windows deals
;		     (multiple-value-bind (ftype directory basename)
;			 (asdf::component-name-to-pathname-components (namestring lib))
;		       (declare (ignore ftype basename))
		     (let ((directory (cdr (pathname-directory lib))))
		       (let ((parent (cons :absolute (reverse (cdr (reverse directory)))))
			     (basename (car (last directory))))
			 (multiple-value-bind (matchstring matches)
                         (cl-ppcre:scan-to-strings "^([^ ]*) ([0-9.]+)$" basename)
                       (push (namestring (truename (make-pathname :directory parent)))
                             additional-library-directories)
		       (if matchstring
                           ;; library with version
                           (push (cons (elt matches 0) (elt matches 1)) libraries)
                           ;; library directory without version
		           (push (last directory) libraries)))))
                 ;; simple file, no doubt containing Modelica code
                 (push lib file-names)
                 ))
            (t (error "library ~S must be either pathname or string" lib)))))
  (values
   (if additional-library-directories
       (let ((skimmed (remove-duplicates additional-library-directories :test #'string-equal)))
         ;; should just be using 'substitute' in the next clause, but it doesn't seem to work on CCL!
         #+(or :mswindows :WINDOWS) (substitute-if #\/ #'(lambda (x) (eql x #\\)) (format nil "~{~A~^;~}" skimmed))
         #-(or :mswindows :WINDOWS) (format nil "~{~A~^:~}" skimmed)
         ))
   file-names libraries)
  ))

(defun figure-openmodelica-binary-and-home (omcbinary openmodelicahome)
  (cond ((and omcbinary openmodelicahome)
         (values omcbinary openmodelicahome))
        ((not (null omcbinary))
         (values
          omcbinary
         (namestring (make-pathname
                      :directory
                      ;; we need the parent of the binary's directory
                      (reverse (cdr (reverse (pathname-directory (pathname omcbinary)))))))))
        ((and (not (null openmodelicahome)) (probe-file (truename openmodelicahome)))
         (values
          (namestring (merge-pathnames (pathname "bin/omc") (pathname openmodelicahome)))
          openmodelicahome))
	((and (null openmodelicahome)(asdf::getenv "OPENMODELICAHOME")
	      (probe-file (asdf::getenv "OPENMODELICAHOME")))
	 (values 
	  (namestring (merge-pathnames (pathname "bin/omc") 
				       (probe-file (asdf::getenv "OPENMODELICAHOME"))))
	  (asdf::getenv "OPENMODELICAHOME")))
        (t
         (values nil nil))))

(defun form-environment-variables (libdirs openmodelicahome)
  "LIBDIRS should be a string containing a SEPARATOR-separated list of directories,
   where SEPARATOR is ; on Windows and : on other platforms.  OPENMODELICAHOME,
   if specified, should be a string giving the location of the OpenModelica root
   directory."
  (assert (or (null libdirs) (stringp libdirs)))
  (assert (or (null openmodelicahome) (stringp openmodelicahome)))
;  (error "foo2")
  (let (vars)
    (if openmodelicahome (push (cons "OPENMODELICAHOME" openmodelicahome) vars))
    (if libdirs (push (cons "OPENMODELICALIBRARY" libdirs) vars))
    vars))



(defun shell-successful? (result)
  "Return T if RESULT indicates successful subprocess execution on
              this platform, NIL otherwise."
  (declare (ignore result))
  ;; may want to change this on Windows?
;; [11/13/2013 klenk] linux is also returning result 2 even when successful.
;; [11/13/2013 klenk] Thus we are ignoring the error code for the time being
					;(= 0 result)
  t)


(defun omc-csv (modelfile modelname 
		&key
                omcbinary params-lists openmodelicahome directory specified-result-filename
		(libraries)
		(output-format "csv")
		(start-time 0)
		(stop-time 1)
		(step-size .002)
                (callback nil)
		)


"If PARAMS-LISTS is specified, things work somewhat differently.  PARAMS-LISTS
should be an list of simulation specs, each spec consisting of an alist of
 (NAME . VALUE) pairs, where NAME is the name of a Modelica parameter
or constant, and VALUE is a value to try for that parameter or
constant.  Before the simulation is run, the MODELNAME_init.xml file
is read, and the value for any Modelica parameter (or Modelica
constant) named NAME will be replaced by each possible value for that
NAME.  In this case, the return value from omc-csv is a list
of (((NAME . VALUE)...) RESULT-FILENAME) triples, where the
RESULT-FILENAME will be gensymed.  if SPECIFIED-RESULT-FILENAME is
given, it will be used as a prefix to each value of RESULT-FILENAME. 

CALLBACK is function which will be called as the omc-csv process
proceeds.  It should take two parameters, a MODE-NAME string and
a PERCENT-DONE float."

  ;; check to make sure the model file exists
  (labels ((successful? (result)
             "Return T if RESULT indicates successful subprocess execution on
this platform, NIL otherwise."
             ;; may want to change this on Windows?
             (= 0 result))

           (replace-attribute (xmls-val attrname attrval)
             "Destructively replace the value of ATTRNAME in XMLS-VAL with
the value ATTRVAL.  XMLS-VAL has the form (TAG ATTRS CHILDREN...), where
ATTRS has the form ((NAME VALUE)...)."
             (let* ((attrs (second xmls-val))
                    (attr-position (position-if #'(lambda (x) (equal attrname (car x))) attrs)))
               (if attr-position
                   (setf (elt attrs attr-position) (list attrname attrval))
                   (push (list attrname attrval) attrs))
               ))

           (replace-param-value (xmls-parse param-name param-value)
             "In the s-expr XMLS-PARSE of an omc _init.xml file, find the parameter
PARAM-NAME, and replace its value with the specified PARAM-VALUE.
Returns the modified XMLS-PARSE."
             ;; TODO
             (let ((variables (xmls:xmlrep-find-child-tag "ModelVariables" xmls-parse)))
               (dolist (var (xmls:xmlrep-find-child-tags "ScalarVariable" variables))
                 (if (and (equal param-name (xmls:xmlrep-attrib-value "name" var nil))
                          (xmls:xmlrep-find-child-tag "Real" var))
                     (let ((var-val (xmls:xmlrep-find-child-tag "Real" var)))
                       ; (format t "~S~%" var-val)
                       (replace-attribute var-val "start" (format nil "~S" param-value))
                       (replace-attribute var-val "useStart" "true")
                       (replace-attribute var-val "useNominal" "false")
                       (replace-attribute var-val "fixed" "true")
                       ; (format t "~S~%" var-val)
                       ))))
             xmls-parse)
           )
    
  (if (not modelfile)
      (let ((newfile (get-tempfile-pathname :extension "mo")))
        (with-open-file (stream (open newfile :direction :output :if-exists :supersede :if-does-not-exist :create))
          (close stream))
        (setq modelfile newfile)))
  (assert (probe-file modelfile))

  (let ((simulation-directory (or directory *temporary-directory*)))
      (multiple-value-bind (library-paths file-names library-names)
          (process-libraries-list libraries openmodelicahome)
	(multiple-value-bind (omcbinary openmodelicahome)
	    (figure-openmodelica-binary-and-home omcbinary openmodelicahome)
        (let ((results-filename (or specified-result-filename (concatenate 'string modelname ".results." output-format)))
              (env-vars (form-environment-variables library-paths openmodelicahome))
              (simulation-filename (namestring (merge-pathnames simulation-directory
                                                                (make-pathname :name modelname))))
              (library-just-names (mapcar #'car library-names)))
          (if (not (find "Modelica" library-just-names :test #'string-equal))
              (push '("Modelica") library-names))
          (if (not (find "ModelicaServices" library-just-names :test #'string-equal))
              (push '("ModelicaServices") library-names))
          (when
              ;; successful generation of simulation code
              (and (shell-successful?
                    (progn
                      (if callback (funcall callback "generating simulation code" -1))
                      (run-shell-command "~a +s +i=~a ~a ~a"
                                         (list (or omcbinary "omc") modelname modelfile 
                                               (if (or library-names file-names)
                                                   (format nil "~{~A~^ ~}"
                                                           (concatenate
                                                            'list
                                                            (mapcar #'car library-names)
                                                            (mapcar #'namestring file-names)))
                                                   ""))
                                         :env env-vars
                                         :directory simulation-directory)))
                   (shell-successful?
                    (progn
                      (if callback (funcall callback "building executable" -1))
                      (run-shell-command "make -f ~a.makefile" (list modelname)
                                         :directory simulation-directory))))

            (if params-lists
                ;; modify specified parameters
                (let ((init-filename (concatenate 'string simulation-filename "_init.xml")))
                  (let ((init-parse (xmls:parse (open init-filename)))
                        (results nil)
                        (counter 0)
                        (mode (format nil "running ~A simulations" (length params-lists))))
                    (if init-parse
                        ;; modify the xml here...
                        (dolist (params-list params-lists)
                          (if callback (funcall callback mode (float (/ (* 100 (float counter)) (length params-lists)))))
                          (incf counter)
                          (let ((init-parse-copy (copy-tree init-parse)))
                            (dolist (param-value params-list)
                              (replace-param-value init-parse-copy (car param-value) (cdr param-value)))
                            ;; now write it out again...
                            (let ((output-stream (open init-filename :direction :output :if-exists :supersede)))
                              (xmls:write-xml init-parse-copy output-stream)
                              (close output-stream))
                            (let ((results-filename
                                   (concatenate 'string (symbol-name (gensym (or specified-result-filename ""))) "." output-format)))
                              (if (shell-successful? 
                                   (run-shell-command
                                    "~a -emit_protected -r=~a -override outputFormat=~a,startTime=~A,stopTime=~A,stepSize=~A"
                                    (list simulation-filename results-filename output-format
                                          start-time stop-time step-size)
                                    :directory simulation-directory))
                                  ;; when successful, return the pathname for the csv file
                                  (push (list params-list (truename (merge-pathnames simulation-directory
                                                                                     (make-pathname :name results-filename)))) results))
                              ))))
                    results))

                ;; else just build the simulation program and run it
                (progn
                  (if callback (funcall callback "running simulation" 0.0))
                  (if (shell-successful? (run-shell-command "~a -emit_protected -r=~a -override outputFormat=~a,startTime=~A,stopTime=~A,stepSize=~A"
                                                            (list simulation-filename results-filename
                                                                  output-format
                                                                  start-time stop-time step-size)
                                                            :directory simulation-directory))
                      ;; when successful, return the pathname for the csv file
                      (truename (merge-pathnames simulation-directory (make-pathname :name results-filename))))
                  )))))))))


(defun omc-simulate (modelname 
                     &key
                     (omcbinary)
                     (openmodelicahome)
                     (directory)
                     (specified-result-filename)
                     (libraries)
                     (output-format "csv")
                     (start-time 0)
                     (stop-time 1)
                     (step-size .002)
                     (clean-up? t)
                     )

  "Run OpenModelica's 'omc' program produce a simulator for the model
MODELNAME.  Run that simulator to produce a csv file, and return the
pathname of that csv file.  If OMCBINARY is specified, it is used;
otherwise it is assumed that the omc binary is on your execution
'path'.  By default, the result file produced is called
MODELNAME.results.csv; you can override that default by setting
SPECIFIED-RESULT-FILENAME to the desired filename.  If the key
OPENMODELICAHOME is provided, it should be the path to the 'home'
directory for OpenModelica, that is, the directory where the 'bin',
'lib', and other such subdirectories are to be found.  If the key
DIRECTORY is specified, it should be a directory to put all the
simulation and result files in.  LIBRARIES is a list of either library
names or full pathnames that specifies additional libraries to add.
If LIBRARIES is specified, OPENMODELICAHOME must also be specified.
OUTPUT-FORMAT can be changed to mat if desired.
"

    ;; OpenModelica doesn't really let you specify an output directory
    ;; or a pathname for the simulation results.  It will generate the
    ;; C program in whatever directory happens to be cwd, and the
    ;; output file will be in that directory, with the name
    ;; "<fileNamePrefix>_res.<outputFormat>".

    (assert (or (null directory) (pathnamep directory)))
    (let ((simulation-directory (ensure-directories-exist (or directory *temporary-directory*))))
      (multiple-value-bind (omcbinary openmodelicahome)
          (figure-openmodelica-binary-and-home omcbinary openmodelicahome)
        (multiple-value-bind (library-paths file-names library-names)
            (process-libraries-list libraries openmodelicahome)
          (let ((script-file (get-tempfile-pathname :extension "mos"))
                (output-file (or specified-result-filename
				 (symbol-name (gensym))))
                (env-vars (form-environment-variables
                           library-paths openmodelicahome))
                )
            (with-open-file (fp script-file :direction :output :if-exists :supersede :if-does-not-exist :create)
              (format fp "echo(false);~%")
              (if library-paths
                  (format fp "setModelicaPath(\"~A~A\"+getModelicaPath());~%"
                          library-paths
                          #+(or :mswindows :WINDOWS) ";"
                          #-(or :mswindows :WINDOWS) ":"
                          ))
              (mapc #'(lambda (x)
                        (format fp "loadModel(~A);~%" (car x)))
                    library-names)
              (mapc #'(lambda (x)
                        (format fp "loadFile(~S);~%" (namestring x)))
                    file-names)
              (format fp "cd(~S);~%" (namestring simulation-directory))
	      (format fp "simulate(~A,fileNamePrefix=~S,simflags=\"-emit_protected -override ~A~A~A,outputFormat=~A\");"
		      modelname output-file 
                      (if start-time (format nil "startTime=~,5F" start-time) "")
                      (if stop-time (format nil ",stopTime=~,5F" stop-time) "")
                      (if step-size (format nil ",stepSize=~,5F" step-size) "")
                      output-format)

              (format fp "print(getErrorString());~%")
              )
            (run-shell-command "~a ~a" (list (or omcbinary "omc") script-file)
                               :env env-vars :directory simulation-directory)
            (when clean-up? (delete-file script-file))
            (let ((results-file
                   (merge-pathnames (concatenate 'string output-file "_res." output-format)
                                    simulation-directory)))
              (when (probe-file results-file)
                results-file))
            )))))

(defun omc-initial-values (modelname 
                           &key
                           (omcbinary)
                           (openmodelicahome)
                           (libraries)
                           (start-time 0)
			   (stop-time 1)
                           (clean-up? t)
                           )

  "Run OpenModelica's 'omc' program produce a simulator for the model
MODELNAME.  Run that simulator to produce a csv file, and return the
pathname of that csv file.  If OMCBINARY is specified, it is used;
otherwise it is assumed that the omc binary is on your execution
'path'.  By default, the result file produced is called
MODELNAME.results.csv; you can override that default by setting
SPECIFIED-RESULT-FILENAME to the desired filename.  If the key
OPENMODELICAHOME is provided, it should be the path to the 'home'
directory for OpenModelica, that is, the directory where the 'bin',
'lib', and other such subdirectories are to be found.  If the key
DIRECTORY is specified, it should be a directory to put all the
simulation and result files in.  LIBRARIES is a list of either library
names or full pathnames that specifies additional libraries to add.
If LIBRARIES is specified, OPENMODELICAHOME must also be specified.
OUTPUT-FORMAT can be changed to mat if desired.
"

  (let ((filename (omc-simulate modelname
                                :libraries libraries
                                :omcbinary omcbinary
                                :openmodelicahome openmodelicahome
                                :start-time start-time
                                ;:stop-time start-time
				:stop-time stop-time
                                :output-format "csv"
                                :clean-up? clean-up?)))
    (labels
        ((remove-empty (l)
           (remove-if #'(lambda (x) (or (null x) (and (stringp x) (= (length x) 0)))) l)))
      (when filename
	(with-open-file (fp filename :direction :input)
	  (let* ((names (remove-empty (csv-parser:read-csv-line fp)))
		 (values (remove-empty (csv-parser:read-csv-line fp))))
	    (values (mapcar #'(lambda (name value) (cons name (read-from-string value))) names values)
		    filename))))
      )))




(defun omc-get-xml-dae (modelfile modelname
                        &key
                        (libraries nil)
                        (omcbinary nil)
                        (openmodelicahome nil)
                        (clean-up? t)
                        (check-output? t)
                        (stage nil)
                        (rewrites nil)
                        (output-file nil))

  "OpenModelica's 'omc' program to dump an xml version of the DAE for MODELNAME.
Optionally, load the specified LIBRARIES and FILES before attempting
to form the DAE for the model.  If OMCBINARY is specified, use that
instead of looking for the 'omc' program on the PATH environment
variable.  If OPENMODELICAHOME is specified, it will be so defined in
the environment 'omc' is executed in.  LIBRARIES may be a list of
either pathnames or string truenames.  If LIBRARIES is specified,
OPENMODELICAHOME must also be specified.  STAGE is a parameter to the
XML dump routine.  We've been using 'optimiser', but the default is
now 'backEnd'; use 'optimiser' to get the old behavior.  Other
possible values are 'flat' and 'stateSpace'.  REWRITES is a file
containing rewrite rules; see rewrite_rules.txt for an example.

Returns the pathname for the resulting xml file, if successful, nil otherwise."

  (unless (or (null modelfile) (probe-file modelfile)) (error "Model file ~A does not exist!" modelfile))
  (unless (or (null rewrites) (probe-file rewrites)) (error "Rewrites file ~A does not exist!" rewrites))

  (multiple-value-bind (omcbinary openmodelicahome)
      (figure-openmodelica-binary-and-home omcbinary openmodelicahome)
    (multiple-value-bind (library-paths file-names library-names)
        (process-libraries-list libraries openmodelicahome)
      (let ((script-file (namestring (merge-pathnames (make-pathname :name (symbol-name (gensym))
                                                                     :type "mos")
                                                      *temporary-directory*)))
            (xml-file (namestring (merge-pathnames (symbol-name (gensym)) *temporary-directory*)))
            (env-vars (form-environment-variables library-paths openmodelicahome))
            (stage-name (or stage "optimiser"))
            )
        (with-open-file (fp script-file :direction :output :if-exists :supersede :if-does-not-exist :create)
;          (format fp "echo(false);~%")
          (if library-paths
              (format fp "setModelicaPath(\"~A~A\" + getModelicaPath());~%"
                      library-paths
                      #+(or :mswindows :WINDOWS) ";"
                      #-(or :mswindows :WINDOWS) ":"
                      ))
          (mapc #'(lambda (x)
                    (format fp "loadModel(~A);~%" (car x)))
                library-names)
          (mapc #'(lambda (x)
                    (format fp "loadFile(~S);~%" (namestring x)))
                file-names)
          (if modelfile (format fp "loadFile(~S);~%" (namestring modelfile)))
          (format fp "cd(~S);~%" (namestring *temporary-directory*))
          (if rewrites
              (format fp "dumpXMLDAE(~A,\"~A\",addMathMLCode=true,fileNamePrefix=~S,rewriteRulesFile=~S);~%"
                      modelname stage-name (namestring xml-file) (namestring rewrites))
              (format fp "dumpXMLDAE(~A,\"~A\",addMathMLCode=true,fileNamePrefix=~S);~%"
                      modelname stage-name (namestring xml-file)))
          (format fp "print(getErrorString());~%")
          )
        (let ((xml-file (merge-pathnames (pathname xml-file) (make-pathname :type "xml"))))
          (run-shell-command "~a ~a" (list (or omcbinary "omc") script-file) :env env-vars :directory *temporary-directory*)
          (when clean-up? (delete-file script-file))
          (when (and check-output? 
                     (probe-file xml-file))
            ;; (let ((err-msg (om-xml-errors? (xmls:parse (open xml-file)))))
            ;;   (when err-msg (format t err-msg)))
            )
          (if (probe-file xml-file)
              (if output-file
                  (progn (run-shell-command "cp ~A ~A" (list xml-file output-file))
                         output-file)
                  (truename xml-file))
              (progn
                ;(break "What's up with the output-file: ~S" output-file)
                (format t "~% Probe-file of ~A failed. No XML produced" xml-file))
                )
          )))))


;; (defun print-om-xml-errors (xml-file &optional (stream *standard-output*)) 
;;   (let* ((tree (xmls:parse (open xml-file)))
;; 	 (ccl::*read-default-float-format* 'double-float)
;; 	 (errors (om-xml-errors? tree)))
;;     (if errors
;; 	(format stream errors)
;; 	(format stream "~%No xml->QRM tranlsation problems detected"))))

(defun print-om-xml-errors (xml-file &optional (stream *standard-output*)) 
  (declare (special *exception-log-file*))
  (let* ((tree (xmls:parse (open xml-file)))
#+CCL	 (ccl::*read-default-float-format* 'double-float)
#+allegro (*read-default-float-format* 'double-float)
         (*exception-log-file*
          (open "errors.log" :if-exists :supersede :direction :output)))
    (handler-case
        (interpret-openmodelica-xml tree nil)
      (condition (c)
        (format stream "~&Error analysis terminated prematurely due to uncaught error ~A~%" c)
        (format stream "Before that, the following errors were identified:~%")))
    (close *exception-log-file*)
    (with-open-file (fp "errors.log" :direction :input)
      (do ((line (read-line fp nil 'eof)
                 (read-line fp nil 'eof)))
          ((eq line 'eof))
        (format stream "~&~A~%" line)
        ))))




;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-

;;;; ----------------------------------------------------------------------------

;;;; File name: qualitative-abstractor.lisp

;;;;    System: 

;;;;    Author: klenk

;;;;   Created: January 11, 2013 14:27:48

;;;;   Purpose: This file includes utilities to take a CSV file from modelica and 

;; [01/11/2013 klenk] determine the sequence of qualitative values of the variables

;; [01/11/2013 klenk] and map them into the envisionment for the system

;;;; ----------------------------------------------------------------------------

;;;;  Modified: Tuesday, September 24, 2013 at 12:01:57 by klenk

;;;; ----------------------------------------------------------------------------



(in-package :env2)



;; [02/26/2013 klenk] This is used for the csv-guided envisionment

;; [01/21/2013 klenk] This won't work if multiple situations match the qstate, but that shouldn't be possible

;; [01/21/2013 klenk] the first value is an index of the current qstate

(defun add-csv-filter-information (file system)

  (setf (system-match-qstates system)

;; [04/10/2014 klenk] we do not want to deal with the initial state.

	(cons 2 (abstract-qstates-for-system file system)))

  system)



;; [02/26/2013 klenk] Given a full envisionment traces trajectories

;; [02/26/2013 klenk] Returns the trajectory in the system corresponding to the CSV

;; [02/27/2013 klenk] Returns :unknown-trajectory if the trajectory is not found

(defun csv-trajectory-in-envisionment (csv system)

  (catch :unknown-trajectory 

    (qstates-trajectory-in-envisionment 

     ;; [02/26/2013 klenk] Determining the initial derivs is hard, thus we start in the interval

     (cdr (abstract-qstates-for-system csv system)) 

     (add-children (system-initial-situations system)))))



(defun add-children (sits)

  (mapcan #'(lambda (sit)

	      (cons sit (situation-children sit)))

	  sits))





(defun qstates-trajectory-in-envisionment (qstates sits)

  (let ((sit (when (and qstates (listp (car qstates))) 

	       (find-if #'(lambda (sit) (qstate-matches-sit? (car qstates) sit))

			sits))))

    (debug-print nil "~% num-qstates: ~A qstate: ~A sit: ~A sits: ~A" 

		 (length qstates) (car qstates) sit sits)

    (cond ((null qstates) nil)

	  ((member (car qstates) '(:start-event :end-event))

	   (qstates-discrete-trajectory-in-envisionment qstates sits))

	  (sit

	   (cons sit 

		 (qstates-trajectory-in-envisionment 

		  (cdr qstates)

		  (situation-children sit))))

	  (t 

	   (throw :unknown-trajectory :unknown-trajectory)))))







(defun qstates-discrete-trajectory-in-envisionment (qstates sits)

  (unless (or (null sits)(= (length sits) 1))

    (throw :unknown-trajectory :unknown-trajectory))

  (let ((sit (car sits)))

    (cond ((null sits) nil)

	  ((eq (situation-type sit) :instant)

	   (cons sit 

		 (qstates-discrete-trajectory-in-envisionment 

		  qstates (situation-children sit))))

	  ((eq (situation-type sit) :interval)

	   (qstates-trajectory-in-envisionment 

	    (cddr qstates)

	    sits)))))

  





;; [01/18/2013 klenk] This returns a list of qualitative abstractions

;; [01/18/2013 klenk] Each qualitative abstraction is an alist of variables and qualitative values

;; [01/18/2013 klenk] corresponding to an interval in the envisionment

;; [01/18/2013 klenk] For now we will ignore instants.

(defun abstract-qstates-for-system (csv system)

  (multiple-value-bind (cols rows)

      (read-csv-file csv system)

    (abstract-qstates cols rows system)))



(defun abstract-qstates (cols rows system)

    (let ((ret nil)

	  (rows (identify-events cols rows))

;; [01/21/2013 klenk] Was the last integration step a zero crossing

	  (zero-crossing? nil)

	  (in-event? nil)

	  (var->cols (if system 

			 (var->cols-alist cols system)

			 (mapcar #'(lambda (col)

				     (cons col (position col cols :test #'string=)))

				 cols)))

	  (time-col (position "time" cols :test #'string=)))

      (do* ((rows rows (cdr rows))

	    (row (q-quantities-for-row (car rows)(cadr rows)(caddr rows) var->cols)

		 (q-quantities-for-row (car rows)(cadr rows)(caddr rows) var->cols))

;; [05/ 2/2014 klenk] The two value version fails qabstractor-1 test

;	    (row (q-quantities-for-row-2 (car rows)(cadr rows) var->cols)

;		 (q-quantities-for-row-2 (car rows)(cadr rows) var->cols))

		 )

	  ((null (cddr rows))

	   (make-qstates (mapcar #'car var->cols) 

			(if (eql (car ret) :start-event)

			    (reverse (cdr ret))

			    (reverse ret))

			))

;	(break)

;	(debug-print t "~%row: ~A ~% prev: ~A ~% zero-crossing? ~A "  row (car ret) zero-crossing?)

;	(when (eql (cadddr rows) :start-event) (break))

	(cond 

	  ((eql row :start-event)

	   (push :start-event ret)

	   (setq in-event? t))

	  ((eql row :end-event)

	   (push :end-event ret)

	   (setq in-event? nil))

	  (in-event? nil)

	  ((null row) nil)

	  ((and (consp (car ret))

		(q-quantities-equal (cdr (car ret)) row))

	   (setq zero-crossing? nil)

	   nil)

	  ((and zero-crossing?

		(not (eq (car ret) :end-event))

  ;; [01/21/2013 klenk] This is a check to see if the (car ret) occurs at the same time as row

		(not (eq (cadr ret) :end-event))

		(zero-crossing-row? row (cdr (cadr ret))))

	   (push 

	    (cons

	     (cons :start-time (elt (car rows) time-col))

	     (zero-crossing-union

	      (cdr (pop ret))

	      row))

	    ret))

	  ((and (not (eq (car ret) :end-event))

		(consp (car ret))

		(zero-crossing-row? row (cdr (car ret))))

	   (setq zero-crossing? t)

	   (push (cons (cons :start-time (elt (car rows) time-col)) row)

		 ret))

	  (t

	   (push (cons (cons :start-time (elt (car rows) time-col)) row)

		 ret)

	     )))))



(defun make-qstates (vars rows)

  (mapcar #'(lambda (row)

	      (if (member row '(:start-event :end-event))

		  row

		  (cons (car row)

			(mapcar #'(lambda (var elt)

				    (cons var elt))

				vars

				(cdr row)))))

	  rows))





;; [01/21/2013 klenk] The row includes a Q0 or std value

(defun zero-crossing-row? (row prev-row)

  (and prev-row (listp prev-row)

       (some #'(lambda (val1 val2)

		 (and (zero-crossing? val1)

;; [01/21/2013 klenk] Value 1 must be changing

		      (or 

		       (not (eql (q-quantity-deriv val1) 'Std))

		       (not (zero-crossing? val2)))))

	     row

	     prev-row)))





;; [01/21/2013 klenk] mapover the rows, if there is a zero-crossing use its value

(defun zero-crossing-union (row1 row2)

  (mapcar #'(lambda (q1 q2)

	      (make-q-quantity

	       :value 

	       (if (or (eql (q-quantity-value q1) 'Q0)

		       (eql (q-quantity-value q2) 'Q0))

		   'Q0

		   (progn (assert (eql (q-quantity-value q1)(q-quantity-value q2)))

			  (q-quantity-value q1)))

	       :qspace *simple-qspace*

	       :deriv

	       (if (or (eql (q-quantity-deriv q1) 'Std)

		       (eql (q-quantity-deriv q2) 'Std))

		   'Std

		   (progn (assert (eql (q-quantity-deriv q1)(q-quantity-deriv q2)))

			  (q-quantity-deriv q1)))))

	  row1 row2))



  



;; (progn 

;; 	(multiple-value-setq (cols rows)(abstract-qstates-for-system *lc-csv* *system-being-analyzed*))

;; 	(qstates->situations(match-q-quantities-to-vars cols rows *system-being-analyzed*) *system-being-analyzed*))



;; [01/18/2013 klenk] returns a list where each element is a complete

;; [01/18/2013 klenk] assignment of values to the quantity vars in the

;; [01/18/2013 klenk] system

(defun match-q-quantities-to-vars (cols rows system)

  (mapcar #'(lambda (row)

	      (if (member row '(:start-event :end-event))

		  row

		  (mapcar #'(lambda (var-col)

			      (cons (car var-col)

				    (elt row (cdr var-col))))

			  (var->cols-alist cols system))))

	  rows))





;; [01/21/2013 klenk] We skip the initial instants and just look at their children

;; [01/21/2013 klenk] We also skip the last qstate as it has some strange dynamics

;; [01/21/2013 klenk] Revisit once we figure out events 

(defun qstates->situations (qstates system)

  (let (parent ret) 

    (dolist (qstate (subseq qstates 1 (1- (length qstates)))

	     (reverse ret))

      (let ((next 

	     (quantities->situation 

	      qstate

	      (if parent 

		  (situation-children parent)

		  (mapcan #'situation-children 

			  (copy-list (system-initial-situations system)))))))

  ;     	(debug-print t "~%FUNCALL~%  parent ~A~% next ~A~% qstate ~A~%" parent next qstate)

	(assert next)

	(setq parent next)

	(push next ret)))))

	 

;(mapcan #'situation-children  (copy-list (system-initial-situations *system-being-analyzed*)))



;; [01/18/2013 klenk] given a row of qualitative values and set of 

;; [01/18/2013 klenk] possible situations, determine which one corresponds

;; [01/18/2013 klenk] to the row

(defun quantities->situation (row sits)

  (find-if 

   #'(lambda (sit)

       (qstate-matches-sit? row sit))

   sits))



;; [01/23/2013 klenk] The system is currently in an event if the counter is on :start-event or :end-event

(defun in-event? (system)

  (member (elt (system-match-qstates system)

	       (car (system-match-qstates system)))

	  '(:start-event :end-event)))





(defvar *failed-sits* nil)





(defun qstate-matches-sit? (row sit)

  (declare (special *failed-sits*))

  (assert row)

  (assert (eql (caar row) :start-time))

  (let ((conflict-pair (find-if-not

			#'(lambda (var-pair)

			    (or (var-eliminated (car var-pair))

				(q-quantity-equal 

				 (cdr var-pair)

				 (qualitative-value-in-qspace 

				  (car var-pair)

				  sit

				  (q-quantity-qspace (cdr var-pair))))))

			(cdr row))))

  (debug-print nil "~%qstate-matches-sit? sit (~A) ~%   var: ~A ~%   sit-value: ~A csv-value:  ~A" sit  

	       (car conflict-pair)

	       (when conflict-pair (qualitative-value (car conflict-pair) sit))

	       (cdr conflict-pair))

  (let ((ret 

	 (every 

	  #'(lambda (var-pair)

	      (or (var-eliminated (car var-pair))

		  (q-quantity-equal 

		   (cdr var-pair)

		   (qualitative-value-in-qspace 

	     (car var-pair)

	     sit

	     (q-quantity-qspace (cdr var-pair))))))

	  (cdr row))))

    (unless ret (push sit *failed-sits*))

    ret)))

	

	

    

	



;; [05/ 2/2014 klenk] There is some question about if we should have an instant after the event.

;; [05/ 2/2014 klenk] Do we want that row

;; [01/18/2013 klenk] Identifies rows corresponding to Modelica events, and puts token :start-event

;; [01/18/2013 klenk] after the row triggering the event. And :end-event after the last row of the 

;; [01/18/2013 klenk] event.

;; [01/18/2013 klenk] Events are identified by time step (i.e. two columns with the same time.

(defun identify-events (cols rows)

  (assert (string= (car cols) "time"))

  (let ((discrete-duration-cutoff (* (simulation-time-step rows) .001))

	(in-event? nil)

	(ret))

    (do ((rows rows (cdr rows)))

	((null (cdr rows)) (reverse (cons (car rows) ret)))

;; [05/ 2/2014 klenk] We need more than one row to determine the qualitative values?

      (cond ((initial-event? rows (null ret) discrete-duration-cutoff)

	     (push :start-event ret)

	     (setq in-event? t))

	    ((start-event? rows discrete-duration-cutoff in-event?)

	     (setq in-event? t)

	     (push (car rows) ret)

	     (push :start-event ret)

	     )

	    ((end-event? rows discrete-duration-cutoff in-event?)

	     (setq in-event? nil)

	     (push :end-event ret)

;; [01/23/2013 klenk] We are only looking for the following interval

	     ;(push (car rows) ret)

	     )

	    (t

	     (push (car rows) ret))

	    ))))



(defun initial-event? (rows initial? discrete-duration-cutoff)

  (and initial?

       (< (row-step-size rows) discrete-duration-cutoff)))



(defun end-event? (rows discrete-duration-cutoff in-event?)

  (and in-event?

       (> (row-step-size rows) discrete-duration-cutoff)))



(defun start-event? (rows discrete-duration-cutoff in-event?)

  (and (not in-event?)

       (< (row-step-size rows) discrete-duration-cutoff)))



(defun row-step-size (rows)

  (- (caadr rows)(caar rows)))



;; [01/23/2013 klenk] Simulation time step is the max step taking by the continuous integrator

(defun simulation-time-step (rows)

;; [01/23/2013 klenk] Assumes that time is the first column

  (let ((ret 0))

    (mapl #'(lambda (rows)

	      (if (and (cdr rows)

		       (>  (row-step-size rows) ret))

		  (setq ret (row-step-size rows))))

	  rows)

    ret))

       



;; [01/18/2013 klenk] creates a q-quantity for each element in row using row1 and row 3 to 

;; [01/21/2013 klenk] to define the value and direction

;; [05/ 2/2014 klenk] What if we go back to just using two variables here.

(defun q-quantities-for-row (row1 row2 row3 var-cols)

  (cond ((eql row1 :start-event) :start-event)

	((eql row1 :end-event) :end-event)

	((or (member :start-event (list row1 row2 row3))

	     (member :end-event (list row1 row2 row3)))

	 nil)

	((and row1 row2 row3)

	 (mapcar #'(lambda (var-col)

		     (q-quantity-for-vals (elt row1 (cdr var-col))

					  (elt row2 (cdr var-col))

					  (elt row3 (cdr var-col))

					  (requirement-var? (car var-col))))

		 var-cols))

	(t nil)))



(defun q-quantities-for-row-2 (row1 row2 var-cols)

  (cond ((eql row1 :start-event) :start-event)

	((eql row1 :end-event) :end-event)

	((member row2 '(:start-event :end-event))

	 nil)

	((and row1 row2)

	 (mapcar #'(lambda (var-col)

		     (q-quantity-for-vals-2 (elt row1 (cdr var-col))

					    (elt row2 (cdr var-col))

					    (requirement-var? (car var-col))))

		 var-cols))

	(t nil)))





;; [01/18/2013 klenk] Johan will probably not like this, as it is impercise about

;; [01/18/2013 klenk] concurrent zero crossings that do not affect the dynamics of the 

;; [01/18/2013 klenk] simulation



;; [01/21/2013 klenk] This will have 3 Q0 values for the following sequence

;; [01/21/2013 klenk] (6 4 1 -1 -3 -5)

(defun q-quantity-for-vals (val1 val2 val3 requirement?)

  (if requirement?

      (make-q-quantity :value (ecase val1

				(1 :|success|)

				(2 :|unknown|)

				(3 :|violated|))

		       :qspace *requirement-qspace*

		       :deriv 'Std)

      (make-q-quantity :value (simpleq->interval

			       (cond ((and (> val1 0d0)(> val3 0d0))

				      'Q+)

				     ((and (< val1 0d0)(< val3 0d0))

				      'Q-)

				     (t 'Q0)))

		       :qspace *simple-qspace*

		       :deriv (cond ((< val1 val2 val3)

				     'Inc)

				    ((> val1 val2 val3)

				     'Dec)

				    (t 'Std)))

      ))



(defun q-quantity-for-vals-2 (val1 val2 requirement?)

  (if requirement?

      (make-q-quantity :value (ecase val1

				(1 :|success|)

				(2 :|unknown|)

				(3 :|violated|))

		       :qspace *requirement-qspace*

		       :deriv 'Std)

      (make-q-quantity :value (simpleq->interval

			       (cond ((and (> val1 0d0)(> val2 0d0))

				      'Q+)

				     ((and (< val1 0d0)(< val2 0d0))

				      'Q-)

				     (t 'Q0)))

		       :qspace *simple-qspace*

		       :deriv (cond ((< val1 val2 )

				     'Inc)

				    ((> val1 val2 )

				     'Dec)

				    (t 'Std)))

      ))

  







;; [01/11/2013 klenk] Read the CSV file in as a list of alists so the fields are always accessible

;; [01/16/2013 klenk] Returns a values list of column headings and then data rows

(defun read-csv-file (file &optional system)

  (let (rows

	(ccl::*read-default-float-format* 'double-float))

    (with-open-file (f file :direction :input)

      (let ((cols (csv-parser:read-csv-line f)))

	(do ((vals (csv-parser:read-csv-line f)(csv-parser:read-csv-line f)))

	    ((null vals)

	     (if system

		 (extend-data-with-dummys (subseq cols 0 (1-(length cols))) (reverse rows) system)

		 (values (subseq cols 0 (1-(length cols))) (reverse rows))))



	  (push (mapcar #'safe-read-from-string (subseq vals 0 

							(if (null (car (last vals)))

							    (1- (length vals))

							    (length vals))

							)) rows))))))



;; [04/ 2/2013 klenk] "-1.797693134862316e+308" caused an error

;; [04/ 2/2013 klenk] If read-from-string throws an impossible-number error

;; [04/ 2/2013 klenk] then replace with max/min single float 

;ENV2> most-negative-single-float

;-3.4028235E+38

;ENV2> most-positive-single-float

;3.4028235E+38

(defparameter *failed-strings* nil)

(defun safe-read-from-string (str)

  (handler-case (read-from-string str)

    (ccl::impossible-number (c)

      (declare (ignore c))

      (push str *failed-strings*)

      (if (string= "-" (subseq str 0 1))

	  most-negative-single-float

	  most-positive-single-float))))

  





;; [01/11/2013 klenk] Ignores ifs, constants  Adds new cols to cols and fills in the appropriate data

;; [01/16/2013 klenk] returns a values list of cols and rows

(defun extend-data-with-dummys (cols rows &optional (system *system-being-analyzed*))

  (let ((*system-being-analyzed* system)

	(dummys (remove-if-not #'composite-dummy-var? (dummy-vars system))))

    (values 

     (append cols (mapcar #'var-local-name dummys))

     (mapcar #'(lambda (row)

		 (append

		  row

		  (mapcar #'(lambda (dummy)

			      (compute-value-for-expr (var-type dummy) cols row))

			  dummys)))

	     rows))))



;; [01/11/2013 klenk] searches the system for variables that are simple compositions of the other

;; [01/11/2013 klenk] fields.  

(defun composite-dummy-var? (var)

  (and (listp (var-type var))

       (composite-dummy-var-1? (var-type var))))



(defun composite-dummy-var-1? (form)

  (cond ((var-p form) t)

	((listp form)

	 (and (member (car form) '(+ - * /))

	      (every #'composite-dummy-var-1? (rest form))))

	(t nil)))



(defun compute-value-for-expr (expr cols row)

  (cond ((numberp expr) expr)

	((and (var-p expr)

	      (dummy-var? expr))

	 (compute-value-for-expr (var-type expr) cols row))

	((var-p expr)

	 (get-var-value expr cols row))

	((and (listp expr) 

	      (= (length expr) 2)

	      (eql (car expr) '-))

	 (- (compute-value-for-expr (cadr expr) cols row)))

	((and (= (length expr) 4)

	      (eq (car expr) :tempinterpol1))

	 (compute-dummy-temp-interpol1 expr cols row))

	((listp expr)

	 (reduce (car expr)

		 (mapcar #'(lambda (expr)

			     (compute-value-for-expr expr cols row))

			 (rest expr))))

	(t (error "Unable to compute value for expression"))))



;; [04/11/2014 klenk] This function is very similar to determine-dummy-time-interpol1

(defun compute-dummy-temp-interpol1 (exp cols rows)

  (let ((input-table (third exp)) 

	(table (make-array (array-dimensions (third exp))))

	(u (compute-value-for-expr (second exp) cols rows))

	(icol (fourth exp)))

    (dotimes (i (car (array-dimensions table)))

	(dotimes (j (cadr (array-dimensions table)))

	  (setf (aref table i j)

		(compute-value-for-expr (car (aref input-table i j)) cols rows))))

    (modelica-tempinterpol1 u table icol))

  )



;; [01/16/2013 klenk] Returns a number for the value of var for a particular row

(defun get-var-value (var cols row)

  (cond ((find (var-local-name var) cols :test #'string=)

	 (elt row 

	      (position (var-local-name var) cols :test #'string=)))

	((and (var-fixed? var)

	      (cdr (assoc var (system-parameters *system-being-analyzed*)))))

	(t (error "Unknown-var-value"))))







;; [01/18/2013 klenk] returns an alist for all the quantity-vars

;; [02/27/2013 klenk] remove vars without columns and warn user

(defun var->cols-alist (cols system)

  (let* ((var-cols 

	  (mapcar #'(lambda (var)

		      (cons var

			    (var->col var cols)))

		  (qa-vars system)))

	 (unknown-cols (remove-if #'(lambda (pair) (cdr pair)) var-cols)))

    (cond (unknown-cols 

	   (warn "~% Unable to create column for vars ~A" unknown-cols)

	   (remove-if-not #'(lambda (pair) (cdr pair)) var-cols))

	  (t var-cols))))

			

(defun qa-vars (system)

  (append (remove-if #'not-for-csv-var?

		     (quantity-vars system))

	  (remove-if #'var-eliminated (discrete-vars *system-being-analyzed*))))



(defun var-col-name (var) 

  (if (dummy-deriv? var)

      (d/dt->der var)

      (var-local-name var)))



(defun dummy-deriv?(var)

  (and (stringp (var-type var))

       (string-begins-with (var-type var) "d")

       (string-ends-with (var-type var) "/dt")))



(defun d/dt->der(var)

  (concatenate 'string

	       "der("

	       (subseq (var-type var) 1 (- (length (var-type var)) 3))

	       ")"))





(defun not-for-csv-var? (var)

  (or

   (var-fixed? var)

   (and (dummy-var? var)

	(listp (var-type var))

	(eql (car (var-type var)) 'if))



;; [01/21/2013 klenk] We need to include these because if they are created they may result in elimination of the opposite vars

;   (and (dummy-var? var)

;	(listp (var-type var))

;	(= (length (var-type var)) 2))

))

  

(defun var->col (var cols)

  (position (var-col-name var) cols :test #'string=))













;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;; Debugging



(defun print-qstate (qstate &optional (stream t))

  (format stream "~%qstate values")

  (dolist (pair qstate)

    (format stream "~% ~A : ~A" (car pair)(cdr pair))))



(defun print-qstates (qstates &optional (stream t))

  (format stream "~%qstates values")

  (dolist (var (mapcar #'car (car (remove-if #'atom qstates))))

    (format stream "~% ~A : ~A"

	    (if (var-p var)

		(var-id var)

		var)

	    (mapcar  #'(lambda (qstate)

			 (if (atom qstate) 

			     qstate

			     (cdr (assoc var qstate))

			     ))

		    qstates))))

	    





		



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; test-files for developement

(defparameter *rc2-xml* (merge-pathnames "Modelica/ladder/RC2.xml" cl-user::*my-meta-path*))

(defparameter *rc2-csv* (merge-pathnames "Modelica/ladder/RC2.csv" cl-user::*my-meta-path*))

(defparameter *rc3-xml* (merge-pathnames "Modelica/ladder/RC3.xml" cl-user::*my-meta-path*))

(defparameter *rc3-csv* (merge-pathnames "Modelica/ladder/RC3.csv" cl-user::*my-meta-path*))





(defparameter *lc-xml* (merge-pathnames "Modelica/test-circuits/lc_oscillator.xml" 

					cl-user::*my-meta-path*))

(defparameter *lc-csv* (merge-pathnames "Modelica/test-circuits/lc_oscillator_res.csv" 

					cl-user::*my-meta-path*))





(defparameter *simple-engine-pass-csv* 

  (merge-pathnames "Modelica/March13/SimpleEnginePackage.Pass_res.csv" cl-user::*my-meta-path*))

;; [02/05/2013 klenk] Envisionment does not include the asymptote below the requirement

;; [02/05/2013 klenk] Also, includes extra ambiguity because the eliminator fails on the 

;; [02/05/2013 klenk] special case of a summer with X = Y + Z where Y is a fixed parameter equal to 0

(defparameter *simple-engine-pass-xml* 

  (merge-pathnames "Modelica/March13/SimpleEnginePackage.Pass.xml" cl-user::*my-meta-path*))

(defparameter *simple-engine-fail-csv* 

  (merge-pathnames "Modelica/March13/SimpleEnginePackage.Fail_res.csv" cl-user::*my-meta-path*))

;; [02/05/2013 klenk] Errors due to not handling the der(x,2) in the XML

(defparameter *simple-engine-fail-xml* 

  (merge-pathnames "Modelica/March13/SimpleEnginePackage.Fail.xml" cl-user::*my-meta-path*))







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; End of Code

;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: qr-guided-sampling.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: February 26, 2013 18:26:07
;;;;   Purpose: In this file, we use QR to guide the sampling of numeric parameters
;;;;            and generate a plot useful to designers
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Tuesday, March 12, 2013 at 13:29:43 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;; [02/26/2013 klenk] Takes the results of the omc-csv call and creates a new 
;; [02/26/2013 klenk] csv with a column for each parameter and one column for the result
;; [02/26/2013 klenk] result = 1 if success, 0 otherwise
;; [02/27/2013 klenk] For now, result is last situation
;; [02/27/2013 klenk] -1 is an error code for not a valid trajectory
;; [03/ 1/2013 klenk] This assumes that the system has already been defined,
(defun omc-csv-results->parameters-csv (results system outfile
					&key 
					  (result-header "last_situation_id")
					  (result-fn #'last-situation)
					  (header nil))
  (with-open-file (out outfile
		       :direction :output 
		       :if-exists :supersede 
		       :if-does-not-exist :create)
    (if header
	(csv-parser:write-csv-line out header)
	(csv-parser:write-csv-line out (append (parameter-names-from-result (car results))
					       `(,result-header "file"))))
    (dolist (result results)
      (csv-parser:write-csv-line 
       out 
       (result->csv-row result system result-fn)))))

(defun last-situation (trajectory)
  (car (last trajectory)))

(defun result->csv-row (result system result-fn)
  (cond (system 
	 (let ((traj (csv-trajectory-in-envisionment (second result) system)))
	   (append (parameters-from-result result)
		   (list (if (eq traj :unknown-trajectory)
			     -1
			     (funcall result-fn traj))
			 (pathname-name (second result))
			 ))))
	 (t
	  (append (parameters-from-result result)
		  (list (funcall result-fn (second result))
			(pathname-name (second result)))))))
		  

(defun parameter-names-from-result (result)
  (mapcar #'car (car result)))

(defun parameters-from-result (result)
  (mapcar #'cdr (car result)))




;; [02/26/2013 klenk] Each param-spec is a (<name> <min> <max>) e.g., ("tau" 0 1)
(defun generate-random-parameters (param-specs count)
  (let (ret)
    (dotimes (i count ret)
      (push 
       (mapcar #'(lambda (param-spec)
		   (cons (car param-spec)
			 (random-number-between (second param-spec)(third param-spec))))
	       param-specs)
       ret))))

(defun random-number-between (min max)
  (assert (> max min))
  (+ min (random (float (- max min))))) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; [03/12/2013 klenk] Propogating :success and :failure up the tree

(defun propagate-status ()
  (dolist (sit (append (success-situations)(fail-situations)))
    (propagate-status-1 sit (situation-status sit))
    ))

;; [03/12/2013 klenk] 
(defun propagate-status-1 (sit child-status &optional stack)
  (unless (member sit stack)
    (let ((status (situation-status sit))
	  (stack (cons sit stack)))
      (cond ((eq status :maybe)
	     nil)
	    ((or (null status)
		 (eq child-status :maybe))
	     (setf (situation-status sit) child-status)
	     (dolist (parent (situation-parents sit))
	       (propagate-status-1 parent child-status stack)))

	    ((eq status child-status)
	     (dolist (parent (situation-parents sit))
	       (propagate-status-1 parent child-status stack)))
	    	    ((eq (opposite-status status) child-status)
	     (setf (situation-status sit) :maybe)
	     (dolist (parent (situation-parents sit))
	       (propagate-status-1 parent :maybe stack)))
	    (t (error "propagate-status-1: shouldn't happen, status is ~A, child-status is ~A" status child-status))))))

(defun opposite-status (status)
  (ecase status
    (:success :failure)
    (:failure :success)))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: qspaces.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December 01, 2011 17:17:54
;;;;   Purpose: functions for deriving and defining qualitative values from a
;;;;            (variable,situation) pairs.  Also defines qspaces.
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, June  5, 2013 at 08:35:27 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; make q-quantity

(defun create-q-quantity (var value qspace deriv)
;  (format t "~% quantity ~a ~a" value qspace)
  (when (and value qspace (interval?  value))
    (assert (eql (landmark-below (cadr value) qspace)
		 (car value))))
  (let ((value (if (simpleq-p value)
		   (simpleq->interval value)
		   value))
	(deriv (if (simpleq-p deriv)
		   (simpleq->deriv deriv)
                   deriv)))
    (make-q-quantity :value value 
		     :qspace (if qspace qspace (qspace-for-value var value))
		     :deriv deriv)))

(defun all-finite-q-quantities (qspace &key (derivs))
  (let (ret)
    (dolist (value (all-values-for-qspace qspace) ret)
      (unless (member value '(Inf+ Inf-))
	(if derivs
	    (dolist (deriv derivs)
;	      (format t "~% Making ~a" qspace)
	      (push (make-q-quantity :value value
				     :qspace qspace
				     :deriv deriv) ret))
	    (push (make-q-quantity :value value
				   :qspace qspace) ret))))))
			 
(defun all-derivs ()
  '(Dec Std Inc))

(defun all-values-for-qspace (qspace)
  (let (ret) 
    (do ((remaining qspace (cdr remaining)))
	((null remaining) ret)
      (push (car remaining) ret)
      (when (cdr remaining)
	(push (list (car remaining)(second remaining))  ret)))))



(defun q-quantities-equal (set1 set2)
  (and (listp set1)(listp set2)
       (= (length set1) (length set2))
       (every #'q-quantity-equal set1  set2)))
	
(defun q-quantity-equal (q1 q2 &key (ignore-unknown-deriv? nil))
  (and q1 q2
       (or (and (equal (q-quantity-value  q1) (q-quantity-value q2))
		(equal (q-quantity-qspace q1) (q-quantity-qspace q2))
		(equal (q-quantity-deriv  q1) (q-quantity-deriv q2)))
	   (and ignore-unknown-deriv?
		(equal (q-quantity-value  q1) (q-quantity-value q2))
		(equal (q-quantity-qspace q1) (q-quantity-qspace q2))
		(null (q-quantity-deriv  q1))
		))))

;; [05/30/2012 klenk] every entry in quantity is in signature or signature is null
(defun q-quantity-matches? (quantity signature)
  (and (or (null (q-quantity-value signature))
	   (equal (q-quantity-value signature) (q-quantity-value quantity)))
       (or (null (q-quantity-qspace signature))
	   (equal (q-quantity-qspace signature) (q-quantity-qspace quantity)))
       (or (null (q-quantity-deriv signature))
	   (equal (q-quantity-deriv signature) (q-quantity-deriv quantity)))))


(defun zero-crossing? (q-quantity)
  (or (eql (q-quantity-value q-quantity) 'Q0)
      (eql (q-quantity-deriv q-quantity) 'Std)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Translate a number to a q-quantity

(defun create-q-quantity-from-number (var value)
  (assert (= (length (var-qspaces var)) 1))
  (cond ((simpleqspace? (car (var-qspaces var)))
	 (create-q-quantity var
		     (cond ((= value 0) 'Q0)
			   ((> value 0) '(Q0 Inf+))
			   ((< value 0) '(Inf- Q0)))
		     (car (var-qspaces var))
		     (when (parameter-p var) 'Std) 
		     ))
	((numeric-qspace? (car (var-qspaces var)))
	 (create-q-quantity var
			    (determine-q-value-for-number value (car (var-qspaces var)))
			    (car (var-qspaces var))
			    (when (parameter-p var) 'Std) 
		     ))
	(t (error "unable to create qspace for number"))))


;; [08/28/2013 klenk] If the qspace includes a landmark-1, we get an error
(defun determine-q-value-for-number (val qspace)
  "Searches through a numeric space looking for the value or interval corresponding to val"
  (cond ((= (length qspace) 1)
         ;; only one possible value it can be -- wcj
         (first qspace))
        ((= val (num-val (car qspace))) (car qspace))
	((and (> val (num-val (car qspace)))
	      (< val (num-val (cadr qspace))))
	 (list (car qspace)(cadr qspace)))
	(t (determine-q-value-for-number val (cdr qspace)))))

;; [08/28/2013 klenk] This will throw an error if there is an autogenerated landmark in the 
;; [08/28/2013 klenk] qspace.  The right solution would be to create an ambiguous value
;; [08/28/2013 klenk] and split the state...
(defun num-val (landmark)
  (if (numberp landmark)
      landmark
      (ecase landmark
	(Inf- most-negative-fixnum)
	(Q0 0)
	(Inf+ most-positive-fixnum))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun landmark-for-var? (landmark var)
  (member landmark (var-landmarks var)))

(defun var-landmarks (var)
  (let (ret)
    (dolist (qspace (var-qspaces var) ret)
      (dolist (landmark qspace)
	(pushnew landmark ret)))))

(defun positive-landmarks (qspace)
  (subseq qspace 
	  (1+ (position 'Q0 qspace))
	  (1- (length qspace))))

(defun negative-landmarks (qspace)
  (subseq qspace 
	  1 
	  (position 'Q0 qspace)))
	  

(defun landmark-above (landmark qspace)
  (elt qspace (1+ (position landmark qspace))))

(defun landmark-below (landmark qspace)
  (elt qspace (1- (position landmark qspace))))


;;; assume non-inclusive intervals
(defun interval? (a)
  (and (listp a)
       (= (length a) 2)
       (not (eql (car a) '-))
       (not (eql (car a) 'mode))
       (not (eql (car a) 'deriv))
       (not (eql (car a) 'pre))
       (or (symbolp (first a)) (numberp (first a)))
       (or (symbolp (second a)) (numberp (second a)))))

;;;;;;;;;;;;;;;;
;;; requirement vars

(defparameter *requirement-qspace*
  '(:|success| :|unknown| :|failure|))

(defun requirement-var? (var)
  (and (discrete-var? var)
       (equal (car (var-qspaces var)) *requirement-qspace*)))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Simple Q+, Q0, and Q- should never be stored as values.

(defparameter *simple-qspace* '(Inf- Q0 Inf+))


(defun simpleq-var? (var)
  (every #'(lambda (landmark)
	     (member landmark *simple-qspace*))
	 (var-landmarks var)))

(defun fully-specified-qvalue? (q-quantity)
  (and (q-quantity-p q-quantity)
       (q-quantity-value q-quantity)
       (q-quantity-deriv q-quantity)))
       
       

;; [12/01/2011 klenk] No longer used internally anywhere
;; [12/01/2011 klenk] Simply for backward compatability
(defun simpleq-p (quantity) (member quantity '(Q+ Q- Q0 )))
(defun simpleq-interval-p (quantity) (member quantity '((Inf- Q0) Q0 (Q0 Inf+)) :test #'equalp))

(defun simpleqspace? (qspace) (equal qspace *simple-qspace*))

(defun numeric-qspace? (qspace) 
  (every #'(lambda (landmark)
	     (or (numberp landmark)
		 (string= (symbol-name landmark) "LANDMARK-" :end1 9))) 
	 (set-difference qspace *simple-qspace*)))
 
(defun simpleq->interval (value)
  (ecase value
    (Q0 'Q0)
    (Q- '(Inf- Q0))
    (Q+ '(Q0 Inf+))))

(defun deriv->simpleq (deriv)
  (ecase deriv
    (Inc 'Q+)
    (Std 'Q0)
    (Dec 'Q-)
    (Undefined 'Q?)
    ))

(defun simpleq->deriv (val)
  (ecase val
    (Q+ 'Inc)
    (Q0 'Std)
    (Q- 'Dec )
    (Q? 'Undefined)
    ))

;;; [4/29/2014 Johan] added for efficiency. Optimize the common cases.
;;; [05/16/2014 Johan] modified to not get errors on [nil:Std]
(defun val->simpleq (val)
  (let ((interval (q-quantity-value val))
	(qspace (q-quantity-qspace val)))
    (cond ((null interval) nil)
	  ((eq interval 'Q0) 'Q0)
	  ((equal qspace *simple-qspace*)
  ;;** change equal to eq some day.
	   (cond ((equal val '(Inf- Q0)) 'Q-)
		 ((equal val '(Q0 Inf+)) 'Q+)
		 (t (interval->simpleq interval qspace))))
	  (t (interval->simpleq interval qspace)))))

;; [12/01/2011 klenk] returns Q+, Q0 or Q- 
;; [03/30/2014 Johan] This can be greatly optimized (car (remove ?????
(defun interval->simpleq (interval qspace)
  (cond ((null qspace) (interval->simpleq interval *simple-qspace*))
	((eql interval 'Q0) 'Q0)
	((atom interval) (if (> (position interval qspace)
				(position 'Q0 qspace))
			     'Q+ 'Q-))
	((and (interval? interval)
	      (member 'Q0 interval))
	 (interval->simpleq (car (remove 'Q0 interval)) qspace))
	((and (interval? interval)
	     (eql (interval->simpleq (car interval) qspace)
		  (interval->simpleq (cadr interval) qspace)))
	 (interval->simpleq (car interval) qspace))
	((and (interval? interval)
	      (not (eql (interval->simpleq (car interval) qspace)
			(interval->simpleq (cadr interval) qspace))))
	 (error "Intervals cannot be ambiguious wrt to the sign")
	 ;'Q?
	 )
	(t (error "unable to translate interval into simpleq ~A ~A" interval qspace))))

;; [12/09/2011 klenk] This will be ambiguous for Q0, currently just return the first.
(defun value->qspace (value var)
  (cond ((interval? value)
	 (value->qspace (car (remove 'Q0 value)) var))
	(t 
	 (dolist (qspace (var-qspaces var))
	   (when (find value qspace)
	     (return qspace))))))

(defun q-quantity-simpleq (q-quantity)
  (assert (simpleqspace? (q-quantity-qspace q-quantity)))
  (val->simpleq q-quantity))



;;; The '<> are probably obsolete.  But Matt and Johan editted this same time.
(defun q-add (x y)
  (cond ((or (eq x 'Q?) (eq y 'Q?)) 'Q?)
	((eq x 'Q0) y)
	((eq x 'Q+) (if (eq y 'Q-) 'Q? 'Q+))
	((eq x 'Q-) (if (eq y 'Q+) 'Q? 'Q-))
	(t (error "Impossible q-add qualitative value, x = ~a, y = ~a" x y))))

(defun q-subtract (x y)
  (q-add x (q-invert y)))

(defun q-multiply (x y)
  (cond ((or (eq x 'Q?)
	     (eq y 'Q?)) 'Q?)
	((or (eq x 'Q0)
	     (eq y 'Q0)) 'Q0)
	((eq x 'Q-) (if (eq y 'Q+) 'Q- 'Q+))
	((eq x 'Q+) (if (eq y 'Q+) 'Q+ 'Q-))
	(t (error "Impossible q-multiply error, x = ~a, y = ~a" x y))))
 
(defun q-divide (x y)
  (if (eq y 'Q0) 
      'Q?
      (q-multiply x y)))

;;; - +
;;; 0 0
;;; + -
(defun q-invert (x)
  (case x 
    (Q- 'Q+) (Q0 'Q0) (Q+ 'Q-)(Q? 'Q?)
    (Inc 'Dec)(Std 'Std)(Dec 'Inc)
    (t (if (interval? x)
	   (invert-interval x)
	   (error "Impossible qualitative value")))))

(defun invert-interval (interval)
  (cond ((equal interval '(Q0 Inf+)) '(Inf- Q0))
	((eql interval 'Q0) 'Q0)
	((equal interval '(Inf- Q0)) '(Q0 Inf+))
	(t (error "does not work for non-simple q"))))

;; [02/28/2012 klenk] This will be more complicated when not a simpleq
(defun invert-q-quantity (q-quantity)
;  (format t "~% Inverting ~a" q-quantity)
  (assert (or (null (q-quantity-qspace q-quantity))
	      (simpleqspace? (q-quantity-qspace q-quantity))))
  (make-q-quantity 
   :value (invert-interval (q-quantity-value q-quantity))
   :qspace (q-quantity-qspace q-quantity)
   :deriv (when (q-quantity-deriv q-quantity) 
	    (q-invert (q-quantity-deriv q-quantity)))))

     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Propagate landmarks through the constraint network.

;;; Basic algorithm
;;; For each landmark propogate it through the constraints as follows
;;; 0. Create new qspace with landmarks mirrored (if ambiguous split)
;;; 1. iterate through the constraints for the variable
;;;  ignore if already has qspace/landmark
;;;  if q= add qspace to other var and add other var to queue
;;;  if summer add qspace to each var and add to queue


;; [04/19/2012 klenk] We can probably merge into one later
(defun propagate-all-qspaces ()
  (break)
  (dolist (var (remove-if #'simpleq-var? (quantity-vars)))
    (propagate-var-qspaces var))
;; [04/19/2012 klenk] This check should be after elimination
  (assert (not (some #'multiple-qspaces? (quantity-vars)))))



(defun propagate-var-qspaces (var)
  (setf (var-qspaces var)
	(mapcar #'(lambda (qspace)
;; [04/19/2012 klenk] Need to handle ambiguities later
		    (cond ((mirrored-qspace? qspace) qspace)
			  (t
			   (let ((mirrored-qspace (make-mirrored-qspace var qspace)))
			     (propagate-var-qspace var mirrored-qspace)
			     mirrored-qspace))))
		(var-qspaces var))))

;; [04/19/2012 klenk] huge function, sets up a queue, then propogates through the constraints for the variable
;; [04/19/2012 klenk] different behavior required for different types of constraints. Currently, only doing addition
;; [04/19/2012 klenk] and equatlity
(defun propagate-var-qspace (initial-var qspace)
  (let ((stack (list initial-var)))
    (do ((var (pop stack)(pop stack)))
	((null var))
      (dolist (constraint (var-uses var))
	(case (type-of constraint)
	  ((qequal-constraint general-summer-constraint) 
	   (dolist (other-var (remove var (constraint-variables constraint)))
	     (when (and (not (eql other-var initial-var))
			(add-qspace other-var qspace))
	       (push other-var stack)))))))))

;; [04/19/2012 klenk] adds qspace to var. If var already has the qspace returns nil, else t.
(defun add-qspace (var qspace)
  (if (equal qspace "Integer") (error "bad"))
  (unless (find qspace (var-qspaces var) :test 'equal)
    (cond ((simpleq-var? var)
	   (setf (var-qspaces var) (list qspace)))
	  (t (push qspace (var-qspaces var))))))
	   
;; [04/19/2012 klenk] A mirrored qspace has negative values for each landmark variable
(defun make-mirrored-qspace (var qspace)
  (declare (ignore var))
  (let ((pos (positive-landmarks qspace))
	(negs (negative-landmarks qspace)))
;; [04/19/2012 klenk] Handle later, introduces ambiguities
    (assert (not (and pos negs)))
    (cond (pos
	   `(Inf- ,@(mapcar #'(lambda (landmark)
			     (intern (concatenate 'string "-" (symbol-name landmark))))
			 pos)
		  Q0
		 ,@pos
		 Inf+))
	  (negs
	   `(Inf- ,@negs
		  Q0
		  ,@(mapcar #'(lambda (landmark)
				(intern (concatenate 'string "-" (symbol-name landmark))))
			 negs)
		  Inf+)))))

;; [04/19/2012 klenk] Clearly not the best implementation
(defun mirrored-qspace? (qspace)
  (let ((pos (positive-landmarks qspace))
	(negs (negative-landmarks qspace)))
    (and (= (length pos)(length negs))
	 (every #'(lambda (landmark)
		    (or (find (concatenate 'string "-" (symbol-name landmark)) negs :key #'symbol-name :test #'string=)
			(find (subseq (symbol-name landmark) 1) negs :key #'symbol-name :test #'string=)))
		pos))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun multiple-qspaces? (var)
  (> (length (var-qspaces var)) 1))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; identify vars with multiple qspaces, and create multiple qspace sets

;; [04/20/2012 klenk] returns a set of sets of single qspaces and vars to be overwritten
;; [04/20/2012 klenk] (((q1 q2 q3) v1 v2 v3)
;; [04/20/2012 klenk]  ((q4 q5 q6) v4 v5))
;; [04/20/2012 klenk] 


(defun qspace-ordering-sets (system)
  (let (ret)
    (maphash #'(lambda (qspaces vars)
		 (push (cons (merge-qspaces qspaces) vars) ret))
	     (vars-multi-qspaces system))
    ret))

;; [04/20/2012 klenk] Given a set of qspaces, produce a qset of qspaces in which each landmark is represented in each.
(defun merge-qspaces (qspaces)
  (mapcar #'tot-order->qspace
	  (all-orderings (mapcar #'positive-landmarks qspaces))))

;; [04/20/2012 klenk] ((VBat) (OnVoltage)) means there are two positive landmarks and VBat < OnVoltage
;; [04/20/2012 klenk] ((VBat OnVoltage)) means there are two positive landmarks and VBat = OnVoltage
(defun tot-order->qspace (tot-order)
  (let* ((tot-order (replace-single-landmark-sets tot-order)) 
	 (neg-landmarks (reverse (invert-symbols tot-order))))
  `(Inf- ,@neg-landmarks
	 Q0
	 ,@tot-order
	 Inf+)))

(defun replace-single-landmark-sets (tot-order)
  (mapcar #'(lambda (elt)
	      (assert (listp elt))
	      (cond ((= (length elt) 1) (car elt))
		    (t elt)))
	  tot-order))

;; [04/20/2012 klenk] adds a "-" to the front of every symbol
(defun invert-symbols (lst)
  (cond ((null lst) nil)
	((atom lst) 
	 (assert (not (string= "-" (subseq (symbol-name lst) 0 1))))
	 (intern (concatenate 'string "-" (symbol-name lst)) :env2))
	(t (cons (invert-symbols (car lst))
		 (invert-symbols (cdr lst))))))


;; [04/20/2012 klenk] returns a list of landmark sets
(defun all-orderings (po-landmarks)
  (cond ((null po-landmarks) '(nil))
	(t 
	 (let (ret)
	   (dolist (next-landmarks (powerset-no-nil (next-landmarks po-landmarks)) ret)
	     (dolist (ordering (all-orderings (rest-landmarks next-landmarks po-landmarks)))
	       (push (cons next-landmarks ordering) ret)))))))


(defun next-landmarks (po-landmarks)
  (mapcar #'car po-landmarks))

;; [04/20/2012 klenk] 
(defun rest-landmarks (next po-landmarks)
  (remove nil 
	  (mapcar #'(lambda (po)
		      (if (member (car po) next)
			  (cdr po)
			  po))
		  po-landmarks)))

(defun powerset-no-nil (l)
  (remove nil (powerset l)))

;; [04/20/2012 klenk] ASU homework implementation
(defun powerset (l)
  (cond ((null l) '(nil))
	(t
	 (let ((ps (powerset (cdr l))))
	   (append ps (mapcar #'(lambda (x) (cons (car l) x)) ps))))))

 
;; [04/20/2012 klenk] Returns a hyash table where the each key is a set of qspaces and each value is a set of vars
(defun vars-multi-qspaces (system)
  (let* ((vars (remove-if #'(lambda (var) (= (length (var-qspaces var)) 1)) (quantity-vars system)))
	 (ret-hash (make-hash-table :test 'equal)))
    (dolist (var vars ret-hash)
      (push var (gethash 
		 (sort (copy-tree (var-qspaces var)) #'string-lessp :key #'(lambda (qspace)
								 (symbol-name (second qspace))))
			 ret-hash)))))

    
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*- Mode: LISP; Syntax: Common-Lisp; Base: 10 -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: parse-om-xml-dae-dump.lisp
;;;; System: PARC QM Envisioner, v2
;;;; Author: Bill Janssen
;;;;
;;;; Read in an XML dump of a simplifed DAE produced from OpenModelica, and
;;;; instantiate a model from it
;;;; ----------------------------------------------------------------------------
;;;; Modified: Friday, January 03, 2014 at 14:39:08 by klenk
;;;; ----------------------------------------------------------------------------
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

(defparameter *foo* 'a)

(defparameter *temporary-directory*
  #+clozure
  (let ((tp (ccl:temp-pathname)))
    (truename (make-pathname :directory (pathname-directory tp) :device (pathname-device tp))))
  #-clozure
  ;; (truename (merge-pathnames "envisioner/v2/tmp/" cl-user::*my-meta-path*))
  (cond ((asdf::os-unix-p) (truename "/tmp"))
        ((asdf::os-windows-p) (truename (asdf::getenv "TEMP"))))
  "pathname of directory to use for temporary files"
  )
(proclaim '(special *temporary-directory*))
  
(defun get-tempfile-pathname (&key (extension nil) (directory nil))
  (assert (and (or (null directory) (stringp directory))
               (or (null extension) (stringp extension))))
  (when directory (ensure-directories-exist directory))
  (merge-pathnames 
   (make-pathname 
    :name (symbol-name (gensym)) 
    :type (or extension nil))
   (or (and directory (truename directory)) 
       *temporary-directory*)))

(defun string-ends-with (s suffix)
  "return T if the string 's' ends with suffix 'suffix', NIL otherwise"
  (let ((start (- (length s) (length suffix))))
    (and (<= 0 start)
         (string-equal s suffix :start1 start))))

(defun string-begins-with (s prefix)
  "return T if the string 's' begins with prefix 'prefix', nil otherwise"
  (let ((end (length prefix)))
    (and (<= end (length s))
         (string-equal s prefix :end1 end))))

(defun find-tag (node names)

  "Given a tag-node NODE and a list of tag names NAMES, use the list of
   names as a list of descendant tags, and find and return the descendant
   tag at the end of the list, if it exists."

  (if (> (length names) 0)
      (let ((newnode (xmls:xmlrep-find-child-tag (car names) node nil)))
        (if newnode
            (find-tag newnode (cdr names))))
      node))

(defun find-text-tag (node names)

  "Return the text child of a node"

  (let ((v (find-tag node names)))
    (when (and v (= (length v) 3) (stringp (third v)))
      (third v))))

(define-condition mode-equation (error) ()
  (:report (lambda (condition stream)
             (format stream "#<mode-equation: Can't process mode equation>")))
  )

(define-condition parse-xml-error (error)
  ((expr :initarg :expr :reader expr))
  (:report (lambda (condition stream)
             (format stream "#<parse-xml-error: Can't parse ~A>" (expr condition))))
  )

(define-condition expression-parse-xml-error (parse-xml-error)
  ((err :initarg :err :reader err)))

(define-condition unhandled-operator (expression-parse-xml-error)
  ((operator :initarg :operator :reader operator))
  (:report (lambda (condition stream)
             (format stream "#<unhandled-operator: ~A>" (operator condition))))
  )

(define-condition invalid-tree-or-vars (expression-parse-xml-error)
  ((vars :initarg :vars :reader vars))
  (:report (lambda (condition stream)
             (format stream "#<invalid-tree-or-vars: tree=~A, vars=~A>"
                     (expr condition) (vars condition))))
  )

(define-condition if-expression (expression-parse-xml-error)
  ((var :initarg :var :reader var)
   (value :initarg :value :reader value))
  (:report (lambda (condition stream)
             (format stream "#<if-expression: Unexpected ~A in ~A>"
                     (value condition) (var condition))))
  )


;;; [04/07/2014 Johan] Not right, under construction.
(defun note-exception (exn &key (indent nil))
  (declare (special *translation-errors* *logging-parse-xml-errors*))
  (let ((continue?  *logging-parse-xml-errors*))
    (when (not indent)
      ;; note that we skip recursive errors
      (push (cons exn indent) *translation-errors*))
    (if *error-on-error* (return-from note-exception nil))
    (unless continue?
      (error "not-logging-translation-errors ~A"  exn)
      )))

(defun write-translation-errors-to-file (&optional (file (merge-pathnames "errors.log" cl-user::*my-meta-path*)))
  (with-open-file (f file 
		     :if-exists :supersede 
		     :if-does-not-exist :create 
		     :direction :output)
    (assert f)
    (format f "Number of errors: ~A~%" (length *translation-errors*))
    (dolist (translation-error (reverse *translation-errors*))
      (write-translation-errors-to-file-1 
       (car translation-error)
       (cdr translation-error)
       f))))

(defun write-translation-errors-to-file-1 (exn indent f)
  (dolist (i indent)
    (format f "~A" i))
  (cond ((eq (type-of exn) 'unhandled-operator)
	 (format f "Unhandled operator ~S~%" (operator exn)))
	((eq (type-of exn) 'invalid-tree-or-vars)
	 (format f "Unable to find all variables in expression ~S:~%" (expr exn)))
	((eq (type-of exn) 'if-expression)
	 (format f "Unexpected if-expression ~A~%" (value exn)))
	((eq (type-of exn) 'expression-parse-xml-error)
	 (format f "Expression parse error ~A in expression ~A~%" (err exn) (expr exn))
	 (note-exception (err exn) :indent (cons "   " indent)))
	((eq (type-of exn) 'parse-xml-error)
	 (format f "Parse error ~A in expression ~A~%" (err exn) (expr exn)))
	(t
	 (format f "Catch-all:  ~A~%" exn))
	))


(defvar special-functions-lookup-table
  '(
    ("Modelica.Math.tempInterpol1" . :tempinterpol1)
    ("Modelica.Blocks.Tables.CombiTable1D.tableIpo" . :tableIpo)
    ("terminal" . :terminal)
    ))

(defun parse-math-ml-expression (expr)

  "Recursively descend the parse of the MathML expression, and express it
   as a lisp form acceptable to create-constraints."

  (when (not (null expr))
    (restart-case
        (let ((tag (xmls:xmlrep-tag expr)))
          (cond ((equal tag "ci")
                 ;; text
                 (car (xmls:xmlrep-children expr)))
                ((equal tag "cn")
                 ;; number
                 (read-from-string (first (xmls:xmlrep-children expr))))
                ((member tag '("apply") :test #'string=)
                 (let ((body (mapcar #'parse-math-ml-expression (xmls:xmlrep-children expr))))
                   (cond ((or (and (listp body)
                                   (= (length body) 1)
                                   (listp (car body))
                                   (> (length (car body)) 1)
                                   (or (eq (car (car body)) 'if)
                                       (and (= (length (xmls:xmlrep-children expr)) 1)
                                            (string= (xmls:xmlrep-tag (car (xmls:xmlrep-children expr)))
                                                     "initial"))))
                              (equal body '(:|true|))
                              (equal body '(:|false|)))
                          (car body))
                         ((equal (car body) "transpose")
                          (cdr body))
                         (t body))))
                ((equal tag "equivalent")
                 '=)
                ((equal tag "real")
                 '+)
                ((equal tag "integer")
                 '+)
                ((equal tag "vector")
                 'boolean-vector)
                ((equal tag "minus")
                 '-)
                ((equal tag "plus")
                 '+)
                ((equal tag "times")
                 '*)
                ((equal tag "divide")
                 '/)
                ((equal tag "lt")
                 '<)
                ((equal tag "gt")
                 '>)
                ((equal tag "leq")
                 '<=)
                ((equal tag "geq")
                 '>=)
                ((equal tag "neq")
                 '<>)
                ((equal tag "or")
                 'or)
                ((equal tag "and")
                 'and)
                ((equal tag "not")
                 'not)
                ((equal tag "smooth")
                 'smooth)
                ((equal tag "pre")
                 'pre)
                ((equal tag "power")
                 'power)
                ((equal tag "exp")
                 'exp)
                ((equal tag "sqrt")
                 'sqrt)
                ((equal tag "log10")
                 'log)
                ((equal tag "ln")
                 'ln)
                ((equal tag "sin")
                 'sin)
                ((equal tag "asin")
                 'asin)
                ((equal tag "sinh")
                 'sinh)
                ((equal tag "cos")
                 'cos)
                ((equal tag "acos")
                 'acos)
                ((equal tag "cosh")
                 'cosh)
                ((equal tag "tan")
                 'tan)
                ((equal tag "atan")
                 'atan)
                ((equal tag "atan2")
                 'atan2)
                ((equal tag "tanh")
                 'tanh)
                ((equal tag "abs")
                 'abs)
                ((equal tag "sign")
                 'sign)
                ((equal tag "true")
                 :|true|)
                ((equal tag "false")
                 :|false|)
                ((equal tag "initial")
                 '(<= "time" 0))
                ((equal tag "reinit")
                 'reinit)
                ((equal tag "max") 'max)
                ((equal tag "min") 'min)
                ((equal tag "real") 'real)
                ((equal tag "noEvent") 'noevent)
                ((equal tag "matrix")
                 (let ((rows (mapcar #'parse-math-ml-expression (xmls:xmlrep-children expr))))
                   (let ((newarray (make-array (list (length rows) (length (car rows))))))
                     (dotimes (i (length rows))
                       (dotimes (j (length (car rows)))
                         (setf (aref newarray i j) (elt (elt rows i) j))))
                     newarray)))
                ((equal tag "matrixrow")
                 (mapcar #'parse-math-ml-expression (xmls:xmlrep-children expr)))
                ((equal tag "math")
                 (parse-math-ml-expression (third expr)))
                ((equal tag "diff")
                 'deriv)
                ((equal tag "piecewise")
                 ;; this has the structure (piecewise (piece (value-if-test) (test)) (otherwise (value-if-not-test)))
                 (let ((piece (xmls:xmlrep-find-child-tag "piece" expr))
                       (otherwise (xmls:xmlrep-find-child-tag "otherwise" expr)))
                   (list 'if
                         (parse-math-ml-expression (second (xmls:xmlrep-children piece)))
                         (parse-math-ml-expression (first (xmls:xmlrep-children piece)))
                         (parse-math-ml-expression (first (xmls:xmlrep-children otherwise))))))
                ;; we assume a small number of "special" functions
                ((assoc tag special-functions-lookup-table :test #'equal)
                 (cdr (assoc tag special-functions-lookup-table :test #'equal)))
          
                (t
                 (error 'unhandled-operator :expr expr :operator tag)
                 )

                ))

      ;; restart handler invoked if we are only logging errors to attempt to continue
      (ignore-error () nil)
      )))
  


(defun mathml->lisp (eqn &optional text-form-in)
  (let ((math-ml (xmls:xmlrep-find-child-tag "MathML" eqn)))
    (let ((text-form (or text-form-in (first (xmls:xmlrep-children eqn)))))
      (when (and math-ml (stringp text-form))
        (list (cons :text-form text-form)
              (cons :lisp-form (parse-math-ml-expression (first (xmls:xmlrep-children math-ml)))))
        ))))

(defun when-equation-condition->lisp (eqn)
  (cons :condition
	(cdr (second (mathml->lisp (xmls:xmlrep-find-child-tag "whenEquationCondition" eqn))))))

(defun promote-boolean-vectors (condition &optional not-top-level?)
  "The condition is prefix notation, and the boolean vector operation is treated as binary by the ->prefix code.  boolean vector is n-ary and should only exist once as the top level predicate"
  (cond ((null condition) nil)
	((and (consp condition)
	      (eql (car condition) 'booleanvector))
	 (if not-top-level? 
	     (append (promote-boolean-vectors (second condition) t)
		     (promote-boolean-vectors (third condition) t))
	     (append (list (car condition))
		     (promote-boolean-vectors (second condition) t)
		     (promote-boolean-vectors (third condition) t))))
	(t (list condition))))
  

(defun replace-modelica-array-or (str)
  (cl-ppcre:regex-replace-all
   "initial\\(\\)"
  (cl-ppcre:regex-replace-all
   ","
   (cl-ppcre:regex-replace-all "[{}]" str " ")
   " booleanvector ")
  "(time <= 0)"
  ))

(defun expand-equations (input-equations vars-hash-table)
  "Given a set of equations, produce extra KVL/KCL equations.

For each equation in input-equations, if it is a summer generate a QR form of it, which
consists only of a set of (name . sign) pairs, in lexicographic order
by name.  Put all these forms in a set (the 'old' set).  Any
conditional equation will not be added.

Create the new set, as a copy of the old set.

Now form all pairs of different equations from the 'old' set and 'new'
set.  For each pair of equations, form the additive and subtractive
forms of the pair.  For each of these, if it is not in the original
set, add it to the 'result' set.

Make the old set be the union of the 'old' set and the 'new' set.
Make the 'new' set be the result set.  Repeat until you have an empty
result set.  Return the 'old' set.

Each input-equation is (= VAR1 (op VAR2)) or (= VAR1 (op VAR2 VAR3))
Ignore if-equations, multiplications, etc.
"
  (when (member :continuity *expand-constraints-of-type*)
;;  (let ((*print-pretty* t))
;;    (format t "input-equations is ~S~%" input-equations))
  
  (setf (system-parse *system-being-analyzed*) input-equations)

  (labels ((find-vars (eqn)
             (cond ((listp eqn)
                    (mapcan #'find-vars eqn))
                   ((var-p eqn)
                    eqn)
                   (t nil)))

           (compare-pairs (p1 p2)
             (or (string-lessp (car p1) (car p2))
                 (and (equal (car p1) (car p2)) (eq (cdr p1) '-) (eq (cdr p2) '+))))

           (simplify (var-pairs)
             (let ((new-form (copy-list var-pairs)))
               (dotimes (i (- (length var-pairs) 1))
                 (let ((this-pair (nth i var-pairs))
                       (next-pair (nth (+ i 1) var-pairs)))
                   (when (and (string-equal (car this-pair) (car next-pair))
                              (eq (cdr this-pair) '-) (eq (cdr next-pair) '+))
                     (setf new-form (remove this-pair (remove next-pair new-form)))
                     )))
               new-form))

           (subtract (e1 e2)
             (append (copy-list e1)
                     (mapcar #'(lambda (x)
                                 (cons (car x) (if (eq (cdr x) '-) '+ '-)))
                             (copy-list e2))))

           (add (e1 e2)
             (append (copy-list e1) (copy-list e2)))

           (compare-equations-for-same-vars (e1 e2)
             (equalp (mapcar #'car e1) (mapcar #'car e2)))

           (has-duplicates (eqn)
             (not (equal eqn (remove-duplicates eqn :test #'equal))))

           (sort-eqn-tree (tree)
             "Move variable-only RHS to the LHS."
             (if (and (listp tree)
                      (= (length tree) 3)
                      (eq '= (first tree))
                      (not (stringp (second tree)))
                      (or (stringp (third tree)) (numberp (third tree))))
                 (list (first tree)
                       (third tree)
                       (second tree))
                 tree))


           (convert-to-pairs-form (sign tree &optional (depth 0))
             ;(format t "~vAconvert-to-pairs-form(~S ~S)...~%" depth "" sign tree)
             (let ((pairs-form
                    (cond ((stringp tree)
                           (list (cons tree sign)))
                          ((numberp tree)
                           nil)
                          ((listp tree)
                           ;; first element is affected by sign passed in,
                           ;; rest elements are affected by combo of sign passed in and
                           ;; sign which is car of tree
                           (let ((new-sign (car tree))
                                 (minuend (car (rest tree)))
                                 (subtrahend (rest (rest tree))))
                             (let ((result
                                    (if subtrahend
                                        (append
                                         (convert-to-pairs-form sign minuend (+ depth 1))
                                         (mapcan #'(lambda (x)
                                                     (convert-to-pairs-form
                                                      (if (eq sign (car tree)) '+ '-) x
                                                      (+ depth 1)))
                                                 subtrahend))
                                        (convert-to-pairs-form new-sign minuend (+ depth 1)))))
                               (remove-if #'null result))))
                          (t
                           (error "tree that's not a list or a string/constant!  ~S" tree))))
                   )
               ;(format t "~vA   => ~S~%" depth "" pairs-form)
               pairs-form))

           (filter-out-extant-equations (result-set originals)
             (let ((inverted-originals
                    (mapcar #'(lambda (x) (if (eq (cdr x) '-) '+ '-)) originals)))
               (remove-if #'(lambda (x)
                              (or (member x originals :test #'equalp)
                                  (member x inverted-originals :test #'equalp)))
                          result-set)))

           (fill-result-set (old-set new-set)
;              (let ((*print-pretty* t))
;                (format t "old set is ~S~%" old-set)
;                (format t "new set is ~S~%" new-set))
             (let ((result-set))
               (dolist (e1 old-set)
                 (dolist (e2 new-set)
;		   (format t "e1: ~S~%" e1)
;		   (format t "e2: ~S~%" e2)
		   (unless (equal e1 e2)
                     (let ((sum (simplify (sort (add e1 e2) #'compare-pairs)))
                           (diff (simplify (sort (subtract e1 e2) #'compare-pairs))))
                       (unless (or (null sum)
                                   (has-duplicates sum)
				   (not (equation-qconstrains? e1 e2 sum vars-hash-table))
                                   (member sum old-set :test #'compare-equations-for-same-vars)
                                   (member sum new-set :test #'compare-equations-for-same-vars))
                         ;(format t "sum ~S and ~S => ~S~%" e1 e2 sum)
                         ;(format t "has-duplicates sum  ~S => ~S~%" sum (has-duplicates sum))
                         (pushnew sum result-set :test #'compare-equations-for-same-vars))
                       (unless (or (null diff)
                                   (has-duplicates diff)
				   (not (equation-qconstrains? e1 e2 diff vars-hash-table))
                                   (member diff old-set :test #'compare-equations-for-same-vars)
                                   (member diff new-set :test #'compare-equations-for-same-vars))
                         ;(format t "diff ~S minus ~S => ~S~%" e1 e2 diff)
                         ;(format t "has-duplicates diff ~S => ~S~%" diff (has-duplicates diff))
                         (pushnew diff result-set :test #'compare-equations-for-same-vars))
                       ))))
               result-set))
           (run-algorithm (initial-set)
             (let ((old-set initial-set)
                   (new-set)
                   (result-set initial-set)
                   (counter 1))
               (loop
                  (if (not result-set)
                      (return (union old-set new-set :test #'compare-equations-for-same-vars)))
                  (setq old-set (union old-set new-set :test #'compare-equations-for-same-vars))
                  (setq new-set result-set)
                  (setq result-set nil)
                  (setq result-set (fill-result-set old-set new-set))
;		  (let ((*print-pretty* t))
;                     (format t "~s: result set is ~S~%" counter result-set))
                  (incf counter)
                  )))
           )

    (let ((eqn-sets (make-hash-table :test #'equalp))
          (result-set)
          (return-value))
      ;; initialize from the input equations
      (dolist (eqn (remove-if-not #'summer-equation? input-equations))
        ;; each equation is (= VAR1 (op VAR2)) or (= VAR1 (op VAR2 VAR3))
	(let ((sorted-eqn (sort-eqn-tree eqn)))
          ;(format t "looking at ~S~%" sorted-eqn)
	  (let ((new-form)
		(rhs (convert-to-pairs-form '+ (third sorted-eqn))))
	    (setq new-form
		  (simplify (sort (if (stringp (second sorted-eqn))
				      (append rhs (convert-to-pairs-form '- (second sorted-eqn)))
				      rhs) #'compare-pairs)))
	  ;   (format t "new-form ~S~%" new-form)
	    ;; figure out what set it belongs to
	    (let ((vtype (var-type (gethash (car (first new-form)) vars-hash-table))))
           ;     (format t "vtype for ~A is ~S~%" (car (first new-form)) vtype)
                (pushnew new-form (gethash vtype eqn-sets))))))

;       (let ((*print-pretty* t))
;         (maphash #'(lambda (k initial-set)
;                      (format t "initial set for ~S is ~S~%" k initial-set))
;                  eqn-sets))

      ;; make the first new-set be a copy of the old-set, and run the algorithm
      (maphash #'(lambda (k initial-set)
                   ;(format t "running expand algorithm for ~S...~%" k)
                   (declare (ignore k))
                   (let ((results (run-algorithm initial-set)))
;                      (format t "    results are ~S...~%" results)
                     (setq result-set (append (filter-out-extant-equations results initial-set)
                                              result-set))))
               eqn-sets)

      ;; (let ((*print-pretty* t))
      ;;   (format t "result set is ~S~%" result-set))

      ;; now turn them back into algebraic equations
      (dolist (new-eqn result-set)
        ;(format t "doing ~S...~%" new-eqn)
        (let ((equation
               (let ((sign (cdr (first new-eqn)))
                     (vname (car (first new-eqn)))
                     (rhs (rest new-eqn)))
                 (cond ((null rhs)
                        (list '= vname 0.0))
                       ((= (length rhs) 1)
                        (list '= vname (if (eq sign (cdr (first rhs))) (list '- (car (first rhs))) (car (first rhs)))))
                       (t
                        (if (eq sign '-)
                            (list '= vname
                                  (cons '+ 
                                        (mapcar #'(lambda (pair) (if (eq (cdr pair) '+) (car pair) (list '- (car pair))))
                                                (rest new-eqn))))
                            (list '= vname
                                  (cons '+
                                        (mapcar #'(lambda (pair) (if (eq (cdr pair) '-) (car pair) (list '- (car pair))))
                                                (rest new-eqn))))))
                       ))))
          ;(format t "    reformatted form is ~S~%" equation)
          (if equation
              (pushnew equation return-value :test #'equalp))))
;       (let ((*print-pretty* t))
;	 (format t "result equations are ~S~%" return-value)
;	 (break))
      return-value))))

;;; [04/02/2014 Johan] The code that follow is incomplete.  The following inference
;;; will not be made:
;;; a+b+c=0
;;; -c+d+e=0
;;; a+b+d+e+f=0
;;; implies f=0.
;;; This will be a problem eventually.  This needs a serious rethinking
;;; and redesign.  Perhaps using matrices, or propositional logic, or modern algebra or
;;; recursion.

(defun collect-vars (eq1 eq2)
  (let ((vars))
    (dolist (v eq1) (pushnew (car v) vars :test #'equal))
    (dolist (v eq2) (pushnew (car v) vars :test #'equal))
    vars))

;;; This can only happen if eq3 is of size 1.
(defun equation-qconstrains? (eq1 eq2 eq3 vars-hash-table)
  ;; [4/21/2014 Johan] Needs to be t only for rc-ladder.
  ;; all other tests work.
  ;; [4/25/2014 Johan] making this t doesn't change any test-tap.
  ;; But it causes a difference on run-depth.
  (when t; (= (length eq3) 1)
    (equation-qconstrains-helper? eq1 eq2 eq3 vars-hash-table)))

(defun equation-qconstrains-helper? (eq1 eq2 eq3  vars-hash-table)
  (debug-print nil "~% equation-qconstrains? ~%eqn1 ~a ~%eqn2~a ~%eqn3~a" eq1 eq2 eq3)
  (let* ((vars (collect-vars eq1 eq2))
	 (ret (some #'(lambda (set)
		       (let ((result
			      (constraint-constrains? eq1 eq2 eq3 set)))
			     result))
		   (build-truth-table-new vars))))
	ret))

(defun constraint-constrains? (constraint1 constraint2 constraint3 set)
  (debug-print nil "~% Entering constraint-constrains?")
  (and (not (satisfies? constraint3 set))
       (satisfies? constraint1 set)
       (satisfies? constraint2 set)))

;;;**** notice equal can be smarter.
(defun satisfies? (eqn binding)
  (let ((sum 'Q0))
    (dolist (pair eqn)
      (let ((val (cdr (assoc (car pair) binding :test #'equal))))
	(unless val (format t "~% Cannot find ~a in ~a" (car pair) binding)
		(error "fail"))
;	(print val)
	(ecase (cdr pair)
	  (+ (setq sum (q-add sum val)))
	  (- (setq sum (q-add sum (q-invert val)))))
	(if (eql sum 'Q?) (return-from satisfies? t))))
    (eql sum 'Q0)))
	
;;; Still very inefficient in conses.
;; If sruvives use ids.
(defun build-truth-table-new (vars)
  (cond ((null (cdr vars)) (list (list (cons (car vars) 'Q-))
				 (list (cons (car vars) 'Q0))
				 (list (cons (car vars) 'Q+))))
	(t (mapcan #'(lambda (set)
		       (list (cons (cons (car vars) 'Q-) set) 
			     (cons (cons (car vars) 'Q0) set) 
			     (cons (cons (car vars) 'Q+) set)))
		   (build-truth-table-new (cdr vars))))))

(defun is-conditional-expression (rhs)
  (cond ((listp rhs)
	 (is-conditional-expression (car rhs)))
        ((member rhs '(< <= > >= <> == not and or))
         t)
        (t nil)))

(defun contains-if? (eqn)
  (or (eq eqn 'if)
      (and (listp eqn) (some #'contains-if? eqn))
      (and (listp eqn)
           (> (length eqn) 2)
           (eq (first eqn) '=)
           (stringp (second eqn))
           (is-conditional-expression (third eqn)))))

;;; Although this finds the correct state variables for MSD, when we use these instead of the "State" trailing technique,
;;; the envisoiner gets errors.
(defun find-differentiated-variables (eqn)
  "Given the lisp form of an equation, find any variable for which the
   derivative is taken.  These are a better guess of the state variables."
  ;; If this approach doesn't work consider looking for (= (deriv y) z) its commutative.
  (cond ((stringp eqn) nil)
	((listp eqn)
	 (cond ((not (eq (car eqn) 'deriv))
		(remove-duplicates (mapcan #'find-differentiated-variables (cdr eqn))))
	       ((not (atom (second eqn))) (error "stub not sure this ever happens"))
	       (t (list (second eqn)))))))

(defun find-assertions (tree)
  (let ((algorithms-sections (xmls:xmlrep-find-child-tags "algorithms" tree)))
    (if algorithms-sections
        (let ((algorithms (xmls:xmlrep-find-child-tags "algorithm" (first algorithms-sections))))
          (let ((final-assertions))
            (dolist (algorithm algorithms)
              (let ((assertions (xmls:xmlrep-find-child-tags "assertion" algorithm)))
                (dolist (assertion assertions)
                  (let ((condition (xmls:xmlrep-find-child-tag "condition" assertion))
                        (message (xmls:xmlrep-find-child-tag "message" assertion)))
                                        ; (format t "condition is ~s~%message is ~s~%" condition message)
                    (if (and condition message)
                        (let ((c1 (mathml->lisp condition "foo"))
                              (m1 (string-trim "\"" (fourth message))))
                          (push (cons c1 m1) final-assertions)))))))
                                        ;(format t "final assertions are ~s~%" final-assertions)
            final-assertions)))))

(defun parse-when-equations (tree)

  "Take the XML parse tree of a DAE, 'tree', and return a list
  of the various equations in it.  For each equation, return the Lisp form."

      (let ((equation-lists (append (xmls:xmlrep-find-child-tags "simpleEquations" tree)
                                    (xmls:xmlrep-find-child-tags "equations" tree)
                                    ))
            (eqs))
        ;;     (format t "equation lists are ~s~%" equation-lists)
        ;; [11/15/2013 klenk] They could be in the equations or the when clauses
        (dolist (elist equation-lists)
            
          (dolist (eqn (xmls:xmlrep-find-child-tags "whenEquation" elist))
                                        ;        (format t "whenEqn is ~s~%" eqn)

            (restart-case
                
                (let ((parsed (mathml->lisp eqn))
                      (condition (when-equation-condition->lisp eqn)))
                  (assert (and parsed condition))
                  (push (cons  condition parsed) eqs))

              (ignore-error () nil)
              )))

        (dolist (clause (xmls:xmlrep-find-child-tags 
                         "WhenClause"
                         (xmls:xmlrep-find-child-tag "whenClausesList" tree nil)))
          (restart-case

              (let ((condition (cdr (assoc :lisp-form (mathml->lisp (xmls:xmlrep-find-child-tag "WhenEquationCondition" clause))))))
                (dolist (op (xmls:xmlrep-find-child-tags "WhenOperator" (xmls:xmlrep-find-child-tag "WhenOperatorsList" clause)))
                  (let ((parse (mathml->lisp op)))
                    (assert (and condition parse))
                    (push (cons (cons :condition condition) parse) eqs))))

              (ignore-error () nil)
              ))
          
        ;; return our when-equations
        eqs))


(defun parse-equations (tree)

  "Take the XML parse tree of a DAE, 'tree', and return a list
  of the various equations in it.  For each equation, return the Lisp form."

  (let ((equation-lists (append (xmls:xmlrep-find-child-tags "simpleEquations" tree)
                                (xmls:xmlrep-find-child-tags "equations" tree)
				))
        (eqs)
        (modes))
;    (format t "equation lists are ~s~%" equation-lists)
    (dolist (elist equation-lists)
      (dolist (eqn (xmls:xmlrep-find-child-tags "equation" elist))
;         (format t "eqn is ~s~%" eqn)

        (restart-case
            (let ((parsed (mathml->lisp eqn)))
              (when parsed
                (if (contains-if? (cdr (assoc :lisp-form parsed)))
                    (push parsed modes)
                    (push parsed eqs))))

          (ignore-error () nil)
        )))
                                        ;    (format t "~%state vars are ~a~%" state-vars)
    (values eqs modes)))

(defvar *through-types*
  '("ElectricCurrent"))
(defvar *across-types*
  '("ElectricPotential"))

;; [11/18/2013 klenk] fixed here refers to modelica fixed for the initial equation system
(defun figure-fundamental-type (type fixed flow quantity-type units known?)
  (declare (ignore fixed units flow))
  "Figure the QSpace fundamental-type for the variable."
  
  (cond (known? :fixed-parameter)
	((or (equal type "Boolean")
	     (equal type '(:|false| :|true|)))
	 :discrete)
        ((listp type) :discrete)
        ((member quantity-type *through-types* :test #'equal) :through)
        ((member quantity-type *across-types* :test #'equal) :across)
        (t :variable)))

(defun figure-initial-value (name var &optional known?)
  ;; there are three ways an initial value might be assigned.
  ;; In order, we prefer them as
  ;; 1.  The value of a bindValueExpression, which is a constant.
  ;; 2.  The value of attributesValues/initialValue, which is an initial value
  ;;     for state variables, discrete and fixed variables.
  ;; 3.  A value in an "initial equations" section, which is done elsewhere.
  (declare (ignore name known?))
  (cond ((find-tag var '("bindValueExpression"))
         (block nil
           ;; OK, we've got one of these, so parse it...
                                        ;(format t "~s~%" name)
           ;; might be a simple number...
           (let ((cn (find-text-tag
                      var '("bindValueExpression" "bindExpression" "MathML" "math" "cn"))))
                                        ;(format t "cn is ~s~%" cn)
             (if cn (return (read-from-string cn))))
           
           ;; or a name of an enumerated value...
           (let ((ci (find-text-tag
                      var '("bindValueExpression" "bindExpression" "MathML" "math" "ci"))))
                                        ;(format t "ci is ~s~%" cn)
             (if ci (return ci)))
           
           ;; or a boolean constant...
           (let ((bool (or (find-tag var '("bindValueExpression" "bindExpression" "MathML" "math" "apply" "false"))
                           (find-tag var '("bindValueExpression" "bindExpression" "MathML" "math" "apply" "true")))))
                                        ;(format t "bool is ~s~%" cn)
             (if bool (return (xmls:xmlrep-tag bool))))
           
           ;; or a MathML expression...
           (let ((mathml (find-tag var '("bindValueExpression" "bindExpression"))))
             (if mathml
                 (return
                   (let ((v (mathml->lisp mathml (xmls:xmlrep-attrib-value "string" mathml nil))))
                                        ;(format t "mathml is ~s~%" v)
                     (cdr (assoc :lisp-form v))))))
           
           ;; or something we don't understand yet.
           (error "unhandled case ~s" var)))

        ((and (find-tag var '("attributesValues" "initialValue"))
	      (or 
	       (xml-state-var? var)
	       (xml-discrete-var? var)
	       (xml-fixed-var? var) ;; used to be known?
	       )
	      )
         (xmls:xmlrep-attrib-value "string" (find-tag var '("attributesValues" "initialValue"))))
	((and (find-tag var '("attributesValues" "initialValue"))
	      (xml-variability-parameter-var? var)) ;; used to be known?
         (xmls:xmlrep-attrib-value "string" (find-tag var '("attributesValues" "initialValue"))))
        ))

(defun xml-variability-parameter-var? (var)
  (let ((variability (or (xmls:xmlrep-attrib-value "variability" var nil) "")))
    (string= variability "parameter")))

(defun xml-state-var? (var)
  (let ((variability (or (xmls:xmlrep-attrib-value "variability" var nil) "")))
    (string-ends-with variability "State")))

(defun xml-discrete-var? (var)
  (let ((variability (or (xmls:xmlrep-attrib-value "variability" var nil) "")))
    (string-begins-with variability "Discrete")))

(defun xml-fixed-var? (var)
  (let ((fixed? (or (xmls:xmlrep-attrib-value "fixed" var nil) "")))
    (string-ends-with fixed? "true")))

(defun parse-variables (tree)

  "Take the XML parse tree of a DAE, 'tree', and return a list
   of the various variables mentioned in it.  For each variable,
   return the name, type, and either the fixed value, or nil if
   not a fixed value."

  (let ((variable-lists (xmls:xmlrep-find-child-tag "variables" tree))
        (vars)
        (enumerated-types (make-hash-table :test #'equal)))
    (dolist (vlist (xmls:xmlrep-find-child-tags "orderedVariables" variable-lists))
      (dolist (var (parse-var-list vlist nil enumerated-types))
	(push var vars)))
    (dolist (vlist (xmls:xmlrep-find-child-tags "knownVariables" variable-lists))
      (dolist (var (parse-var-list vlist t enumerated-types))
	(push var vars)))
    (values vars enumerated-types)))

;; [06/10/2013 klenk] Perhaps turn integers into enumerations
(defun parse-enumerated-types (tname)
  (if (string-begins-with tname "enumeration")
      (multiple-value-bind (matchwhole matches)
          (cl-ppcre:scan-to-strings "(?:enumeration\\s*\\()([a-zA-Z0-9_,\\s]+)\\)\\s*" tname)
        (declare (ignore matchwhole))
        (when matches
          (mapcar #'(lambda (s)
                      (or (find-symbol s :keyword) (intern s :keyword)))
                  (cl-ppcre:split "\\s*,\\s*" (aref matches 0)))))
      ;; else
      (if (string-equal tname "Boolean")
          '(:|false| :|true|)
          ;; else
          tname)))

(defun match-number (s)
  (multiple-value-bind (mstart mend reg-starts reg-ends)
      (cl-ppcre:scan "\\s*[+-]?([0-9]*\\.)?[0-9]+\\s*" s)
    (declare (ignore reg-starts reg-ends))
    (and mstart (= mstart 0) (= mend (length s)))))  

(defun parse-var-list (vlist known? enumerated-types)
  (mapcar
   #'(lambda (var)
       (restart-case
           (let ((name (xmls:xmlrep-attrib-value "name" var nil))
                 (type (parse-enumerated-types (xmls:xmlrep-attrib-value "type" var nil)))
                 (fixed (equal "true" (xmls:xmlrep-attrib-value "fixed" var nil)))
                 (flow (equal "Flow" (xmls:xmlrep-attrib-value "flow" var)))
                 (initial-value 
                                        ;	      (when known?
                  (figure-initial-value (xmls:xmlrep-attrib-value "name" var nil) var known?)
                                        ;		)
                   )
                 (quantity-type (find-text-tag var '("attributesValues" "quantity" "MathML" "math" "cn")))
                 (units (find-text-tag var '("attributesValues" "unit" "MathML" "math" "cn")))
                 (variability (or (xmls:xmlrep-attrib-value "variability" var nil) ""))
                 (scoped-name
                  (let ((class-names (find-tag var '("classesNames"))))
                    (if class-names
                        (mapcar #'(lambda (element) (first (xmls:xmlrep-children element)))
                                (xmls:xmlrep-find-child-tags "element" class-names))
                        (list "anonymous")))))
                                        ;	 (format t "~% Variability of ~a is ~a we think its a state: ~a" name variability (not (null (string-ends-with variability "State"))))
             
             ;; note and remember any enumerated types found along the way
             (if (and (listp type)
                      (null (gethash (car (last scoped-name)) enumerated-types)))
                 (setf (gethash (car (last scoped-name)) enumerated-types) type))
             (list (cons :name name)
                   (cons :type type)
                   ;; Parameter types have "fixed=true" by default, but OM doesn't know that
                   ;; So we assume fixed=true for parameters.
                   (cons :fixed (or fixed (string-equal variability "parameter")))
                   (cons :flow flow)
                   (cons :continuous (not (null (string-begins-with variability "continuous"))))
                   (cons :statevar (not (null (string-ends-with variability "State"))))
                   (cons :quantity-type quantity-type)
                   (cons :units units)
                   (cons :scoped-name scoped-name)
                   (cons :initial-value
                         (when initial-value
                       (cond ((and (listp type) (stringp initial-value))
                              (intern (car (last (cl-ppcre:split "\\." initial-value))) :keyword))
                             ((and (equal type "Real") (stringp initial-value) (match-number initial-value))
                              (read-from-string initial-value))
                             (t initial-value))))
	       (cons :fundamental-type (figure-fundamental-type type fixed flow quantity-type units known?))
	       (cons :known? known?)
	       )
	 )
         (ignore-error () nil)
         ))
   (xmls:xmlrep-find-child-tags "variable" (xmls:xmlrep-find-child-tag "variablesList" vlist))))


(defun parse-zero-crossings (tree)
  (let ((parsed-form)
        (zero-crossings (xmls:xmlrep-find-child-tags "zeroCrossingList" tree)))
    (when zero-crossings
      (dolist (crossing (xmls:xmlrep-find-child-tags "zeroCrossingElement" (car zero-crossings)))
        (let ((v (mathml->lisp crossing (xmls:xmlrep-attrib-value "string" crossing nil))))
          (push v parsed-form))))
    parsed-form))


(defun figure-list-value (expr varmap &key (indent 0))

  "Try to figure the value of 'expr' by looking at the values already
in varmap, and performing appropriate arithmetic.  If calculation of the value
requires values not already bound in varmap, return NIL."

  (labels ((evaluate-node (node)
             (let ((value (cond ((stringp node)
                                 (gethash node varmap))
                                ((var-p node)
                                 (gethash (var-local-name node) varmap))
                                ((numberp node)
                                 node)
                                ((symbolp node)
                                 node)
                                ((member node '(* - + /))
                                 node)
                                ((listp node)
                                 (let ((v (figure-list-value node varmap :indent (+ indent 1))))
                                   v))                                   
                                (t node))))
                (if (null value)
                   (return-from figure-list-value nil))
                value))
           )
    (let ((newexpr (mapcar #'evaluate-node expr)))
      ;; if we get this far, every element of the newexpr list has a value
      (cond ((and (member (car newexpr) '(* - + /))
		(every #'numberp (rest newexpr)))
	   ;; sum the numbers
	   (apply (car newexpr) (rest newexpr)))
	  ((and (member (car newexpr) '(< <= > >=))
		(every #'numberp (rest newexpr)))
	   (if (apply (car newexpr) (rest newexpr))
	       :|true|
	       :|false|))
          ((eql (car newexpr) 'if)
           ;; assume simple (if <cond> <v1> <v2>)
           (if (second newexpr) (third newexpr) (fourth newexpr)))
	  ((eql (car newexpr) :tempinterpol1)
	   (figure-initial-value-of-table (second newexpr)
					  (third newexpr)
					  (fourth newexpr) varmap))
	  ;; or return the list
	  (t newexpr)))))

;; [06/14/2013 klenk] Assumes that inital-value tables are used as indexs to known elements
;; [06/14/2013 klenk] Does not do any interpolation
(defun figure-initial-value-of-table (input table output-col varmap)
  (assert (= output-col 2))
;; [06/17/2013 klenk] If there is no input, then this is not a known value
  (when (numberp input)
    (let ((real-table (replace-initial-value-table-with-reals table varmap)))
      (when real-table
        (destructuring-bind (rows cols)
            (array-dimensions real-table)
          (declare (ignore cols))
          (dotimes (row rows)
            (when (= (aref real-table row 0) input)
              (return-from figure-initial-value-of-table (aref real-table row 1))))
          (error "Interpolation required when processing known values"))))))


;; [06/14/2013 klenk] This has the same logic as replace-interpolation-params-with-reals-1
;; [06/14/2013 klenk] just that the reals are stored in a different format
(defun replace-initial-value-table-with-reals (table varmap)
  (format t "~&table is ~S~%" table)
  ;; (format t "Vars are:~%")
  ;; (maphash #'(lambda (key value)
  ;;              (format t "   ~S: ~S~%" key value))
  ;;          varmap)
  (let* ((array table)
	 (array-ret (make-array (array-dimensions array))))
    (destructuring-bind (rows cols)
	  (array-dimensions array)
	(dotimes (row rows)
	  (dotimes (col cols)
	    (let* ((table-ent (aref array row col))
		   (value 
		    (gethash 
		     (if (listp table-ent)
			 (var-local-name (car table-ent))
			 table-ent)
		    varmap)))
              (if (null value)
                  ;; we need a value here, but it isn't bound in varmap yet,
                  ;; apparently
                  (return-from replace-initial-value-table-with-reals nil))
	      (assert (numberp value))
	      (setf (aref array-ret row col) value)))))
     array-ret))

;; [03/27/2014 klenk] very clueless about how this code works or what it does
;; We should only deal with these initial conditions after we have the known values
;; from the other variables
;; Therefore lets drop this entirely for the moment
(defun simplify-initial-conditions (initial-conditions variables)
  ;(format t "simplify-initial-conditions ~%" )


  (let ((varmap (make-hash-table :test #'equal))
         (changed t))
     (loop while changed do
          ;(format t "doing simplification pass...~%")
          (setq changed nil)
          (dolist (condition initial-conditions)
            (let* ((var (first condition))
		   (rhs (third condition))
		   (curr (gethash (var-local-name var) varmap)))
              (unless curr
		;; [05/09/2014 Johan] I added q-quantity, not sure this is the right way to to do this.
                (cond ((or (numberp rhs) (symbolp rhs) (q-quantity-p rhs))
                       (setf (gethash (var-local-name var) varmap) rhs)
                       (setq changed t)
                       )
                      ((and (stringp rhs) (match-number rhs)
                            (or (string= (var-type var) "Real")
                                (string= (var-type var) "Integer")))
                       (setf (gethash (var-local-name var) varmap) (read-from-string rhs))
                       (setq changed t)
                       )
                      ((and (stringp rhs) (gethash rhs varmap))
                       (setf (gethash (var-local-name var) varmap) 
			     (gethash rhs varmap))
  ;                     (setq initial-conditions (remove condition initial-conditions))
                       ;(format t "  removed ~s~%" condition)
                       (setq changed t)
                       )
                      ((and (listp rhs))
                       (let ((v (figure-list-value rhs varmap)))
                         (when (or (symbolp v) (numberp v))
                           (setf (gethash (var-local-name var) varmap) v)
                                        ;                          (setq initial-conditions (remove condition initial-conditions))
                                        ;(format t "  removed ~s~%" condition)
                           (setq changed t))))
                      ((and (var-p rhs) (gethash (var-local-name rhs) varmap))
                       (setf (gethash (var-local-name var) varmap) (gethash (var-local-name rhs) varmap))
;                       (setq initial-conditions (remove condition initial-conditions))
                       ;(format t "  removed ~s~%" condition)
                       (setq changed t))
		      

                      )
                ))))
;; [09/ 1/2012 klenk] At this point, the hash map will have the initial values
;; [09/ 1/2012 klenk] Therefore we just need to replace the string values with
;; [09/ 1/2012 klenk] the appropriate constants
     (let ((ret)
	   (fixed-vars (mapcar #'car (append
				      (modelica-pre-values initial-conditions)
				      (modelica-fixed-vals initial-conditions)))))
  ;(format t "simplify-initial-conditions ~%" )
      (maphash #'(lambda (key value)
		   (let ((var (gethash key variables)))
		     (push (list var :start value
				 :fixed? (or (var-fixed? var)
					     ;; ****JDK added this, not sure its right.
					     (find var fixed-vars))
				 
				 )
			   ret)))
              varmap)
;;; [05/09/2014 Johan] ret now contains an entry for every var in the hash table.
      (setq *foo* ret)

       ;; now look for dummy variables that represent other values
;; [09/ 1/2012 klenk] key is a string value is the var
     (maphash #'(lambda (key value)
                  (when (and (>= (length key)  5)
                             (equal (subseq key 0 5) "dummy")
                             (var-type value)
                             (listp (var-type value)))
                    (unless (member value ret :key #'first)
                      (let ((new-value (figure-list-value (var-type value) varmap)))
;; [09/04/2012 klenk] If it was computed from things that were fixed it should be fixed
			
                        (if (numberp new-value)
			    (push (list value :start new-value :fixed? nil)
				  ret)
			    )
                        ))))
             variables)
  ;   (break)

     ret)
    ))


  
(defun handle-if-expression (expr ics &optional existing-condition)

  "Takes an if-expression 'expr' and optionally an existing lisp form
of a condition, and returns a list of (condition . expression) dotted
pairs, where for each pair the car is the condition which must return
true for the cdr to be 'in force'.  The cdr is a non-conditional
expression which holds when the car is T."
  (let ((result
         (labels ((join-conditions (c1 c2)
                    (assert (and (listp c1) (listp c2)))
                    (cond ((eq c1 c2) c1)
                          ((and c1 c2) (remove-duplicates (concatenate 'list c1 c2)
							  :test #'equalp))
                          (c1 c1)
                          (c2 c2)))

                  (listify (x)
                    (if (listp x) x (list x)))

                  (negate-condition (c)
                    (if (and (listp c)
			     (eq (car c) 'not))
                        (handle-boolean-variable (second c))
                        (cons 'not (list c))))

                  (handle-boolean-variable (c)
;                    (format t "handle-boolean-variable ~S ~s ~s~%" c (and (var-p c) (var-fundamental-type c))
;			    (and (var-p c) (var-type c)))
                    (cond ((and (listp c)
                                (= (length c) 1)
                                (var-p (car c))
                                (eq (var-fundamental-type (car c)) :discrete)
                                (eq (var-type (car c)) 'env2-names::|Boolean|))
;; [09/07/2012 klenk] We should be able to just handle a variable here.
;; [09/07/2012 klenk] If we do replacements it gets bad with pre's
			   c
                           ;(list (list '== (car c) :|true|)))
			   )
                          ((null c)
                           nil)
                          ((listp c)
                           (cons (handle-boolean-variable (car c)) (handle-boolean-variable (cdr c))))
                          (t
                           c)))
                  )

           (setf existing-condition (handle-boolean-variable existing-condition))
           (cond ((not (listp expr))
                  (list (cons (listify existing-condition) (handle-boolean-variable expr))))
                 ((equal (car expr) 'if)
                  (concatenate 'list
                   (handle-if-expression (third expr) ics
                                         (if existing-condition
                                             (cons (second expr) existing-condition)
                                             `(,(second expr))))
                   (handle-if-expression (fourth expr) ics
                                         (if existing-condition
                                             (cons `(not ,(second expr)) existing-condition)
                                             `(,(negate-condition (second expr)))))))
                 ;; need a little y-combinator action here
                 ((= (length expr) 2)
                  (mapcar #'(lambda (x) 
			      (cons (car x) (list (car expr) (cdr x))))
                          (handle-if-expression (second expr) ics existing-condition)))
                 ((= (length expr) 3)
                  (let ((seconds (handle-if-expression (second expr) ics existing-condition))
                        (thirds (handle-if-expression (third expr) ics existing-condition))
                        (results))
                    (mapcar
                     #'(lambda (secondary)
                         (mapcar
                          #'(lambda (tertiary)
                              (push (cons (join-conditions (listify (car secondary))
                                                           (listify (car tertiary)))
                                          (list (car expr) (cdr secondary) (cdr tertiary)))
                                    results))
                          thirds))
                     seconds)
                    results))
                 ((= (length expr) 4)
                  (let ((seconds (handle-if-expression (second expr) ics existing-condition))
                        (thirds (handle-if-expression (third expr) ics existing-condition))
                        (fourths (handle-if-expression (fourth expr) ics existing-condition))
                        (results))
                    (mapcar
                     #'(lambda (secondary)
                         (mapcar
                          #'(lambda (tertiary)
                              (mapcar
                               #'(lambda (quaternary)
                                   (push (cons (join-conditions
                                                (join-conditions (listify (car secondary)) (listify (car tertiary)))
                                                (listify (car quaternary)))
                                               (list (car expr) (cdr secondary) (cdr tertiary) (car quaternary)))
                                         results))
                               fourths))
                          thirds))
                     seconds)
                    results))
                 (t (error (format nil "unexpected if-expression ~A" expr)))
           ))))
;    (format t "handle-if-exp ~A => ~A~%" expr result)
    result))



;; [08/28/2012 klenk] new-equ is a a list of the form (= <dummy> (<op> <var1> <var2>))
(defun propagate-dummy-attributes (new-equ)
  (error "deprecated")
  (unless (eql (car (third new-equ)) 'if)
    (setf (var-state-var? (second new-equ))
	  (dummy-state-var? (third new-equ))
	  (var-fixed? (second new-equ))
	  (dummy-fixed? (third new-equ))
;; [04/ 2/2013 klenk] This is the wrong place for this
	  ;(var-fundamental-type (second new-equ))
	  ;(dummy-fundamental-type (third new-equ))
	  )))



;; (defun maybe-update-conditions-with-enum (system)
;;   (dolist (constraint (system-constraints system))
;;     (setf (constraint-condition constraint)
;; 	  (maybe-update-condition-with-enum (constraint-condition constraint))))) 

;; (defun maybe-update-condition-with-enum (condition)
;;   (cond ((null condition) nil)
;; 	((var-p condition) condition)
;; 	((member (car condition) '(or and not))
;; 	 (cons (car condition)
;; 	       (mapcar #'(lambda (c1)
;; 			   (maybe-update-condition-with-enum c1))
;; 		       (cdr condition))))
;; 	((discrete-equality? condition)
;; 	 ;(replace-dummy-var-with-value condition)
;; 	 condition  ;;maybe we don't have to do this?
;; 	 )
;; 	(t condition)))


;; (defun replace-dummy-var-with-value (condition)
;;   (let ((lhs (cadr condition))
;; 	(rhs (caddr condition)))
;;   (list '= 
;; 	(if (discrete-expression? lhs)
;; 	    lhs
;; 	    (discrete-val-for-var lhs))
;; 	(if (discrete-expression? rhs)
;; 	    rhs
;; 	    (discrete-val-for-var rhs)))))

;; (defun discrete-val-for-var (var)
;;   (assert (and (var-p var)
;; 	       (var-fixed? var)
;; 	       (integerp (var-type var))))
;;   (var-type var))
;; [06/14/2013 klenk] 
	
	

(defun discrete-equality? (condition)
  (when (listp condition)
    (let ((lhs (cadr condition))
	  (rhs (caddr condition)))
      (and (eql (car condition) '=)
	   (or (discrete-expression? lhs)
	       (discrete-expression? rhs))))))

(defun discrete-expression? (exp)
  (or (discrete-var? exp)
      (and (consp exp)
	   (eql (car exp) 'pre))))
	
;; [06/13/2013 klenk] Should we change the integers in the rhs to the discrete values?
;; [06/13/2013 klenk] If we do, we are going to have to remember the mapping to overwrite
;; [06/13/2013 klenk] the conditionals in which the mode var appears
(defun maybe-convert-integer-to-enum (form vars-hash-table)
  "if the lhs of the equation is an integer that is really a mode, we will
update fundamental-type slot on the variable and the qspaces."
  (let ((var (gethash (second form) vars-hash-table)))
    (cond ((var-integer? var)
	   (setf (var-fundamental-type var) :discrete
		 (var-qspaces var) (list
				    (remove-duplicates 
				     (create-enums-for-rhs (third form)))))
	   (values form (car (var-qspaces var))))
	  (t form))))

;; [06/13/2013 klenk] Form should only inlcude conditional operators
;; [06/13/2013 klenk] every atomic consequent should only be an integer
(defun create-enums-for-rhs (conditional)
  (cond ((null conditional) nil)
	((integerp conditional) (list conditional)) 
	((eql (car conditional) 'if)
	 (append (create-enums-for-rhs (third conditional))
		 (create-enums-for-rhs (fourth conditional))))
	(t (error "Unexpected righthand side of mode equation ~A" conditional))))


(defun var-integer? (var)
  (and (var-p var)
       (eql (var-type var)
	    (intern "Integer" +env2-names+))))

(defun walk-tree-replacing-variable-names (tree vars)
  "Replace variable references (by name) with var structs"
  (restart-case
      (mapcar #'(lambda (node)
                  (cond ((stringp node)
                         ;; variable
                         (let ((var (gethash node vars)))
                           (if (not var)
                               (error "unknown var ~s~%" node)
                               var)))
                        ((or (symbolp node) (numberp node))
                         node)
                        ((listp node)
                         (walk-tree-replacing-variable-names node vars))
                        ((arrayp node)
                         (replace-array-vars node vars))
                        (t
                         (error "Unhandled equation node ~s" node))))
              tree)
    (ignore-error () nil)
    ))

(defun replace-array-vars (node vars)
  (dotimes (i (array-total-size node))
    (setf (row-major-aref node i)
	  (walk-tree-replacing-variable-names (list (row-major-aref node i)) vars)))
  node)


(defun value-in-ics (var ics)
  (cond ((and (var-p var)
	      (var-fixed? var)
	      (fifth (find var ics :key #'car)))
	 (if (stringp (third (find var ics :key #'car)))
	     (value-in-ics (car (find (third (find var ics :key #'car))
				      ics :key #'car))
			   ics)
	     (third (find var ics :key #'car))))
  ;; [07/29/2013 klenk] This is going to get terrible!?!?!
	((listp var)
	 (case (car var)
	    (abs 
	     (let ((val (value-in-ics (second var) ics)))
	       (if (and val (not (eq val :unknown))) 
		   (abs val)
		   :unknown)))
	    ((- +) 
	     (let ((lhs (value-in-ics (second var) ics))
		   (rhs (if (third var) (value-in-ics (third var) ics) nil)))
	       (cond ((or (eq lhs :unknown)(eq rhs :unknown)) :unknown)
		     (rhs (funcall (car var) lhs rhs))
		     (t (funcall (car var) lhs)))))
	    (t :unknown)))
	(t :unknown)))
      

(defun evaluate-condition-with-ics (condition ics)
  (cond ((var-p condition)
	 (evaluate-condition-with-ics 
	  (list '= condition :|true|) ics))
	(t
	 (ecase (car condition)
	   (>= 
	    (evaluate->=-with-ics 
	     (second condition) (third condition) ics))
	   (<= 
	    (evaluate->=-with-ics  (third condition)(second condition) ics))
	   (> 
	    (evaluate->-with-ics (second condition) (third condition) ics))
	   (<
	    (evaluate->-with-ics (third condition) (second condition) ics))
	   ((q= == =)
	    (evaluate-=-with-ics (second condition)(third condition) ics))
	   (not 
	    (ecase (evaluate-condition-with-ics (second condition) ics)
	      (:true :false)
	      (:false :true)
	      (:unknown :unknown)))
	   (and
	    (cond ((every #'(lambda (c)
			      (eql 
			       (evaluate-condition-with-ics c ics)
			       :true))
			  (cdr condition))
		   :true)
		  ((some #'(lambda (c)
			     (eql (evaluate-condition-with-ics c ics)
				  :false))
			 (cdr condition))
		   :false)
		  (t :unknown)))
	   (or
	    (cond ((every #'(lambda (c)
			      (eql 
			       (evaluate-condition-with-ics c ics)
			       :false))
			  (cdr condition))
		   :false)
		  ((some #'(lambda (c)
			     (eql (evaluate-condition-with-ics c ics)
				  :true))
			 (cdr condition))
		   :true)
		  (t :unknown)))
	   ))))

(defun evaluate->=-with-ics (lhs rhs ics)
  (let ((lhs-val (value-in-ics lhs ics))
	(rhs-val (value-in-ics rhs ics)))
  (cond ((or (eq lhs-val :unknown)
	     (eq rhs-val :unknown))
	 :unknown)
	((>= lhs-val rhs-val)
	 :true)
	(t
	  :false))))

(defun evaluate->-with-ics (lhs rhs ics)
  (let ((lhs-val (value-in-ics lhs ics))
	(rhs-val (value-in-ics rhs ics)))
  (cond ((or (eq lhs-val :unknown)
	     (eq rhs-val :unknown))
	 :unknown)
	((> lhs-val rhs-val)
	 :true)
	(t
	 :false))))

(defun evaluate-=-with-ics (lhs rhs ics)
  (let ((lhs-val (value-in-ics lhs ics))
	(rhs-val (value-in-ics rhs ics)))
    (cond ((or (eq lhs-val :unknown)
	       (eq rhs-val :unknown))
	   :unknown)
	  ((= lhs-val rhs-val)
	   :true)
	  (t
	   :false))))

;; [11/28/2012 klenk] An equation which could used as a general summer constraint
(defun summer-equation? (form)
  (labels (

           ;; [11/28/2012 klenk] Every operator must be '+ or '-
           (summer-expr? (form)
             (cond ((atom form) t)
                   ((listp form)
                    (and (member (car form) '(+ -))
                         (every #'summer-expr? (rest form)))
                    )))
           )
    (and (eql (car form) '=)
         (summer-expr? (second form))
         (summer-expr? (third form))
         )))

(defun format-lisp-form-properly (form vars-hash-table model ics
				  &key (require-equation t)
				  (when-equation? nil))
  "To use create-equations to build the constraints, we need to re-factor
the lisp form so that variable names are replaced with variable structs,
and variables are always the left-hand side of the equation."

;  (format t "~%~%~% format-lisp-form-properly initial form is ~s" form)
  ;; first replace the vars with entries from the hash table
  (when (and require-equation 
	     (not (member (car form) '(= >))))
    (error "Form ~s not an equation!" form))
  (let ((new-eqns)
        (new-vars)
	(discrete-enum))
    (labels ((make-dummy-var-1 (name)
	       (let ((new-var))
                 ;; first, see if there's already a dummy var for this expression
		 (maphash #'(lambda (key value)
                              (declare (ignore key))
			      (if (or 
				   (equal name (var-type value))
				   (and (listp name)
					(eql (car name) 'deriv)
					(var-p (second name))
					(var-p value)
					(stringp (var-type value))
					(string= (format nil "d~A/dt" 
							 (var-local-name (second name)))
						 (var-type value))))
				  (setf new-var value)))
                          vars-hash-table)
                 
		 (if (null new-var)
                     (setf new-var (make-dummy-var name model)))
		 (when discrete-enum
;		   (format t "~% discrete-enum ~A" discrete-enum)
;		   (format t "~% name ~A" name)
;		   (format t "~% new-var ~A" new-var)
		   (setf (var-qspaces new-var) discrete-enum
			 (var-discrete-var? new-var) t))
		 ;; [07/30/2013 klenk] It is ok that these aren't propagated back up as this information
;; [07/30/2013 klenk] is redundant with the created equation
		 (when (numberp name)
		   (pushnew (list new-var :start name :fixed? t) ics
			    :test #'equal))
		 (push new-var new-vars)
		 (setf (gethash (var-local-name new-var) vars-hash-table) new-var)
		 (debug-print nil "~% make-dummy-var-1 ~A => ~A " name new-var )
		 new-var))
             (walk-tree-transforming-modelica-expressions (expr)
               (if (listp expr)
                   (cond ((eq (car expr) 'smooth)
                          ;; just remove it
                          (walk-tree-transforming-modelica-expressions (third expr)))
                         ((eq (car expr) 'exp)
                          ;; just remove it
                          (walk-tree-transforming-modelica-expressions (second expr)))
			 ((eq (car expr) :tempinterpol1)
			  (let* ((new-var (make-dummy-var-1 expr))
				 (new-eqn (simplify-equation (list '= new-var expr))))
			    
			    (debug-print nil "~% Pushing new eqn for tempinterpol1 ~a" expr)
			    (push new-eqn new-eqns)
			    new-var))
			 ((eq (car expr) 'pre)
;; [07/25/2013 klenk] This could cause a problem in events that change the value
;; [07/25/2013 klenk] of the pre-variable
			  (warn "removing Modelica pre operator ~A" expr) 
			  (walk-tree-transforming-modelica-expressions (second expr))
			  )
			 (t
                          (mapcar #'walk-tree-transforming-modelica-expressions expr)))
                   expr))
             (walk-tree-replacing-constants (expr enumerated-type-qspace)
;	       (format t "~% walk-tree-replacing-constants ~A" expr)
               (if (listp expr)
                   (mapcar #'(lambda (x)
;; [06/13/2013 klenk] Do not create a dummy var for anything that is in the quantity
;; [06/13/2013 klenk] space of the lhs?
                               (cond ((member x enumerated-type-qspace) x)
;; [06/13/2013 klenk] Do not create a dummy var for a discrete equality either
				     ((discrete-equality? x) x)
				     ((and (listp x)
					   (member (car x) *modelica-fns*))
				      x)
				     ;; Why create a useless dummy?
;				     ((numberp x) x)
				     ((numberp x)
				      ;; [04/06/2014 Johan] This creates a useless dummy which immediately gets
				      ;; eliminated.
                                      (let* ((new-var (make-dummy-var-1 x))
                                             (new-eqn (simplify-equation (list '= new-var x))))
					;                                        (format t "added new equation ~a~%" new-eqn)
                                        (push new-eqn new-eqns)
                                        new-var))
                                     ((listp x)
                                      (walk-tree-replacing-constants
				       x enumerated-type-qspace))
                                     (t x)))
                           expr)
                   expr))

             (walk-tree-simplifying-conditions (expr &optional (top-level?))
               "Conditional expressions such as X < Y cause problems down the line.
                Replace them all with an equation D = X - Y and the condition (< D 0)."

;	       (format t "~% walk-tree-simplifying-conditions ~A" expr)
	       
               (cond ((and (not top-level?)
			   (listp expr)
			   (= (length expr) 3)
			   (member (car expr) '(< > >= <=)))
                      (let ((second-elt (replace-subexpressions (second expr)))
                            (third-elt (replace-subexpressions (third expr))))
                        (if (and (var-p second-elt) (var-p third-elt))
                            (let* ((new-var (make-dummy-var-1 (list '- second-elt third-elt)))
                                   (new-eqn (simplify-equation (list '= new-var (list '- second-elt third-elt)))))
;; [11/14/2013 klenk] Should not need this anymore
;	       		      (propagate-dummy-attributes new-eqn)
                              (push new-eqn new-eqns)
                              (list (car expr) new-var 0.0))
                            expr)))
                     ((listp expr)
	       	      (mapcar #'walk-tree-simplifying-conditions expr))
                     (t
                      expr))
	       )
             
             (walk-tree-ordering-branches (tree)
               "Move variable-only RHS to the LHS.  Why is this recursive?"
               (cond ((and (listp tree)
                           (= (length tree) 3)
                           (eq '= (first tree))
                           (not (var-p (second tree)))
                           (var-p (third tree)))
                      (list (first tree)
                            (third tree)
                            (second tree)))
                     ((not (listp tree))
                      tree)
                     (t
                      (mapcar #'walk-tree-ordering-branches tree))))
             (simplify-equation (eqn)
               "Equations must have the form VAR1 = F(VAR2,VAR3).  Replace
                anything more complicated with simpler forms by adding dummy
                variables and equations."
	       (debug-print nil "~% simplify-equation node ~A" eqn)
	       (let ((operation (car eqn))
                     (lhs (second eqn))
                     (rhs (third eqn)))
		 (list operation
		       ;; LHS must be a single variable
		       (replace-subexpressions lhs)
		       (cond 
		       ;; RHS must have at most one operation
			     ((listp rhs)
			      (append (list (car rhs))
				      (mapcar #'replace-subexpressions (cdr rhs))))
			     (t rhs)))))
	     (replace-subexpressions (node)
               "Replace a subexpression by adding a new dummy variable for that
                subexpression and adding new equation DUMMYVAR = EXPR.  Recurse
                down the expression simplifying all the way down."
;	       (format t "~% replace-subexpressions node ~A" node)
	       (cond ((not (listp node)) node)
		     ((member (car node) '(+ - / * deriv :tempinterpol1 if))
		      (replace-subexpression node))
		     ((member (car node) '(> < >= <= <> ==))
		      (cons (car node) (mapcar #'replace-subexpressions (rest node))))
		     (t node)))
	     (replace-subexpression (node)
	       "replace a single node with a dummy-variable"
	       (let* ((new-var (make-dummy-var-1 node))
                                        ; (new-eqn (replace-inverters (simplify-equation (list '= new-var node)))
		      (new-eqn (simplify-equation (list '= new-var node))))
					;                            (format t "added new equation ~a~%" new-eqn)
;		 (propagate-dummy-attributes new-eqn)
		 (push new-eqn new-eqns)
		 (when (and (listp (third new-eqn))
			    (eq 'deriv (car (third new-eqn))))
		   ;; we want to save the fact that new-var is a derivative
		   (setf (var-type new-var) (format nil "d~A/dt" (var-local-name (second (third new-eqn)))))
		   (setf (var-deriv (second (third new-eqn))) new-var))
		 new-var))
	     (walk-tree-replacing-known-conditionals (node)
	       "Replace any conditional in which the condition is known with 
                the appropriate clase.  This function makes use of the initial-conditions"
;	       (format t "~% walk-tree-replacing-known-conditionals ~A" node)
	       
               (cond ((and (listp node) 
			   (eql (car node) 'if)
			   (conditional-result node))
		      (walk-tree-replacing-known-conditionals
		       (conditional-result node)))
		     ((listp node)
		      (mapcar #'walk-tree-replacing-known-conditionals node))
                     (t node))
	       )
	     (conditional-result (node)
	       "If the initial conditions set the values of fixed-parameters
                ensuring a particular branch of a conditional must be taken
                then return it. Else return nil"
;	       (format t "~% condition ~A" (second node))
	       (ecase (evaluate-condition-with-ics (second node) ics)
		 (:false (fourth node))
		 (:true (third node))
		 (:unknown nil)))
;; [07/26/2013 klenk] when-equations can not have a conditional at the top level
	     (replace-top-level-conditional (node)
	       (let ((op (car node))
		     (lhs (second node))
		     (rhs (third node)))
		 (list op
		       lhs
		       (if (and (listp rhs)
				(eql (car rhs) 'if))
			   (let* ((new-var (make-dummy-var-1 rhs))
				  (new-eqn (list '= new-var rhs)))
;			     (propagate-dummy-attributes new-eqn)
			     (push new-eqn new-eqns)
			     new-var)
			   rhs))))

             ;; [06/12/2012 klenk] Not sure how general this will be
             ;; [06/12/2012 klenk] This will have to expand as we get more modelica requirements blocks
             ;; 0.0 = if <condition> (- <dis-var> <enum1>)(- <dis-var> <enum2>)
             (discrete-conditional? (eqn)
               (when (and (eql (car eqn) '=)
                          (numberp (second eqn))
                          (consp (third eqn))
                          (eql (car (third eqn)) 'if))
                 (let ((then (third (third eqn)))
                       (else (fourth (third eqn))))
                   (and (consp then)
                        (some #'discrete-var? (rest then))
                        (consp else)
                        (some #'discrete-var? (rest else))))))

             ;; [06/12/2012 klenk] This is a single equation
             ;; [06/12/2012 klenk] lhs is the discrete var of enumerated type
             ;; [06/12/2012 klenk] then is one discrete value
             ;; [06/12/2012 klenk] else is another discrete value
             (replace-discrete-equations (eqn)
               (if (not (discrete-conditional? eqn))
                   eqn
                   (let ((condition (second (third eqn)))
                         (then (third (third eqn)))
                         (else (fourth (third eqn))))

                     (assert (and (eql (car then)(car else))
                                  (eql (car then) '-)
                                  (eql (second then)(second else))))
                     (list '=
                           (second then) ;; discrete var being assigned
                           (list 'if
                                 condition
                                 (third then)
                                 (third else))))))

             )
      
;      (format t "~% Considering: ~a" form)
      (cond ((summer-equation? form)
	     (values 
	      (walk-tree-replacing-constants 
	       (walk-tree-replacing-variable-names form vars-hash-table) 
	       nil)
	      (remove-duplicates new-eqns :test #'equalp) new-vars))
	    (t
;; [06/13/2013 klenk] If the equation is setting an enumerated type, don't replace
;; [06/13/2013 klenk] numbers with dummys
	     (multiple-value-bind (form enumerated-type-qspace)
		 (maybe-convert-integer-to-enum form vars-hash-table)
	       (let* 
		   ((vars-replaced-form (walk-tree-replacing-variable-names form vars-hash-table))
		    (replaced-discrete-equations
		     (progn 
;		       (format t "~% vars-replaced form ~A" vars-replaced-form)
		       (replace-discrete-equations vars-replaced-form)))
		    (constant-eliminated-form 
		     (progn 
;		       (format t "~% replaced-discrete-equations ~A" replaced-discrete-equations)
		       (walk-tree-replacing-constants
			replaced-discrete-equations
			enumerated-type-qspace)))
		    (simplified-conditions-form 
		     (progn
;		       (format t "~% constant-eliminated-form ~A" constant-eliminated-form)
		       (walk-tree-simplifying-conditions 
			(walk-tree-replacing-known-conditionals constant-eliminated-form)
			t
			)))
		    (bowdlerized-form 
		     (progn
;		       (format t "~% simplified-conditions-form ~A" simplified-conditions-form)
		       (walk-tree-transforming-modelica-expressions simplified-conditions-form)))
		    (ordered-form (walk-tree-ordering-branches bowdlerized-form))
					;(final-form (replace-inverters (simplify-equation ordered-form))
		    (final-form 
		     (progn
		       (setq discrete-enum (if enumerated-type-qspace(list enumerated-type-qspace)))
		       (simplify-equation ordered-form))))
;		 (format t "~% final-form is ~s~%" final-form)
;		 (format t "~% new vars added are ~a~%" new-vars)
	       (values (if when-equation? 
			   (replace-top-level-conditional final-form)
			   final-form)
		       (remove-duplicates new-eqns :test #'equalp) new-vars)
	       )))))))
    

(defun dummy-vars (&optional (system *system-being-analyzed*)) 
  (remove-if-not #'dummy-var?  
		 (system-active-variables system)))

;; [11/14/2013 klenk] Probably remove and just use the slot
(defun dummy-var? (var) 
  (or
   (and (var-p var)
	(var-dummy? var))
   (and (var-p var)
	(stringp (var-local-name var))
	(> (length (var-local-name var)) 5)
	(string= (subseq (var-local-name var) 0 5) "dummy"))))

(defun print-dummy-vars  (&key (ids nil)(system *system-being-analyzed*)) 
  (dolist (var (sort (if ids 
			 (mapcar #'lookupv ids)
			 (dummy-vars system)) #'< :key #'var-id))
    (format t "~%~A =" (var-local-name var) )
    (pprint (var-type var))))

(defun make-dummy-var (name model)
   "Make a new dummy variable and add it to the vars-hash-table"
  ;; [05/14/2012 klenk] using the type slot for dummy varibles to hold what they are replacing
   ;; Johan - we are creating far too many dummies.
   (let ((var (ncreate-var model (format nil "dummy~a" (1+ (system-max-cell *system-being-analyzed*)))
			   nil
			   (dummy-type name)
			   name
			   (dummy-state-var? name)
			   'make-dummy-var
			   t)
	      ))
     (when (eq (var-fundamental-type var) :fixed-parameter)
       (make-var-fixed var (list 'make-dummy-var name)))
     var))

(defun dummy-type (name)
  (cond ((var-p name) (var-fundamental-type name))
	((numberp name) :fixed-parameter)
	((listp name) (dummy-type-composition name))
	(t (error "Unknown Dummy-type for ~A" name))))

(defun dummy-type-composition (name)
  (ecase (car name)
    (deriv (dummy-type (second name)))
    ((- + * / power)
     (let ((types (mapcar #'dummy-type (rest name))))
       (cond ((member :time types) :time)
	     ((member :discrete types) :discrete)
	     ((member :variable types) :variable)
	     ((member :fixed-parameter types) :fixed-parameter)
	     ;; [11/14/2013 klenk] The following types are deprecated
             ((member :through types) :through)
             ((member :flow types) :flow)
             ((member :across types) :across)
             (t (error "Unknown Dummy-type for composition ~A" name)))))
    (:tempinterpol1 (dummy-type (second name)))
    (if (if (member :discrete (mapcar #'dummy-type (cddr name)))
            :discrete
            :variable))))
	 

(defun dummy-fixed? (name)
  (or (numberp name)
      (and (listp name)
	   (member (car name) '(- + * /))
	   (and (var-p (second name))(var-p (third name))) 
	   (var-fixed? (second name))
	   (var-fixed? (third name)))
      (and (listp name)
	   (member (car name) '(- deriv)) ;;not sure why one would take the deriv of a param
	   (= (length name) 2)
	   (or 
	    (and (var-p (second name))
		 (var-fixed? (second name)))
	    (and (dummy-fixed? (second name)))))))


;; [08/28/2012 klenk] only works for simple expressions (<op> <v1> <v2>)
(defun dummy-state-var? (name)
  (or
   (and (listp name)
	(member (car name) '(- + * /))
	(and (var-p (second name))(var-p (third name)))
	(or (var-fixed? (second name))(var-state-var? (second name)))
	(or (var-fixed? (third name))(var-state-var? (third name)))
	(or (var-state-var? (second name))(var-state-var? (third name))))
   (and (listp name)
	(member (car name) '(-))
	(= (length name) 2)
	(var-p (second name))
	(var-state-var? (second name)))
   ))


(defun preprocess-equations (raw-lisp-form-eqns vars-hash-table initial-conditions model)
  (let ((lisp-form-eqns))
    (debug-print nil "~% raw equations ~A" raw-lisp-form-eqns)
    (dolist (eqn raw-lisp-form-eqns)

      (restart-case

          (multiple-value-bind (result-eqn new-eqns new-vars)
              (format-lisp-form-properly eqn vars-hash-table model initial-conditions)
            ;; save the processed lisp form
            (push result-eqn lisp-form-eqns)
            ;; append any new equations to the end of eqns
            (dolist (new-eqn new-eqns)
              (cond ((and (listp new-eqn)
                          (= (length new-eqn) 3)
                          (eq (car new-eqn) '=)
                          (numberp (third new-eqn))
                          (member (second new-eqn) new-vars))
                     ;; set dummy variable equal to constant
                     (let ((var (second new-eqn)))
                       (pushnew 
                        (list var :start (third new-eqn) :fixed? t)
                        initial-conditions :test #'equal)
                       (make-var-fixed var 'preprocess-equations)
                       (setf (var-fundamental-type var) :fixed-parameter)
                       (setf (var-type var) (third new-eqn))))
                    ;; other cases
                    (t (push new-eqn lisp-form-eqns))))
            ;; new vars are handled automatically by adding them to the vars-hash-table
            )

        (ignore-error () nil)
        ))

    ;; now expand set to include elided KVL and KCL equations
    (let ((more-equations (expand-equations raw-lisp-form-eqns vars-hash-table)))
 ;     (format t "~% more-equations ~A" more-equations)
 ;     (break)
      (dolist (eqn more-equations)

        (restart-case

            (multiple-value-bind (result-eqn new-eqns new-vars)
                (format-lisp-form-properly eqn vars-hash-table model initial-conditions)
              ;; save the processed lisp form
              (push result-eqn lisp-form-eqns)
              ;; append any new equations to the end of eqns
              (dolist (new-eqn new-eqns)
                (cond ((and (listp new-eqn)
                            (= (length new-eqn) 3)
                            (eq (car new-eqn) '=)
                            (numberp (third new-eqn))
                            (member (second new-eqn) new-vars))
                       ;; set dummy variable equal to constant
                       (let ((var (second new-eqn)))
                         (pushnew (list var :start (third new-eqn) :fixed? t) 
                                  initial-conditions :test #'equal)
                         (make-var-fixed var 'preprocess-equations1)
                         (setf (var-fundamental-type var) :fixed-parameter)
                         (setf (var-type var) (third new-eqn))))
                      ;; other cases
                      (t (push new-eqn lisp-form-eqns))))
              ;; new vars are handled automatically by adding them to the vars-hash-table
              )
          (ignore-error () nil)
          )))

    (values lisp-form-eqns initial-conditions)))

(defun preprocess-conditional-equations (eqns vars-hash-table initial-conditions model)
  "
   returns (values <lisp-form-equations-for-dummy-vars> <condition-equation-pairs> <new-initial-values)"
  (let ((lisp-form-eqns)
        (conditional-equations))
    ;; (labels ((invert-condition (c)
    ;;            (list (first c) (third c) (second c)))
    ;;          (get-condition-value (c)
    ;;            (if (and (eq (length c) 3)
    ;;                     (var-p (third c)))
    ;;                (let ((value (find-if #'(lambda (v)
    ;;                                          (and (eq (first v) '=)
    ;;                                               (var-p (second v))
    ;;                                               (eq (second v) (third c))
    ;;                                               (numberp (third v))))
    ;;                                      initial-conditions)))
    ;;                  (list (first c) (second c) (third value)))
    ;;                c)))
    (dolist (eqn eqns)

      (restart-case

          (multiple-value-bind (result-eqn new-eqns new-vars)
              (format-lisp-form-properly (cdr (assoc :lisp-form eqn)) vars-hash-table model
                                         initial-conditions)
;	    (format t "~% mode equation is ~s~%result equation is ~s~%new equations are ~s"
;                                        		eqn result-eqn new-eqns)
            ;; remember to include the top-level if-equation
            (push result-eqn new-eqns)
            ;; now look through what we've got and handle any if equations
            (dolist (new-eqn new-eqns)
              (cond ((and (eq (first new-eqn) '=)
                          (var-p (second new-eqn))
                          (listp (third new-eqn))
                          (eq (first (third new-eqn)) 'if))
                     ;; if it's an if-equation
                     (let ((possible-left-sides (handle-if-expression (third new-eqn) 
                                                                      initial-conditions)))
                       ;; turn this into a list of condition+equation pairs
                       (dolist (left-side possible-left-sides)
;			 (format t "Conditional eqn1: ~A => ~A = ~A~%" (car left-side) (second new-eqn) (cdr left-side))
                                        ;		     (break)
                         (push (cons (car left-side) (list '= (second new-eqn) (cdr left-side))) conditional-equations)
                         )
                       ))
                    ;; how about a boolean equation?
                    ((and (eq (first new-eqn) '=)
                          (var-p (second new-eqn))
                          (listp (third new-eqn))
                          (is-conditional-expression (third new-eqn)))
		     (let ((possible-left-sides (handle-if-expression (list 'if (third new-eqn) :|true| :|false|) initial-conditions)))
                       ;; turn this into a list of condition+equation pairs
                       (dolist (left-side possible-left-sides)
;			 (format t "Conditional eqn: ~A => ~A = ~A~%" (car left-side) (second new-eqn) (cdr left-side))
                         (push (cons (car left-side) (list '= (second new-eqn) (cdr left-side))) conditional-equations)
                         )
                       ))
                    ((and (listp new-eqn)
                          (= (length new-eqn) 3)
                          (eq (car new-eqn) '=)
                          (numberp (third new-eqn))
                          (member (second new-eqn) new-vars))
                     ;; set dummy variable equal to constant
                     (let ((var (second new-eqn)))
                       (pushnew (list var :start (third new-eqn) :fixed? t) 
                                initial-conditions :test #'equal)
                       (make-var-fixed var 'preprocess-conditional-equations)
                       (setf (var-fundamental-type var) :fixed-parameter)
                       (setf (var-type var) (third new-eqn))))
                    ;; other cases
                    (t (push new-eqn lisp-form-eqns))))
            ;; new vars are handled automatically by adding them to the vars-hash-table
            )
        (ignore-error () nil)
        ))
    (values lisp-form-eqns conditional-equations initial-conditions)
    ))


;; [10/29/2013 klenk] No dummy variables in when equations effects.
(defun preprocess-when-equations (eqns vars-hash-table initial-conditions model)
  "All calculations involving when equations should only be performed at events"
  (declare (ignore model initial-conditions))
  (let ((equations-for-dummy-vars)
        (when-equations)
	(conditional-equations))
    (declare (ignore conditional-equations equations-for-dummy-vars))
    (dolist (eqn eqns)

      (restart-case

          (let ((condition (walk-tree-replacing-variable-names 
                            (cdr (assoc :condition eqn))
                            vars-hash-table))
                (result-eqn (walk-tree-replacing-variable-names 
                             (cdr (assoc :lisp-form eqn)) vars-hash-table)))
            (push (cons condition result-eqn) when-equations))
        (ignore-error () nil)
        ))

    when-equations
    ))






(defun preprocess-assertions (assertions vars-hash-table initial-conditions model)
  ;; for each assertion, create a conditional mode equation
  (labels ((mattify-condition (condition)
             ;; adjust boolean expression to operators Matt handles in his code
             (cond ((not (listp condition))
                    condition)
                   ((member (car condition) '(== >= and or not))
                    (cons (car condition)
                          (mapcar #'mattify-condition (rest condition))))
                   ((eq (car condition) '<>)
                    (cons 'not (list '==
                                     (mattify-condition (third condition))
                                     (mattify-condition (second condition)))))
                   ((eq (car condition) '<)
                    (list '>=
                          (mattify-condition (third condition))
                          (mattify-condition (second condition))))
                   ((eq (car condition) '>)
                    (list 'and
                          (list '>=
                                (mattify-condition (third condition))
                                (mattify-condition (second condition)))
                          (cons 'not (list '==
                                           (mattify-condition (second condition))
                                           (mattify-condition (third condition))))))
                   ((eq (car condition) '<=)
                    (list 'or
                          (cons 'not (list '>=
                                           (mattify-condition (third condition))
                                           (mattify-condition (second condition))))
                          (list '==
                                (mattify-condition (second condition))
                                (mattify-condition (third condition)))))
                   (t condition)))
           )
    (let ((failure-conditions)
          (created-eqns))
      (dolist (assertion assertions)
        (let ((condition (cdr (assoc :lisp-form (car assertion))))
              (mode-var (make-dummy-var (cdr assertion) model)))
					;(format t "assertion: ~S~%mattified version: ~S~%" condition (mattify-condition condition))
          (setf (gethash (var-local-name mode-var) vars-hash-table) mode-var)
          (push (list '= mode-var 0.0)
		initial-conditions)
          (push (list (cons :TEXT-FORM (cdr (assoc :lisp-form (car assertion))))
                      (cons :LISP-FORM
                            (list '= (var-local-name mode-var)
                                  (list 'if (mattify-condition condition) 1.0 0.0))))
                failure-conditions)
          ))
      (values failure-conditions created-eqns initial-conditions))))

(defun parse-initial-equations (tree)
  (let ((parsed-form)
        (initial-equations (xmls:xmlrep-find-child-tags "initialEquations" tree)))
    ;; (format t "initial-equations: ~S~%" initial-equations)
    (when initial-equations
      (dolist (equation (xmls:xmlrep-find-child-tags "equation" (car initial-equations)))
        (let ((eqn (mathml->lisp equation nil)))
            (push eqn parsed-form))))
    parsed-form))

(defun interpret-openmodelica-xml (tree &optional (ignore-errors? t))

  "Take the parsed XML sexp and pull the variables and equations out of it."

  (let ((*logging-parse-xml-errors* (not ignore-errors?))
        (cl-user::*read-default-float-format* 'double-float))
    (multiple-value-bind (variables enumerated-types)
        (parse-variables tree)
      (let ((zero-crossings (parse-zero-crossings tree))
            (assertions (find-assertions tree))
            (when-equations (parse-when-equations tree))
            (initial-equations (parse-initial-equations tree)))
        (let ((state-vars 
               (reduce #'(lambda (a v)
                           (if (cdr (assoc :statevar v))
                               (push (cdr (assoc :name v)) a)
                               a))
                       variables :initial-value (list))))
                                        ;	(format t "~% Statevars are now: ~a" state-vars)
          (multiple-value-bind (equations mode-equations)
              (parse-equations tree)
            
					;(format t "variables are ~s~%equations are ~s~%mode equations are ~s~%state variables are ~s~%"
					;        variables equations mode-equations state-vars)
            (list (cons :variables variables)
                  (cons :enumerated-types enumerated-types)
                  (cons :equations equations)
                  (cons :initial-equations initial-equations)
                  (cons :when-equations when-equations)
                  (cons :zero-crossings zero-crossings)
                  (cons :modes mode-equations)
                  (cons :statevars state-vars)
                  (cons :assertions assertions))
            ))))))
  
;;; Temporary alternative to see if it works.
;; (defun interpret-openmodelica-xml (tree ignore-errors?)

;;   "Take the parsed XML sexp and pull the variables and equations out of it."

;;   (when (and (not ignore-errors?) (om-xml-errors? tree))
;;     ;(error (om-xml-errors? tree))
;;     )
;;   (multiple-value-bind (variables enumerated-types)
;;       (parse-variables tree)
;;     (let ((zero-crossings (parse-zero-crossings tree))
;;           (assertions (find-assertions tree))
;; 	  (when-equations (parse-when-equations tree))
;; 	  (initial-equations (parse-initial-equations tree)))
;;         (multiple-value-bind (equations mode-equations state-vars)
;;             (parse-equations tree)
	  
;; 					;(format t "variables are ~s~%equations are ~s~%mode equations are ~s~%state variables are ~s~%"
;; 					;        variables equations mode-equations state-vars)
;;           (list (cons :variables variables)
;;                 (cons :enumerated-types enumerated-types)
;;                 (cons :equations equations)
;;                 (cons :initial-equations initial-equations)
;; 		(cons :when-equations when-equations)
;;                 (cons :zero-crossings zero-crossings)
;;                 (cons :modes mode-equations)
;;                 (cons :statevars state-vars)
;;                 (cons :assertions assertions))
;;           ))))

(defvar *int-errs* nil)
(defvar *math-errs* nil)
(defvar *fns-errs* nil)

;; [06/10/2013 klenk] This function looks for operators/types in the XML that are not handled correctly by QRM,
;; [06/10/2013 klenk] It will return a possibly empty string of all error
(defun om-xml-errors? (tree)
  (let ((error-msg nil))
    (when (not (equal (first tree) "dae"))
      (setf error-msg (concatenate 'string error-msg "~% XML tree doesn't seem to contain a DAE")))
;; [06/10/2013 klenk] When Equations
;    (when (when-equations-in-tree? tree)
;      (setf error-msg (concatenate 'string error-msg "~% OpenModelica->QRM translation does not support when equations yet")))

    (when (functions-in-known-values? tree)
      (setf error-msg (concatenate 'string error-msg "~% OpenModelica->QRM translation does not support functions in known values yet")))

    (when (algorithms-in-tree? tree)
      (setf error-msg (concatenate 'string error-msg (format nil "~% OpenModelica->QRM translation does not support algorithms ~A" (algorithms-in-tree? tree)))))

    (setq *int-errs* (om-xml-integers tree)
	  *fns-errs* (unhandled-modelica-fns tree))
    (setq *math-errs* (set-difference (unhandled-math-operators tree)
				      *fns-errs* :test #'string=))
    (when *int-errs*
      (setf error-msg (concatenate 
		       'string error-msg 
		       (format nil "~% OpenModelica->QRM translation does not support integers yet ~A"
			       *int-errs*))))
    (when *fns-errs*
      (setf error-msg 
	    (concatenate 
	     'string error-msg 
	     (format nil "~% OpenModelica->QRM translation does not support the following procedures ~A"
		     *fns-errs*))))
    (when *math-errs*
      (setf error-msg 
	    (concatenate 
	     'string error-msg 
	     (format nil "~% OpenModelica->QRM translation does not support the following math operators ~A" *math-errs*))))

    error-msg
    ))

(defun initial-equations-in-tree? (tree)
  (let ((ies (xmls:xmlrep-find-child-tags 
	     "equation" 
	     (xmls:xmlrep-find-child-tag "initialEquations" tree nil))))
    (mapcar #'third ies)))

(defun initial-algorithms-in-tree? (tree)
  (let ((ies (xmls:xmlrep-find-child-tags 
	      "algorithm" 
	      (xmls:xmlrep-find-child-tag "initialEquations" tree nil))))
    (mapcar #'third ies)))

;; [06/12/2013 klenk] need to look for these in two ways.
(defun when-equations-in-tree? (tree)
  (or 
   (xml-node-path-exists? '("equations" "whenEquation") tree)
   (xml-node-path-exists? '("zeroCrossingList" 
			    "zeroCrossingElement"
			    "involvedWhenEquations") tree)))

(defun functions-in-known-values? (tree)
  (some #'(lambda (kvs)
	    (some #'kv-mentions-handled-fn?
		  (xmls:xmlrep-find-child-tags "variable"
					       (xmls:xmlrep-find-child-tag
						"variablesList" kvs)))) 
   (xmls:xmlrep-find-child-tags "knownVariables"
				(xmls:xmlrep-find-child-tag "variables" tree))))

(defun kv-mentions-handled-fn? (tree)
  
  (some #'(lambda (op)
	    (member op *modelica-fns*))
	(math-operators-in-lisp-form 
	 (parse-math-ml-expression 
	  (first (xmls:xmlrep-children 
		  (xmls:xmlrep-find-child-tag 
		   "MathML"
		   (xmls:xmlrep-find-child-tag
		    "bindExpression"
		    (xmls:xmlrep-find-child-tag
		     "bindValueExpression" tree nil)
		    nil) nil)))))))


(defun algorithms-in-tree? (tree)
  (mapcar #'third
	  (mapcan #'(lambda (xml-tree)
		      (xmls:xmlrep-find-child-tags "algorithm" xml-tree)) 
		  (copy-list (xmls:xmlrep-find-child-tags "equations" tree)))))

(defparameter *handled-math-operators*
  '(= deriv / not < <= > and or pre if * - + >= smooth)
  "this is the list of math operators that are currently accepted in QRM")

;; [06/10/2013 klenk] This function will look for things like trig functions, logs, etc.
(defun unhandled-math-operators (tree)
  (let (ret)
    (dolist (eqn 
	      (mapcan #'(lambda (xml-tree)
			  (xmls:xmlrep-find-child-tags "equation" xml-tree)) 
		      (copy-list (xmls:xmlrep-find-child-tags "equations" tree)))
	     ret)
      (dolist (op (math-operators-in-lisp-form 
		   (parse-math-ml-expression 
		    (first (xmls:xmlrep-children (xmls:xmlrep-find-child-tag "MathML" eqn))))))
	(unless (or (member op *handled-math-operators*)
		    (member op *modelica-fns*))
	  (pushnew op ret :test #'(lambda (e1 e2)
				    (or (and (stringp e1)(stringp e2)
					     (string= e1 e2))
					(eql e1 e2)))))))))


(defun math-operators-in-lisp-form (lisp-form &optional argument?)
  (cond ((null lisp-form) nil)
	((atom lisp-form) nil)
	((and (null argument?)
	      (consp lisp-form)
	      (atom (car lisp-form))
	      (cdr lisp-form))
	 (cons (car lisp-form)
	       (math-operators-in-lisp-form (cdr lisp-form) t)))
;; [06/12/2013 klenk] need to handle :unhandled
	((and (null argument?)
	      (consp (car lisp-form))
	      (eql (caar lisp-form) :unhandled))
	 (cons   (subseq (second (car lisp-form))
			 2 (position " " (second (car lisp-form)) :test #'string=))
		(math-operators-in-lisp-form (cdr lisp-form) t)))
	((and argument?
	      (consp (car lisp-form)))
	 (append (math-operators-in-lisp-form (car lisp-form) nil)
		 (math-operators-in-lisp-form (cdr lisp-form) t)))
	(t (math-operators-in-lisp-form (cdr lisp-form) argument?))))


(defun unhandled-modelica-fns (tree)
  (remove-if
   #'(lambda (fn-name)
       (member fn-name *modelica-fn-names* :test #'string=))
   (modelica-fn-names tree)))

(defun modelica-fn-names (tree)
  (mapcar #'(lambda (fn)
	      (xmls:xmlrep-attrib-value "name" fn))
	  (xmls:xmlrep-find-child-tags "function" 
				       (xmls:xmlrep-find-child-tag "functions" tree))))
 

;; [06/25/2013 klenk] I'm concerned about integers that do not represent modes
;; [06/25/2013 klenk] This would mean that the ordered-variable integer appears 
;; [06/25/2013 klenk] on the rhs of the an equation not in a condition
(defun om-xml-integers (tree)
  (declare (ignore tree))
  nil)
  ;; (let ((order-variables (xmls:xmlrep-find-child-tags "orderedVariables" 
  ;; 						      (xmls:xmlrep-find-child-tag "variables" tree)))
  ;; 	(known-variables (xmls:xmlrep-find-child-tags "knownVariables"
  ;; 						      (xmls:xmlrep-find-child-tag "variables" tree))))
  ;;   (mapcar #'(lambda (xml-var)
  ;; 	      (xmls:xmlrep-attrib-value "name" xml-var))
  ;; 	    (remove-if-not 
  ;; 	     #'xml-var-integer?
  ;; 	     (mapcan #'(lambda (xml-tree)
  ;; 			 (xmls:xmlrep-find-child-tags 
  ;; 			  "variable" 
  ;; 			  (xmls:xmlrep-find-child-tag
  ;; 			   "variablesList" xml-tree)))
  ;; 		     (append order-variables known-variables)))))) 




(defun xml-var-integer? (xml-var)
  (string= "Integer" (xmls:xmlrep-attrib-value "type" xml-var)))

;; [06/10/2013 klenk] searchs for the XML tags in the children of tree starting from the first 
(defun xml-node-path-exists? (tag-list tree)
  (cond ((null tag-list) tree)
	((xmls:xmlrep-find-child-tags (car tag-list) tree)
	 (some #'(lambda (child)
		   (xml-node-path-exists? (cdr tag-list) child))
	       (xmls:xmlrep-find-child-tags (car tag-list) tree)))
	(t nil)))


(defun parse-om-xml-dae-dump (filepath
                              &key
                              (show nil)
                              (interpret t)
			      (ignore-errors? nil))
  "Parse the XML in FILEPATH, generated by OpenModelica's DumpXMLDAE code,
and return a Lisp form of the DAE.  If SHOW is non-nil, the raw parse of the
XML will be output to stdout.  If INTERPRET is nil, the raw XML parse will
be returned; by default, the Lisp form of the DAE will be returned."

  (let ((tree (xmls:parse (open filepath))))
    (if show
        (format t "~s~%" tree))
    (if interpret
        (let ((newtree (interpret-openmodelica-xml tree ignore-errors?)))
          newtree)
        tree)))

(defun process-variables (parse top-model)
  ;; create the variables, and put them in a hash table
  (let ((variables (make-hash-table :test #'equal))
        (state-variables (cdr (assoc :statevars parse)))
        (initial-equations
         (let ((initial-equations-table (make-hash-table :test #'equal)))
           (dolist (initial-equation (cdr (assoc :initial-equations parse)))
             (let ((form (assoc :lisp-form initial-equation)))
               (setf (gethash (third form) initial-equations-table) (fourth form))))
           initial-equations-table))
        (initial-conditions nil))

    (dolist (var (cdr (assoc :variables parse)))
                                        ;      (format t "doing var ~S~%" var)
                                        ;      (assert (assoc :scoped-name var))
      (restart-case
	  (if (assoc :scoped-name var)
	      (let* ((vname (cdr (assoc :name var)))
		     (vtype (cdr (assoc :type var)))
		     (ftype (cdr (assoc :fundamental-type var)))
		     (var-struct (ncreate-var top-model vname 
					      (when (cdr (assoc :known? var)) t)
					      ftype
					      (intern (car (last (cdr (assoc :scoped-name var)))) +env2-names+)
					      nil
					      'process-variables0
					      ) )
		     )
;		(if (= (var-id var-struct) 12) (error "look"))
		(when (or (eq ftype :discrete)
			  (listp vtype)
			  (var-integer? var-struct))
		  (setf (var-discrete-var? var-struct) t)
		  ;; override the default qspaces
		  (cond ((eq (var-type var-struct) (intern "Boolean" :env2-names))
			 (setf (var-qspaces var-struct) (list vtype)))
			((eq (var-type var-struct) (intern "Integer" :env2-names))
			 (assert (cdr (assoc :initial-value var)))
			 (setf (var-qspaces var-struct) 
			   (list (list (cdr (assoc :initial-value var))))))
			;;; [05/12/2014 Johan] Why was this not a problem earlier?
			(vtype (setf (var-qspaces var-struct) (list vtype)))
			(t (error "Unknown type to set qspaces up for"))
			))
            (setf (gethash vname variables) var-struct)
            ;; [08/30/2012 klenk] Now we need to add initialization information about the variables
            ;; [08/30/2012 klenk] If there is an start value
            ;; [08/30/2012 klenk] and if it is a fixed value
            (let ((init-value (or (gethash vname initial-equations) (cdr (assoc :initial-value var))))
                  (fixed (or (if (gethash vname initial-equations) t) (cdr (assoc :fixed var)))))
              (if init-value
                  (push (list var-struct :start init-value :fixed? fixed)
                        initial-conditions)
                  ;; else
                  (if (member vname state-variables :test #'equal)
                      (push (list var-struct :initial-value 0 :fixed? nil)
                            initial-conditions))
                  ))
            (when (member vname state-variables :test #'equal)
              (setf (var-state-var? var-struct) t)
              (push var-struct (system-statevars *system-being-analyzed*)))
            )
          (format t "~&Unknown variable ~S~%" var))
        (ignore-error () nil)
        )
      )
    ;; add the Modelica special variable "time"
    (let ((time (create-var  top-model "time"
                             :qspaces (list '(Inf- Q0 Inf+))
                             :uses '()
                             :fundamental-type :time
                             :type (intern "time" +env2-names+)
                             :state-var? t
			     :source 'process-variables2
			     )))
      (setf (gethash "time" variables) time)
      (push (list time :start 0 :fixed? t)
            initial-conditions)
      (let ((time-der (create-var  top-model "dtime/dt"
                                   :qspaces (list '(Inf- Q0 Inf+))
                                   :uses '()
                                   :fundamental-type :time
                                   :type (intern "dtime/dt" +env2-names+)
                                   :fixed? t
				   :source 'process-variables3
				   )))
        (setf (gethash "dtime/dt" variables) time-der)
        (push (list time-der :start (create-q-quantity time-der 'Q+ nil 'Std)  ;'Q+
		    :fixed? t)
              initial-conditions)
        (setf (var-deriv time) time-der)
        ))
    (let ((plus-var (create-var top-model "qplus"
                                :qspaces (list '(Inf- Q0 Inf+))
                                :fundamental-type :fixed-parameter
                                :fixed? t
				:source 'process-variables4
				)))
      (setf (gethash "qplus" variables) plus-var)
      (push (list plus-var :start (create-q-quantity plus-var 'Q+ nil 'Std) :fixed? t)
            initial-conditions))

    ;; add dummy variables for each value of each enumerated type
    (let ((enumerated-types (cdr (assoc :enumerated-types parse))))
      (if enumerated-types
          (maphash #'(lambda (etypename etypevalues)
                       (dolist (etypevalue etypevalues)
                         (let ((v (create-var top-model
                                              (format nil "~A.~A" etypename (symbol-name etypevalue))
                                              :uses '()
                                              :fundamental-type :discrete
                                              :fixed? t
                                              :type (intern etypename +env2-names+)
					      :why-fixed 'process-variables5
					      :source 'process-variables5
					      )))
			   (setf (var-qspaces v) (list etypevalues))
                           (setf (gethash (var-local-name v) variables) v)
;;;XXXX something squirrely here.XXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;Should we only do the push???
;;**** adding this breaks things:
			   (if *use-global*
			       (clobber-global v etypevalue :discrete)
			     (construct-qset top-model v etypevalue nil nil) )
;			   (push (list v :start etypevalue :fixed? t)
;				 initial-conditions)
                           )))
                   enumerated-types)))
    (values variables initial-conditions)))

(defun get-system-name-from-parse (parse)
  (let ((real-name (assoc :name parse)))
    (if real-name
        (cdr real-name)
        (dolist (var (cdr (assoc :variables parse)))
          (let ((scoped-name (cdr (assoc :scoped-name var))))
            (when (> (length scoped-name) 0)
              (return (first scoped-name))))))))  

;;; This function call other functions to create the constraints themselves.
(defun create-constraints-from-om-xml (model eqns condition initial-conditions)
  ;; Special case.  Not sure the best way to integrate this.  Matt maybe you can
  ;; do this more generally.
  (create-equations model eqns condition initial-conditions))

(defun create-system-from-om-xml-dae-dump (filepath
                                           &key
                                           (process-assertions nil)
					   (debug? nil))

  "Given an OpenModelica DAE dump in XML format, in file designated
   by FILEPATH, read it and create an env2 system struct, and
   return that struct."

  (let ((parse (parse-om-xml-dae-dump filepath :ignore-errors? debug?))
	(variables)
	 (initial-conditions)
	 (failure-conditions)
	 (assertion-equations)
	 (system)
	 (top-model)
	 )
					 ;(format t "parse is ~s~%" parse)
     ;; first create the system and model
     (let ((system-name (get-system-name-from-parse parse)))
       (setq *system-being-analyzed* (setq system (create-system system-name)))
       (setf (system-debug system) debug?)
       (push :omc (system-analyses system))
       (setq top-model (make-model :id (new-id) :local-name system-name)))
     (push top-model (system-models system) )
     (setf (gethash (model-local-name top-model) (system-top-models system)) 
	   top-model)
     (multiple-value-bind (vars-hash-table initial-initial-conditions)
	 (process-variables parse top-model)



       (setq variables vars-hash-table)
       (setq initial-conditions initial-initial-conditions))


     
     ;; do assertions if enabled
     (if process-assertions
	 (multiple-value-bind (new-failure-conditions new-assertion-equations new-initial-conditions)
	     (preprocess-assertions (cdr (assoc :assertions parse)) variables initial-conditions top-model)
	   (if new-failure-conditions
	       (setf failure-conditions (append failure-conditions new-failure-conditions)))
	   (setq assertion-equations new-assertion-equations)
	   (setq initial-conditions new-initial-conditions)
	   ))
					 ;(format t "assertion-equations are ~s~%" assertion-equations)
     (multiple-value-bind (mode-equations conditional-equations initial-conditions)
	 (preprocess-conditional-equations (append (cdr (assoc :modes parse)) failure-conditions)
					   variables initial-conditions top-model)
       (let ((when-equations (preprocess-when-equations  (cdr (assoc :when-equations parse))
				       variables initial-conditions top-model)))
	 (multiple-value-bind (lisp-form-equations initial-conditions)
	     (preprocess-equations 
	      (mapcar #'(lambda (eqn)(cdr (assoc :lisp-form eqn)))
		      (cdr (assoc :equations parse)))
	      variables initial-conditions top-model)
	   ;; This code seems never to be used.
	   (setf (system-xml-variables system) variables)	   
	  (let ((vars-as-list
		 (hash-table->model variables top-model)))
					;(debug-print t "~S vars are ~s~%" (length (model-variables top-model)) (model-variables top-model))
					;(debug-print t "~S equations are ~s~%" (length lisp-form-equations) lisp-form-equations)
					;(debug-print t "~S conditional equations are ~s~%" (length conditional-equations) conditional-equations)
					;(format t "~S assertion equations are ~s~%" (length assertion-equations) assertion-equations)

	    (setf (system-variables system) vars-as-list)
	    (setf (system-active-variables system) (copy-list vars-as-list))
	    ;; remove duplicates
	    (create-constraints-for-equations-from-xml
	     (remove-duplicates 
	      (append lisp-form-equations mode-equations 
		       assertion-equations) :test #'equal)
	     top-model vars-as-list initial-conditions)
	    (create-conditional-constraints 
	     (append conditional-equations)
	     top-model initial-conditions)
	    (create-when-structs when-equations top-model)
            (setq initial-conditions (simplify-initial-conditions initial-conditions variables))
            ;; (if failure-conditions
            ;;     (let ((failure-condition (list 'not (cons 'and failure-conditions))))
            ;;       (setf (system-success-function system)
            ;;             #'(lambda (sit)
            ;;                 (evaluate-situation-wrt sit nil failure-condition)))))

            (add-$der-constraints system)
	    (propagate-discrete-information-through-constraints system)
;	    (maybe-update-conditions-with-enum system)

	    (values system initial-conditions)
            ))))))

(defun hash-table->model (variables top-model)
	      (let ((vars))
		(maphash #'(lambda (key value)
			     (declare (ignore key))
			     ;; re-number the variable ids so as not to surprise the code
			     (push value vars)
			     )
			 variables)
	    ;; put the variables into the model
		(setf (model-variables top-model)
		      (mapcar #'(lambda (variable) (cons (var-local-name variable) variable))
			  vars))
		vars))

(defun create-constraints-for-equations-from-xml (all-equations top-model vars-as-list 
						  initial-conditions)
					;(format t "~S non-conditional equations after removing duplicates~%" (length all-equations))
  (dolist (eqn all-equations)
    (debug-print nil "equation is ~s~%" eqn)
    (restart-case  
        (let ((constraint (create-constraints-from-om-xml top-model (list eqn)
                                                          nil initial-conditions)))
          
          (declare (ignore constraint))
					;(format t " => constraint is ~s~%" constraint)
          )
      (ignore-error () nil)))
  ;; add constraints for derivatives of other vars
  (dolist (var vars-as-list)
    (restart-case
        (if (member (var-deriv var) vars-as-list)
            (let ((deriv-var (var-deriv var)))
              (construct-deriv-constraint var deriv-var (var-parent var))
              ))
      (ignore-error () nil)
      ))
  )


;; [07/26/2013 klenk] We should get the system from the top-model
(defun create-when-structs (when-equations top-model)
  (declare (ignore top-model))
  (dolist (when-eqn when-equations)
    (restart-case
        (push
         (make-mod-when :id (new-id) :trigger (car when-eqn) :equ (cdr when-eqn)) 
         (system-when-equations *system-being-analyzed*))
      (ignore-error () nil)
      )))

(defun create-conditional-constraints (conditional-equations top-model initial-conditions)
  (if conditional-equations
      (progn
					;		  (format t "doing conditional equations...~%")
	(dolist (conditional-equation conditional-equations)
	  ;; Dummies seem to be already created?
;	  (format t "~% ccc: ~a" conditional-equation)
;	  (push conditional-equation *foo*)
          (restart-case
              (let ((condition (car conditional-equation))
                    (eqn (cdr conditional-equation)))
					;		      (format t "~%   condition ~A ~%   eqn ~A" condition eqn) 
                (assert (and (listp condition)
                             (= (length condition) 1)
                             (if (listp (first condition))
                                 (not (var-p (first condition)))
                                 t)))
                (let ((constraint
                       (create-constraints-from-om-xml 
                        top-model (list eqn) 
                        (if (= (length condition) 1)
                            (car condition)
                            (cons 'and condition)
                            )
                        initial-conditions)))
                  (declare (ignore constraint))
					;(format t " => conditional constraint is ~s with condition ~A~%" constraint (constraint-condition (car constraint)))
                  ))
            (ignore-error () nil)
            )))))

;; [06/14/2013 klenk] necessary for mode variables and the dummies in their conditional
;; [06/14/2013 klenk] equation
(defun propagate-discrete-information-through-constraints (system)
  (dolist (constraint (system-constraints system))
    (when (and (qequal-constraint-p constraint)
	       (not (constraint-eliminated constraint)))
      (propagate-discrete-information (qequal-constraint-var1 constraint)
				      (qequal-constraint-var2 constraint)))))

;; [02/04/2013 klenk] variables with the name $DER.x are equivalent to der(x) in Modelica,
;; [02/04/2013 klenk] so we need to add a deriv constraint between $DER.x and x
(defun add-$der-constraints (system)
  (dolist (var (system-active-variables system))
    (restart-case 
	(when ($der-var? var)
	  (assert (integral-of var))
					;      (format t "~% making ~a a deriv because $DER." (integral-of var))
	  (setf (var-deriv (integral-of var)) var)
	  (construct-deriv-constraint (integral-of var) var (var-parent var)))
      (ignore-error () nil)
      )))

;; [02/04/2013 klenk] 
(defun $der-var? (var)
  (and (stringp  (var-local-name var))
       (> (length (var-local-name var)) 4)
       (string= (var-local-name var) "$DER" :end1 4)))


(defun $der-var->der-str (var)
  (if ($der-var? var)
      (format nil "der(~A)" ($der-var->der-str (var-integral var)))
      (var-local-name var)))

(defun integral-of (var)
  (find (subseq (var-local-name var) 5) 
	(system-active-variables *system-being-analyzed*)
	:test #'string= :key #'var-local-name))

						     
;; [01/25/2013 klenk] Uses the csv file to produce a single trajectory and then expands
;; [01/25/2013 klenk] every situation by depth
(defun perform-depth-bounded-envisionment (xml csv depth)
  (envision-model-from-om-xml-dae-dump xml :csv-file csv)
  (expand-envisionment-by (total-situations) :depth depth))

(defun envision-model-from-om-xml-dae-dump (filepath &key
                                            (process-assertions nil)
					    (debug? nil)
					    (display? nil)
					    (allow-initial-ambiguity? nil)
					    (depth nil)
                                            (graphviz-directory nil)
                                            (json-directory nil)
					    (eliminate? t)
;; [09/17/2012 klenk] pseudo-state-vars enforce continuity for the listed var ids at discrete transitions
;; [09/17/2012 klenk] or :all assumes that all variabes are continuous
					    (pseudo-state-vars nil) 
;; [09/10/2012 klenk] This takes in lists of total ordered landmark variables
;; [09/10/2012 klenk] These are dummy variable ids
					    (landmark-orders nil)
;; [01/21/2013 klenk] When specified an envisionment filter function will be created
;; [01/21/2013 klenk] constraining next situations to follow the trajectory specified by the csv file
					    (csv-file nil) 
					    (terminate-on-success-failure? t)
					    )
  ;; copied from create-situation-and-system in create-model.lisp
  (setq *subgraph* nil) ;;; for debuging subgraphs
  (setq *system-being-analyzed* nil)
  (multiple-value-bind (initial-sits system)
      (multiple-value-bind (system initial-conditions)
	  (create-system-from-om-xml-dae-dump filepath 
					      :process-assertions process-assertions
					      :debug? debug?)
					;(format t "system: ~s~%" system)
	(setf (system-success-function system) #'modelica-success-fn
	      (system-terminate-on-success-failure? *system-being-analyzed*) terminate-on-success-failure?)
	(setf (system-initial-conditions system) initial-conditions)
	(mark-pseudo-state-vars pseudo-state-vars)
	(when eliminate? (eliminate))
	(compactor)
	(add-higher-deriv-equalities)
	(propagate-fixed-vars)
	(add-landmark-constraints
         (or landmark-orders
             (figure-landmark-constraints system initial-conditions :debug? debug?)))
	(delete-unconstrained-vars)	
	(let ((sits (create-initial-sits 
		     (add-$dummy-inits
		      (remove-unnecessary-initial-conditions initial-conditions))
		     system)))
	  (unless sits (error "unknown initial situation"))
	  (setf (system-initial-situations *system-being-analyzed*) sits )
	  (unless (or allow-initial-ambiguity?
		      (= (length sits) 1))
	    (error "initial situation ambiguous"))
	  (when csv-file 
	    (add-csv-filter-information csv-file system)
;; [01/21/2013 klenk] At some point, we should do something intelligent to prune the initial state
	    (incf (car (system-match-qstates system))))
	  (values sits system)))
    
    (envision initial-sits depth)
    (cond ((or graphviz-directory display?)
           (let ((dot-file-pathname
                  (if graphviz-directory
                     (get-tempfile-pathname :extension "dot" :directory graphviz-directory)
                     (get-tempfile-pathname :extension "dot"))))
             (out-graphviz-dot initial-sits nil dot-file-pathname)
             (values (car initial-sits) system dot-file-pathname)
             ))
          (json-directory
           (let ((json-file-pathname (get-tempfile-pathname :extension "json" :directory json-directory)))
             (generate-json json-file-pathname initial-sits)
             (values (car initial-sits) system json-file-pathname)
             ))
          (t 
	   (values (car initial-sits) system nil)))
    ))


;;; [4/17/2014 Johan] We should modify the constraint language so these are generated automatically.
(defun add-higher-deriv-equalities ()
;; [12/20/2012 klenk] if v1 = v2 then all explicit derivs of v1 and v2 should also be equal
  (when (member :higher-order *expand-constraints-of-type*)
    (dolist (multi-deriv-var (remove-if-not 
			      #'(lambda (var)
				(> (length (var-deriv-constraints var)) 1))
			    (system-active-variables *system-being-analyzed*)))
      (add-qequals-for-var-derivs (deriv-var-polarity-pairs multi-deriv-var)))
;; [4/29/2013 Klenk] x - y + FixedParameter = 0 all explicit derivs of x and y are equal
;; We lose out doing this after elimination, but so be it.
    (dolist (summer 
	      (remove-if-not #'fixed-parameter-summer?
			     (system-constraints *system-being-analyzed*)))
      (add-qequals-for-var-derivs
       (fixed-parameter-summer-deriv-var-polarity-pairs summer)))
					;  (dolist (multi 
;	    (remove-if-not #'fixed-parameter-multi?
;			   (system-constraints *system-being-analyzed*)))
;    (add-qequals-for-var-derivs
;     (fixed-parameter-multi-deriv-var-polarity-pairs multi)))
    ))
	   
;;; This was added to prune Test.SimpleEngine.xml
(defun fixed-parameter-summer? (constraint)
  (and (general-summer-constraint-p constraint)
       (not (constraint-eliminated constraint))
       (= (length (remove-if #'var-fixed? (constraint-variables constraint))) 2)
;; Must use the constraints because elimination does not use the other things
       (every #'var-deriv-constraints
	      (remove-if #'var-fixed? (constraint-variables constraint)))))
       
;;; [04/17/2014 Johan].  Given a summer that looks like x+y+K=0, where K is a constant.  You
;;; know for sure that dx/dt+dy/dt=0.  This is a correct inference, but it should not be done here.
;;; Again, this will be reorganized soon.
(defun fixed-parameter-summer-deriv-var-polarity-pairs (constraint)
  (let ((vars (remove-if #'var-fixed? (constraint-variables constraint)))
	(poss (general-summer-constraint-pos-vars constraint))
	(negs (general-summer-constraint-neg-vars constraint)))
      (cond ((and (intersection vars poss)
		  (intersection vars negs))
	     ;; This is the equivalent of q=
	     (append (deriv-var-polarity-pairs (car vars) nil)
		     (deriv-var-polarity-pairs (cadr vars) nil)))
	    (t ;; this is q= with opposite polarity
	     (append (deriv-var-polarity-pairs (car vars) nil)
		     (deriv-var-polarity-pairs (cadr vars) t))
	     ))))

(defun fixed-parameter-multi? (constraint)
  (and (multiply-constraint-p constraint)
       (not (constraint-eliminated constraint))
       (= (length (remove-if #'var-fixed? (constraint-variables constraint))) 2)
;; Must use the constraints because elimination does not use the other things
       (every #'var-deriv-constraints
	      (remove-if #'var-fixed? (constraint-variables constraint)))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defun add-qequals-for-var-derivs (qequal-var-polarity-pairs)
  (let* ((base-var (caar qequal-var-polarity-pairs))
	 (base-polarity (cdar qequal-var-polarity-pairs))
	 (next-deriv-polarity-pairs 
	  (deriv-var-polarity-pairs base-var (eq base-polarity '-))
	   ))
      (dolist (var-polarity-pair (cdr qequal-var-polarity-pairs))
	(let ((target-var (car var-polarity-pair))
	      (target-polarity (cdr var-polarity-pair)))
;	  (format t "~% ~A = ~A negate? ~A" base-var target-var (not (eq base-polarity target-polarity)))
;	  (trace construct-qequal)
	  ;; [04/17/2014 Johan] The way the logic of this works is that (qequal x x) is easily constructed.
	  ;; Also, this is not qequals, but really equals.***  So more can be done.
	  (unless (equal base-var target-var)
	    (construct-qequal (car (system-models *system-being-analyzed*))
			      base-var
			      target-var
			      nil  ;; Would need to be more clever for conditional  constraints
			      (not (eq base-polarity target-polarity))
			      'add-qequals-for-var-derivs))
;	  (untrace construct-qequal)
	
	  (dolist (pair (deriv-var-polarity-pairs target-var (eq target-polarity '-)))
	    (push pair next-deriv-polarity-pairs))))
      (when next-deriv-polarity-pairs 
	(add-qequals-for-var-derivs next-deriv-polarity-pairs))))

;; [12/20/2012 klenk] The deriv constraints where var is the deriv-var
;; [12/20/2012 klenk] ignores any conditional constraints
(defun var-deriv-constraints (var)
  (remove-if-not 
   #'(lambda (constraint)
       (and (deriv-constraint-p constraint)
	    (null (deriv-constraint-condition constraint))
	    (eql (deriv-constraint-var constraint)
		 var)))
   (var-uses var)))

;;; [04/17/2014 Johan] This returns a list of all derivatives which occur in var's deriv-constraints
;;; as ((deriv . polarity) ...)
;;; Again, I think this will soon go away.
(defun deriv-var-polarity-pairs (var &optional invert?)
  (mapcar #'(lambda (constraint)
	      (cons 
	       (deriv-constraint-deriv constraint)
	       (if invert? 
		   (invert-polarity (deriv-constraint-polarity  constraint))
		   (deriv-constraint-polarity  constraint))))
	  (var-deriv-constraints var)))


;; [09/10/2012 klenk] Landmark orders is a list of lists of var ids
;; [09/10/2012 klenk] ((56 38)) says that 56 is less than 38
;; [09/10/2012 klenk] ((56 38)(5 8 10)) etc.
(defun add-landmark-constraints (landmark-orders)
  (when (member :landmarks *expand-constraints-of-type*)
    (let ((qplus (qplus-var)))
      (dolist (landmark-list landmark-orders)
	(assert (> (length landmark-list) 1))
	(do* ((arg1 (car landmark-list) (car rest-list))
	      (rest-list (cdr landmark-list) (cdr rest-list)))
	     ((null rest-list) nil)
	  (construct-summer  (list (lookupv arg1))(list (lookupv (car rest-list)) qplus) nil))))))

(defun qplus-var ()
  (find "qplus" (system-active-variables *system-being-analyzed*) :key #'var-local-name :test #'string=))

;; [06/ 6/2013 klenk] :all means that all vars are continuous

(defun mark-pseudo-state-vars (pseudo-state-vars)
  (if (eql pseudo-state-vars :all)
      (dolist (var (quantity-vars))
	(setf (var-state-var? var) :pseudo-state-var))
      (dolist (id pseudo-state-vars)
	(cond ((numberp id)
	       (setf (var-state-var? (lookupv id)) :pseudo-state-var))
	      ((and (stringp id)
		    (find id (system-active-variables *system-being-analyzed*) 
			    :key #'var-local-name :test #'string=))
	       (setf (var-state-var? 
		      (find id (system-active-variables *system-being-analyzed*) 
			    :key #'var-local-name :test #'string=))
		     :pseudo-state-var))
	      (t (warn "Unknown pseudo-state-var ~A" id))
	      ))))


;; [09/11/2012 klenk] assign fixed vars using constraints that are always active
(defun propagate-fixed-vars ()
  (let* ((fixed-vars (remove-if-not #'var-fixed? (system-active-variables *system-being-analyzed*)))
	 (constraints 
	  (remove-if #'deriv-constraint-p
		     (remove-if #'constraint-condition (system-constraints *system-being-analyzed*))))
	 (changed? t))
    (loop while changed? do
	 (setq changed? nil)
	 (dolist (c2 (remove-if-not #'(lambda (constraint)
					(some #'(lambda (var) (member var (constraint-variables constraint)))
					      fixed-vars))
				    constraints))
	   (let ((unfixed-vars (remove-if #'var-fixed? (constraint-variables c2)) ))
	     (when (= (length unfixed-vars) 1)
	       (let ((var (car unfixed-vars)))
		 (debug-print nil "~% c2: ~A adding new fixed-var ~A" c2 var)
		 (make-var-fixed var 'propagate-fixed-vars)
		 (push var fixed-vars)
		 (setq changed? t))))))))
  
 

;; [08/31/2012 klenk] Something that is missing here is calculations between numeric values
;; [08/31/2012 klenk] that could set the initial values of dummy variables
;; [09/ 4/2012 klenk] (use-modelcia-starts? t) and (use-Modelica-defaults? nil) builds in the
;; [09/ 4/2012 klenk] assumption that the modeler knows what they are doing.
;; [09/ 4/2012 klenk] The main difference between our approach and modelicas is that we don't
;; [09/ 4/2012 klenk] relax the model defaults to identify a single initial situation
(defun create-initial-sits (ics system &key (use-modelica-starts? t)(use-modelica-defaults? nil))
  (declare (ignore system))
  (let ((left-limits (create-left-limits ics)))
    (debug-print nil "~% Left limits are")
    (debug-print nil "~% ~A" 
		 (with-output-to-string (stream)
		   (print-varss left-limits :stream stream :vars (discrete-vars))))
    (remove-duplicate-starting-situations 
     (mapcan #'(lambda (left)
                 (restart-case
                     (create-right-instants 
                      left ics use-modelica-starts? use-modelica-defaults?)
                   (ignore-error () nil)))
	     left-limits))))

(defun remove-duplicate-starting-situations (sits)
  (let ((sits (remove nil sits)))
    (mapc #'collect-state sits)
    (remove-duplicates
     sits
     :test #'situation-equal
     )))


(defun create-left-limits (ics)
  (let* ((left-limit (create-situation :instant nil)))
    (set-values left-limit (modelica-pre-values ics))
    (complete-discrete-values left-limit)))

;;; No need to run constraints here
;; [06/20/2013 klenk] No need to worry about dummys here, we are just trying to set
;; [06/20/2013 klenk] the values for the pre
(defun complete-discrete-values (left-limit)
;  (debug-print nil "~% Left Limit ~A" left-limit)
;  (debug-print nil "~% ~A" (with-output-to-string (stream)
;			     (print-vars left-limit :stream stream :fixed-parameters? t)))
  (let ((unknown-discrete-vars 
	 (remove-if #'dummy-var? 
		    (unknown-discrete-vars left-limit))))
    (if (null unknown-discrete-vars)
	(list left-limit)
	 (mapcan #'(lambda (val)
		     (let ((new-sit (create-situation-copy left-limit)))
		       (clobber (car unknown-discrete-vars)
				val new-sit '((plunk)) :discrete)
		       (debug-print nil "~%created new sit: ~A" new-sit)
		       (complete-discrete-values new-sit)))
		 (vals-for-discrete-var (car unknown-discrete-vars))))))



;; [06/21/2013 klenk] what is the relationship between the pre values and the discrete values?
;; [06/24/2013 klenk] If the left-limit results in inconsistent right instants, then return nil
(defun create-right-instants (left-limit ics use-modelica-starts? use-modelica-defaults?)
    (clear-constraints)
    (let ((*debug?* nil))
      (debug-print nil "~% Left Limit ~A" left-limit)
      (debug-print nil "~% ~A" (with-output-to-string (stream)
				 (print-vars left-limit :stream stream :vars (discrete-vars))))
      (let ((initial-situation (create-situation :instant left-limit)))
;; [05/09/2014 Johan] no longer needed because we now have globals.???
	(set-values initial-situation (modelica-fixed-vals ics))

	(cond ((eq (run-constraints initial-situation) :fail)
	       (debug-print nil "~% Initial-sit after fixed continuous vals ~A inconsistent with left-limit ~A" initial-situation left-limit)
	       (debug-break)
	       nil)
	      ((set-initial-values 
		initial-situation ics use-modelica-starts? use-modelica-defaults?)
	       (run-completer initial-situation left-limit)


	       )
	      (t nil)))))

;; [06/21/2013 klenk] Unless a when-equation is active at initialization, then the
;; [06/21/2013 klenk] pre(d)=xd p.252 Fritzon
(defun set-discrete-values (sit left-limit)
  (mapc #'(lambda (discrete-var)
	    (unless (or (mentioned-in-when-equation? discrete-var)
			(var-fixed? discrete-var) ; don't have  pre's
			(dummy-var? discrete-var)
			(discrete-value discrete-var sit))
	      (clobber discrete-var (discrete-value discrete-var left-limit)
		       sit '((:unchanged-discrete)) :discrete))) 
	    (discrete-vars)))

;; [06/21/2013 klenk] This is a placeholder till we have to deal with this case
(defun mentioned-in-when-equation? (var)
  (declare (ignore var))
  nil)

;; [06/24/2013 klenk] Returns nil if inconsistent
(defun set-initial-values (initial-situation ics
			   use-modelica-starts? use-modelica-defaults?)
  (debug-print 
   nil 
   "~% Initial-sit after fixed continuous vals ~A" initial-situation)
  (debug-print nil "~% ~A" (with-output-to-string (stream)
			     (print-vars initial-situation
					 :stream stream
					 :fixed-parameters? t)))
  (set-discrete-values initial-situation (car (situation-parents initial-situation)))
  (when use-modelica-starts?
    (set-values initial-situation (modelica-suggested-start-vals ics))
    (when (eq (run-constraints initial-situation) :fail)
      (debug-print nil "~%Assuming suggested values in ~A results in contradictions: ~A" 
		   initial-situation (system-last-contradiction *system-being-analyzed*))
      (return-from set-initial-values nil) 
      ))
  (debug-print nil "~% Initial-sit after suggested start vals ~A" initial-situation)
  (debug-print nil "~% ~A" (with-output-to-string (stream)
			     (print-vars initial-situation :stream stream :fixed-parameters? t)))
  (when use-modelica-defaults?
    (assume-modelica-defaults initial-situation)
    (when (eq (run-constraints initial-situation) :fail)
      (error "Assuming Modelica defaults (reals = Q0) results in contradictions" )))
  ;; [09/14/2012 klenk] If we perform a discrete transition here (Basically assume that C1 is Nil), we could look to see if any of the discrete variables change and then iterate from there. Explore this afterwards.  
  t)


;; [09/04/2012 klenk] All quantity variables we don't know are equal to Q0
(defun assume-modelica-defaults (sit)
  (dolist (var (remove-if-not #'quantity-var? (unknown-vars sit)))
    (clobber var 'Q0 sit '((:init assume-modelica-defaults)))))

;(#<var: 4 (>> brake1.w_small Simple_Brake_Tests.Brake_Test_1)> :START  10000000000 :FIXED? T)
(defun modelica-pre-values (ics)
  (remove-if-not #'(lambda (ic)
		     (and (discrete-var? (car ic))
			  (fifth ic)
			  ))
		 ics))

;(#<var: 4 (>> brake1.w_small Simple_Brake_Tests.Brake_Test_1)> :START  10000000000 :FIXED? T)
(defun modelica-fixed-vals (ics)
  (remove-if-not #'(lambda (ic)
		     (or
;; [09/14/2012 klenk] Known values should be considered fixed
		      (and (discrete-var? (car ic))
			   (var-fixed? (car ic)))
		      (and (quantity-var? (car ic))
			   (fifth ic))))
		 ics))

;; [09/ 2/2012 klenk] Is there such a thing as suggested discrete vars?
;; [09/ 2/2012 klenk] Doesn't look like it from the modelica documentation
(defun modelica-suggested-start-vals (ics)
  (remove-if-not #'(lambda (ic)
		    (and (quantity-var? (car ic))
			 (not (fifth ic))))
		 ics))

;(defun set-values (sit ics)
;  ;; Do this once.
;  (if (= (situation-depth sit) 0)
;      (set-values-1 sit ics)))

(defun set-values (sit ics)
;  (format t "~% set-values called on: ~a ~a" ics sit)
  (dolist (ic ics)
;    (format t "~% set-values is considering ~a" ic)
;; [08/31/2012 klenk] let clobber figure out the appropriate data type
    ;; For symbolic algebra.  A fixed parameter with a numeric value don't use clobber.
    ;; Instead cache it.  Need to decide where the best place to cache is.
    (cond ((var-global-cell (car ic)))	
	  ((and (var-fixed? (car ic))
		(numberp (third ic))
		(not (var-eliminated (car ic))))
	   ;; temp tet:
;	   (if (equal "Integer" (car (var-qspaces (car ic)))) (error "bad"))
	   (let ((qvalue (create-q-quantity-from-number (car ic) (third ic))))
	     ;; ??
	     (if *use-global*
		 (clobber-global (car ic) 
				 qvalue
				 :qualitative)
	       (clobber (car ic) qvalue
			sit  '((:init1)) :qualitative))
	     ))
	  ((and (var-fixed? (car ic))
		(var-eliminated (car ic)))
	   nil)
	  ((and ;(var-state-var? (car ic))
	    (numberp (third ic))
	    )

	   ;; What we do here needs more discussion with Matt.
	   ;; My understanding is these are all ICs.  But it kills symbolic analysis.
	   (push (cons (car ic) (third ic)) (system-ics *system-being-analyzed*))
	   (clobber-qvalue-by-numeric (car ic) (third ic) sit `((:qualitative ic ,ic)))


;	   (clobber-qvalue-by-numeric (car ic) (third ic) sit `((:qualitative)))
;	   (push (cons (car ic) (third ic)) (system-ics *system-being-analyzed*))
;	   (clobber-qvalue-by-numeric (car ic) (third ic) sit `((:qualitative ic ,ic)))
	   )
	  ((var-eliminated (car ic)))
	  ((var-fixed? (car ic))
	   (let ((value (if (symbolp (third ic))
			    (make-q-quantity :value (third ic) :qspace (car (var-qspaces (car ic))) :deriv 'Std)
			  (third ic))))
	     (cond ((null *use-global*) 
		    (clobber (car ic) value sit `((:init3 ic1 ,ic))))
		   (t (clobber-global (car ic) (third ic))))))
	  (t 
	     (clobber (car ic)
		      (third ic)
		      sit `((:init2 ic2 ,ic))))))

  
  )
;		      sit '((:init)))))
  

;;; [05/07/2014 Johan] To monitor what is going on this is a separate function.
;;; Could maybe merge this with clobber?
;;; global values are held in a cell in the var structure.
(defun clobber-global (var value &optional supplied-type)
  (debug-print nil "~% Setting global value of ~a to ~a of type ~a" var value supplied-type)
;  (if (var-eliminated var) (error "look"))

;  (if (= (var-id var) 61) (error "look"))

  (let ((type (or supplied-type (type-from-value value var))))
    (when (eq type :simple-qualitative)
      (setq value (simpleq->interval value)
	    type :qualitative))
    (when (eq type :discrete)
      (if (not (q-quantity-p value))
	  (setq value (make-q-quantity :value value :qspace (car (var-qspaces var)) :deriv 'Std)
		type :qualitative)
	  (setq type :qualitative)))
    (when (and (eq type :qualitative)
	       (not (q-quantity-p value)))
      (setq value (create-q-quantity var value nil nil)))
    (let ((cell (var-global-cell var)))
      (cond (cell (error "Only clobber global's once"))
	    (t (setq cell (make-cell :var var :situation 'global))
	       (setf (var-global-cell var) cell)
	       ))
;      (debug-print t "~% Setting final global value of ~a to ~a of type ~a" var value type)

      ;; Derivatives will always be 0.
      (when (q-quantity-p value)
	(setf (q-quantity-deriv value) 'Std))

      (let ((new-value (make-datum :quantity value :cell cell :type type :justifications (list '(clobber-global)))))
	(push new-value (cell-values cell))
	(propagate new-value nil 'global)
	)


      )))
    

;; [06/27/2012 klenk] This function looks for any discrete-vars that are not fixed
;; [06/27/2012 klenk] If one has a value of violated, then the situation is :failed
;; [06/27/2012 klenk] putting off the success case for the time being
(defun modelica-success-fn (sit)
   (cond ((some #'(lambda (var)
		   (and (not (var-fixed? var))
			(member 
			 (q-quantity-value (discrete-value var sit))
			 (list :violated *violated*))))
	       (discrete-vars))
	 :failure)
	 ((some #'(lambda (var)
		   (and (not (var-fixed? var))
			(member 
			 (q-quantity-value (discrete-value var sit))
			 (list :success *success*))))
	       (discrete-vars))
	 :success)
	(t :maybe)))
            

;; [04/09/2012 klenk] Optional argument
(defun make-dot-file-pathname (graphviz-directory)
  (let ((dir-pathname
         (cond ((pathnamep graphviz-directory) graphviz-directory)
               ((stringp graphviz-directory) (parse-namestring graphviz-directory))
               (t (merge-pathnames "envisioner/v2/" cl-user::*my-meta-path*)))))
    (make-pathname
     :device (pathname-device dir-pathname)
     :directory (pathname-directory dir-pathname)
     :name (symbol-name (gensym))
     :type "dot")))


;; [03/15/2012 klenk] Can't set variables that aren't part of the system
(defun remove-unnecessary-initial-conditions (initial-conditions)
  (remove-if-not #'(lambda (ic)
;                     (if (not (member (car ic) (system-variables *system-being-analyzed*)))
;                         (format t "removing initial-conditions ~A~%" ic)
;			 )
		     (member (car ic) (system-active-variables *system-being-analyzed*)))
		 initial-conditions))

;; [03/15/2012 klenk] Need to add an initial condition for the $dummy parameter
(defun add-$dummy-inits (ics)
  (if (find "$dummy" (system-active-variables *system-being-analyzed*)
	    :key #'var-local-name :test 'string=)
      (cons (list (find "$dummy" (system-active-variables *system-being-analyzed*)
			:key #'var-local-name :test 'string=)
		  :start 'Q0
		  :fixed? t)
	    ics)
      ics))


;; (parse-om-xml-dae-dump "/local/PARC-QM/META/Modelica/battery-and-two-resistors/battery-and-two-resistors.xml" :print-parse)

(defun delete-unconstrained-vars ()
  (setf (system-active-variables *system-being-analyzed*)
	(remove-if-not #'(lambda (var)
			   (or (var-uses var)
			       (var-fixed? var)
			       (some #'(lambda (mod-when)
					 (eq (second (mod-when-equ mod-when)) var))
				     (system-when-equations *system-being-analyzed*))
			       ))
		       (system-active-variables *system-being-analyzed*))))

(defun system-from-xml-battery-and-two-resistors ()
  (multiple-value-bind (system initial-conditions)
      (create-system-from-om-xml-dae-dump (merge-pathnames "Modelica/battery-and-two-resistors/battery-and-two-resistors.xml"
                                                           cl-user::*my-meta-path*))
    (format t "~s~%" system)
    (format t "~s~%" initial-conditions)
    system))

(defun show-conditional-equations ()
  (let ((xml-files (mapcar #'(lambda (x)
                               (list x (merge-pathnames x cl-user::*my-meta-path*)))
                           '("Modelica/battery-and-two-resistors/battery-and-two-resistors.xml"
                             ; "Modelica/drivetrain/shift-delay/drivetrain_simple.xml"
                             ; "Modelica/drivetrain/shift-delay/drivetrain_with_delay.xml"
                             "Modelica/ladder/RC3.xml"
                             "Modelica/ladder/RC4.xml"
                             "Modelica/ladder/RC5.xml"
                             "Modelica/ladder/RLC1.xml"
                             "Modelica/ladder/RLC2.xml"
                             "Modelica/ladder/RLC3.xml"
                             "Modelica/ladder/two_R.xml"
                             "Modelica/ladder/two_R_one_C.xml"
                             "Modelica/single-cap-diode/single-cap-diode.xml"))))
    (dolist (f xml-files)
      (let ((parse (parse-om-xml-dae-dump (cadr f))))
        (format t "~s: ~s~%" (car f) (cdr (assoc :conditional-equations parse)))))))

;;; -*- syntax:common-lisp; mode: lisp; package: (env2 global 1000.); base: 10. -*-

;;;;  modified: sunday nov 26, 2000 at 12:45 by dekleer



(in-package :env2)



"(c) copyright 1986, 1987, 1988, 1989, 1990, 1991 xerox corporation.

all rights reserved.  subject to the following conditions, permission is

granted to use and copy this software and to prepare derivative works:

such use, copying or preparation of derivative works must be for

non-commercial research or educational purposes; each copy or derivative

work must include this copyright notice in full; a copy of each

completed derivative work must be returned to:  dekleer@xerox.com

(arpanet) or johan de kleer, xerox parc, 3333 coyote hill road, palo

alto, ca 94304.  this software is made available as is, and xerox

corporation makes no warranty about

the software or its performance."



;;; o storing hashes themselves in the table is not worth it. it never seems to miss

;;;   therefore, i might as well reduce the table size by 30%.



;;; o install env-gc for at least flushing inactive envs.  see rehash-env below.



;;; o what about true/false assumptions in make-environments? or other

;;;   atms calls.  the atms does not check in passed in arguments of inactive envs.



;;; o the clever array referencing stuff here doesn't seem to buy us much.  think

;;;   this out more clearly sometime.



;;; o look at rms lisp manual for ways to make bitvectors arrays.  unfortunately, that

;;;   won't necessarily work on a 3600 so maybe it is not worth it.



;;; o use hash-statistics on a big problem.  it looks as if storing the hash is a 

;;;   worthless exercise.  given the size of the env hash array, we would have 30%

;;;   right off the top if we did that.



;;; o contradictory environments might be in hash table, but there without an environment

;;;   structure, just a key.  thats sort of how it works right now anyway, but they

;;;   can now be removed after the fact too.... i guess this is only important if

;;;   if we start testing the envs keys themselves and shorten the env vectors even more.



;;; o rehashing should garbage collect unused assumptions, environment using unused

;;;   assumptions, any environment containing a true or false assumption.



;;; this uses an algorithm suggested by danny bobrow (blame him).



(defstruct (hash (:type vector) :named)

  (p1 nil)					; small prime.

  (p2 nil)					; size of table --- a prime.

  (primes nil)					; remaining good primes.

  (free nil)					; number of free slots.

  (thresh nil)					; free > thresh or rehash.

  (array nil)					; hash array.

  (array-loc nil)				; (aloc array 0)

  (area nil)

  )



(defmacro fast-make-array (length &optional area) area `(make-array ,length))



(defmacro fast-aset (value base offset) `(setf (aref ,base ,offset) ,value))



;; Was //

(defmacro divide// (x y) `(values (floor ,x ,y)))



(defvar *good-double-primes* '(103 139 181 229 283 349 433 523 619 811

			       1021 1231 1453 1621 1849 2029 2341 2713 2971

			       3529 4003 4423 5023 5503 6091 6553 7129 7591

			       8221 8971 9631 10273 14983 16063 17029 18043

			       19081 20023 22039 24109 25999 28099 30013

			       33073 36013 39841 45007 50021 55001 66029

			       79229 95063 114067 136859 164231 200003

			       240007 345601 414721 497671 597209 800011 960017

			       1440037 1728043 2073647 2488379 2986037 3583271

			       5000011 6000011 7200007 8640001

			       ))



;;; this finds a prime above n extremely stupidly.  

(defun fprime (n &aux primes end)

  (setq primes (list 2) end primes)

  (do ((i 3. (1+ i))) (nil)

    (cond ((dolist (p primes)

	     (if (> (* p p) i) (return nil))

	     (if (= (rem i p) 0) (return t))))

	  (t (rplacd end (list i)) (setq end (cdr end))

	     (cond ((> i n) (format t "~% ~d" i) (setq n (floor (* 1.2 n)))))))))



;;; don't allow utilization to go above 75%.

(defun make-hash-table-situation (size area &aux hash-table)

  (do ((p1 *good-double-primes* (cdr p1))

       (p2 (cdr *good-double-primes*) (cdr p2)))

      ((null p2) (error "sorry i'm out of good primes"))

    (when (> (car p2) size)

      (setq hash-table (make-hash :p1 (car p1)

				  :p2 (car p2)

				  :primes (cdr p2)

				  :free (car p2)

				  :thresh (floor (* .25 (car p2)))

				  :array (make-array (car p2) :initial-element nil)

				  :area area))

      (setf (hash-array-loc hash-table)

	(hash-array hash-table))

      (return hash-table))))



;;; sort of strange, but makes thing simpler.

(defun copy-hash-table-situation (hash-table &aux new-hash-table)

  (setq new-hash-table (copy-hash hash-table))

  (setf (hash-array new-hash-table)

	(make-array (hash-p2 new-hash-table) :initial-element nil))

  (setf (hash-array-loc new-hash-table)

    (hash-array new-hash-table))

  (setf (hash-free new-hash-table) (hash-p2 hash-table))

  new-hash-table)



;;; lots of cycles get wasted here.

;(defun reset-hash-table-situation (table)

;  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))

;  (fill (hash-array table) nil)

;  (setf (hash-free table) (hash-p2 table)))



;;; Faster:

(defun reset-hash-table-situation (table &aux array)

  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))

  (setq array (hash-array table))

  (do ((i (the fixnum (1- (the fixnum (hash-p2 table)))) (the fixnum (1- (the fixnum i)))))

      (nil)

    (declare (fixnum i))

    (setf (svref array i) nil)

    (if (= i 0) (return nil)))

  (setf (hash-free table) (hash-p2 table)))



;;; this returns a raw pointer if possible, otherwise an integer offset.

(defmacro hloc (array offset)

  array

  `,offset)



;;; slot is either (1) an situation defstruct.

;;;                (2) vector if its an inconsistent entry. (not used in QRM yet, but will be).



(defun puthash-situation (key value hash-table &aux i slot p1)

  (let* ((baseloc (hash-array-loc hash-table))

	 (p2 (hash-p2 hash-table))

	 (p (hash-situation key p2)))

    #+:symbolics (declare (sys:array-register baseloc))

    (do nil (nil)

      (setq slot (aref baseloc p))

      (cond ((null slot)

	     (fast-aset value baseloc p)

	     (if (< (decf (hash-free hash-table)) (hash-thresh hash-table))

		 (maybe-rehash-situation hash-table))

	     (return value))

	    ((listp slot)

	     (when (states-equal key slot) (fast-aset value baseloc p) (return value)))

	    ((states-equal key (situation-state slot)) (fast-aset value baseloc p) (return value)))

      (unless i

	(setq p1 (hash-p1 hash-table))

	(if (= 0 (setq i (rem p p1))) (setq i p1)))

      (incf p i)

      (if (>= p p2) (decf p p2)))))



;;; this returns the situation if it is found, otherwise it returns an array offset

;;; to the empty slot.  this now only returns a locative if the slot is empty.

(defun nget-or-puthash-situation (key hash-table &optional dont-allocate &aux i p1 slot (probes 0))

  (let* ((baseloc (hash-array-loc hash-table))

	 (p2 (hash-p2 hash-table))

	 (p (the fixnum (hash-situation key p2))))

    (do nil (nil)

      (setq slot (aref baseloc p))

      (cond ((null slot)

	     (cond ((and (not dont-allocate)

			 (< (decf (hash-free hash-table)) (hash-thresh hash-table)))

		    (maybe-rehash-situation hash-table)

		    (return (nget-or-puthash-situation key hash-table dont-allocate)))

		   (t (return (hloc baseloc p)))))

	    ((vector-p slot)

	     (if (states-equal key slot) (return :removed-situation)))

	    ((states-equal key (situation-state slot)) (return slot)))

      ;; this happens extremely rarely.  

      ;; sometimes this can cause a loop.******

      ;; understand why this happens better.

      (incf probes)

      (when (> probes 100)

	(rehash-situation hash-table nil t)

	(return (nget-or-puthash-situation key hash-table dont-allocate)))

      (unless i

	(setq p1 (hash-p1 hash-table))

	(if (= 0 (setq i (rem p p1))) (setq i p1)))

      (incf p i)

      (if (>= p p2) (decf p p2)))))



;;; use if you called nget-or-puthash-situation with dont-allocate set to t and you changed

;;; your mind.

(defun hash-allocate (hash-table)

  (if (< (decf (hash-free hash-table)) (hash-thresh hash-table))

      (maybe-rehash-situation hash-table)))



;;; if gethash-situation misses, it returns as a second argument what nget-or-puthash-situation would.

(defun gethash-situation (key hash-table &aux i p1 slot)

  (let* ((baseloc (hash-array-loc hash-table))

	 (p2 (hash-p2 hash-table))

	 (p (hash-situation key p2)))

    (do nil (nil)

      (setq slot (or (aref baseloc p) (return nil)))

      (if (listp slot)

	  (if (states-equal key slot) (return :removed-situation))

	  (if (states-equal key (situation-state slot)) (return slot)))

      (unless i

	(setq p1 (hash-p1 hash-table))

	(if (= 0 (setq i (rem p p1))) (setq i p1)))

      (incf p i)

      (if (>= p p2) (decf p p2)))))



;;; used only for debugging.  returns the array slot index.

(defun gethash-situation-p (key hash-table &aux i p1 slot)

  (let* ((baseloc (hash-array-loc hash-table))

	 (p2 (hash-p2 hash-table))

	 (p (hash-situation key p2)))

    (do nil (nil)

      (setq slot (or (aref baseloc p) (return (values p nil))))

      (if (listp slot)

	  (if (states-equal key slot) (return (values p :removed-situation)))

	  (if (states-equal key (situation-state slot)) (return (values p slot))))

      (unless i

	(setq p1 (hash-p1 hash-table))

	(if (= 0 (setq i (rem p p1))) (setq i p1)))

      (incf p i)

      (if ( p p2) (decf p p2)))))



(defvar *compress-situation-table* t)



;;; call this function whenever you want.  usually called when free space

;;; in hash table gets low.  to prevent thrashing this ensures that 1.5 threshold

;;   table is free before this function is necessarily called again.

(defun maybe-rehash-situation (hash-table)

  (format t "~% gc ing because the hash table is ~d% full"

	  (divide// (* (- (hash-p2 hash-table) (hash-free hash-table)) 100.)

	      (hash-p2 hash-table)))

  (rehash-situation hash-table *compress-situation-table*)

  (format t "~% after gc the hash table is ~d% full"

	  (divide// (* (- (hash-p2 hash-table) (hash-free hash-table)) 100.)

	      (hash-p2 hash-table)))

  (unless (and *compress-situation-table*

	       (> (hash-free hash-table) (* 1.5 (hash-thresh hash-table))))

    (rehash-situation hash-table nil t))

  hash-table)



;;; could replace all false environemnts with their bitstrings.  but that may not be

;;; a good idea because it'll make binary subsumption tests hard. (not used in qrm).



;;; Feature not used in Qrm yet:

;;; this throws away any env which is subsumed by a binary nogood.

;;; this throws away any env which is no longer active.

(defun rehash-situation (hash-table &optional nogrowthp keep-everything

		   &aux new-hash-table p3 key

		   p2 p i p1 slot (gc-count 0))

  (declare (optimize (speed 3) (safety 0) (debug 0) (space 0)))

  (format t "~%rehashing ")

  (if nogrowthp (format t " for gc only") (format t " for more space ..."))

  (setq new-hash-table (if nogrowthp

			   (copy-hash-table-situation hash-table)

			   (make-hash-table-situation (floor (* 1.5s0 (hash-p2 hash-table)))

						(hash-area hash-table))))

  (let ((ptr (hash-array-loc hash-table))

	(baseloc (hash-array-loc new-hash-table)))

    #+:symbolics (declare (sys:array-register ptr baseloc))

    (setq p3 0 p1 (hash-p1 new-hash-table) p2 (hash-p2 new-hash-table))

    (dotimes (k (hash-p2 hash-table))

      (setq slot (aref ptr p3))

      (cond ((null slot))

;;;*** here is the place to flush situations which are no longer relevant.

;	    ((and (not keep-everything)

; 

;		  (if (listp slot)

;		      (vector-flush? slot)

;		      (or (subsumed-by-binary-nogood? slot)

;			  (not (active-env? slot)))))

;

;	     (incf gc-count)

;	     )

	    (t (setq i nil

		     key (if (listp slot) slot (situation-state slot))

		     p (hash-situation key p2))

	       (do nil (nil)

		 ;; guaranteed not to hit twice...

		 (unless

		   (aref baseloc p)

		   (fast-aset slot baseloc p)

		   (decf (hash-free new-hash-table))

		   (return))

		 (unless i (if (= 0 (setq i (rem p p1))) (setq i p1)))

		 (incf p i)

		 (if (>= p p2) (decf p p2)))))

      (incf p3))

    (replace hash-table new-hash-table)

    (format t "~:d situation hash slots collected" gc-count)))



;;; test to see just how much it costs to scan the hash table.

(defun scan (hash-table &aux p3 start-time count)

  (setq start-time (get-internal-run-time)

	p3 0

	count 0)

  (let ((ptr (hash-array-loc hash-table)))

    #+:cl-zl (declare (sys:array-register ptr))

    (dotimes (k (hash-p2 hash-table)) (if (aref ptr k) (incf count)))

    (format t "~d entries, ~d s for scan." count (time-taken start-time))))



(defun bignums? (hash-table &aux situation)

  (let ((ptr (hash-array-loc hash-table))) 

    #+:cl-zl (declare (sys:array-register ptr))

    (dotimes (k (hash-p2 hash-table))

      (setq situation (aref ptr k))

      (cond ((null situation))

	    ((listp situation))

	    (t (dolist (w (situation-state situation))

		 (if (typep w 'bignum) (error "bignum it bit vector?"))))))))



(defconstant *max-probe* 200.)



;;; used for debugging.  Needs to be updated for qrm.





;;; For debugging, delete.

(defun compare-vectors (v1 v2)

  (do ((v1 v1 (cdr v1))

       (v2 v2 (cdr v2))

       (w 0 (1+ w)))

      ((and (null v1) (null v2)))

    (cond ((equal (car v1) (car v2)))

	  (t (format t "~% mismatch at word ~d, v1: ~d, v2: ~d"

		     w (car v1) (car v2))))))



;;; instrumented gethash-situation, used to see how bad things are.

;;; returns probes.

(defun igethash-situation (key hash-table &optional trace &aux i p1 slot)

  (let* ((p2 (hash-p2 hash-table))

	 (p (hash-situation key p2))

	 (baseloc (hash-array-loc hash-table))

	 (probes 0))

    #+:symbolics (declare (sys:array-register baseloc))

    (do nil (nil)

      (incf probes)

      (setq slot (aref baseloc p))

      (if trace (format t "~% at slot ~d found ~a" p slot))

      ;; *** should be 100 to be consistent, but am debugging this at the moment 7/23/2006.

      (cond ((> probes 200) (error "> 200 probes"))

	    ((null slot) (error "key not found?"))

	    ((listp slot) (if (states-equal key slot) (return (values slot probes))))

	    ((states-equal key (situation-state slot)) (return (values slot probes))))

      (unless i

	(setq p1 (hash-p1 hash-table))

	(if (= 0 (setq i (rem p p1))) (setq i p1)))

      (incf p i)

      (if (>= p p2) (decf p p2)))))



;;;;  Modified: Wednesday, May 07, 2014 at 15:43:08 by klenk
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: web-ui.lisp
;;;;    System: envisioner v2
;;;;    Author: Bill Janssen <janssen@parc.com>
;;;;   Created: 4 June 2012
;;;;   Purpose: GML output generation
;;;; ----------------------------------------------------------------------------
;;;;  USAGERIGHTS: meta-x
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(defvar *acceptor* nil
  "Hunchentoot acceptor for Web connections")

(defvar *base-page* nil
  "The HTML top-level page for this 'server'")

(defvar *d3* nil
  "A cached version of the d3 library")

(defvar *ui-js* nil
  "Our d3-using Javascript UI code")

(defvar *dagre-page* nil "dagre visualization page")
(defvar *dagre-js* nil "javascript for the dagre visualization")

(defvar *gamma-page* nil "Gamma demo visualization page")
(defvar *gamma-js* nil "Gamma demo visualization code")
(defvar *d3-slider-js* nil "Code to implement a D3 slider")
(defvar *d3-slider-css* nil "Styling for a D3 slider")

;; hash table mapping port numbers to acceptors
(defvar *servers* (make-hash-table :test #'equal))

;; define a reloading function that automatically re-pulls the content
;; if the file backing it has changed

(defun read-entirely (nmstr)
 (let ((ret (make-string-output-stream)))
   (with-open-file (input (merge-pathnames nmstr cl-user::*my-meta-path*)
			  :direction :input)
     ;; [06/06/2012 klenk] file-length gets confused by newline and carriage returns
     (do ((line (read-line input nil 'EOF)(read-line input nil 'EOF)))
	 ((eql line 'EOF) (get-output-stream-string ret))
       (write-line line ret)))))

(defun read-bytes-entirely (stream)
  (let ((seq (make-array (file-length stream) :element-type '(unsigned-byte 8) :fill-pointer t)))
    (setf (fill-pointer seq) (read-sequence seq stream))
    seq))


(defclass reloading-file ()
  ((filename :initarg :filename :initform nil :accessor filename)
   (cached-content :initarg :cached-content :initform "" :accessor cached-content)
   (binary :initarg :binary :initform nil :accessor binary?)
   (modify-date :initarg :modify-date :initform 0.0 :accessor modify-date))
  (:metaclass #+ccl cl-user::funcallable-standard-class
	      #+allegro mop::funcallable-standard-class
	      ;; [04/25/2014 Johan] enter your favorite.
	      ))

(defmethod initialize-instance :after ((instance reloading-file) &rest initargs)
  (declare (ignore initargs))
  (cl-user::set-funcallable-instance-function
   instance
   #'(lambda ()
       ;; Note that we have to support the dumped case, where no instance
       ;; of the file exists.  So we only reload when the file exists.
       (let ((fpathname (merge-pathnames (filename instance) cl-user::*my-meta-path*)))
         (when (probe-file fpathname)
           (let ((current-modify-date (file-write-date fpathname)))
             (when (and (numberp current-modify-date)
                        (> current-modify-date (modify-date instance)))
               (setf (cached-content instance)
                     (if (binary? instance)
                         (with-open-file (stream fpathname :direction :input :element-type '(unsigned-byte 8))
                           (read-bytes-entirely stream))
                         (read-entirely (filename instance))))
               (setf (modify-date instance) current-modify-date))))
         (cached-content instance)))
   ))

(defmacro defreloader (symbolname filename &key (binary nil))
  "A macro to make the reloading content cache a bit easier to use.
It will define the SYMBOLNAME as a function which when called will return
the current contents of FILENAME."
  `(progn
     (setf (symbol-function ',symbolname) (make-instance 'reloading-file :filename ,filename :binary ,binary))
     (,symbolname)))         

(defreloader *base-page* "envisioner/v2/ui/basepage.html")
(defreloader *d3* "envisioner/v2/ui/d3.v3.js")
(defreloader *ui-js* "envisioner/v2/ui/ui.js")
(defreloader *dagre-js* "envisioner/v2/ui/dagre.js")

(defun empty-json ()
  (declare (special *envisioner-major-version* *envisioner-minor-version*
                    *envisioner-version-tag* *envisioner-vcs-revision*))
  (with-output-to-string (out)
    (format out "{~%")
    (format out "  \"model_generator\": \"Open Modelica, version 1.8.1+ with PARC extensions\",~%")
    (format out "  \"model\": \"(No system)\",~%")
    (format out "  \"envisioner\": { \"major_version\": ~A, \"minor_version\": ~A, \"tag\": ~A, \"revision\": ~A },~%"
            *envisioner-major-version* *envisioner-minor-version*
            (or (and *envisioner-version-tag* (format nil "~S" *envisioner-version-tag*)) "null")
            (or (and *envisioner-vcs-revision* (format nil "~S" *envisioner-vcs-revision*)) "null"))
    (format out "  \"variables\": {}~%")
    (format out "  \"situations\": {}~%")
    (format out "  \"transitions\": {}~%")
    (format out "}~%")
    out))

;;;
;;; Generic named callback class, which provides access to a hashtable
;;; of named callback functions
;;;

(defclass callback-provider ()
  ((name :initarg :name :initform nil :accessor callback-provider-name)
   (callbacks :initarg :callbacks
              :accessor callback-provider-callbacks
              :documentation "hash-table mapping URIs to functions"))
  (:documentation "A class which provides a set of callbacks to a Web server"))

(defmethod initialize-instance ((self callback-provider) &rest initargs &key &allow-other-keys)
  (declare (ignore initargs))
  (call-next-method)
  (setf (callback-provider-callbacks self) (make-hash-table :test #'equal)))

(defmethod add-callback ((self callback-provider) relative-uri callback)
  (setf (gethash relative-uri (callback-provider-callbacks self)) callback))

;;;
;;; A subclass of hunchentoot:acceptor which knows how to work with callback providers
;;;

(defclass uiserver (hunchentoot:acceptor)
  ((providers :initform nil :accessor uiserver-providers
              :documentation "hashtable maps top-level names to callback objects"))
  (:documentation "A subclass of hunchentoot:acceptor which knows how to work with callback providers"))

(defmethod initialize-instance ((self uiserver) &rest initargs &key &allow-other-keys)
  (declare (ignore initargs))
  (call-next-method)
  (setf (uiserver-providers self) (make-hash-table :test #'equal)))

(defmethod root-content ((self uiserver) path parameters)
  (declare (ignore path parameters))
  ; (hunchentoot:log-message* :warning "root-content uiserver, path is ~A, parameters is ~A~%" path parameters)
  (setf (hunchentoot:return-code hunchentoot:*reply*) hunchentoot:+http-not-found+)
  (hunchentoot:abort-request-handler))

(defmethod hunchentoot:acceptor-dispatch-request ((self uiserver) request)
  ;; Process an incoming request.  We assume a threaded lisp, so hunchentoot
  ;; by default should be using a new thread for each incoming connection.
  ; (hunchentoot:log-message* :warning "acceptor-dispatch-request: ~A" request)
  ;;
  ;; This operates by first looking in the path of the request for
  ;; "/NAME/".  If not found, but if the script name is absolute
  ;; (begins with "/"), it calls the "root-content" method.
  ;; Otherwise, it looks for a provider named "NAME", and a callback
  ;; in that provider named "/WHATEVER-COMES-AFTER-NAME".  If found,
  ;; it's called.  Otherwise, it just punts the default
  ;; acceptor-dispatch-request.

  (let ((path (hunchentoot:script-name* request))
        (parameters (hunchentoot:get-parameters* request)))
    (let* ((namedlevel (and (equal (char path 0) #\/)
                            (search "/" path :start2 1)))
           (provider (and namedlevel (gethash (subseq path 1 namedlevel) (uiserver-providers self))))
           (callback (and provider (gethash (subseq path namedlevel) (callback-provider-callbacks provider)))))
      (cond ((and (not namedlevel) (equal (char path 0) #\/))
             ;; some kind of toplevel thing
             (multiple-value-bind (ctype content)
                 (root-content self path parameters)
               (setf (hunchentoot:content-type*) ctype)
               content))
            ((not (null callback))
             ;; callback found, so invoke it
             (funcall callback request parameters))
            (t
             ;; invoke call-next-method to get the static file handlers
             (call-next-method))))))

(defmethod run ((self uiserver) &key (continue nil))
  "Start the server.  If :continue is t, return immediately.
Otherwise, block in an endless loop handling requests."
  (declare (ignore continue))
  ;; start the web service
  (hunchentoot:start self))

(defmethod run :after ((self uiserver) &key (continue nil))
  ;; should we enter blocking mode?
  (if (not continue)
      ;; yes -- now just sit around and accept connections
      (hunchentoot:accept-connections self)))

;;;
;;; This is a subclass of uiserver which knows how to serve up the *system-being-analyzed*
;;; It really doesn't use the dispatching capabilities -- everything is done in
;;; "root-content".
;;;

(defclass single-ui-server (uiserver)
  ())

(defmethod initialize-instance :after ((self single-ui-server) &rest initargs &key &allow-other-keys)
  (declare (ignore initargs))
  ;; provide access to our various Javascript and CSS resources
  (setf (hunchentoot:acceptor-document-root self)
        (merge-pathnames "envisioner/v2/ui/" cl-user::*my-meta-path*)))

(defmethod root-content ((self single-ui-server) path parameters)
  (declare (ignore parameters))
  ;(hunchentoot:log-message* :warning "root-content single-ui-server, path is ~A, parameters is ~A~%" path parameters)
  (cond ((string-equal path "/")
         ;; Send back our base page
         (values "text/html"
                 (format nil (*base-page*)
                         (if *system-being-analyzed*
                             (system-name *system-being-analyzed*)
                             ;; else
                             "(No system)"))))

        ((string-equal path "/current")
         ;; send back the JSON description of the system
         (values "text/x-json"
                 (if *system-being-analyzed*
                     (with-output-to-string (the-message)
                       (generate-json the-message
                                      (system-initial-situations *system-being-analyzed*))
                       the-message)
                     ;; else
                     (empty-json))))

        (t
         ;; send back a static file (d3.v3.js, etc.)
         (let ((full-path (merge-pathnames (if (equal "/" path) #p"index.html" (subseq path 1))
                                           (hunchentoot:acceptor-document-root self))))
           (hunchentoot:handle-static-file full-path)))))

;;;
;;; Add a function to start this
;;;

(defun start-server (port)
  (declare (special *acceptor* *servers*))
  (let ((server (make-instance 'single-ui-server
                               :port port
                               :acceptor-document-root (merge-pathnames "envisioner/v2/ui/" cl-user::*my-meta-path*))))
    (setf (gethash port *servers*) server)
    (setf *acceptor* server)
    (run server :continue t)
    server))

(defun stop-server (&optional (port nil))
  (declare (special *acceptor* *servers*))
  (let ((acceptor (or (if port (gethash port *servers*)) *acceptor*)))
    (when acceptor
      (hunchentoot:stop acceptor)
      (if (eq acceptor *acceptor*)
          (setf *acceptor* nil))
      )))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;
;;; Everything below can be junked once the demo is over
;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


(defmacro define-qrm-handler (acceptor uri &body body)
  `(hunchentoot:define-easy-handler (,(gensym) :uri ,uri :acceptor-names (list ,`(hunchentoot:acceptor-name ,acceptor))) ()
     ,@body))

(defun start-gamma (port)

  (declare (special *servers*))

  (let ((gamma-image-driveline2
         (make-instance 'reloading-file :filename "envisioner/v2/ui/images/driveline_2.png" :binary t))
        (gamma-image-roadwheelload
         (make-instance 'reloading-file :filename "envisioner/v2/ui/images/road_wheel_load.png" :binary t))
        (gamma-image-qrm-analysis
         (make-instance 'reloading-file :filename "envisioner/v2/ui/images/qrm-analysis-screenshot.png" :binary t))
	(gamma-tutorial
	 (make-instance 'reloading-file :filename  "envisioner/v2/ui/images/QRM-Tutorial-3.pdf" :binary t))
        (gamma-landing-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/gammalanding.html"))
        (gamma-page-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/gammapage.html"))
        (gamma-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/ui-gamma.js"))
        (d3-v3-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.v3.js"))
        (d3-slider-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.slider.js"))
        (d3-slider-css-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.slider.css"))
        (d3-linegraph-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.linegraph.js"))
        (d3-linegraph2-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.linegraph2.js"))
        (d3-fisheye-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.fisheye.js"))
        (dagre-js-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/dagre.js"))
        (d3-linegraph-css-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.linegraph.css"))
        (d3-linegraph2-css-content
         (make-instance 'reloading-file :filename "envisioner/v2/ui/d3.linegraph2.css")))
    (let ((name (symbol-name (gensym))))
      (let ((acceptor (make-instance 'hunchentoot:easy-acceptor :port port :name name)))
        (setf (gethash port *servers*) acceptor)

        (define-qrm-handler acceptor "/"
          (declare (special *system-being-analyzed*))
          (setf (hunchentoot:content-type*) "text/html")
          (funcall gamma-landing-content))

        (define-qrm-handler acceptor "/gamma-demo"
          (declare (special *system-being-analyzed*))
          (setf (hunchentoot:content-type*) "text/html")
          (format nil (funcall gamma-page-content)
                  (if *system-being-analyzed*
                      (system-name *system-being-analyzed*)
                      ;; else
                      "(No system)")))

        (define-qrm-handler acceptor "/current"
          (declare (special *system-being-analyzed*))
          (setf (hunchentoot:content-type*) "text/x-json")
          (if *system-being-analyzed*
              (with-output-to-string (the-message)
                (generate-json the-message
                               (system-initial-situations *system-being-analyzed*))
                the-message)
              ;; else
              (empty-json)))

        (define-qrm-handler acceptor "/gamma-data"
          (setf (hunchentoot:content-type*) "text/json")
          (get-variables-as-json-for-parameters
           (map 'list #'(lambda (x) (cons (car x) (float (read-from-string (cdr x)))))
                (hunchentoot:get-parameters*))))
      
        (define-qrm-handler acceptor "/ui-gamma.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall gamma-js-content))
      
        (define-qrm-handler acceptor "/images/driveline_2.png"
          (setf (hunchentoot:content-type*) "image/png")
          (funcall gamma-image-driveline2))

        (define-qrm-handler acceptor "/images/road_wheel_load.png"
          (setf (hunchentoot:content-type*) "image/png")
          (funcall gamma-image-roadwheelload))

        (define-qrm-handler acceptor "/images/qrm-analysis-screenshot.png"
          (setf (hunchentoot:content-type*) "image/png")
          (funcall gamma-image-qrm-analysis))

	(define-qrm-handler acceptor "/images/QRM-Tutorial-2.pdf"
	  (setf (hunchentoot:content-type*) "application/pdf")
	  (funcall gamma-tutorial))  

        (define-qrm-handler acceptor "/d3.v3.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall d3-v3-js-content))

        (define-qrm-handler acceptor "/d3.slider.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall d3-slider-js-content))

        (define-qrm-handler acceptor "/d3.slider.css"
          (setf (hunchentoot:content-type*) "text/css")
          (funcall d3-slider-css-content))

        (define-qrm-handler acceptor "/d3.linegraph.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall d3-linegraph-js-content))

        (define-qrm-handler acceptor "/d3.linegraph.css"
          (setf (hunchentoot:content-type*) "text/css")
          (funcall d3-linegraph-css-content))

        (define-qrm-handler acceptor "/d3.linegraph2.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall d3-linegraph2-js-content))

        (define-qrm-handler acceptor "/d3.linegraph2.css"
          (setf (hunchentoot:content-type*) "text/css")
          (funcall d3-linegraph2-css-content))

        (define-qrm-handler acceptor "/d3.fisheye.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall d3-fisheye-js-content))

        (define-qrm-handler acceptor "/dagre.js"
          (setf (hunchentoot:content-type*) "text/javascript")
          (funcall dagre-js-content))

        ;; finally, start the server
        (hunchentoot:start acceptor)
        ))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-

;;; [05/11/2014 Johan] a set of functions to track speed up improvements.
;;; Most of this is taken from GDE/ATMS

(in-package :env2)

(defun time-taken (start-time)
   (/ (float (- (get-internal-run-time) start-time)) internal-time-units-per-second))

(defun real-time-taken (start-time)
   (/ (float (- (get-internal-real-time) start-time)) internal-time-units-per-second))

(defun date-string ()
  (multiple-value-bind (second minute hour date month year)
      (get-decoded-time)
    (format nil "~4d-~2,'0d-~2,'0d-~2,'0d-~2,'0d-~2,'0d"
	    year month date hour minute second)))

#+allegro
(defun log-run (benchmark-name results)
  (let* ((file-name (concatenate 'string cl-user::*my-meta-path* "envisioner/logging/" cl-user::*this-machine* "/" (s-exp-to-nice-string benchmark-name) ".xls"))
	 (existsp (probe-file file-name)))
    (ensure-directories-exist file-name)
    (with-open-file (stream file-name :direction :output :if-exists :append :if-does-not-exist :create :if-error nil)
      (unless existsp
	(format stream "QRM major version, minor version, date, cpu time (non-gc) user, system, cputime (gc) user, system, cpu time total user, system, real time, space: cons cells, other-bytes, static bytes, total situations, notes"))
      (cond ((null stream) (error "Not possible"))
	    (t (format stream "~% ~a, ~a, ~a" *envisioner-major-version* *envisioner-minor-version* (date-string))
	       (destructuring-bind (tgcu tgcs tu ts tr scons sother static) results
		 (format stream ", ~a, ~a, ~a, ~a, ~a, ~a, ~a, ~a, ~a, ~a, ~a"
			 (- tu tgcu)
			 (- ts tgcs)
			 tgcu 
			 tgcs
			 tu ts
			 tr
			 (- scons excl::time-cons-base)
			 (- sother excl::time-other-base)
			 static
			 (length (total-situations))
			 )))))))

;;; This will be part of filename, so make it acceptable by getting rid of spaces and replacing them with underscores.
(defun s-exp-to-nice-string (exp)
  (remove-if #'(lambda (ch) (member ch '(#\Space #\( #\)))) (format nil "~a" exp)))

(defun depths (&optional (n 2))
  (do ((i n (1+ i)))
      (nil)
    (format t "~% run-depth ~a" i)
    (let* ((form `(env2::run-depth ,i))
	   (results (time-my-funcall #'time-report #'(lambda () 
						       (run-depth i)))))
      (log-run form results))))

(defmacro perform-benchmark (form)
  `(let ((results (time-my-funcall #'time-report #'(lambda () ,form))))
     (log-run ',form results)
     results))

;;; Don't know if this will work in ccl.
#+allegro
(defun time-my-funcall (report-function timed-function
		       &rest timed-function-args)
  (declare (optimize (speed 3)))
  (let ((.oldrealtime (get-internal-real-time))
	(.oldspace (make-array 4 :element-type
			       #-64bit '(unsigned-byte 32)
			       #+64bit '(unsigned-byte 64)))
	(.newspace (make-array 4 :element-type
			       #-64bit '(unsigned-byte 32)
			       #+64bit '(unsigned-byte 64))))
    (declare (type (simple-array #-64bit (unsigned-byte 32)
				 #+64bit (unsigned-byte 64) (*))
		   .oldspace .newspace))
    (multiple-value-bind (.olduser .oldsystem .oldgcu .oldgcs)
	(excl::get-internal-run-times)
      (sys::gsgc-totalloc .oldspace t)
      (multiple-value-prog1 (apply timed-function timed-function-args)
	(sys::gsgc-totalloc .newspace t)
	(let ((.newrealtime (get-internal-real-time)))
	  (multiple-value-bind (.newuser .newsystem .newgcu .newgcs)
	      (excl::get-internal-run-times)
	    (let ((results (list 
			    (- .newgcu .oldgcu)
			    (- .newgcs .oldgcs)
			    (- .newuser .olduser)
			    (- .newsystem .oldsystem)
			    (- .newrealtime .oldrealtime)
			    (- (aref .newspace 0) (aref .oldspace 0))
			    (- (aref .newspace 2) (aref .oldspace 2))
			    (- (aref .newspace 3) (aref .oldspace 3)))))
	      (apply report-function results)
	      (return-from time-my-funcall results)
	      )))))))

#+allegro
(defun time-report (tgcu tgcs tu ts tr scons sother static)
  (let ((s *trace-output*))
    (format s "~&; cpu time (non-gc) ~a user, ~a system~%"
	    (print-msec (- tu tgcu))
	    (print-msec (- ts tgcs)))
    (format s "; cpu time (gc)     ~a user, ~a system~%"
	    (print-msec tgcu)
	    (print-msec tgcs))
    (format s "; cpu time (total)  ~a user, ~a system~%"
	    (print-msec tu)
	    (print-msec ts))
    (format s "; real time  ~a~%" (print-msec tr))
    (format s
	    "; space allocation:~%;  ~:d cons cell~:p, ~:d other byte~:p, ~:d static byte~:p"
	    (- scons excl::time-cons-base)
	    (- sother excl::time-other-base)
	    static)))

(defun print-msec (raw)
  (declare (optimize speed))
  (let ((msec 0) (sec 0) (min 0) (hrs 0))
    (declare (fixnum msec sec min hrs))
    (when (>= raw 1000)
      (multiple-value-setq (sec msec)
	(floor raw 1000))
      (when (>= sec 60)
	(multiple-value-setq (min sec)
	  (floor sec 60))
	(when (>= min 60)
	  (multiple-value-setq (hrs min)
	    (floor min 60))
	  (when (>= hrs 100)
	    (return-from print-msec
	      (format nil "~:d msec (~,3f days)"
		      raw (float (/ raw (* 1000 60 60 24)))))))))
    (format nil "~:d msec~:[~; (~2,'0d:~2,'0d:~2,'0d~:[~;.~3,'0d~])~]"
	    raw (> min 0) hrs min sec (> msec 0) msec)
    ))

;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-

;;; [05/24/2014 Johan] Dumping and reading of envisionments.

(in-package :env2)

(defvar *dump-format-version* 2)

(defvar cl-user::*this-machine* (asdf:hostname))

;;; Possible improvements.
;;;  also store out non-envisionment situations?
;;;  lots of compression possibiltiies if envisionments get too big.
;;;  lots of efficiency improvements if comparing envisionments get too slow.

;;; Look to compare the current envisionment.  Only really does subset!****** fix.
(defun compare-envisionment ()
  (let ((file-name (find-next-version (concatenate 'string 
					cl-user::*my-meta-path* "envisioner/envisionments/"
					cl-user::*this-machine*
					"/"
					(string (system-name *system-being-analyzed*))
					".lisp.")
				      nil))
	(situations (make-hash-table :test #'eq))
	(cl-user::*package* (find-package :env2))
	(initial-situations)
	(dumped nil))
    (format t "~% Comparing to ~a" file-name)

    (with-open-file (stream file-name)
      ;; Read the meta-data. For now ignore most.
      (do ((pair (read stream) (cddr pair)))
	  ((null pair))
	(case (car pair)
	  (initial (setq initial-situations (cadr pair)))
	  (max-situation 
	   (setq dumped (make-array (1+ (cadr pair)) 
				    :element-type '(unsigned-byte 1) 
				    :initial-element 0)))))
      ;; Now read all the situations.
      (let ((form))
	(do ()
	    ((null (setq form (read stream nil nil))))
	  (setf (gethash (car form) situations) (cdr form)))))
    (unless (equal initial-situations (mapcar #'situation-id (system-initial-situations *system-being-analyzed*)))
      (format t "~% Old initial situations: ~a" initial-situations)
      (format t "~% New initial situations: ~a" (mapcar #'situation-id (system-initial-situations *system-being-analyzed*)))
      (error "Initial situation mismatch"))
    (compare-situations (system-initial-situations *system-being-analyzed*) situations dumped)))

;;; This compares the current envsionment to make sure all of the old one exists.
;;; Doesn't compare the old to the new for now.*********************
(defun compare-situations (new old dumped)
  (dolist (situation new)
    (when (= 0 (aref dumped (situation-id situation)))
      (let ((children (situation-children situation)))
	(setf (aref dumped (situation-id situation)) 1)
	(unless (equal (mapcar #'situation-id children)
		       (old-children situation old))
	  (error "mismatch"))
	(compare-situations children old dumped)))))

(defun old-children (new-situation old)
  (do ((pair (gethash (situation-id new-situation) old) (cddr pair)))
      ((null pair))
    (if (eq (car pair) :c)
	(return (second pair)))))



;;; Dumps the current envisionment to the svn.  It always creates new versions, never overwrites.
(defun dump-envisionment ()
  (let ((file-name (find-next-version (concatenate 'string 
					cl-user::*my-meta-path* "envisioner/envisionments/"
					cl-user::*this-machine*
					"/"
					(string (system-name *system-being-analyzed*))
					".lisp.")
				      t))
	(situations (make-array (1+ (system-env-count *system-being-analyzed*)) 
				:element-type '(unsigned-byte 1) 
				:initial-element 0)))
    (ensure-directories-exist file-name)

    (format t "~% Dumping to ~a" file-name)

    (with-open-file (stream file-name :direction :output :if-exists :new-version :if-does-not-exist :create)
      (format stream ";;; (<situation> :t (type = instant or interval) :v (unused) :c (children))")
      (format stream "~%(version ~a" *dump-format-version*)
      (format stream " situations ~a" (length (total-situations)))
      (format stream " name ~s" (string (system-name *system-being-analyzed*)))
      (format stream " machine ~a" cl-user::*this-machine*)
      (format stream " date ~a" (date-string))
      (format stream " qrmversion ~d.~d" *envisioner-major-version* *envisioner-minor-version*)
      (format stream " initial ~a" (mapcar #'situation-id (system-initial-situations *system-being-analyzed*)))
      (format stream " max-situation ~a" (system-env-count *system-being-analyzed*))
      (format stream " use-global ~a" env2::*use-global*)
      (format stream " depth-bound ~a" (system-depth-bound *system-being-analyzed*))
      (format stream ")")
      (dump-situations stream (system-initial-situations *system-being-analyzed*) situations))))

(defun dump-situations (stream situations dumped)
  (dolist (situation situations)
    (when (= 0 (aref dumped (situation-id situation)))
      (let ((children (situation-children situation)))
	(format stream "~%(s ~d :t ~a :v ~a :c ~a)"
		(situation-id situation)
		(situation-type situation)
		nil
		(mapcar #'situation-id children))
	(setf (aref dumped (situation-id situation)) 1)
	(dump-situations stream children dumped)))))

(defun load-situations (file-name)
  (with-open-file (stream file-name)
    (let ((first-line (read stream)))
      (print first-line))))
      

;;; From GDE.

(defun find-next-version (dirname new &aux max-version version)
  (dolist (file (directory (concatenate 'string dirname "*")))
    (setq version (safe-parse-integer (pathname-type file)))
    (if version (setq max-version (if max-version (max version max-version) version))))
  (cond ((null max-version)
	 (if new (setq max-version 1) (error "does not exist")))
	(new (incf max-version)))
  (concatenate 'string dirname (format nil "~d" max-version)))

(defun safe-parse-integer (ext)
  (and (typep ext 'string)
       (handler-case (parse-integer ext)
         (parse-error ()))))
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;;
;;;; USAGERIGHTS meta-x
;;;;

(in-package :env2)

;;; [04/17/2014 Johan] This assigns positions for each variable that is not eliminated.
;;; *** next step is to put true constants elsewhere.
(defun compactor ()
  (let ((unknown-fixed-vars))
    (when (system-compacted-p *system-being-analyzed*)
      (unless (= (system-compacted-p *system-being-analyzed*)
		 (system-max-position *system-being-analyzed*))
	(error "Someting changed")))
    (unless (system-compacted-p *system-being-analyzed*)
      (dolist (var (system-active-variables *system-being-analyzed*))
	(cond ((var-eliminated var) (error "Cannot happen"))
	      ((eq (var-type var) :fixed-parameter)
	       (ensure-global-queued var))
	      ((and *use-global* (var-fixed? var))
	       (set-global-value var)
	       (cond ((var-global-cell var)  (ensure-global-queued var))
		     (t (push var unknown-fixed-vars)))
	       )

	      (t ;(setf (var-position var) (incf (system-max-position *system-being-analyzed*)))
		 )))
      (setf (system-compacted-p *system-being-analyzed*) (system-max-position *system-being-analyzed*))

;      (run-constraints (system-global-situation *system-being-analyzed*))

      (run-constraints 'global)

      (dolist (var unknown-fixed-vars)
	(unless (var-global-cell var)
	  (error "Fixed value with no value")))
      ;; Assign positions after all globals are determined.
      (dolist (var (system-active-variables *system-being-analyzed*))
	(cond ((var-eliminated var))
	      ((eq (var-type var) :fixed-parameter))
	      ((and *use-global* (var-fixed? var)))
	      (t (setf (var-position var) (incf (system-max-position *system-being-analyzed*)))
		 )))
;      (find-global-uses)

      (if *use-global* (global-removal))

      (setf (system-compacted-p *system-being-analyzed*) (system-max-position *system-being-analyzed*))

      )


      ))
	  
;;; This ensures any global values have been queued.  
(defun ensure-global-queued (var) nil)


;;; [05/12/2014 Johan] Job is to find the global value for every one.  Otherwise why would it be global?
;;;******* put in exact number is also an option for the future.
(defun set-global-value (var)
;  (format t "~% set-global-value")
  (if (var-position var) (error "Cannot be local and global"))

  (unless (var-global-cell var)
    (let ((ic (assoc var (system-initial-conditions *system-being-analyzed*)))
	  (equiv-global))
      (cond ((and (var-equivalent-class var) (null ic))
	     (let ((eclass (var-equivalent-class var))
		   (polarity t))
	       (or (dolist (var (equivalent-class-positives eclass))
		     (setq ic (assoc var (system-initial-conditions *system-being-analyzed*)))
		     (when ic (return t))
		     (when (setq equiv-global (var-global-cell var))
		       (return t))
		     )
		   (dolist (var (equivalent-class-negatives eclass))
		     (setq ic (assoc var (system-initial-conditions *system-being-analyzed*)))
		     (when ic (setq polarity nil) (return t))
		     (when (setq equiv-global (var-global-cell var))
		       (setq polarity nil)
		       (return t))
		     ))
	       (cond (equiv-global 
		      (let ((values (cell-values equiv-global)))
			;; This presumes one qualitative.
			(cond ((null values) (error "No fixed value is accessible?"))
			      ((cdr values) (error "Stub - more than one value stub"))
			      (polarity (clobber-global var (datum-quantity (car (cell-values equiv-global)))))
			      (t (error "Need to invert --- does this ever happen stub")))))
		     ((null ic))
		     (t (let ((new-value (third ic)))
			  (cond ((numberp (third ic))
				 (cond (polarity 
					(let ((qvalue (create-q-quantity-from-number (car ic) (third ic))))
					  (clobber-global var 
							  qvalue
							  :qualitative)))
				       (t (error "stub"))))
				(t (error "stub"))))))))
	    ((numberp (third ic))
	     (let ((qvalue (create-q-quantity-from-number (car ic) (third ic))))
	       (clobber-global (car ic) 
			       qvalue
			       :qualitative)))

	    ((null ic)
	     ;; Do nothing.
					;	     (error "No initial condition for ~a" var)
	     )

	    ((symbolp (third ic))
	     (clobber-global (car ic) (third ic)))
	    ((q-quantity-p (third ic))
	     (clobber-global (car ic) (third ic)))
	    ;; This is messy.  Maybe the eliminator should update this when it has it.
	    ;; Find an equivalent which has an ic.

	    (t (print ic)
	       (error "stub"))))))

;; Debugging:
(defun find-global-uses ()
  (let ((uses))
    (dolist (var (system-active-variables *system-being-analyzed*))
      (when (and (var-global-cell var) (var-uses var))
	(push var uses)
	(format t "~% Global ~a has ~d uses" var (length (var-uses var)))))
    uses))
    
;;; Do zeros first.
(defun global-removal ()
  (dolist (var (system-active-variables *system-being-analyzed*))
    (when (and (var-global-cell var)
	       (var-uses var))
      (let ((global-value (qualitative-value var 'global)))
	(when (and (eq (q-quantity-value global-value) 'Q0)
		   (eq (q-quantity-deriv global-value) 'Std))
	  (dolist (constraint (var-uses var))
	    (unless (or (constraint-eliminated constraint) (constraint-condition constraint))
	      (case (type-of constraint)
		(general-summer-constraint (substitute-out-general-summer var constraint)
					   )
		(multiply-constraint (substitute-out-multiply var constraint)
		 )
		(qequal-constraint (substitute-out-qequal var constraint))
		(interpolation (substitute-out-interpolation var constraint))
		(qset-constraint (substitute-out-qset var constraint))
		(deriv-constraint (substitute-out-deriv var constraint))
		(power-constraint (substitute-out-power var constraint)) 
		(gt-constraint)
		(t (error "Unknown constraint type: ~a" constraint))))))))))

;;; Check all are global?***

;;; Only zeros right now.
(defun substitute-out-qequal (var constraint)
  (and (var-global-cell (qequal-constraint-var1 constraint))
       (var-global-cell (qequal-constraint-var2 constraint))
       (remove-constraint constraint)))

;;; var is a global.
;;; Presumes 0 right now.
(defun substitute-out-general-summer (var constraint)
  ;; Only do 0's for now.
  (let ((global-value (qualitative-value var 'global)))
    (when (and (eq (q-quantity-value global-value) 'Q0)
	       (eq (q-quantity-deriv global-value) 'Std))
;      (format t "~% Taking 0 out of ~a" constraint)
      (cond ((member var (general-summer-constraint-pos-vars constraint))
	     (setf (general-summer-constraint-pos-vars constraint) (remove var (general-summer-constraint-pos-vars constraint))))
	    (t (setf (general-summer-constraint-neg-vars constraint) (remove var (general-summer-constraint-neg-vars constraint)))))
      (format t "~% New length ~d" (+ (length (general-summer-constraint-neg-vars constraint))(length (general-summer-constraint-pos-vars constraint))))
      (dolist (var (general-summer-constraint-neg-vars constraint))
	(unless (var-global-cell var) (return-from substitute-out-general-summer nil)))
      (dolist (var (general-summer-constraint-pos-vars constraint))
	(unless (var-global-cell var) (return-from substitute-out-general-summer nil)))
      ;; Summer is irrelevant.
      (remove-constraint constraint)

      )))

;;; This is only replacing zeros right now.
(defun substitute-out-multiply (var constraint)
  (cond ((and (dolist (var (multiply-constraint-multiplicands constraint) t) (unless (var-global-cell var) (return nil)))
	      (var-global-cell (multiply-constraint-result constraint)))
	 (format t "~% Removing ~a" constraint)
	 (remove-constraint constraint))
	((member var (multiply-constraint-multiplicands constraint))
	 (print 'stub-cand))
	((eq var (multiply-constraint-result constraint))
	 (print (list 'stub-result-often-multipliedeletd)))
	(t (error "bound elsewhere, condition maybe?"))))

;;; Only replacing zeros right now.
(defun substitute-out-deriv (var constraint)
  (cond ((eq var (deriv-constraint-var constraint))
	 (clobber-global (deriv-constraint-deriv constraint)
			 (qualitative-value var 'global))
	 (remove-constraint constraint))
	((eq var (deriv-constraint-deriv constraint))
	 (clobber-global (deriv-constraint-var constraint)
			 (qualitative-value var 'global))
	 (remove-constraint constraint))))

  

      ;;;*** remove from neg-var/pos-vars also.
  ; (cond ((member var (general-summer-constraint-pos-vars constraint))
  ; 	 (push (invert-q-quantity (qualitative-value var 'global)) (general-summer-constraint-results constraint)))
  ; 	(t (push (qualitative-value var 'global)  (general-summer-constraint-results constraint))))
  ; (setf (general-summer-constraint-pos-vars constraint) (remove var (general-summer-constraint-pos-vars constraint)))
  ; (setf (var-uses var) (remove constraint (var-uses var))))
  




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;; -*- mode: lisp; syntax: Common-Lisp; package: env -*-

;;; Copyright (c) 2012, Palo Alto Research Center Incorporated.
;;; Developed with the sponsorship of the Defense Advanced Research Projects Agency (DARPA).

;;; Permission is hereby granted, free of charge, to any person obtaining a
;;; copy of this data, including any software or models in source or binary
;;; form, as well as any drawings, specifications, and documentation
;;; (collectively "the Data"), to deal in the Data without restriction,
;;; including without limitation the rights to use, copy, modify, merge,
;;; publish, distribute, sublicense, and/or sell copies of the Data, and
;;; to permit persons to whom the Data is furnished to do so, subject to
;;; the following conditions:
;;;
;;; The above copyright notice and this permission notice shall be included
;;; in all copies or substantial portions of the Data.
;;;
;;; THE DATA IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
;;; IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
;;; FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
;;; THE AUTHORS, SPONSORS, DEVELOPERS, CONTRIBUTORS, OR COPYRIGHT HOLDERS
;;; BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
;;; ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
;;; CONNECTION WITH THE DATA OR THE USE OR OTHER DEALINGS IN THE DATA.

(in-package :env2)

;; ideal voltage source

(defprototype triangle-wave-source
    :superclasses (electrical-one-port)
    :fixed-parameters ((v-min)
		       (v-max)
		       (slew-neg)   ; slew rates in volts/sec,
		       (slew-pos))  ;  e.g.: -2, 3
    :variables ((v (voltage t1 t2) :landmarks (v-min Q0 OnVoltage v-max))
);		(slew (deriv (voltage t1 t2) 1 t) :landmarks (slew-neg Q0 slew-pos)))
    :equations ((= slew-neg Q-)
		(= slew-pos Q+))
    :mode (decreasing :entry ((= v v-max))
		      :equations ((= (deriv v 1 t) slew-neg)))
    :mode (increasing :entry ((= v v-min))
		      :equations ((= (deriv v 1 t) slew-pos)))
)

(defprototype triangle-wave-source-test
    :internal-nodes ((SRC//R :electrical)
		     (R//LED :electrical)
		     (ground :electrical))  ;LED//SRC
    :components ((SRC (triangle-wave-source SRC//R ground))
		 (R (ideal-resistor SRC//R R//LED))
		 (LED (ideal-diode R//LED ground)))
    :initial ((= (>> v SRC) v-min)
	      (== (mode LED) off)
	      (== (mode SRC) increasing))
)

(defun analyze-triangle-wave-source-test (&key (display? nil) (debug? nil))
  (analyze 'ckt 'triangle-wave-source-test nil
	   :visualization '((>> i R ckt)
			    (>> v SRC ckt))
	   :display? display? :debug? debug?))
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: electrical.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: January 30, 2012 10:51:51
;;;;   Purpose: models of components and simple systems for electronic circuits
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Friday, October 26, 2012 at 18:18:03 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;; [02/24/2012 klenk] There are no difference between these in QML
(defconnector signal-connector
    :variables ((sig Signal)))

(defconnector pin
    :variables ((v voltage)
		(i current :flow)))

(defprototype one-port
    :components ((p (pin))
		 (n (pin)))
    :variables ((v voltage)
		(i current))
    :equations ((= v (- (>> v p)(>> v n)))
		(= 0 (+ (>> i p)(>> i n)))
		(= i (>> i p))
		))


(defprototype ideal-resistor 
    :extends (one-port)
    :parameters ((R :value Q+))
    :equations ((= v (* i R))))

;; [01/30/2012 klenk] All landmarks are parameters which can be set during instantiation, 
;; [01/30/2012 klenk] but they need to maintain the same ordering.
(defprototype ideal-battery
    :extends (one-port)
    :variables ((v voltage :landmarks (Q VBat)))
    :equations ((= v VBat)))

(defprototype current-source
    :extends (one-port)
    :variables ((i current :landmarks (IOut Q)))
    :equations ((= i IOut)))

;; [02/02/2012 klenk] This differs from the modelica model by requiring that the current equals 0
(defprototype ground
    :components ((p (pin)))
    :equations ((q= (>> v p) Q0)
		(q= (>> i p) Q0)))


(defprototype ideal-capacitor
    :extends (one-port)
    :parameters ((C :value Q+))
    :equations
    ((= i (* C (deriv v 1 t)))))

(defprototype ideal-inductor
    :extends (one-port)
    :fixed-parameters ((L :value Q+))
    :equations
    ((= v (* L (deriv i 1 t)))))


(defprototype electrical-two-port
    :components ((p1 (pin))
		 (n1 (pin))
		 (p2 (pin))
		 (n2 (pin)))
    :variables ((v1 voltage)
		(i1 current)
		(v2 voltage)
		(i2 current))
    :equations
    ((= v1 (- (>> v p1)(>> v n1)))
     (= v2 (- (>> v p2)(>> v n2)))
     (= 0 (+ (>> i p1)(>> i p1)))
     (= 0 (+ (>> i p2)(>> i n2)))
     (= i1 (>> i p1))
     (= i2 (>> i p2))
     ))

;;; Turns = 1
(defprototype ideal-transformer 
    :extends (electrical-two-port)
    :equations
    ((q= v1 v2)
     (q= i1 (- i2))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Systems

(defprototype br-system
    :components ((b (ideal-battery))
		 (r (ideal-resistor))
		 (g (ground)))
    :equations ((connect (>> p b)(>> p r))
		(connect (>> n b)(>> p g))
		(connect (>> n r)(>> p g))))

;; [03/13/2012 klenk] Translater had problems with resistor1
;; [03/13/2012 klenk] (e1) simulates the XML of this version
(defprototype simple2 :components
              ((resistor2 (ideal-resistor))
               (constantvoltage1 (ideal-battery)) (ground1 (ground))
               (resistor1 (ideal-resistor)))
              :equations
              ((connect (>> p constantvoltage1) (>> p resistor1))
               (connect (>> n resistor1) (>> p resistor2))
               (connect (>> n resistor2) (>> n constantvoltage1))
               (connect (>> p ground1) (>> n constantvoltage1))))

(defun envision-br-system (&key (display? nil) (debug? nil)(eliminate?))
  (analyze 'system
	   'br-system
	   nil 
	   :display? display? :debug? debug?
	   :eliminate? eliminate?))


;; [02/29/2012 klenk] This system is design to run the system

(defprototype resistor-unknown-R
    :extends (one-port)
    :parameters ((R))
    :equations ((= v (* i R))))    

(defprototype br-system-2
    :components ((b (ideal-battery))
		 (r (resistor-unknown-R))
		 (g (ground)))
    :equations ((connect (>> p b)(>> p r))
		(connect (>> n b)(>> p g))
		(connect (>> n r)(>> p g)))
    )

(defun envision-br-system-2 (&key (display? nil) (debug? nil)(eliminate?))
  (analyze 'system
	   'br-system-2
	   '((= (>> R r) 1))
	   :display? display? :debug? debug?
	   :eliminate? eliminate?))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defprototype lc-oscillator
    :components ((L (ideal-inductor))
		 (C (ideal-capacitor))
		 (G (ground)))
    :equations ((connect (>> p L)(>> p C))
		(connect (>> n L)(>> n C))
		(connect (>> n L)(>> p G)))
    :initial ((q= (>> i L) Q0)
	      (q= (>> v C) Q+)))


(defun envision-lc-oscillator (&key (display? nil)(debug? nil)(eliminate? t))
  (analyze 'o
	   'lc-oscillator
	   nil
	   :visualization '((>> i L o) (>> v C o))
	   :display? display? :debug? debug?
	   :eliminate? eliminate?
	   :max-depth 10))


(defprototype lcr-oscillator
    :components ((L (ideal-inductor ))
		 (C (ideal-capacitor))
		 (R (ideal-resistor ))
		 (G (ground)))
    :equations ((connect (>> p L)(>> p C))
		(connect (>> p L)(>> p R))
		(connect (>> n L)(>> n C))
		(connect (>> n L)(>> n R))
		(connect (>> n L)(>> p G)))
    :initial ((q= (>> i L) Q+)
	      (q= (>> v C) Q+)))

(defun envision-rlc-parallel (&key (display? nil) (debug? nil))
  (analyze 'o
	   'lcr-oscillator
	   nil
	   :visualization
           '((>> i L o)
             (deriv (>> i L o) 1)
             (>> v C o)
             (deriv (>> v C o) 1))
	   :display? display? :debug? debug? ))

(defprototype series-rlc
    :components ((L (ideal-inductor ))
		 (C (ideal-capacitor))
		 (R (ideal-resistor ))
		 (G (ground)))
    :equations ((connect (>> n L)(>> p R))
		(connect (>> n C)(>> n R))
		(connect (>> n C)(>> p G))
		(connect (>> p C)(>> p L)))
    :initial ((q= (>> i R) Q-)
	       (q= (>> v L) Q+)
	       (q= (>> v C) Q-)))

(defun envision-rlc-series (&key (display? nil) (debug? nil))
  (analyze 'o
	   'series-rlc
	   nil
	   :visualization '((>> i L) (>> v C))
	   :display? display? :debug? debug? ))



(defprototype Adby346 
;  :external-parameters
;; [12/20/2011 klenk] Not sure how to do the VBat setting
;  (;(= (>> VBat E) 1.5)
   ;(= (>> R R1) 1000)
   ;(= (>> C C1) 1.0e-6) (= (>> C C2) 1.0e-6)
   ;(= (>> L L) 1.0e-6) (= (>> R R2) 1000)
;   )
  :components
  ((R2 (ideal-resistor))
   (L (ideal-inductor  ))
   (C2 (ideal-capacitor  ))
   (C1 (ideal-capacitor  ))
   (R1 (ideal-resistor  ))
   (E (ideal-battery  ))
   (G (ground)))
  :equations ((connect (>> p R2) (>> n L))
	      (connect (>> n R2) (>> n E))
	      (connect (>> p L) (>> p C2))
	      (connect (>> p C1) (>> p C2))
	      (connect (>> n C2) (>> n E))
	      (connect (>> n C1) (>> p R1))
	      (connect (>> p E) (>> n R1))
	      (connect (>> p G) (>> n E)))
  :initial
  ((= (>> v C1) Q0)
   (= (>> v C2) Q0)
   (= (>> i L) Q0)
   ))

(defun envision-Adby346 (&key (display? nil) 
			 (debug? nil)
			 (state-vars '((>> i R1)(>> v C1)(>> i L)(>> i R2)(>> v C2)))
			 (max-depth 32)
			 (eliminate? t))
  (analyze 'o
	   'Adby346
	   nil
	   :visualization state-vars
	   :display? display? :debug? debug?
	   :max-depth max-depth
	   :eliminate? eliminate?))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Diode


(defprototype ideal-diode
    :extends (one-port)
    :variables ((v voltage :landmarks (Q OnVoltage)))
    :mode (off :entry ((= i Q0)) 
	       :initial ()
	       :equations ((= i Q0)))
    :mode (on :entry ((= v OnVoltage)) 
	      :initial ()
	      :equations ((= v OnVoltage))))

(defprototype diode-test
    :components ((D (ideal-diode))
		 (C (ideal-capacitor ))
		 (R1 (ideal-resistor))
		 (R2 (ideal-resistor))
		 (B (ideal-battery))
		 (G (ground)))
    :initial ((q= (>> v D) Q0)
	      (== (mode D) off))
    :equations ((connect (>> p B)(>> p R1))
		(connect (>> n R1)(>> p C))
		(connect (>> n R1)(>> p R2))
		(connect (>> p D)(>> n R2))
		(connect (>> n D)(>> p G))
		(connect (>> n C)(>> p G))
		(connect (>> n B)(>> p G))))
		


(defun expt-diode (&key (display? nil) (debug? nil)(eliminate? t))
  (analyze 'd 'diode-test nil
	   :visualization '((mode D d)
			    (>> i C d)
			    )
	   :display? display? :debug? debug? :eliminate? eliminate?))


(defprototype ideal-diode-2
    :extends (one-port)
    :variables ((v voltage :landmarks (Q OnVoltage)))
    :mode (off :entry ((= i Q0)) 
	       :initial ()
	       :equations ((= i Q0)))
    :mode (on :entry ((> v OnVoltage)) 
	      :initial ()
	      :equations ((= v OnVoltage))))


(defprototype diode-test-2
    :components ((D (ideal-diode-2))
		 (C (ideal-capacitor ))
		 (R1 (ideal-resistor))
		 (R2 (ideal-resistor))
		 (B (ideal-battery))
		 (G (ground)))
    :initial ((q= (>> v D) Q0)
	      (== (mode D) off))
    :equations ((connect (>> p B)(>> p R1))
		(connect (>> n R1)(>> p C))
		(connect (>> n R1)(>> p R2))
		(connect (>> p D)(>> n R2))
		(connect (>> n D)(>> p G))
		(connect (>> n C)(>> p G))
		(connect (>> n B)(>> p G))))

;; [01/17/2012 klenk] This diode triggers with >
(defun expt-diode-2 (&key (display? nil) (debug? nil))
  (analyze 'd 'diode-test-2 nil
	   :visualization '((mode D d)
			    (>> i C d)
			    )
	   :display? display? :debug? debug?))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; RC ladder tests

(defprototype rc_test :components
              ((ground1 (ground)) (capacitor2 (ideal-capacitor))
               (capacitor1 (ideal-capacitor))
               (resistor1 (ideal-resistor))
               (constantvoltage1 (ideal-battery))
               (resistor2 (ideal-resistor)))
	   ;   :variables ((vR_dot real))
              :equations
              (;(= (deriv (>> v resistor1)) vR_dot)
	       ;(= vR_dot (- (>> i capacitor1)))
;; [10/26/2012 klenk] Three KVL equations with source's second deriv std
	       (= (deriv (>> v resistor1)) (- (deriv (>> v capacitor1))))
	       (= (deriv (>> v capacitor1))
		  (+ (deriv (>> v capacitor2)) (deriv (>> v resistor2))))
	       (= Q0 
		  (+  (deriv (>> v capacitor2)) (deriv (>> v resistor2))(deriv (>> v resistor1)) ))
;; [10/26/2012 klenk] KCL Node -> Have to introduce a new variable, the deriv of current...
	       (= (deriv (>> v resistor1))
		  (+  (deriv (>> i capacitor1))
		      (deriv (>> v resistor2))
		      ))
	       (connect (>> p constantvoltage1) (>> p resistor1))
               (connect (>> n resistor1) (>> p resistor2))
               (connect (>> n resistor1) (>> p capacitor1))
               (connect (>> n resistor2) (>> p capacitor2))
               (connect (>> n capacitor2) (>> n capacitor1))
               (connect (>> n capacitor1) (>> n constantvoltage1))
               (connect (>> n capacitor1) (>> p ground1))
	       )

	      )
(defun envision-rc-ladder-2 (&key (display? nil) (debug? nil))
  (analyze 'o 'rc_test
	   '((q= (>> v capacitor1) Q0)
	     (q= (>> v capacitor2) Q0))
	   :visualization '((>> i capacitor1 o)
			    (>> i capacitor2 o))
	   :display? display? :debug? debug?))

(defprototype rc_test-3 :components
              ((capacitor3 (ideal-capacitor))
               (resistor3 (ideal-resistor))
               (capacitor1 (ideal-capacitor))
               (capacitor2 (ideal-capacitor))
               (constantvoltage1 (ideal-battery)) (ground1 (ground))
               (resistor1 (ideal-resistor))
               (resistor2 (ideal-resistor)))
              :equations
              ((connect (>> n resistor2) (>> p capacitor2))
               (connect (>> p constantvoltage1) (>> p resistor1))
               (connect (>> n resistor1) (>> p resistor2))
               (connect (>> n capacitor2) (>> n capacitor1))
               (connect (>> n capacitor1) (>> n constantvoltage1))
               (connect (>> n capacitor1) (>> p ground1))
               (connect (>> n resistor1) (>> p capacitor1))
               (connect (>> n resistor2) (>> p resistor3))
               (connect (>> n resistor3) (>> p capacitor3))
               (connect (>> n capacitor3) (>> n capacitor2))))

(defun envision-rc-ladder-3 (&key (display? nil) (debug? nil))
  (analyze 'o 'rc_test-3
	   '((q= (>> v capacitor1) Q0)
	     (q= (>> v capacitor2) Q0)
	     (q= (>> v capacitor3) Q0))
	   :visualization '((>> i capacitor1 o)
			    (>> i capacitor2 o))
	   :display? display? :debug? debug?))
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Voltage and current sensors hooked up to requirements
;;;; rc-ladder with voltage and current sensors

(defprototype voltage-sensor
    :extends (one-port)
    :components ((out (signal-connector)))
    :equations
    ((q= (>> i p) Q0) ;; no current flow
     (q= (>> i n) Q0) ;; no current flow
     (q= (>> sig out) v)))

(defprototype current-sensor
    :extends (one-port)
    :components ((out (signal-connector)))
    :equations
    ((q= v Q0) ;; no voltage drop
     (q= (>> sig out) i)))

(defprototype positive-threshold-req
    :components ((in (signal-connector)))
    :variables ((qspace Real :landmarks (Q0 threshold)))
    :equations ((q= qspace (>> sig in)))
    :mode (normal :entry ((< qspace threshold)) 
		  :initial ()
		  :equations ((q= qspace (>> sig in))))
    :mode (success  :entry ((> qspace threshold)) 
		    :initial ()
		    :equations ((q= qspace (>> sig in))))
    :initial ((== mode normal)))


(defprototype positive-threshold-saftey-req
    :components ((in (signal-connector)))
    :variables ((qspace Real :landmarks (Q0 threshold)))
    :equations () ;;; 
    :mode (normal :entry ((< qspace threshold)) 
		  :initial ()
		  :equations ((q= qspace (>> sig in))))
    :mode (fail  :entry ((= qspace threshold)) 
		 :initial ()
		 :equations ((q= qspace (>> sig in))))
    :initial ((== mode normal)))

(defprototype Q0-threshold-saftey-req
    :components ((in (signal-connector)))
    :variables ((qspace Real))
    :equations ((q= qspace (>> sig in))) ;;; 
    :mode (normal :entry () 
		  :initial ()
		  :equations ((q= qspace (>> sig in))))
    :mode (fail  :entry ((= qspace Q0)) 
		 :initial ()
		 :equations ((q= qspace (>> sig in))))
    :initial ((== mode normal)))



;;;;;; (:total 13 :success 1 :fail 0 :terminal 5 :edges 12)
;; [02/28/2012 klenk] Does the current through the diode reach a particular threshold
(defprototype diode-sensor-test
    :components ((D (ideal-diode))
		 (C (ideal-capacitor ))
		 (R1 (ideal-resistor))
		 (R2 (ideal-resistor))
		 (B (ideal-battery))
		 (G (ground))
		 (Sensor (current-sensor))
		 (Threshold (positive-threshold-req)))
    :initial ((q= (>> v D) Q0)
	      (== (mode D) off)
	      )
    :equations ((connect (>> p B)(>> p R1))
		(connect (>> n R1)(>> p C))
		(connect (>> n R1)(>> p R2))
		(connect (>> p D)(>> n Sensor))
		(connect (>> p Sensor)(>> n R2))
		(connect (>> out Sensor)(>> in Threshold))
		(connect (>> n D)(>> p G))
		(connect (>> n C)(>> p G))
		(connect (>> n B)(>> p G))))

(defun expt-diode-sensor (&key (display? nil) (debug? nil))
  (analyze 'd 'diode-sensor-test nil
	   :visualization '((mode D d)
			    (>> i C d)
			    (mode Threshold d)
			    )
	   :display? display? :debug? debug?
	   :evaluation-fn #'check-modes-for-terminals))



;;;;;;;;;;;;;;;;;;;
;;untested

(defprototype rc_test-sensor :components
  ((resistor1 (ideal-resistor))
   (currentsensor1 (current-sensor))
   (voltagesensor1 (voltage-sensor))
   (capacitor2 (ideal-capacitor))
   (capacitor1 (ideal-capacitor))
   (constantvoltage1 (ideal-battery))
   (resistor2 (ideal-resistor)) (ground1 (ground))
   (v-threshold (positive-threshold-req)))
  :equations
  ((connect (>> n capacitor1) (>> n constantvoltage1))
   (connect (>> n capacitor1) (>> p ground1))
   (connect (>> n capacitor2) (>> n capacitor1))
   (connect (>> n resistor2) (>> p capacitor2))
   (connect (>> p capacitor2) (>> p voltagesensor1))
   (connect (>> n voltagesensor1) (>> n capacitor2))
   (connect (>> p constantvoltage1) (>> p resistor1))
   (connect (>> n resistor1) (>> p resistor2))
   (connect (>> n resistor1) (>> p currentsensor1))
   (connect (>> n currentsensor1) (>> p capacitor1))
   (connect (>> out voltage-sensor1)(>> in v-threshold))))

(defun envision-rc-ladder-2-sensor (&key (display? nil) (debug? nil))
  (analyze 'o 'rc_test-sensor
	   '((q= (>> v capacitor1) Q0)
	     (q= (>> v capacitor2) Q0))
	    ; (= (>> mode v-))
	   :visualization '((>> i capacitor1 o)
			    (>> i capacitor2 o))
	   :display? display? :debug? debug?
	   :evaluation-fn #'check-modes-for-terminals))



(defprototype RRCC
    :components ((source (current-source))
		 (R1 (ideal-resistor))
		 (C1 (ideal-capacitor))
		 (R2 (ideal-resistor))
		 (C2 (ideal-capacitor))
		 (G (ground)))
    :equations ((connect (>> p source)(>> p R1))
		(connect (>> p R1)(>> p C1))
		(connect (>> n source)(>> n R1))
		(connect (>> n R1)(>> n C1))
		(connect (>> n C1)(>> p G))
		
		(connect (>> p C1)(>> p R2))
		(connect (>> p C2)(>> p R2))
		(connect (>> n R2)(>> n C2))
		(connect (>> n C2)(>> p G)))
    :initial ((= (>> v C2) Q0)
	      (= (deriv (>> v C2) 1) Q0)))
		
		


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: drivetrain-el.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: February 08, 2012 11:31:55
;;;;   Purpose: This file contains the drivetrain model considered as an electrical circuit
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Tuesday, March  6, 2012 at 16:36:38 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(defconnector signal
    :variables (s signal))

(defprototype gearbox-selector 
    :components ((output signal))
    :variables ((s signal :landmarks (Q0 G1 G2 G3)))
    :equations ((= (>> s output) s))
    :mode (gear1 :entry ()
		 :initial ((= s G1))
		 :equations ((= s G1)))
    :mode (gear2 :entry ()
		 :initial ((= s G2))
		 :equations ((= s G2)))
    :mode (gear3 :entry ()
		 :initial ((= s G3))
		 :equations ((= s G3))))
;; [02/08/2012 klenk] 

;; (defprototype gearbox-controller
;;     :component ((input signal :landmark (Q0 G1-High G2-High)))
;;     :variables ((delay variable :landmarks (Q0 Reset)))
;;     :equations ()
;;     :mode (ready :entry ((= delay Reset))
;; 		 :initial ((= delay Q0))
;; 		 :equations ())
;;     :mode (entering-gear1 :entry ((
;;     ))))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Hull inertia

(defprototype hull-part-constant
    :components ((Bat (ideal-battery))  ;;; Change to a step source to see what happens at disconnect
		 (L (ideal-inductor ))
		 (C (ideal-capacitor))
		 (R (ideal-resistor ))
		 (G (ground)))
    :equations ((connect (>> p Bat)(>> p L))
		(connect (>> p C)(>> p L))
		(connect (>> n L)(>> p R))
		(connect (>> n C)(>> n R))
		(connect (>> n C)(>> p G))
		(connect (>> n C)(>> n Bat))
		)
    :initial ((= (>> i R) Q0) ;; Starts at rest
	      (= (>> i C) Q0)
	      ))

(defun envision-hull-constant (&key (display? nil) (debug? nil))
  (analyze 'o
	   'hull-part-constant
	   nil
	   :visualization '((>> i R))
	   :display? display? :debug? debug? ))

(defprototype engine-part
    :components ((Bat (ideal-battery))
		 (L1 (ideal-inductor))
		 (R (ideal-resistor))
		 (L2 (ideal-inductor))
		 (G (ground)))
    :equations ((connect (>> p Bat)(>> p L1))
		(connect (>> n L1)(>> p R))
		(connect (>> n R)(>> p L2))
		(connect (>> n L2)(>> p G))
		(connect (>> n Bat)(>> p G)))
    :initial ((= (>> i R) Q0)
	      (= (>> v L1) Q+)
	      (= (>> v L2) Q+)))

(defprototype engine-part-2
    :components ((Bat (ideal-battery))
		 (L1 (ideal-inductor))
		 (R (ideal-resistor))
		 (R2 (ideal-resistor))
		 (G (ground)))
    :equations ((connect (>> p Bat)(>> p L1))
		(connect (>> n L1)(>> p R))
		(connect (>> n R)(>> p R2))
		(connect (>> n R2)(>> p G))
		(connect (>> n Bat)(>> p G)))
    :initial ((= (>> i R) Q0)
	      (= (>> v L1) Q+)
	      ))


(defun envision-engine-part (&key (display? nil) (debug? nil))
  (analyze 'o
	   'engine-part
	   nil
	   :visualization '((>> i R))
	   :display? display? :debug? debug? ))



(defprototype drivetrain-no-tf
    :components ((Bat (ideal-battery))
		 (L1 (ideal-inductor))
		 (R1 (ideal-resistor))
		 (R2 (ideal-resistor))
		 (L2 (ideal-inductor))
		 (G1 (ground))
		 (R3 (ideal-resistor ))
		 (C1 (ideal-capacitor))
		 (L3 (ideal-inductor ))
		 (R4 (ideal-resistor ))
		 (G2 (ground)))
    :equations ((connect (>> p Bat)(>> p L1))
		(connect (>> n Bat)(>> p G1))
		(connect (>> n L1)(>> p R1))
		(connect (>> n R1)(>> p L2))
		(connect (>> n L2)(>> p R2))
		(connect (>> n R2)(>> p C1))
;; [02/ 9/2012 klenk] There should be a transformer in here
		(connect (>> p C1)(>> p L3))
		(connect (>> n C1)(>> n R2))
		(connect (>> n L3)(>> p R2))
		(connect (>> p G2)(>> n R2))
		)
    :initial ((= (>> i R1) Q0)
	      (= (>> v L1) Q+)
	      (= (>> v L2) Q+)
	      (= (>> i R2) Q0) ;; Starts at rest
	      (= (>> i C1) Q0)
	      (= (>> v C1) Q0)
	      ))

(defun envision-drivetrain-el (&key (display? nil) (debug? nil))
  (analyze 'o
	   'drivetrain-no-tf
	   nil
	   :visualization '((>> i R2))
	   :display? display? :debug? debug? ))


(defprototype post-gear-shift
    :components ((C (ideal-capacitor))
		 (L (ideal-inductor ))
		 (R (ideal-resistor ))
		 (G (ground)))
    :equations ((connect (>> p C)(>> p L))
		(connect (>> n C)(>> n R))
		(connect (>> n L)(>> p R))
		(connect (>> p G)(>> n R))
		)
    :initial ((q= (>> i R) Q+) ;; Starts at rest
	      (q= (>> v L) Q0)
	      (q= (>> v C) Q+)))

(defun envision-chassis-post-gear-shift (&key (display? nil) (debug? nil))
  (analyze 'o
	   'post-gear-shift
	   nil
	   :visualization '((>> i R))
	   :display? display? :debug? debug? ))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code

;;; Generated from modelica
(defprototype drivetrain_el :components
  ((inductor3 (ideal-inductor)) (capacitor1 (ideal-capacitor))
   (resistor3 (ideal-resistor)) (resistor1 (ideal-resistor))
   (transformer1 (ideal-transformer)) (ground2 (ground))
   (ground1 (ground)) (resistor4 (ideal-resistor))
   (resistor2 (ideal-resistor)) (inductor2 (ideal-inductor))
   (inductor1 (ideal-inductor)) (constantvoltage1 (ideal-battery))
   
;; [02/28/2012 klenk] Added by me for requirements, but there are closely related modelica components
   (current-sensor1 (current-sensor))
   (target-velocity1 (positive-threshold-req))
   )
  :equations
  ((connect (>> p constantvoltage1) (>> p inductor1))
   (connect (>> n constantvoltage1) (>> p ground1))
   (connect (>> p ground1) (>> n resistor2))
   (connect (>> p resistor2) (>> n resistor1))
   (connect (>> n resistor1) (>> p inductor2))
   (connect (>> n inductor1) (>> p resistor1))
   (connect (>> n inductor2) (>> p1 transformer1))
   (connect (>> n1 transformer1) (>> n resistor2))
   (connect (>> n2 transformer1) (>> p ground2))
   (connect (>> n capacitor1) (>> p ground2))
   (connect (>> p capacitor1) (>> n resistor3))
   (connect (>> p2 transformer1) (>> p resistor3))
   (connect (>> n resistor3) (>> p inductor3))
   (connect (>> n inductor3)(>> p current-sensor1)) 
   (connect (>> n current-sensor1)(>> p resistor4))
   (connect (>> out current-sensor1)(>> in target-velocity))
   (connect (>> n resistor4) (>> p ground2)))

  )


(defun envision-chassis (&key (display? nil) (debug? nil) (max-depth 2))
  (analyze 'o
	   'drivetrain_el
	   nil
	   :visualization '((>> i resistor3))
	   :display? display? :debug? debug?
	   :max-depth max-depth))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(defprototype partial_train :components
              ((capacitor1 (ideal-capacitor))
               (resistor2 (ideal-resistor)) (ground1 (ground))
               (resistor3 (ideal-resistor))
               (inductor2 (ideal-inductor))
               (resistor1 (ideal-resistor))
               (inductor1 (ideal-inductor))
               (constantvoltage1 (ideal-battery)))
              :equations
              ((connect (>> p constantvoltage1) (>> p inductor1))
               (connect (>> n inductor1) (>> p resistor1))
               (connect (>> n resistor1) (>> p inductor2))
               (connect (>> n resistor1) (>> p resistor2))
               (connect (>> n resistor2) (>> p ground1))
               (connect (>> n inductor2) (>> p resistor3))
               (connect (>> n resistor3) (>> p capacitor1))
               (connect (>> n capacitor1) (>> p ground1))
               (connect (>> n constantvoltage1) (>> p ground1)))
	      :initial
	      ((q= (>> i constantvoltage1) Q0)
	       (q= (>> v inductor1) Q+)
	       (q= (>> i resistor2) Q0)
	       (q= (>> v inductor2) Q0)
	       (q= (>> i resistor3) Q0)
	       (q= (>> v capacitor1) Q0)))
	       
	       


(defun envision-partial-train (&key (display? nil) (debug? nil) (max-depth nil))
  (analyze 'o
	   'partial_train
	   nil
	   :visualization '((>> i resistor3))
	   :display? display? :debug? debug?
	   :max-depth max-depth
;; [02/28/2012 klenk] Doesn't work with the eliminator yet
	   ;:failure-condition '(q= (>> i constantvoltage1) Q+)
	   
	   ))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Sensors for prototypes


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Imported from drivetrain_el


;; [02/24/2012 klenk] This was automatically g22enerated form modelica
(defprototype drivetrain_el :components
              ((resistor4 (ideal-resistor))
               (inductor3 (ideal-inductor))
               (inductor1 (ideal-inductor))
               (resistor1 (ideal-resistor))
               (inductor2 (ideal-inductor))
               (constantvoltage1 (ideal-battery))
               (capacitor1 (ideal-capacitor))
               (resistor2 (ideal-resistor)) (ground1 (ground)))
              :equations
              ((connect (>> p ground1) (>> n resistor2))
               (connect (>> n capacitor1) (>> p ground1))
               (connect (>> n constantvoltage1) (>> p ground1))
               (connect (>> p resistor2) (>> n resistor1))
               (connect (>> n resistor1) (>> p inductor2))
               (connect (>> p constantvoltage1) (>> p inductor1))
               (connect (>> n inductor1) (>> p resistor1))
               (connect (>> n inductor2) (>> p capacitor1))
               (connect (>> p capacitor1) (>> p inductor3))
               (connect (>> n resistor4) (>> p ground1))
               (connect (>> n inductor3) (>> p resistor4))))

(defun envision-drivetrain-no-gears (&key (display? nil) (debug? nil) (max-depth nil))
  (analyze 'o
	   'drivetrain_el
	   '((q= (>> i constantvoltage1) Q0)
	     (q= (>> v inductor1) Q+)
	     (q= (>> i resistor2) Q0)
	     (q= (>> v inductor2) Q0)
	     (q= (>> i resistor4) Q0)
	     (q= (>> v capacitor1) Q0))
	   :visualization '((>> i resistor4))
	   :display? display? :debug? debug?
	   :max-depth max-depth
	   :failure-condition '(q= (>> i constantvoltage1) Q+)
))




(defprototype drivetrain_el-sensors :components
              ((resistor4 (ideal-resistor))
               (inductor3 (ideal-inductor))
               (inductor1 (ideal-inductor))
               (resistor1 (ideal-resistor))
               (inductor2 (ideal-inductor))
               (constantvoltage1 (ideal-battery))
               (capacitor1 (ideal-capacitor))
               (resistor2 (ideal-resistor)) (ground1 (ground))
	       ;;;; Sensors and modes represent requirements
	       (c-sensor1 (current-sensor))
	       (tv-req (positive-threshold-req))
	       (c-sensor2 (current-sensor))
	       (max-rpm-req (positive-threshold-saftey-req))
	       (min-rpm-req (Q0-threshold-saftey-req))
	       )
              :equations
              ((connect (>> p ground1) (>> n resistor2))
               (connect (>> n capacitor1) (>> p ground1))
               (connect (>> n constantvoltage1) (>> p ground1))
               (connect (>> p resistor2) (>> n resistor1))
               (connect (>> n resistor1) (>> p inductor2))
               (connect (>> p constantvoltage1) (>> p inductor1))
               (connect (>> n inductor1)(>> p c-sensor2))
	       (connect (>> n c-sensor2)(>> p resistor1))
	       (connect (>> out c-sensor2)(>> in max-rpm-req))
	       (connect (>> out c-sensor2)(>> in min-rpm-req))
               (connect (>> n inductor2) (>> p capacitor1))
               (connect (>> p capacitor1) (>> p inductor3))
               (connect (>> n resistor4) (>> p ground1))
               (connect (>> n inductor3)(>> p c-sensor1)) 
	       (connect (>> n c-sensor1)(>> p resistor4))
	       (connect (>> out c-sensor1)(>> in tv-req))
	       ))

(defun envision-drivetrain-no-gears-sensors (&key (display? nil) (debug? nil) (max-depth nil))
  (analyze 'o
	   'drivetrain_el-sensors
	   '((q= (>> i constantvoltage1) Q0)
	     (q= (>> v inductor1) Q+)
	     (q= (>> i resistor2) Q0)
	     (q= (>> v inductor2) Q0)
	     (q= (>> i resistor4) Q0)
	     (q= (>> v capacitor1) Q0)
	     )
	   :visualization '((>> i resistor4))
	   :display? display? :debug? debug?
	   :max-depth max-depth
	   :evaluation-fn #'check-modes-for-terminals
))




;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: march-demo.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: March  6, 2012 13:03:25
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Monday, July  2, 2012 at 15:17:57 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


;; Demo 1
;; diplay spring block envision by looking at the distance from rest
(defun envision-spring-block-oscillator ()
  (analyze 'o 'lc-oscillator nil :display? nil
	   :visualization '((>> v C o)))
  (dot->pdf)
  (open-envisionment-in-preview)
  )



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Components for drivetrain requirements

(defprototype ideal-resistor-rpm
    :extends (one-port)
    :variables ((i current :landmarks (Q0 MaxRPM)))
    :parameters ((R :value Q+))
    :equations ((= v (* i R))))

(defprototype ideal-resistor-tv
    :extends (one-port)
    :variables ((i current :landmarks (Q0 TV)))
    :parameters ((R :value Q+))
    :equations ((= v (* i R))))

(defprototype ideal-capacitor-MaxTorque
    :extends (one-port)
    :variables ((v voltage :landmarks (Q0 MaxTorque)))
    :parameters ((C :value Q+))
    :equations
    ((= i (* C (deriv v 1 t)))))

;; [02/24/2012 klenk] This was automatically g22enerated form modelica
(defprototype drivetrain_el-req :components
              ((resistor4 (ideal-resistor-tv))
               (inductor3 (ideal-inductor))
               (inductor1 (ideal-inductor))
               (resistor1 (ideal-resistor-rpm))
               (inductor2 (ideal-inductor))
               (constantvoltage1 (ideal-battery))
               (capacitor1 (ideal-capacitor-MaxTorque))
               (resistor2 (ideal-resistor)) (ground1 (ground)))
              :equations
              ((connect (>> p ground1) (>> n resistor2))
               (connect (>> n capacitor1) (>> p ground1))
               (connect (>> n constantvoltage1) (>> p ground1))
               (connect (>> p resistor2) (>> n resistor1))
               (connect (>> n resistor1) (>> p inductor2))
               (connect (>> p constantvoltage1) (>> p inductor1))
               (connect (>> n inductor1) (>> p resistor1))
               (connect (>> n inductor2) (>> p capacitor1))
               (connect (>> p capacitor1) (>> p inductor3))
               (connect (>> n resistor4) (>> p ground1))
               (connect (>> n inductor3) (>> p resistor4))))


;; [03/18/2012 klenk] (envision-drivetrain-req :display? t :max-depth 3) if you want to show
;; [03/18/2012 klenk] an envisionment using zgraph/dot
(defun envision-drivetrain-req (&key (display? nil)(max-depth)(demo? t))
  (let ((*demo-output* demo?))
    (analyze 'o
	     'drivetrain_el-req
	     '((q= (>> i constantvoltage1) Q0)
	       (q= (>> v inductor1) Q+)
	       (q= (>> i resistor2) Q0)
	       (q= (>> v inductor2) Q0)
	       (q= (>> i resistor4) Q0)
	       (q= (>> v capacitor1) Q0))
	     :visualization '((>> i resistor4)
			      (>> v capacitor1))
	     :display? display? 
	     :max-depth max-depth
;;; Drivetrain: The engine should not reach MaxRPM.
;;; Drivetrain: The drivetrain compliance should not reach MaxTorque.	   
	     :failure-condition '(or 
				  (q= (>> i resistor1) MaxRPM)
				  (q= (>> v capacitor1) MaxTorque)
				  (and (q= (>> i resistor1) Q0)
				   (not (q= (>> v inductor1) Q+))))
	     ;;  Performance: The vehicle reaches the target velocity (TV)
	     :success-condition '(q= (>> i resistor4) TV)
	     )
    (summary-env2)
    ))







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
(in-package :env2)


(defun envision-parc-driveline2 (&key (use-cache? nil))
  (envision-model-from-modelica
   "driveLine_2.driveLine_2"
   (merge-pathnames "Modelica/test-circuits/driveLine_2.mo" cl-user::*my-meta-path*)
   :rewrites-file (merge-pathnames "envisioner/v2/rewrite_rules.txt" cl-user::*my-meta-path*)
   :use-cache? use-cache?
   :pseudo-state-vars '(env2-names::|droad_Wheel_Load_Both_Sides.mass.v/dt| "road_Wheel_Load_Both_Sides.quadratic_damper.f" "$DER.road_Wheel_Load_Both_Sides.brake.phi" "spring.phi_rel" "road_Wheel_Load_Both_Sides.supportFriction.lossPower" "road_Wheel_Load_Both_Sides.vehicleSpeed" "road_Wheel_Load_Both_Sides.brake.flange_a.tau" "road_Wheel_Load_Both_Sides.idealRollingWheel.flangeR.tau" "inertia.phi" "clutch.tau" "road_Wheel_Load_Both_Sides.mass.v" "road_Wheel_Load_Both_Sides.mass.s" "time" "road_Wheel_Load_Both_Sides.brake.tau0_max" "clutch.tau0" "road_Wheel_Load_Both_Sides.brake.a_relfric" "spring.w_rel" "road_Wheel_Load_Both_Sides.quadratic_damper.s_rel" "road_Wheel_Load_Both_Sides.vehicle_speed" "clutch.lossPower" "clutch.f_normalized" "spring.a_rel" "road_Wheel_Load_Both_Sides.mass.flange_a.f" "inertia.w" "road_Wheel_Load_Both_Sides.brake.tau" "inertia2.a" "inertia2.w" "road_Wheel_Load_Both_Sides.force1.s" "road_Wheel_Load_Both_Sides.brake.fn" "clutch.phi_rel" "road_Wheel_Load_Both_Sides.fixed.flange.f" "clutch.tau0_max" "road_Wheel_Load_Both_Sides.supportFriction.f" "road_Wheel_Load_Both_Sides.supportFriction.s" "$DER.$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.speedSensor.flange.s" "ramp2.y" "road_Wheel_Load_Both_Sides.brake.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.s_b" "clutch.w_rel" "idealGear.flange_b.tau" "road_Wheel_Load_Both_Sides.supportFriction.support.f" "clutch.fn" "spring.tau_d" "spring.tau_c" "spring.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.sa" "spring.tau" "$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.phi" "road_Wheel_Load_Both_Sides.forceSensor.f" "road_Wheel_Load_Both_Sides.supportFriction.flange_b.f" "idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.sa" "road_Wheel_Load_Both_Sides.brake.tau0" "inertia2.phi")))

(defun record-driveline2-run-times (&optional (max-depth 10))
  (with-open-file (f (merge-pathnames "parc-model-2-runtimes.log" cl-user::*my-meta-path*)
		     :direction :output
		     :if-exists :supersede :if-does-not-exist :create)
    (env2::envision-model-from-modelica
     "driveLine_2.driveLine_2"
     (merge-pathnames "Modelica/test-circuits/driveLine_2.mo" cl-user::*my-meta-path*)
     :rewrites-file (merge-pathnames "envisioner/v2/rewrite_rules.txt" cl-user::*my-meta-path*)
   :translation-only? t)
    (dotimes (depth max-depth)
      (let ((start (get-internal-real-time)))
	(env2::envision-model-from-modelica
	 "driveLine_2.driveLine_2"
	 (merge-pathnames "Modelica/test-circuits/driveLine_2.mo" cl-user::*my-meta-path*)
	 :rewrites-file (merge-pathnames "envisioner/v2/rewrite_rules.txt" cl-user::*my-meta-path*)
	 :use-cache? t :depth (+ 2 depth)
	 :pseudo-state-vars '(env2-names::|droad_Wheel_Load_Both_Sides.mass.v/dt| "road_Wheel_Load_Both_Sides.quadratic_damper.f" "$DER.road_Wheel_Load_Both_Sides.brake.phi" "spring.phi_rel" "road_Wheel_Load_Both_Sides.supportFriction.lossPower" "road_Wheel_Load_Both_Sides.vehicleSpeed" "road_Wheel_Load_Both_Sides.brake.flange_a.tau" "road_Wheel_Load_Both_Sides.idealRollingWheel.flangeR.tau" "inertia.phi" "clutch.tau" "road_Wheel_Load_Both_Sides.mass.v" "road_Wheel_Load_Both_Sides.mass.s" "time" "road_Wheel_Load_Both_Sides.brake.tau0_max" "clutch.tau0" "road_Wheel_Load_Both_Sides.brake.a_relfric" "spring.w_rel" "road_Wheel_Load_Both_Sides.quadratic_damper.s_rel" "road_Wheel_Load_Both_Sides.vehicle_speed" "clutch.lossPower" "clutch.f_normalized" "spring.a_rel" "road_Wheel_Load_Both_Sides.mass.flange_a.f" "inertia.w" "road_Wheel_Load_Both_Sides.brake.tau" "inertia2.a" "inertia2.w" "road_Wheel_Load_Both_Sides.force1.s" "road_Wheel_Load_Both_Sides.brake.fn" "clutch.phi_rel" "road_Wheel_Load_Both_Sides.fixed.flange.f" "clutch.tau0_max" "road_Wheel_Load_Both_Sides.supportFriction.f" "road_Wheel_Load_Both_Sides.supportFriction.s" "$DER.$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.speedSensor.flange.s" "ramp2.y" "road_Wheel_Load_Both_Sides.brake.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.s_b" "clutch.w_rel" "idealGear.flange_b.tau" "road_Wheel_Load_Both_Sides.supportFriction.support.f" "clutch.fn" "spring.tau_d" "spring.tau_c" "spring.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.sa" "spring.tau" "$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.phi" "road_Wheel_Load_Both_Sides.forceSensor.f" "road_Wheel_Load_Both_Sides.supportFriction.flange_b.f" "idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.sa" "road_Wheel_Load_Both_Sides.brake.tau0" "inertia2.phi"))
	(let ((real-time (float (/ (- (get-internal-real-time) start)
				   internal-time-units-per-second))))
	  (format f "~% Depth: ~A real-time: ~A summary-env: ~A" (+ depth 2) real-time (summary-env))
	  (finish-output f))))))


(defun run-depth (depth)
  (env2::envision-model-from-modelica
   "driveLine_2.driveLine_2"
   (merge-pathnames "Modelica/test-circuits/driveLine_2.mo" cl-user::*my-meta-path*)
   :rewrites-file (merge-pathnames "envisioner/v2/rewrite_rules.txt" cl-user::*my-meta-path*)
   :use-cache? nil :depth depth
   :pseudo-state-vars '(env2-names::|droad_Wheel_Load_Both_Sides.mass.v/dt| "road_Wheel_Load_Both_Sides.quadratic_damper.f" "$DER.road_Wheel_Load_Both_Sides.brake.phi" "spring.phi_rel" "road_Wheel_Load_Both_Sides.supportFriction.lossPower" "road_Wheel_Load_Both_Sides.vehicleSpeed" "road_Wheel_Load_Both_Sides.brake.flange_a.tau" "road_Wheel_Load_Both_Sides.idealRollingWheel.flangeR.tau" "inertia.phi" "clutch.tau" "road_Wheel_Load_Both_Sides.mass.v" "road_Wheel_Load_Both_Sides.mass.s" "time" "road_Wheel_Load_Both_Sides.brake.tau0_max" "clutch.tau0" "road_Wheel_Load_Both_Sides.brake.a_relfric" "spring.w_rel" "road_Wheel_Load_Both_Sides.quadratic_damper.s_rel" "road_Wheel_Load_Both_Sides.vehicle_speed" "clutch.lossPower" "clutch.f_normalized" "spring.a_rel" "road_Wheel_Load_Both_Sides.mass.flange_a.f" "inertia.w" "road_Wheel_Load_Both_Sides.brake.tau" "inertia2.a" "inertia2.w" "road_Wheel_Load_Both_Sides.force1.s" "road_Wheel_Load_Both_Sides.brake.fn" "clutch.phi_rel" "road_Wheel_Load_Both_Sides.fixed.flange.f" "clutch.tau0_max" "road_Wheel_Load_Both_Sides.supportFriction.f" "road_Wheel_Load_Both_Sides.supportFriction.s" "$DER.$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.speedSensor.flange.s" "ramp2.y" "road_Wheel_Load_Both_Sides.brake.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.s_b" "clutch.w_rel" "idealGear.flange_b.tau" "road_Wheel_Load_Both_Sides.supportFriction.support.f" "clutch.fn" "spring.tau_d" "spring.tau_c" "spring.lossPower" "road_Wheel_Load_Both_Sides.supportFriction.sa" "spring.tau" "$DER.idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.phi" "road_Wheel_Load_Both_Sides.forceSensor.f" "road_Wheel_Load_Both_Sides.supportFriction.flange_b.f" "idealGear.phi_a" "road_Wheel_Load_Both_Sides.brake.sa" "road_Wheel_Load_Both_Sides.brake.tau0" "inertia2.phi")));;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: bouncing-ball.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: December  5, 2012 14:24:23
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Thursday, April 25, 2013 at 17:29:34 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

;; [12/ 5/2012 klenk] Don't really have a hybrid systems definition
(defprototype bouncing_ball
    :parameters ((e :value Q+)
		 (ya :value Q-))
    :variables ((y position)
		(yv velocity))
    :equations ((= (deriv y 1) yv)
		(= (deriv yv 1) ya)
		(mod-when (and (<= y Q0)
			       (<= yv Q0))
			  (reinit yv (* (- e) (pre yv)))))
    :initial ((= y Q+)
	      (= yv Q0)))

;; [01/25/2013 klenk] THIS IS A TERRIBLE USE OF GLOBALS ONCE WE GET AN XML DUMP 
;; [01/25/2013 klenk] DO THIS RIGHT
(defun envision-bouncing-ball (&key (debug? nil))
  (declare (special *when-equations*))
  (setq *when-equations* nil)
  (analyze 's
	   'bouncing_ball
	   nil 
	   :display? nil :debug? debug?
	   :eliminate? nil)
  (setq *when-equations* nil)
  )




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: omedit-examples.lisp
;;;;    System: PARC QM Envisioner, v2
;;;;    Author: Bill Janssen
;;;;   Created: 2/7/2012
;;;;   Purpose: Read in an XML dump of a simplifed DAE produced from OpenModelica,
;;;;            and instantiate a model from it
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Tuesday, November 19, 2013 at 19:28:33 by klenk
;;;; ----------------------------------------------------------------------------


(in-package :env2)

(defun envision-battery-and-two-resistors (&key (debug? nil)(display? nil))
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/battery-and-two-resistors/battery-and-two-resistors.xml" cl-user::*my-meta-path*)
   :debug? debug?
   :display? display?
   ))

;; [03/18/2012 klenk] The lc oscillator system should allow for initial ambiguities. There is no
;; [03/18/2012 klenk] way to know the initial current through the inductor is 0 from the XML

(defun omedit-lc-2  (&key (debug? nil)(display? nil)
		     (allow-initial-ambiguity? nil))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/test-circuits/lc_oscillator.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?)
    (declare (ignore dot-file-pathname))
    (values sit system)))

(defun omedit-spring_block  (&key (debug? nil)(display? nil)
			     (allow-initial-ambiguity? nil))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/test-circuits/spring_block.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?)
    (declare (ignore dot-file-pathname))
    (values sit system)))


;; [03/18/2012 klenk] Annoying aspect of OMEdit. If you assign an extra parameter that is inconsistant,
;; [03/18/2012 klenk] it is ignored.
(defun omedit-rlc  (&key (debug? nil)(display? nil)
		    (allow-initial-ambiguity? nil)
		    (depth nil))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/test-circuits/rlc_series.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?
       :depth depth)
    (declare (ignore dot-file-pathname))
    (values sit system)))

;; [09/ 1/2012 klenk] 
;;dumpXMLDAE(adby,"optimiser",addMathMLCode=true,fileNamePrefix="/code/parc/META/Modelica/adby346/adby346")

(defun omedit-adby  (&key (debug? nil)(display? nil)
		       (allow-initial-ambiguity? nil)
		       (depth nil))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/adby346/adby346.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?
       :depth depth)
    (declare (ignore dot-file-pathname))
    (values sit system)))

;; [06/27/2012 klenk] Too many requirements to debug effectively
(defun omedit-rlc-req  (&key (debug? nil)(display? nil)
			(allow-initial-ambiguity? nil)
			(depth nil))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/test-circuits/rlc_series_test_1.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?
       :depth depth)
    (declare (ignore dot-file-pathname))
    (values sit system)))


(defun omedit-br-switch  (&key (debug? nil)(display? nil)
			  (allow-initial-ambiguity? nil)
			  (depth nil)(eliminate? t))
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
       (merge-pathnames "Modelica/test-circuits/br_switch.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?
       :depth depth
       :eliminate? eliminate?)
    (declare (ignore dot-file-pathname))
    (values sit system)))

(defun omedit-simple-engine-req (&key (debug? nil)(display? nil)
				 (allow-initial-ambiguity? nil)
				 (depth nil)(eliminate? t)
				 (graphviz-directory nil)
				 (terminate-on-success-failure? t)
				 )
  (multiple-value-bind (sit system dot-file-pathname)
      (envision-model-from-om-xml-dae-dump
;; [04/ 2/2013 klenk] Not sure which Modelica model this is from
       (merge-pathnames "Modelica/Siyuan/SimpleEngine_req.xml" cl-user::*my-meta-path*)
       :debug? debug?
       :display? display?
       :allow-initial-ambiguity? allow-initial-ambiguity?
       :depth depth
       :eliminate? eliminate?
       :graphviz-directory graphviz-directory
       :terminate-on-success-failure? terminate-on-success-failure?)
    (declare (ignore dot-file-pathname))
    (values sit system)))

(defun omedit-single-cap-diode (&key (debug? nil)(eliminate? nil)
				(allow-initial-ambiguity? nil))
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/single-cap-diode/SingleCapDiode.testmsl.xml" cl-user::*my-meta-path*)
   :eliminate? eliminate?
   :debug? debug?
   :allow-initial-ambiguity? allow-initial-ambiguity?
   :pseudo-state-vars :all))

(defun omedit-VU-MassSpringDamper (&key (debug? nil)(eliminate? nil)
				   (allow-initial-ambiguity? nil))
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/VU/MassSpringDamperTest/MassSpringDamperTest.xml" cl-user::*my-meta-path*)
   :eliminate? eliminate?
   :debug? debug?
   :allow-initial-ambiguity? allow-initial-ambiguity?))

(defun omedit-VU-Battery-Test (&key (debug? nil)(eliminate? nil)
			       (allow-initial-ambiguity? nil))
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/VU/RC_car/XML_VU_08_18/Battery_test.Battery_test_for_qr.xml"
		    cl-user::*my-meta-path*)
   :eliminate? eliminate?
   :debug? debug?
   :allow-initial-ambiguity? allow-initial-ambiguity?))


;; [09/11/2012 klenk] This model requires using the landmark ordering and pseudo state vars
(defun omedit-PARC-Brake-Test-1 ()
   (envision-model-from-om-xml-dae-dump 
       (merge-pathnames "Modelica/test-circuits/Simple_Brake_Tests.Brake_Test_1.xml" cl-user::*my-meta-path*)
;; [12/18/2012 klenk] dummy55 is the input ramp. And in this system it is piecewise continuous
;(IF (< #<var: 52 dummy52> 0.0)
;    #<var: 51 dummy51>
;    (IF (< #<var: 54 dummy54> 0.0)
;        (/ (* (- #<var: 36 time> #<var: 14 ramp1.startTime>)
;              #<var: 11 ramp1.height>)
;           #<var: 12 ramp1.duration>)
;        #<var: 11 ramp1.height>))
       :pseudo-state-vars '("ramp1.y")
;; [12/18/2012 klenk] v74 (- #<var: 32 brake1.sa> #<var: 35 brake1.tau0>)
;; [12/18/2012 klenk] v64 (- #<var: 32 brake1.sa> #<var: 34 brake1.tau0_max>)
       :landmark-orders '((72 62))))

;; [09/17/2012 klenk] This does not work
(defun omedit-PARC-Brake-Test-2 ()
  (envision-model-from-om-xml-dae-dump 
   (merge-pathnames "Modelica/test-circuits/Simple_Brake_Tests.Brake_Test_2.xml" cl-user::*my-meta-path*)
   :pseudo-state-vars '(26)
   :landmark-orders '((74 64))
   :allow-initial-ambiguity? t))

(defun omedit-MSL-Brake-Test ()
   (envision-model-from-modelica
    "Simple_Brake_Tests.Brake_Test_1_msl"
    (merge-pathnames "Modelica/test-circuits/Simple_Brake_Tests.mo"
		     cl-user::*my-meta-path*)
    :landmark-orders '((79 67))
    :pseudo-state-vars '("ramp1.y"))
   )

(defun omedit-msl-brake-test-req ()
  (envision-model-from-modelica
       "Simple_Brake_Tests.Brake_Test_1_msl_w_Req"
       (merge-pathnames "Modelica/test-circuits/Simple_Brake_Tests.mo"
			cl-user::*my-meta-path*)
       :landmark-orders '((87 75)(65 61)(60 88))
       :pseudo-state-vars '("ramp1.y")
       :use-cache? nil))
  
(defun omedit-rally-car3 ()
  (envision-model-from-om-xml-dae-dump 
   (merge-pathnames "Modelica/CyDesign/RallyCarLitePARC3.PointDesign.xml" cl-user::*my-meta-path*)))

(defun xml-no_controls()
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/March13/ModelonPARC/no_control_PARC.xml" cl-user::*my-meta-path*)))
  
;;; Runs QR over every XML file in the directory, and returns a list of cons with
;;; the file name and results of envisionment (error string or summary-env)
(defun omedit-on-dir (directory &key (allow-initial-ambiguity? nil))
  (mapcar #'(lambda (file)
	      (cons (pathname-name file)
		    (handler-case 
			(progn 
			  (envision-model-from-om-xml-dae-dump
			   file :allow-initial-ambiguity? allow-initial-ambiguity?)
			  (summary-env))
		      (error (condition)
			(format nil "~A" condition)))))
	  (xml-files-in-dir directory)))

(defun xml-files-in-dir (dir)
  (directory (merge-pathnames "*.xml" dir)))
  
(defun dae-dump-single-cap-diode ()
  (let ((parse (parse-om-xml-dae-dump
                (merge-pathnames "Modelica/single-cap-diode/single-cap-diode.xml"
                                 cl-user::*my-meta-path*)
                :show nil)))
    parse
    ))

(defun omedit-rc2 ()
  (envision-model-from-modelica "step_voltage_test" 
				(merge-pathnames "Modelica/ladder/RC2.mo" cl-user::*my-meta-path*)
				:libraries '("Modelica"))
   )

(defun omedit-rc3 ()
  (envision-model-from-modelica "three_R_C" 
				(merge-pathnames "Modelica/ladder/RC3.mo" cl-user::*my-meta-path*)
				:libraries '("Modelica")))

;; [09/17/2012 klenk] This spawns too many situations.
;; [11/19/2013 klenk] WAAAYYY TOO MANY!!
(defun xml-rc3 ()
  (envision-model-from-om-xml-dae-dump
   (merge-pathnames "Modelica/ladder/RC3.xml" cl-user::*my-meta-path*)))

(defun system-from-xml (path)
  (multiple-value-bind (system initial-conditions)
      (create-system-from-om-xml-dae-dump
       (merge-pathnames path cl-user::*my-meta-path*))
    (declare (ignore initial-conditions))
    ;(format t "~s~%" system)
    ;(format t "~s~%" initial-conditions)
    system))

(defun envision-from-xml (path &key (debug? nil) (display? nil)
                          (allow-initial-ambiguity? nil)
                          (output-file nil))
  (multiple-value-bind (initial-sits system dot-file-pathname)
      (with-open-file (*standard-output* (or output-file "/tmp/output.txt")
                       :direction :output :if-exists :supersede)
        (envision-model-from-om-xml-dae-dump
         (merge-pathnames path cl-user::*my-meta-path*)
         :allow-initial-ambiguity? allow-initial-ambiguity?
         :debug? debug?
         :display? display?))
    (declare (ignore system initial-sits))
    (namestring dot-file-pathname)))

(defun system-from-xml-rc3 ()
  (system-from-xml "Modelica/ladder/RC3.xml"))


(defun parse-xml-rc3 ()
  (format t "parse is ~s~%"
          (parse-om-xml-dae-dump
           (merge-pathnames "Modelica/ladder/RC3.xml" cl-user::*my-meta-path*))
          ))

(defun expand-single-cap-diode ()
  (test-expand-equations (merge-pathnames "Modelica/single-cap-diode/single-cap-diode.xml"
                                          cl-user::*my-meta-path*)))

(defun test-expand-equations (xmlfile)
  ;; goddam global variable side-effects
  (let ((original-equations)
        (added-equations)
        (vars-hash-table))
    (with-output-to-string (*standard-output*)
    (setq *system-being-analyzed* (create-system "the-system"))
      (let* ((parse (parse-om-xml-dae-dump
                     (merge-pathnames xmlfile cl-user::*my-meta-path*)
                     :show nil))
             (raw-lisp-form-eqns
              (mapcar #'(lambda (eqn) (cdr (assoc :lisp-form eqn)))
                      (cdr (assoc :equations parse))))
             (dummy-model (make-model :id 1 :local-name "dummy-model")))
        (setf original-equations raw-lisp-form-eqns)
        ;; we need to have the variables in the hash-table for this to work
        (multiple-value-bind (new-vars-hash-table initial-conditions)
            (process-variables parse dummy-model)
          (declare (ignore initial-conditions))
          (setf vars-hash-table new-vars-hash-table)
          ;(format t "~S raw equations~%" (length raw-lisp-form-eqns))
          ;; convert to var form
          ;; (dolist (eqn raw-lisp-form-eqns)
          ;;   (multiple-value-bind (final-form new-equations new-vars)
          ;;       (format-lisp-form-properly eqn vars-hash-table dummy-model) 
          ;;     (declare (ignore new-vars))
          ;;     (setq formatted-equations (append new-equations (list final-form) formatted-equations))
          ;;     ))
          )))
    ;; now expand set to include elided KVL and KCL equations
    (setf added-equations (expand-equations original-equations vars-hash-table))
    ;(format t "original equations:~%")
    ;(dolist (eqn original-equations)
      ;(format t "  ~S~%" eqn))
    ;(format t "extra equations are~%")
    ;(dolist (eqn added-equations)
      ;(format t "  ~S~%" eqn))
    added-equations))
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: math.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: April 09, 2012 16:45:07
;;;;   Purpose: 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, April 11, 2012 at 17:31:36 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)

(defprototype power-test-1
    :variables ((base variable)
		(result variable))
    :fixed-parameters ((deriv-base :value Q+))
    :initial ((q= base Q-)
	      (q= result Q+))
    :equations ((= result (power base 2))
		(= (deriv base) deriv-base)))


(defun expt-power-test-1 (&key (display? nil) (debug? nil))
  (analyze 'd 'power-test-1 nil
	   :visualization '((>> base d)
			    (>> result d)
			    )
	   :display? display? :debug? debug?))

(defprototype power-test-2
    :variables ((base variable)
		(result variable))
    :fixed-parameters ((deriv-base :value Q+))
    :initial ((q= base Q-)
	      (q= result Q-))
    :equations ((= result (power base 3))
		(= (deriv base) deriv-base)))


(defun expt-power-test-2 (&key (display? nil) (debug? nil))
  (analyze 'd 'power-test-2 nil
	   :visualization '((>> base d)
			    (>> result d))
	   :display? display? :debug? debug?))




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: 2013-march-demo.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: March  6, 2013 16:38:58
;;;;   Purpose: contains code to be run for the March 2013 demo 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, April  3, 2013 at 08:45:55 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


(defparameter *no-controls-parameter-initial-values*
  '(("example_Engine_Basic.MaxTorque" . 2080)
    ("idealGear.ratio" . 3)
    ("road_Wheel_Load_Both_Sides.vehicle_mass" . 30000)
    ("road_Wheel_Load_Both_Sides.grade" . 10)))

(defvar *param-results-csv* nil)

(defun build-no-controls-envisionment (&optional use-param-results?)
  (format t "~% building no controls envisionment")
  (let ((results (if use-param-results?
		     *param-results-csv*
		     (run-no-controls-deterministic-sampling)))
	(output-file (merge-pathnames "envisioner/v2/tmp/summary-no-controls.csv"
				      cl-user::*my-meta-path*)))
    (format t "~% Rewriting Enumerated Type Req in CSV files from 1,2,3 to -1,0,1")
    (unless use-param-results? (rewrite-reqs (mapcar #'second results)))
    (format t "~% Mapping csvs into qualitative trajectories")
    (build-envisionment-from-csvs (mapcar #'second results))
    (format t "~% Label success and failure")
    (situation-coloring)
    (unless *acceptor* (start-server 4646))
    (run-shell-command "open http://localhost:4646" nil)
    (no_controls_results->csv results output-file) 
    ))

(defun run-no-controls-deterministic-sampling ()
  (setq *param-results-csv*
	(omc-csv 
	 (merge-pathnames "Modelica/March13/ModelonPARC/C2M2L_Test_Assemblies.mo" cl-user::*my-meta-path*)
	"ModelonPARC.C2M2L_Test_Assemblies.no_controls_PARC"
	:omcbinary "/Applications/OMedit.app/Contents/Resources/bin/omc"
	:openmodelicahome "/Applications/OMedit.app/Contents/Resources"
;; [04/ 1/2013 klenk] Need to copy this library into the OMC library path
	:additional-libraries "ModelonPARC"
	:params-lists (determine-useful-parameter-ranges)
	:directory (merge-pathnames "envisioner/v2/tmp/" cl-user::*my-meta-path*)
	:specified-result-filename "no-controls"
	:stop-time 30 :step-size .06)))

;; [03/12/2013 klenk] Assumes that success has been Req has been rewritten
(defun no_controls_results->csv (results file)
  (omc-csv-results->parameters-csv results nil file 
				   :header '("MaxT" "Ratio" "Mass" "success" "file")
				   :result-fn #'no_controls-csv->success?))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Use the detailed model for the April PI Deep dive

(defun no_controls_2_deterministic_sampling ()
  (setq *param-results-csv*
	(omc-csv 
	 (merge-pathnames "Modelica/March13/C2M2L_OM/C2M2L_Test_Assemblies.mo" cl-user::*my-meta-path*)
	 "C2M2L_OM.C2M2L_Test_Assemblies.no_controls_2"
	 :omcbinary "/Applications/OMedit.app/Contents/Resources/bin/omc"
	:openmodelicahome "/Applications/OMedit.app/Contents/Resources"
	:additional-libraries "C2M2L_OM"
	:params-lists (determine-useful-parameter-ranges 
		       '(("road_Wheel_Load_Both_Sides.vehicle_mass" . 30000)
			 ("road_Wheel_Load_Both_Sides.grade" . 10))
		        60
		        120
		        20)
	:directory (merge-pathnames "envisioner/v2/tmp/" cl-user::*my-meta-path*)
	:specified-result-filename "no-controls_2"
	:stop-time 30 :step-size 0.06)))


(defun build-no-controls-2-envisionment (&optional use-param-results?)
  (format t "~% building no controls envisionment")
  (let ((results (if use-param-results?
		     *param-results-csv*
		     (time (no_controls_2_deterministic_sampling))))
	(output-file (merge-pathnames "envisioner/v2/tmp/summary-no-controls.csv"
				      cl-user::*my-meta-path*)))
    (format t "~% Rewriting Enumerated Type Req in CSV files from 1,2,3 to -1,0,1")
    (unless use-param-results? (time (rewrite-reqs (mapcar #'second results))))
    (format t "~% Mapping csvs into qualitative trajectories")
    (time (build-envisionment-from-csvs (mapcar #'second results) '("Req") ))
    (format t "~% Label success and failure")
    (time (situation-coloring))
    (unless *acceptor* (start-server 4646))
    (run-shell-command "open http://localhost:4646" nil)
    ;;;;  Modified: Tuesday, April  2, 2013 at 20:40:12 by klenk
    (time (omc-csv-results->parameters-csv results
				     nil
				     output-file 
				     :header '("Mass" "Grade" "success" "file")
				     :result-fn #'no_controls-csv->success?))
    ))


;(time (no_controls_2_deterministic_sampling))
;(time (rewrite-reqs (mapcar #'second *param-results-csv*)))
;(time (build-envisionment-from-csvs (mapcar #'second *param-results-csv*) :limit-to-vars '("Req") ))
;(time (omc-csv-results->parameters-csv *param-results-csv*
;				     nil
;				     (merge-pathnames "envisioner/v2/tmp/summary-no-controls.csv"
;				      cl-user::*my-meta-path*)
;				     :header '("Mass" "Grade" "success" "file")
;				     :result-fn #'no_controls-csv->success?))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; general functions

;; [03/ 7/2013 klenk] Returns parameter sets to call omc with
(defun determine-useful-parameter-ranges (&optional
					    (params (subseq *no-controls-parameter-initial-values* 0 3))
					    (min 80)
					    (max 120)
					    (step 10))

  (cond ((null (cdr params))
	 (mapcar #'list (create-param-val-pairs (car params) min max step)))
	(t
	 (let ((param-lists (determine-useful-parameter-ranges (cdr params) min max step)))
	   (mapcan #'(lambda (param-val)
		       (mapcan #'(lambda (param-vals)
				   (list (cons param-val param-vals)))
			       param-lists))
		   (create-param-val-pairs (car params) min max step))))))

(defun create-param-val-pairs (param-init min max step)
  (let ((param (car param-init))
	(base-val (cdr param-init)))
    (do* ((percentage min (+ percentage step))
	  (val (* (/ percentage 100.0) base-val)(* (/ percentage 100.0) base-val))
	  (ret (list (cons param val))(cons (cons param val) ret)))
	 ((> percentage max) ret))))


(defun no_controls-csv->success? (file)
  (multiple-value-bind (cols rows)
      (read-csv-file file)
    (if (= (elt 
	    (car (last rows))
	    (position "Req" cols :test #'string=))
	   1)
	1
	0)))
    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Abstract CSV file

;; [03/08/2013 klenk] takes a bunch of simulation runs and creates an envisionment graph
;; [03/08/2013 klenk] Create a system/model
;; [03/08/2013 klenk] Create the variables
;; [03/08/2013 klenk] then read the file and create any new states?
;; [04/ 2/2013 klenk] The Keyword argument limit-to-vars is optional
;; [04/ 2/2013 klenk] If a list of strings are given, only those variables will be created 
;; [04/ 2/2013 klenk] and considered for abstraction
(defun build-envisionment-from-csvs (files &key (limit-to-vars nil))
  (let ((system (create-system-from-csv (car files) limit-to-vars)))
    (dolist (file files)
      (create-situations-from-csv file system))))

(defun create-system-from-csv(file &optional limit-to-vars)
  (let (system  top-model)
    (setq system (setq *system-being-analyzed* (create-system "no_contols")))
    (setq top-model (make-model :id (new-id) :local-name "no_controls"))
    (push top-model (system-models system) )
    (setf (gethash (model-local-name top-model) (system-top-models system)) 
          top-model)
    (get-variables-from-csv file top-model system limit-to-vars)
    system))

(defun get-variables-from-csv (file model system &optional limit-to-vars)
  (mapcar #'(lambda(col)
	      (unless (and limit-to-vars
			   (not (member col limit-to-vars :test #'string=)))
		(let ((var (create-var model col)))
		  (push (cons col var) (model-variables model))
		  (push var (system-active-variables system))
		  (push var (system-variables system))
		  var)))
	  (read-csv-file file system)))

;; [03/08/2013 klenk] Ignore all events, and just graph the situations
(defun create-situations-from-csv (file system)
  (compactor)
  (let (cur-state)
    (dolist (qstate (abstract-qstates-for-system file system))
      (let* ((sit (find-or-make-sit-for-qstate qstate cur-state))
	     (old (find-situation sit)))
	(format nil "~% cur-sit: ~A sit: ~A redunandt: ~A" cur-state sit (redundant-event? cur-state sit))
	
	(cond ((redundant-event? cur-state sit)
	       (remove-redundant-event cur-state sit))
	      (old
	       (pushnew old (situation-children cur-state))
	       (pushnew cur-state (situation-parents cur-state))
	       (setf cur-state old))
	      (cur-state 
	       (pushnew sit (situation-children cur-state))
	       (pushnew cur-state (situation-parents sit))
	       (add-system-situation sit))
	      (t 
	       (pushnew sit (system-initial-situations system))
	       (add-system-situation sit)))
	(setq cur-state sit)
	))))

(defun redundant-event? (parent child)
  (and parent
       (not(member parent (situation-parents child)))
       (member :event (situation-trace parent))
       (not (member :event (situation-trace child)))
       (has-great-grandparent? child
			       (car 
				(situation-parents
				 (car (situation-parents parent)))))))

;; [03/08/2013 klenk] Pretty sure this is not destructive
(defun has-great-grandparent? (sit ggp)
  (some #'(lambda (parent)
	    (and (member :event (situation-trace parent))
		 (eql
		  (car 
		   (situation-parents
		    (car (situation-parents parent))))
		  ggp)))
	(situation-parents sit)))
	

(defun remove-redundant-event (parent child)
  (declare (ignore child))
  (cond ((car 
	  (situation-parents
	   (car (situation-parents parent))))
	 (remove-impossible-instant parent)
	 (remove-impossible-instant (car (situation-parents parent)))
	 )
	(t 
	 (setf  (system-initial-situations *system-being-analyzed*)
		(remove (car (situation-parents parent)) (system-initial-situations *system-being-analyzed*)))
	 (remove-situation (car (situation-parents parent)))
	 (remove-situation parent))))
    


;; [03/08/2013 klenk] Push tons and tons of event instants out there
(defun find-or-make-sit-for-qstate (qstate  parent-sit)
  (let* ((sit (make-sit-for-qstate qstate parent-sit))
	 (old (find-situation sit)))
    (cond ((and old (not (member :event (situation-trace sit))))
	   old
	   )
	  (t
	   sit))))

(defun make-sit-for-qstate (qstate parent-sit)
  (cond ((atom qstate)
	 (let ((sit (if parent-sit
			(create-situation :instant parent-sit)
			(create-situation :instant nil)
			)))
	   (push :event (situation-trace sit))
	   sit))
	(t
	 (let ((sit (create-sit-for-qstate parent-sit)))
	   (dolist (var-val qstate sit)
	     (clobber (car var-val) 
		      (cdr var-val)
		      sit '((init nil))))))))

(defun create-sit-for-qstate (parent-sit)
  (cond (parent-sit (create-sit-for-qstate-parent parent-sit))
	(t (create-situation 
	  :instant
	  nil))))

(defun create-sit-for-qstate-parent (parent-sit)
  (let ((type (ecase (situation-type parent-sit)
		(:instant :interval)
		(:interval :instant))))
    (create-situation type parent-sit)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defun color situations

(defun situation-coloring ()
  (let ((req-var (find "Req" 
		       (system-variables *system-being-analyzed*)
		       :key #'var-local-name :test #'string=)))
    (dolist (sit (total-situations)(propagate-status))
      (unless (member :event (situation-trace sit))
	(ecase (simple-qvalue req-var sit)
	  (Q0 nil)
	  (Q- (setf (situation-status sit) :failure))
	  (Q+ (setf (situation-status sit) :success)))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Rewriting the req to be 0 : unknown 1 : success -1 : failure




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-
;;;; ----------------------------------------------------------------------------
;;;; File name: 2013-march-demo.lisp
;;;;    System: 
;;;;    Author: klenk
;;;;   Created: March  6, 2013 16:38:58
;;;;   Purpose: contains code to be run for the March 2013 demo 
;;;; ----------------------------------------------------------------------------
;;;;  Modified: Wednesday, April  3, 2013 at 08:45:55 by klenk
;;;; ----------------------------------------------------------------------------

(in-package :env2)


(defparameter *driveline-2-parameters*
  '(("torqueStep.stepTorque" . 400)
    ("clutch.cgeo" . 0.5)
    ("road_Wheel_Load_Both_Sides.vehicle_mass" . 3500)
    ("road_Wheel_Load_Both_Sides.brake.cgeo" . 0.5)))


(defparameter *driveline-2-variables*
  '("road_Wheel_Load_Both_Sides.mass.s" 
    "road_Wheel_Load_Both_Sides.vehicle_speed"
    "speedReq"
    "backRollReq"
    "brakingDistanceReq"
    "clutchLockedReq"))

(defparameter *powertrain-params*
  '(("engine.T_max" . 32) ;; must be greater than 24 for speed req
    ("finalDrive.idealDifferential.ratio" . 0.6) ;; must be greater than 0.31
;    ("Clutch.cgeo" . 0.019) ;;must be greater than .019 for clutch locked
;    ("vehicleMass" . 5100) ;;must be greater than 5100 for braking distance
    ))

(defparameter *powertrain-vars*
  '("chassis.speed"
    "engine.flange_a.tau"
    "speedReq"
;    "backRollReq"
    "brakingDistanceReq"
 ;   "clutchLockedReq"
    ))

    

(defvar *param-results-csv* nil)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; top level functions

(defun build-driveline-2-envisionment (&key use-param-results?
				       (min 80)
				       (max 120)
				       (step 20))
  (let ((results (if use-param-results?
		     *param-results-csv*
		     (run-gamma-deterministic-sampling
		      :min min :max max :step step))))
    (build-param-envisionment-from-csvs results)
    (situation-coloring)
    ))


(defun build-vehicle-powertrain-envisionment (&key use-param-results?
					      (min 80)
					      (max 120)
					      (step 20))
  (let* ((model-name "Powertrain.vehicle_QR")
	 (results (if use-param-results?
		     *param-results-csv*
		     (run-gamma-deterministic-sampling
		      :params *powertrain-params*
		      :min min :max max :step step 
		      :model-name model-name
		      :model-file 
		      (merge-pathnames "Modelica/test-circuits/Powertrain.mo"
				       cl-user::*my-meta-path*)
		      :stop-time 80 :step-size .25))))
    (build-param-envisionment-from-csvs 
     results 
     :limit-to-vars *powertrain-vars*
     :model-name model-name :system-name model-name)
    (situation-coloring :only-children? nil)))
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Params -> json arrays for continuous variables in *driveline-2-variables*

(defun params->values (params &optional (vars *driveline-2-variables*) (results *param-results-csv*))
  "params is an association list of the form appended in build-driveline-2-envisionment.
   This is used to access the csv file *param-results-csv* and then return an alist
   where each element is a continuous variable from *driveline-2-variables* and the value
   is a list of time value pairs"
  (let ((file
         (second
          (assoc params results
                 :test #'(lambda (l1 l2)
                           (equalp (sort (copy-list l1) #'string-lessp :key #'car )
                                   (sort (copy-list l2)  #'string-lessp :key #'car)))))))
    (assert file)
    (csv->values-for-vars 
     file
     (remove-if-not #'quantity-var? 
		    (mapcar #'lookupv vars)))))

(defun csv->values-for-vars (file vars)
  (multiple-value-bind (cols rows)
      (read-csv-file file *system-being-analyzed*)
    (let ((ret (make-hash-table))
	  (rows (identify-events cols rows))
	  (var->cols (mapcar #'(lambda (var)
				 (cons var (var->col var cols)))
			     vars)))
      (dolist (row rows)
	(unless (atom row)
	  (dolist (var->col var->cols)
	    (let ((vals (gethash (car var->col) ret))
		  (duration (car row))
		  (val (elt row (cdr var->col))))
	      (assert (and duration val)) 
	      (unless (and vals (equalp (car vals) (list duration val)))
		(setf (gethash (car var->col) ret) (push (list duration val) vals)))))))
      (maphash #'(lambda (key values)
		   (setf (gethash key ret) (reverse values)))
	       ret)
      ret)))



(defun run-gamma-deterministic-sampling 
    (&key
     (params *driveline-2-parameters*)
     (min 20)
     (max 180)
     (step 20)
     (model-file (merge-pathnames "Modelica/test-circuits/driveLine_2.mo"
				 cl-user::*my-meta-path*))
     (model-name "driveLine_2.driveLine_2")
     (stop-time 75)
     (step-size .1))
  (setq *param-results-csv*
	(omc-csv model-file model-name
		 :params-lists (determine-parameter-ranges 
				params min max step)
		 :directory (ensure-directories-exist (merge-pathnames "envisioner/v2/tmp/" cl-user::*my-meta-path*))
		 :specified-result-filename model-name
		 :stop-time stop-time :step-size step-size)))



(defun determine-parameter-ranges (&optional
				   (params *driveline-2-parameters*)
				   (min 20)
				   (max 180)
				   (step 20))

  (cond ((null (cdr params))
	 (mapcar #'list (create-param-val-pairs (car params) min max step)))
	(t
	 (let ((param-lists (determine-useful-parameter-ranges (cdr params) min max step)))
	   (mapcan #'(lambda (param-val)
		       (mapcan #'(lambda (param-vals)
				   (list (cons param-val param-vals)))
			       param-lists))
		   (create-param-val-pairs (car params) min max step))))))

(defun create-param-val-pairs (param-init min max step)
  (let ((param (car param-init))
	(base-val (cdr param-init)))
    (do* ((percentage min (+ percentage step))
	  (val (* (/ percentage 100.0) base-val)(* (/ percentage 100.0) base-val))
	  (ret (list (cons param val))(cons (cons param val) ret)))
	 ((> percentage max) (cdr ret)))))



    

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; Abstract CSV file

;; [03/08/2013 klenk] takes a bunch of simulation runs and creates an envisionment graph
;; [03/08/2013 klenk] Create a system/model
;; [03/08/2013 klenk] Create the variables
;; [03/08/2013 klenk] then read the file and create any new states?
;; [04/ 2/2013 klenk] The Keyword argument limit-to-vars is optional
;; [04/ 2/2013 klenk] If a list of strings are given, only those variables will be created 
;; [04/ 2/2013 klenk] and considered for abstraction
;;
;; What the heck is "files"?
;; I think it's "a list of (((NAME . VALUE)...) RESULT-FILENAME)"
;;
(defun build-param-envisionment-from-csvs (files
                                           &key
                                           (limit-to-vars *driveline-2-variables*)
                                           (model-name "driveline_2")
                                           (system-name "driveline_2")
                                           (callback nil))
  (if callback (funcall callback "Creating system..." -1))
  (let ((system (create-system-from-csv (cadar files) limit-to-vars :model-name model-name :system-name system-name))
        (counter 0))
    (dolist (file files)
      (if callback (funcall callback "Parsing simulation results..." (/ (* 100 (float counter)) (length files))))
      (incf counter)
      (create-param-situations-from-csv file system))))

(defun create-system-from-csv (file limit-to-vars &key (model-name "driveline_2") (system-name "driveline_2"))
  (let (system  top-model)
    (setq system (setq *system-being-analyzed* (create-system system-name)))
    (setq top-model (make-model :id (new-id) :local-name model-name))
    (push top-model (system-models system) )
    (setf (gethash (model-local-name top-model) (system-top-models system)) 
          top-model)
    (get-variables-from-csv file top-model system limit-to-vars)
    system))



(defun get-variables-from-csv (file model system &optional limit-to-vars)
  (mapcar #'(lambda(col)
	      (unless (and limit-to-vars
			   (not (member col limit-to-vars :test #'string=)))
		(let ((var (create-var model col)))
		  (when (string-ends-with (var-local-name var) "Req")
		    (setf (var-discrete-var? var) t)
		    (setf (var-qspaces var) (list *requirement-qspace*)))
		  (push (cons col var) (model-variables model))
		  (push var (system-active-variables system))
		  (push var (system-variables system))
		  var)))
	  (read-csv-file file system)))

;; [03/08/2013 klenk] Ignore all events, and just graph the situations
;; [04/30/2014 klenk] Don't stress getting intervals and instants right
(defun create-param-situations-from-csv (param-file system)
  (compactor)
  (let (cur-state parent
	(param (car param-file)))
;    (format nil "~% params : ~A" param)
    (let ((qstates (abstract-qstates-for-system (second param-file) system)))
    (dolist (qstate qstates)
       (unless (atom qstate)
	(let* ((sit (find-or-make-sit-for-qstate qstate cur-state))
	       (old (find-situation sit))
	       (old2 (let (ret)
		       (invert-sit-type sit)
		       (setf ret (find-situation sit))
		       (invert-sit-type sit)
		       ret))
	       )
;	  (format t "~% cur-sit: ~A sit: ~A old: ~A redunandt: ~A" cur-state sit old (redundant-event? cur-state sit))
	  (unless (and cur-state (member cur-state (list sit old old2))) 
	    (cond ((redundant-event? cur-state sit)
		   (remove-redundant-event cur-state sit))
		  ((and (null cur-state) old))
		  ((and cur-state old)
		   (pushnew old (situation-children cur-state))
		   (pushnew cur-state (situation-parents cur-state)))
		  ((and cur-state old2)
		   (pushnew old2 (situation-children cur-state))
		   (pushnew cur-state (situation-parents cur-state)))
		  (cur-state 
		   (pushnew sit (situation-children cur-state))
		   (pushnew cur-state (situation-parents sit))
		   (add-system-situation sit))
		  (t (pushnew sit (system-initial-situations system))
		     (add-system-situation sit))
		  )
	    (setq parent cur-state)
	    (setq cur-state (or old old2 sit))
;	    (format t "~% cur-sit: ~A parent: ~A sit: ~A old: ~A old2: ~A" 
;		    cur-state parent sit old old2)
	    (push (list :params 
			(if parent (situation-id parent) -1)
			param
			(car qstate))
		  (situation-trace cur-state)))
	  ))))))

(defun invert-sit-type (sit)
  (setf (situation-type sit)
	(ecase (situation-type sit)
	  (:instant :interval)
	  (:interval :instant))))

(defun redundant-event? (parent child)
  (and parent
       (not(member parent (situation-parents child)))
       (member :event (situation-trace parent))
       (not (member :event (situation-trace child)))
       (has-great-grandparent? child
			       (car 
				(situation-parents
				 (car (situation-parents parent)))))))

;; [03/08/2013 klenk] Pretty sure this is not destructive
(defun has-great-grandparent? (sit ggp)
  (some #'(lambda (parent)
	    (and (member :event (situation-trace parent))
		 (eql
		  (car 
		   (situation-parents
		    (car (situation-parents parent))))
		  ggp)))
	(situation-parents sit)))
	

(defun remove-redundant-event (parent child)
  (declare (ignore child))
  (cond ((car 
	  (situation-parents
	   (car (situation-parents parent))))
	 (remove-impossible-instant parent)
	 (remove-impossible-instant (car (situation-parents parent)))
	 )
	(t 
	 (setf  (system-initial-situations *system-being-analyzed*)
		(remove (car (situation-parents parent)) (system-initial-situations *system-being-analyzed*)))
	 (remove-situation (car (situation-parents parent)))
	 (remove-situation parent))))
    


;; [03/08/2013 klenk] Push tons and tons of event instants out there
(defun find-or-make-sit-for-qstate (qstate  parent-sit)
  (let* ((sit (make-sit-for-qstate qstate parent-sit))
	 (old (find-situation sit)))
    (cond ((and old (not (member :event (situation-trace sit))))
	   old
	   )
	  (t
	   sit))))

(defun make-sit-for-qstate (qstate parent-sit)
  (cond ((atom qstate)
	 (error "Shouldn't happen anymore")
	 (let ((sit (if parent-sit
			(create-situation :instant parent-sit)
			(create-situation :instant nil)
			)))
	   (push :event (situation-trace sit))
	   sit))
	(t
	 (let ((sit (create-sit-for-qstate parent-sit)))
	   (dolist (var-val (cdr qstate) sit)
	     (clobber (car var-val) 
		      (cdr var-val)
		      sit '((init nil))))))))

(defun create-sit-for-qstate (parent-sit)
  (cond (parent-sit (create-sit-for-qstate-parent parent-sit))
	(t (create-situation 
	  :instant
	  nil))))

(defun create-sit-for-qstate-parent (parent-sit)
  (let ((type (ecase (situation-type parent-sit)
		(:instant :interval)
		(:interval :instant))))
    (create-situation type parent-sit)))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Defun color situations

(defun situation-coloring (&key 
			   (system *system-being-analyzed*)
			   (only-children? t)
			   )
  (dolist (sit (system-situations system))
    (let ((status (modelica-success-fn sit)))
      (setf (situation-status sit) 
	    (cond ((eq status :failure) :failure)
		  ((and (eq status :success)
			(or  
			 (not only-children?)
			 (null (situation-children sit))))
		   :success)
		  (t :maybe))))))


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;; parameters 

(defun situations-matching-params (params)
  (remove-if-not #'(lambda (sit)
		     (situation-matches-params? sit params))
		 (system-situations *system-being-analyzed*)))

(defun situation-matches-params? (sit params)
  (some #'(lambda (sit-params)
	    (every #'(lambda (sit-param)
		       (equal-within?  (cdr (assoc (car sit-param) params :test #'string=))
				       (cdr sit-param)))
		   (second sit-params)))
	(situation-trace sit)))

(defun equal-within? (v1 v2 &optional (tol 0.01))
  (declare (ignore tol))
  (= v1 v2))



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; Rewriting the req to be 0 : unknown 1 : success -1 : failure

(defun rewrite-all-reqs (files)
  "Assumes requirement variables end in Req"
  (error "This function is no longer needed as requirements are handled explicitly in the qualitative-abstractor.lisp")
  (dolist (file files)
    (format t "~% modifying file: ~A" file)
    (rewrite-all-reqs-1 file)))


(defun rewrite-all-reqs-1 (file)
  (multiple-value-bind (cols rows)
      (read-csv-file file nil)
    (with-open-file (out file
			 :direction :output
			 :if-exists :supersede)
      (csv-parser:write-csv-line out cols)
      (dolist (row rows)
	(csv-parser:write-csv-line 
	 out
	 (replace-all-reqs row cols))))))

(defun replace-all-reqs (row cols)
  (dolist (req (remove-if-not #'(lambda (name) (string-ends-with name "Req")) cols) row)
    (let ((req-val (elt 
		    row
		    (position req cols :test #'string=))))
      (setf (elt 
	     row
	     (position req cols :test #'string=))
	    (ecase req-val
	      (1 'success)
	      (2 'unknown)
	      (3 'violated)))
      row)))






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;; End of Code
;;;; -*-  Mode: LISP; Syntax: Common-Lisp; Base: 10                          -*-

;;;; ----------------------------------------------------------------------------

;;;; File name: AAAI2014.lisp

;;;;    System: 

;;;;    Author: klenk

;;;;   Created: January 27, 2014 15:33:23

;;;;   Purpose: THIS FILE REDEFINES MANY FUNCTIONS

;;;; ----------------------------------------------------------------------------

;;;;  Modified: Friday, January 31, 2014 at 11:45:09 by klenk

;;;; ----------------------------------------------------------------------------







(in-package :env2)



;;; model-name model-file landmark-orders psuedo-state-vars libraries

(defparameter *model-file-pairs*

  (list 

   (list "Simple_Brake_Tests.Brake_Test_1_msl"

	 (merge-pathnames "Modelica/test-circuits/Simple_Brake_Tests.mo"

			  cl-user::*my-meta-path*)

	 '((79 67))

	 '("ramp1.y")

	 (list "Modelica"))

   ;; (list "CyPhy.TestBenches.verif_MassSpringDamperAuto2cfgs_cfg1"

   ;; 	 (merge-pathnames 

   ;; 			  cl-user::*my-meta-path*)

   ;; 	 nil

   ;; 	 nil

   ;; 	 (list "Modelica"

   ;; 	       (merge-pathnames "Modelica/test-circuits/MSD939/CyPhy/"

   ;; 				cl-user::*my-meta-path*)))

   (list "three_R_C"

	 (merge-pathnames "Modelica/ladder/RC3.mo"

			  cl-user::*my-meta-path*)

	 nil

	 nil

	 (list "Modelica")

	 )

   (list "adby" (merge-pathnames "Modelica/adby346/adby346.mo" cl-user::*my-meta-path*)

       nil nil 

       (list "Modelica"))

   ))



(defun generate-data-for-AAAI-2014 (&optional (specs *model-file-pairs*))

  (mapcar #'envision-model-by-trial specs))



(defparameter *AAAI2014-conditions* '((:higher-order :continuity :landmarks) nil))



(defun envision-model-by-trial (spec)

  (let ((use-cache? nil))

    (cons (car spec)

	  (mapcar #'(lambda (trial)

		      (prog1 (num-situations-by-trial spec trial use-cache?) 

			(setq use-cache? t)))

		  *AAAI2014-conditions*))))



(defun num-situations-by-trial (spec trial use-cache?)

  (let ((*expand-constraints-of-type* trial))

    (envision-model-from-modelica (car spec) (second spec)

				  :landmark-orders (third spec)

				  :pseudo-state-vars (fourth spec)

				  :use-cache? use-cache?

				  :libraries (fifth spec))

    (cons trial (length (total-situations)))))





(defun collect-increasing-ladder-data (&optional continue?)

  (multiple-value-bind (results x)

      (open-results-stream continue?)

    (unless continue? 

      (format results "modelname , all , all-runtime , none , non-runtime ~%"))

    (loop do 

	 (progn (incf x)

		(do-ladder x results))

       until (= x 11))

    (close results)))





(defun do-ladder (x results)

  (let ((modelname (format nil "RCLadder.RC~A" x)))

	   (format t "~% modelname = ~A" modelname)

	   (let* ((start-all (get-internal-run-time))

		  (all (let ((*expand-constraints-of-type* 

			      '(:higher-order :continuity :landmarks)))

			 (envision-model-from-modelica

			  modelname

			  (merge-pathnames "Modelica/ladder/AAAI14_RC.mo"

					   cl-user::*my-meta-path*))

			 (length (total-situations))))

		  (end-all (get-internal-run-time))

		  (start-none (get-internal-run-time))

		  (none (let ((*expand-constraints-of-type*))

			  (envision-model-from-modelica

			  modelname

			  (merge-pathnames "Modelica/ladder/AAAI14_RC.mo"

					   cl-user::*my-meta-path*))

			  (length (total-situations))))

		  (end-none (get-internal-run-time)))

	     (format results "~A , ~A , ~A , ~A , ~A ~%"

		     modelname all (- end-all start-all) none (- end-none start-none))

	     (finish-output results))))





(defun open-results-stream (continue?)

  (let* ((filename (merge-pathnames "results.csv" cl-user::*my-meta-path*))

	 (index (if continue? 

		    (with-open-file (file filename :direction :input)

		      (do ((line (read-line file nil nil nil)

				 (read-line file nil nil nil))

			   (count 0 (incf count)))

			  ((null line) (1- count))))

		    0)))

    (values (open filename 

		  :if-exists (if continue? :append :supersede) 

		  :if-does-not-exist :create

		  :direction :output)

	    index)))









;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; End of Code

